#!/bin/bash

echo -e "Restart Web Server..."

#---------------------------------------------------------------
# define
#---------------------------------------------------------------
SPIDER_DAEMON=/spider/daemon
USR_LOCAL=/usr/local
TMP_DATABASE=/tmp/SpiderDB

#---------------------------------------------------------------
# library path
#---------------------------------------------------------------
export LD_LIBRARY_PATH=$SPIDER_DAEMON/curl/lib:$SPIDER_DAEMON/libpcap/lib:$SPIDER_DAEMON/libxml2/lib:$SPIDER_DAEMON/openssl/lib:$SPIDER_DAEMON/pcre/lib:$SPIDER_DAEMON/sqlite/lib

#---------------------------------------------------------------
# kill apps
#---------------------------------------------------------------
APPS=(lighttpd
      php-cgi)
for app in ${APPS[@]}; do
    pids=`/spider/bin/pgrep -f $app`
    for pid in $pids; do
        kill -9 $pid
        echo -e $app [$pid] killed
    done
done

#---------------------------------------------------------------
# HTTP/HTTPS
#---------------------------------------------------------------
IFS=','
row=( $($SPIDER_DAEMON/sqlite/bin/sqlite3 $TMP_DATABASE/Network.db -separator "," "SELECT IFNULL(Https,0), IFNULL(HttpPort,80), IFNULL(HttpsPort,443) FROM Network") )
if [ ${row[0]} -eq 1 ]; then
    sed 's/${port}/'"${row[2]}"'/' $USR_LOCAL/lighttpd/lighttpsd.conf > $USR_LOCAL/lighttpd/current.conf
else
    sed 's/${port}/'"${row[1]}"'/' $USR_LOCAL/lighttpd/lighttpd.conf > $USR_LOCAL/lighttpd/current.conf
fi

#---------------------------------------------------------------
# OPENAPI
#---------------------------------------------------------------
IFS=','
row=( $($SPIDER_DAEMON/sqlite/bin/sqlite3 $TMP_DATABASE/Spider.db -separator "," "SELECT IFNULL(Enabled,0), IFNULL(Port,0), IFNULL(ClientIP,''), IFNULL(AuthKey,''), IFNULL(HashKey,''), IFNULL(AuthKeyUse,'') FROM OPENAPI") )
if [ ${row[0]} -eq 1 ]; then
    spider_model=( $($SPIDER_DAEMON/sqlite/bin/sqlite3 $TMP_DATABASE/Network.db -separator "," "SELECT IFNULL(Model,0), IFNULL(Type,0) FROM Network") )
    export OPENAPI_DATA=${row[2]}:${row[3]}:${row[4]}:${row[5]}:${spider_model[0]}:${spider_model[1]}
    sed -i 's/${apiport}/'"${row[1]}"'/' $USR_LOCAL/lighttpd/current.conf
    sed -i 's/#{ONAPI}/''/' $USR_LOCAL/lighttpd/current.conf
fi

#---------------------------------------------------------------
# lighttpd start
#---------------------------------------------------------------
$USR_LOCAL/lighttpd/sbin/lighttpd -f $USR_LOCAL/lighttpd/current.conf
