#!/bin/bash
#---------------------------------------------------------------
# Neptune H501 setup.sh
#---------------------------------------------------------------
echo -e "neptune-h501 setup..."

#---------------------------------------------------------------
# tmpfs
#---------------------------------------------------------------
FSTAB=/etc/fstab
row=`grep SpiderDB $FSTAB`
if [ "$row" == "" ]; then
    echo "tmpfs /tmp/SpiderDB tmpfs size=100M,nr_inodes=10,mode=1777 0 0" >> $FSTAB
fi

#---------------------------------------------------------------
# sshd_config
#---------------------------------------------------------------
sed -i 's/#*Port 22/Port 1022/g' /etc/ssh/sshd_config

#---------------------------------------------------------------
# hostname
#---------------------------------------------------------------
echo "neptune-h501" > /etc/hostname
echo "127.0.0.1 localhost" > /etc/hosts
echo "127.0.0.1 neptune-h501" >> /etc/hosts

#---------------------------------------------------------------
# welcome
#---------------------------------------------------------------
sed -i 's/$BOARD_VENDOR/neptune-h501/g' /etc/update-motd.d/10-header
sed -i 's/^echo/# echo/g' /etc/update-motd.d/32-site

#---------------------------------------------------------------
# pi account
#---------------------------------------------------------------
sed -i 's/--autologin pi //g' /etc/systemd/system/getty@tty1.service.d/autologin.conf
sed -i 's/--autologin pi //g' /etc/systemd/system/serial-getty@ttyS0.service.d/autologin.conf
sed -i 's/--autologin pi //g' /etc/systemd/system/serial-getty@ttyAMA0.service.d/autologin.conf
sed -i 's/--autologin pi //g' /etc/systemd/system/serial-getty@ttySAC0.service.d/autologin.conf
usermod -L pi

#---------------------------------------------------------------
# start.sh
#---------------------------------------------------------------
if [ ! -L "/etc/rc3.d/S99sicunet" ]; then
    ln -s /spider/shell/start.sh /etc/init.d/sicunet.sh
    ln -s /etc/init.d/sicunet.sh /etc/rc3.d/S99sicunet
fi

#---------------------------------------------------------------
# NetworkManager
#---------------------------------------------------------------
systemctl stop NetworkManager.service
systemctl disable NetworkManager.service

#---------------------------------------------------------------
# ntp
#---------------------------------------------------------------
systemctl stop ntp
systemctl disable ntp

#---------------------------------------------------------------
# ntpdate
#---------------------------------------------------------------
if [ -f /usr/sbin/ntpdate ]; then
    mv /usr/sbin/ntpdate /usr/sbin/ntpdate_
fi

#---------------------------------------------------------------
# reboot
#---------------------------------------------------------------
echo Setup $(date) > /spider/shell/setup.done

sync;sync;sync
reboot -f

