<?php

class MyPDOStatement extends PDOStatement
{
    protected $_debugValues = null;

    protected function __construct()
    {
        // need this empty construct()!
    }

    public function execute($values=array())
    {
        $this->_debugValues = $values;
        try {
            $t = parent::execute($values);
            // maybe do some logging here?
            $query = $this->_debugQuery();
            if( strtoupper(substr($query, 0, 6)) == 'INSERT' || strtoupper(substr($query, 0, 6)) == 'UPDATE' || strtoupper(substr($query, 0, 6)) == 'DELETE') {
	            //include APP_DIR.'/libraries/Log.php';
	            $log = new Log();
	            $log->query_history($this->_debugQuery());
            }
        } catch (PDOException $e) {
            // maybe do some logging here?
            throw $e;
        }

        return $t;
    }

    public function executeSilent($values=array())
    {
        $this->_debugValues = $values;
        try {
            //여기
            $t = parent::execute($values);
            // maybe do some logging here?
        } catch (PDOException $e) {
            // maybe do some logging here?
            throw $e;
        }

        return $t;
    }

    public function _debugQuery($replaced=true)
    {
        $q = $this->queryString;

        if (!$replaced) {
            return $q;
        }

        $this->_debugValueIndex = 0;
        return preg_replace_callback('/:([0-9a-z_]+)|\?/i', array($this, '_debugReplace'), $q);
    }

    protected function _debugReplace($m)
    {
        if( $m[0] === '?' ) {
            $v = $this->_debugValues[$this->_debugValueIndex];
            $this->_debugValueIndex++;
        } else {
            $v = $this->_debugValues[$m[1]];
        }
        if ($v === null) {
            return "NULL";
        }
        if (!is_numeric($v)) {
            $v = str_replace("'", "''", $v);
        }

        return "'". $v ."'";
    }
}