<?php

header("Pragma: no-cache");
header("Cache-Control: no-cache,must-revalidate,no-store");

include APP_DIR.'/libraries/EnumTable.php';
include APP_DIR.'/libraries/ConstTable.php';
include APP_DIR.'/libraries/class.smtp.php';
include APP_DIR.'/libraries/class.phpmailer.php';
include APP_DIR.'/libraries/PHPMailerAutoload.php';

class controller
{
    public $class;
    public $method;
    public $prepath;

    public $conn;
    public $conn_log;
    public $net_work;

    public $lang;
    
    public $input;
    public $from;
    public $log;
    public $log_table_error;
    public $Util;
    
    var $free_auth  = FALSE;
    
    public function __construct()
    {        
        $this->class        = $GLOBALS['class'];
        $this->method       = $GLOBALS['method'];
        // $this->prepath      = $GLOBALS['prepath'];

        $this->conn         = $GLOBALS['conn'];
        $this->conn_log     = $GLOBALS['conn_log'];
        $this->net_work     = $GLOBALS['net_work'];
        
        $this->input = new Input();
		$this->from = new Form();
		$this->log = new Log();
		$this->util = new Util();
		
		$this->log_table_error = $this->log->is_error_log_table();
		
		if(!empty($_SESSION['spider_language'])){
			$this->lang = new Language($_SESSION['spider_language']);
		}else{
			$this->lang = new Language();
			$_SESSION['spider_language'] = LANG;
		}

        //$this->lang         = new Language($_SESSION['spider_language']);
		

//        session_start();
        if( $this->class == 'user' && $this->method == 'logout' )
        {
            $this->logout();
        } else if( $this->class == 'user' && $this->method == 'forgot_password' ) {
            $this->forgot_password();
        }

        if( !$this->is_login() )
        {
            $this->login();
        }

        //liu - 보안
        if($_SESSION['_init'] == 1){
	        $this->resetPassword();
        }
        
        if( !$this->is_licensekey() && $this->class != 'license' )//라이센스 항목이 공백 인지 확인
        {
           	$this->setlicense();
        }        
        else /* wtkim 20190425 : 라이센스 변경되면 대응 위해서 - 라이센스틑 들어있는데 result 항목이 틀림*/
        {   //공백 아닐때
            if($this->change_license() && $this->class != 'license')
            {
                $this->util->alert("The license has been changed.\\nGo to the website and get a new license.\\nWebsite - http://license.remote-manager.net");
                $this->setlicense();
            }            
        }
        
        if( !$this->valid_license() && $this->class != 'license' )
        {
			$this->util->alert($this->lang->common->invalid_license);
           	$this->setlicense();
        }
        
        if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL && 
            $_SESSION['spider_model'] != ConstTable::MODEL_ELITE && 
            $_SESSION['spider_model'] != ConstTable::MODEL_ENTERPRISE && 
			$_SESSION['spider_model'] != ConstTable::MODEL_GIANT && 
            $this->class != 'license' && $this->class != 'client' && $this->class != 'updateclient')
        {
           	$this->setclient();
        }
        
//        session_write_close();    
        if( !$this->open_auth() && $_SERVER['QUERY_STRING'] != '' )
        {            
            $this->util->alert($this->lang->menu->error_not_permission);
            $this->util->back();
            exit;
        }

		if($this->is_option(ConstTable::OPTION_RMR)) {
	        $rmr   = $this->conn->prepare("SELECT * FROM Rmr");
		    $rmr->execute();
			$this->rmr	= $rmr->fetch(PDO::FETCH_ASSOC);
		}
    }

    public function display($vars=array(), $view='', $layout='')
    {
        if( $layout !== FALSE )	$this->load_layout_top($layout, $vars);

        $this->load_view($vars, $view);

        if( $layout !== FALSE )	$this->load_layout_bottom($layout, $vars);
    }

    public function load_layout_top($layout='', $vars=array())
    {
        if( empty($layout) )    $layout = 'top';
        else                    $layout = $layout.'_top';

        if( substr($layout, 0, 1) != '/' )
            $layout = APP_DIR.'/views/common/layout_'.$layout.EXT;
//          echo $layout;
        $this->output($layout, $vars);
    }

    public function load_layout_bottom($layout='', $vars=array())
    {
        if( empty($layout) )    $layout = 'bottom';
        else                    $layout = $layout.'_bottom';

        if( substr($layout, 0, 1) != '/' )
            $layout = APP_DIR.'/views/common/layout_'.$layout.EXT;

        $this->output($layout, $vars);
    }

    public function load_view($vars=array(), $view='')
    {
        if( empty($view) )
            $view = $this->class;
            
        if( substr($view, 0, 1) != '/' )
            $view = realpath(APP_DIR.'/views/'.$view.EXT);

        $this->output($view, $vars, TRUE);
    }

    public function output($path='', $vars=array())
    {
        $lang   = $this->lang;
        if( isset($vars) && is_array($vars) )       extract($vars);
        if( isset($path) && file_exists($path) )    require $path;
    }

    public function is_login()
    {
	    if(!empty($_SESSION['spider_status'])){
		    $spider_status = $_SESSION['spider_status'];
	    }else{
		    $spider_status = '';
	    }
	    
		//if( $spider_status == '-1' && $this->class != 'layout' )
		if( $spider_status == '-1' )
		{
			$this->util->alert($this->lang->common->auto_disconnect);
			$this->logout();
			exit;
		}

        if( empty($_SESSION['spider_id']) ) {
			return FALSE;
		}

		return TRUE;
    }
    
    public function is_licensekey()
    {
        if( empty($_SESSION['spider_key']) ) 		return FALSE;
        else                                		return TRUE;
    }

	public function valid_license()
	{
		$license  = $this->net_work->prepare("SELECT Result FROM License WHERE No = 2");
		$license->execute();
		$license = $license->fetchColumn();

		return $license == '1' ? TRUE : FALSE;
	}
    
    // wtkim 20190425 : 라이센스 변경되면 대응 위해서 - 라이센스 상태 체크 함수
    public function change_license()
	{
		$license  = $this->net_work->prepare("SELECT Result FROM License WHERE No = 1");
		$license->execute();
		$license = $license->fetchColumn();

		return $license == '2' ? TRUE : FALSE;
    }

    public function open_auth()
    {
        if( $_SESSION['spider_type'] == 'spider' )  
            return TRUE;

        if( $this->free_auth )                      
            return TRUE;
        
        $classname=$this->class;
        
        //Util::alert($classname);
        // By SUN07 - 2011.12.19 : 처음 page Open 을 위해 alarm_map 은 무조건 들어가도록 한다.
        if ($classname == "alarm_map")
            return TRUE;
            
        // By SUN07 - 2011.12.19 : 처음 page Open 을 위해 alarm_map 은 무조건 들어가도록 한다.
        if ($classname == "user")
            return TRUE;
            
        if ($classname == "sitemapsetting")
            return TRUE;   
            
        if ($classname == "card_holder_credential")
            return TRUE;

            
        // By SUN07 - 2011.12.22 : Skin Change 는 spider 가 아니면 안되도록 한다.
        if ($classname == "skinchange" && $_SESSION['spider_type'] != 'spider' )
        	return FALSE;

        $auth   = $this->conn->prepare("SELECT Authority FROM UserRoleTable WHERE Site=? AND UserRole=? AND FormIndex=?");
        $auth->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole'], $this->lang->formindex->$classname));
        $auth   = $auth->fetchAll(PDO::FETCH_ASSOC);
        
        foreach ($auth as $key=>$val)
        {
            if ($val['Authority'] == "0")
                return TRUE;
            
        	// By SUN07 - 2012.01.12 : Data Export, Import 는 별도 검사
	        if ($classname == "dexport" && $val['Authority'] == "19")
	        	return TRUE;
	        if ($classname == "dimport" && $val['Authority'] == "18")
	        	return TRUE;
        }
        
        // By SUN07 - 2011.23.23 : Network 이나 System 의 경우에는 View 권한이 없어도 들어가도록 한다.
        if ($this->lang->formindex->$classname == 71 || $this->lang->formindex->$classname == 72)
            return TRUE;
            
        return FALSE;
    }    

    public function is_auth($FormIndex, $Authority)
    {
		if( $_SESSION['spider_type'] == 'spider' )  return TRUE;
		if( $this->free_auth )  return TRUE;
		
		$userroletable  = $this->conn->prepare("SELECT COUNT(*) FROM UserRoleTable WHERE Site = ? AND UserRole = ? AND FormIndex = ? AND Authority = ?");
		$userroletable->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole'], $FormIndex, $Authority));
		$userroletable	= $userroletable->fetchColumn();

        if( $userroletable > 0 )	return TRUE;
        else						return FALSE;
    }
    
    public function is_SuperAdmin()
    {
        if( $_SESSION['spider_type'] == 'spider' )  return TRUE;
        else                                        return FALSE;
    }
    
    public function to_array_site()
    {
        $data = $this->conn->query("SELECT No, Name FROM Site");
        $data->execute();
        $data = $data->fetchAll(PDO::FETCH_ASSOC);

        $arr = array();
        foreach( $data as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
    }

	public function is_option($index)
	{
		if(substr($_SESSION['spider_option'], $index, 1) == '1') {
			return TRUE;
		}

		return FALSE;
	}
    
	public function resetPassword()
    {
	    if( IS_AJAX )
        {
	        $login_id = $this->input->post('login_id');
	        $login_pw = $this->input->post('login_pw');
            $re_login_pw = $this->input->post('re_login_pw');
            $login_site = $_SESSION['spider_site'];

            $check_pw_status = $this->input->post('check_pw_status');
            
            if(empty($login_id)){
	            session_write_close(); 
	            $this->util->alert( $this->lang->user->error_login_id_required, TRUE );
            }
            
            if($login_pw != $re_login_pw){
	            session_write_close(); 
	            $this->util->alert( $this->lang->ctrl->error_not_matched_new, TRUE );
            }
            
            $ctrl = $this->conn->prepare("UPDATE Controller SET Password=? WHERE ID = ? AND No = 1");
            $values	= array(hash('sha256', $re_login_pw, false), $login_id);
            
            if( !$ctrl->execute($values) ){
	            $this->util->alert($this->lang->common->error_update, TRUE );
			}  
			
			if(strtolower($login_pw) != "admin"){
                $_SESSION['_init'] = '';
                $factory_pw_up = $this->net_work->prepare("UPDATE Network SET FactoryPW='2' where no=1");
                $factory_pw_up->execute();
			}
			
	        session_write_close();

            $this->util->reload();
            exit;
	    }
        else
        {
	        session_write_close();
            $vars['arr_site'] = $this->to_array_site();
            $vars['spider_model'] = '0';
            
            $licensekey   = $this->net_work->query("SELECT LicenseKey, Model, Type FROM Network");
            $licensekey->execute();
            if ( $licensekey = $licensekey->fetch(PDO::FETCH_ASSOC) )
            {
                $vars['spider_model'] = $licensekey['Model'];
            }
            
            $this->display($vars, 'resetPassword', 'none');
        }

        session_write_close();
        exit;
    }

    public function login()
    {
        if( IS_AJAX )
        {
            $login_id   = $this->input->post('login_id');
            $login_pw   = $this->input->post('login_pw');
            $login_site = $this->input->post('login_site');
            $check_pw_status = $this->input->post('check_pw_status');

            if (empty($login_site) || $login_site == 0)
            	$login_site = '1';
            
            $_SESSION['spider_site'] = $login_site;
            $_SESSION['spider_userno'] = '';
            
			$connect_user = 0;
            $licensekey   = $this->net_work->query("SELECT LicenseKey, Model, Type FROM Network");
            $licensekey->execute();
            
            if ( $licensekey = $licensekey->fetch(PDO::FETCH_ASSOC) )
            {
            	if ($licensekey['Model'] == 1)
    				$connect_user = 8;
		    	if ($licensekey['Model'] == 2)
		    		$connect_user = 16;
		    	if ($licensekey['Model'] == 3)
		    		$connect_user = 32;
            }            	
  
            if( empty($login_id) )  						{ session_write_close(); $this->util->alert( $this->lang->user->error_login_id_required, TRUE ); }
            if( empty($login_pw) )  						{ session_write_close(); $this->util->alert( $this->lang->user->error_login_pw_required, TRUE ); }
            //if( $this->util->GetSessionCount() >= $connect_user)	{ session_write_close(); $this->util->alert( $this->lang->addmsg->error_limit_connect, TRUE ); }

            $licensekey   = $this->net_work->query("SELECT LicenseKey, Model, Type FROM Network");
            $licensekey->execute();
            if ( $licensekey = $licensekey->fetch(PDO::FETCH_ASSOC) )
            {
                $_SESSION['spider_key']   = $licensekey['LicenseKey'];
                $_SESSION['spider_model'] = $licensekey['Model'];
                $_SESSION['spider_kind']  = $licensekey['Type'];
            }
            
            $ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND No = 1");
            $ctrl->execute(array($login_id));            
			// 임시 사용 불가 처리 함. 
			// CMS API에서 호환성 문제 발생 함.
			//SHA256+Base64 (admin) : jGl25bVBBBW96Qi9Te4V37Fnqchz/Eu4qB9vKrRIqRg=
            //$ctrl->execute(array($login_id, base64_encode( hash('sha256', $login_pw, true))));
            
            if( $ctrl = $ctrl->fetch(PDO::FETCH_ASSOC) )
            {	            
	            //if( $ctrl['Password'] == $login_pw ) {
                  if( $ctrl['Password'] == hash('sha256', $login_pw, false)) {
			            
		            $_SESSION['spider_type']     = 'spider';
	                $_SESSION['spider_userno']   = '';
	                $_SESSION['spider_userrole'] = 'free_auth';
	                $_SESSION['spider_id']       = $ctrl['ID'];
	                $_SESSION['spider_name']     = "Super Admin";
	                $_SESSION['spider_userimg']  = '';
	                $_SESSION['spider_site']     = $login_site;
	
	                $_SESSION['spider_language']   = $ctrl['Language'];
	                $_SESSION['spider_page']       = $ctrl['DefaultPage'];
	                $_SESSION['spider_default']    = $ctrl['DefaultPage'];
	                $_SESSION['spider_floor']      = $ctrl['DefaultFloorNo'];
	                $_SESSION['spider_floorstate'] = $ctrl['DefaultFloorState'];
                    $_SESSION['spider_simplemenu'] = $ctrl['SimpleMenu'];
	                $_SESSION['spider_auto_disconnect_time'] = 1;
	
	                $optionvalue   = $this->net_work->query("SELECT OptionValue FROM Option");
		            $optionvalue->execute();
		            if ( $optionvalue = $optionvalue->fetch(PDO::FETCH_ASSOC) )
		            {
		                $_SESSION['spider_option']   = $optionvalue['OptionValue'];
		            }
	                
	                if(!$this->check_version()) {
	                    $_SESSION['spider_page'] = 'server_client';
	                    $this->util->alert( $this->lang->common->error_mismatch_version);
	                }
                        
                    //if(strtolower($login_id) == "admin" && strtolower($login_pw) == "admin"){
		                //$_SESSION['_init'] = 1;
                    //}

                    if($check_pw_status == '1')
                    {
                        $_SESSION['_init'] = 1;
                    }
                    else if($check_pw_status == '0')
                    {
                        $_SESSION['_init'] = '';
                    }
                    else if($check_pw_status == '2')
                    {
                        $factory_pw_up = $this->net_work->prepare("UPDATE Network SET FactoryPW='2' where no=1");
                        $factory_pw_up->execute();
                        $_SESSION['_init'] = '';
                    }
                    else
                    {
                        $_SESSION['_init'] = '';
                    }
                    
	                session_write_close();
	                $this->log->set_log('user', 'login');
	                //$this->util->redirect("/?c=alarm_map");   
	                $this->util->reload();
	                exit;
		            
	            }
			}
			
            $webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Site = ?");
			$webuser->execute(array($login_id, $login_site));

			//CMS API 호환성 문제로 인하여 사용 중지 함.
            //$webuser->execute(array($login_id, base64_encode( hash('sha256', $login_pw, true)), $login_site));

            if( $webuser = $webuser->fetch(PDO::FETCH_ASSOC) )
            {
//                if( $webuser['Password'] == $login_pw ) {
                  if( $webuser['Password'] == hash('sha256', $login_pw, false)) {
			            
		            // 동접수 확인
	                $max_concurrent	= EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][15];
	                if( $this->session_count($login_id) >= $max_concurrent )
	                {
	                    $this->util->alert( $this->lang->common->error_concurrent_over);
	                    exit;
	                }
	
	                $user   = $this->conn->query("SELECT * FROM User WHERE WEBLevel = ?");
	                $user->execute(array($webuser['No']));
	                $user = $user->fetch(PDO::FETCH_ASSOC);
	                
	                $_SESSION['spider_type']     = $webuser['Type'];
	                $_SESSION['spider_userno']   = $webuser['No'];
	                $_SESSION['spider_userrole'] = $webuser['UserRole'];
	                $_SESSION['spider_id']       = $webuser['ID'];
	                $_SESSION['spider_name']     = $webuser['name'];
	                $_SESSION['spider_userimg']  = $webuser['ImageFile'];
	                $_SESSION['spider_site']     = $login_site;
	
	                $_SESSION['spider_language']   = $webuser['Language'];
	                $_SESSION['spider_page']       = $webuser['DefaultPage'];
	                $_SESSION['spider_floor']      = $webuser['DefaultFloorNo'];
	                $_SESSION['spider_floorstate'] = $webuser['DefaultFloorState'];
	                $_SESSION['spider_auto_disconnect_time'] = $webuser['AutoDisconnectTime'];
	                
	                $optionvalue   = $this->net_work->query("SELECT OptionValue FROM Option");
		            $optionvalue->execute();
		            if ( $optionvalue = $optionvalue->fetch(PDO::FETCH_ASSOC) )
		            {
		                $_SESSION['spider_option']   = $optionvalue['OptionValue'];
		            }
	
	                if(!$this->check_version()) {
	                    $_SESSION['spider_page'] = 'server_client';
	                    $this->util->alert( $this->lang->common->error_mismatch_version);
	                }
	
	                session_write_close();
	                $this->log->set_log('user', 'login');
	
	                $this->util->reload();
		            
		        }
            }
            else
            {
            	$this->log->set_log_id('user', '_execfail', $login_id); 
            	
                session_write_close();
                $this->util->alert( $this->lang->user->error_login_fail);
                //load_login();                
            }
        }
        else
        {
            session_write_close();
            $vars['arr_site'] = $this->to_array_site();
            $vars['spider_model'] = '0';
            
            $licensekey   = $this->net_work->query("SELECT LicenseKey, Model, Type FROM Network");
            $licensekey->execute();
            if ( $licensekey = $licensekey->fetch(PDO::FETCH_ASSOC) )
            {
                $vars['spider_model'] = $licensekey['Model'];
            }
            
            $this->display($vars, 'login', 'none');
        }

        session_write_close();
        exit;
    }

    public function logout()
    {
        $this->log->set_log('user', 'logout');

        $_SESSION['spider_type']     = '';
        $_SESSION['spider_userno']   = '';
        $_SESSION['spider_userrole'] = '';
        $_SESSION['spider_id']       = '';
        $_SESSION['spider_name']     = '';
        $_SESSION['spider_userimg']  = '';
        $_SESSION['spider_site']     = '0';
        $_SESSION['spider_key']      = '';
        $_SESSION['spider_model']    = '';
        $_SESSION['spider_kind']     = '';
		$_SESSION['spider_status']   = '';
		$_SESSION['spider_language']       = '';
		$_SESSION['spider_page']       = '';
		$_SESSION['spider_floor']      = '';
		$_SESSION['spider_floorstate']      = '';
        
        session_write_close();

		$this->util->js('top.location.href="/";');

        exit;
    }

    public function session_count($without_id = '')
    {
        $count  = $this->net_work->prepare("SELECT COUNT(*) FROM sessions WHERE user_id != ? AND user_id != '' AND session_expiration >= ? AND status = 1");
        $count->execute(array($without_id, time()));
        $count  = $count->fetchColumn();

        return $count;
    }

    public function forgot_password()
    {
        exec(SPIDER_COMM." smtp pwrqsend " . $this->input->post('login_id', ''));
        $this->util->alert("Sent a request message to the administrator.");
        exit;
    }

    public function check_version()
    {
    /* 2018.05.29 CJMOON 더이상 사용되지 않음.
        $server = $this->get_version();

        $clients = $this->conn->prepare("SELECT * FROM Host WHERE No != '1'");
        $clients->execute();
        while( $client = $clients->fetch(PDO::FETCH_ASSOC) ) {
            if( $server != $client['Version'] ) {
                return FALSE;
            }
        }
    */
        return TRUE;
    }
    
    public function get_version()
    { 
		exec(SPIDER_COMM." ver", $output);

		$version	= @$output[count($output)-2];
        
		return $version;
	}

    public function setlicense()
    {        
    	$this->class  = 'license';
		$this->util->redirect("/?c=license");
    	exit;
    }
    
    public function setclient()
    {
    	$this->class  = 'client';
    	$this->util->redirect("/?c=client");
    	exit;
    }

    public function Get_Server_Door()
    {
        //$result   = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Disable = 0 AND No BETWEEN '1' AND '4'");
        //$result->execute();
        //$result   = $result->fetchAll(PDO::FETCH_ASSOC);
        
        $result = $this->conn->query("SELECT COUNT(*) FROM Door WHERE Disable = 0 AND No BETWEEN '1' AND '4'");
        $result = $result->fetchAll(PDO::FETCH_ASSOC);

        return $result;
    }

    public function Get_Network_Https_Port()
    {
        //$result   = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Disable = 0 AND No BETWEEN '1' AND '4'");
        //$result->execute();
        //$result   = $result->fetchAll(PDO::FETCH_ASSOC);

        //$result = $this->conn->query("SELECT HTTPS, HTTPSPORT FROM NETWORKINFO WHERE No=1");
        $result = $this->net_work->query("SELECT HTTPS, HTTPSPORT FROM NETWORK WHERE No=1");
        $result = $result->fetchAll(PDO::FETCH_ASSOC);

        foreach( $result as $key=>$val )
        {
            $result['HTTPS']  = $val['HTTPS'];
            $result['HTTPSPORT']  = $val['HTTPSPORT'];
        }

        return $result;
    }

}
?>
