<?php


class action extends controller
{
    // ----------------------------------------------------------------------------------

   public function index()
    {
        $vars['EventActionNo']  = $this->input->get('EventActionNo');
        $vars['attrWhere']      = $this->to_array_where();

        $this->display($vars, '', 'frame');
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM action");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Action ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM action WHERE $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM action WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val)
        {
            $val['TypeStr']     = EnumTable::$attrEventType[$val['typ']];
            $val['WhereList']   = $this->get_where_arr($val['No']);
            $val['WhereStr']    = $this->get_where_str($val['No'], $val['typ']);
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page=="" ? 1 : $page;
        $result['rowsize']      = $pagination->row_size;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function to_array_where()
    {
        $arr    = array();
        $arr['1'] = $this->to_array_aux_output();
        $arr['2'] = $this->to_array_door();
        $arr['3'] = $this->to_array_power_fault();

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_aux_output()
    {
        $list   = $this->conn->prepare("SELECT * FROM AuxOutput WHERE Disable='0' AND Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_door()
    {
        $list   = $this->conn->prepare("SELECT * FROM Door WHERE Disable='0' AND Site=?");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array(array($_SESSION['spider_site']));
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_power_fault()
    {
        $list   = $this->conn->prepare("SELECT * FROM PowerFault");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function get_where_str($No, $Type)
    {
        $arr_where = $this->to_array_where();

        $list   = $this->conn->prepare("SELECT * FROM ActionTarget WHERE ActionNo=?");
        $list->execute(array($No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[]  = $arr_where[$Type][$val['TargetNo']];
        }

        return implode(',', $arr);
    }

    // ----------------------------------------------------------------------------------

   public function get_where_arr($No)
    {
        $list   = $this->conn->prepare("SELECT * FROM ActionTarget WHERE ActionNo=?");
        $list->execute(array($No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[]  = $val['TargetNo'];
        }

        return "[". implode(',', $arr) ."]";
    }

    // ----------------------------------------------------------------------------------

}


?>