<?php


class event_action extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $vars['arr_sch']    = $this->to_array_sch();

        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM EventAction WHERE Site=?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM EventAction WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM EventAction WHERE Site=? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], "%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM EventAction WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], "%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $arr_sch    = $this->to_array_sch();

        foreach( $list as $key=>$val)
        {
            $val['sch_str'] = $arr_sch[$val['ScheduleNo']];
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page=="" ? 1 : $page;
        $result['rowsize']      = $pagination->row_size;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function insert()
    {
        $No = $this->conn->prepare("SELECT MAX(No) from EventAction WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No    = $No->fetchColumn() + 1;
        
        $name           = $this->input->post('name');
        $mean           = $this->input->post('mean');
        $ack            = $this->input->post('ack');
        $sch            = $this->input->post('sch');

        if( empty($name) )      $this->util->alert( $this->lang->event_action->error_name_required, TRUE );

        $sth    = $this->conn->prepare("INSERT INTO EventAction SET (Site,No,Name,Mean,Ack,ScheduleNo) VALUES (?,?,?,?,?,?)");

        $values = array($_SESSION['spider_site'],$No,$name,$mean,$ack,$sch,$No);
        if( $sth->execute($values) )
        {
            $this->log->insert();
            $this->util->js('load_list()');
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No             = $this->input->post('No');
        $name           = $this->input->post('name');
        $mean           = $this->input->post('mean');
        $ack            = $this->input->post('ack');
        $sch            = $this->input->post('sch');

        if( empty($name) )      $this->util->alert( $this->lang->event_action->error_name_required, TRUE );

        $sth    = $this->conn->prepare("UPDATE EventAction SET Name=?,Nean=?,Ack=?,ScheduleNo=? WHERE No=?");

        $values = array($name,$mean,$ack,$sch,$No);
        if( $sth->execute($values) )
        {
            $this->log->update();
            $this->util->js('update_list("'.$No.'")');
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
        $No     = $this->input->get('No');

        $sth    = $this->conn->prepare("DELETE FROM EventAction WHERE No=?");

        if( $sth->execute(array($No)) )
        {
            $this->log->delete();
            $this->util->js('update_list()');
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

   public function to_array_sch()
    {
        $list   = $this->conn->prepare("SELECT * FROM Schedule");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr_sch    = array('0'=>'NONE');
        foreach( $list as $key=>$val)
        {
            $arr_sch[$val['No']]    = $val['Name'];
        }

        return $arr_sch;
    }

    // ----------------------------------------------------------------------------------

}


?>