<?php

class access_report extends controller
{
    
	// ----------------------------------------------------------------------------------

   public function index()
	{
		$vars	= array();
		$vars['doors']			= $this->door_to_assoc();
		$vars['elevators']		= $this->elevator_to_assoc();
		//$vars['cardholders']	= $this->cardholder_to_assoc();
		$vars['accesslevels']	= $this->acceslevel_to_assoc();
		$this->display($vars);
	}

	// ----------------------------------------------------------------------------------

   public function condition_by_search()
	{
		$where	= "WHERE (Log.Site=0 OR Log.Site=?)";
		$params	= array($_SESSION['spider_site']);

		$start_date	= $this->input->param('StartDate', FALSE);
		if( $start_date ) {
			$date_part = explode('-', $start_date);
			$start_date = mktime(0, 0, 0, $date_part[0], $date_part[1], $date_part[2]);
			$where .= " AND Log.Date >= ?";
			$params[] = $start_date;
		}

		$end_date	= $this->input->param('EndDate', FALSE);
		if( $end_date ) {
			$date_part = explode('-', $end_date);
			$end_date = mktime(23, 59, 59, $date_part[0], $date_part[1], $date_part[2]);
			$where .= " AND Log.Date <= ?";
			$params[] = $end_date;
		}

		$eventcode	= $this->input->param('eventcode');
		$where	.= " AND Log.EventCode = ?";
		$params[] = $eventcode;

		$sub_condition	= array();

		if($eventcode == '400') {
			$door_no	= $this->input->param('door', FALSE);
			if( $door_no ) {
                if( $this->is_SuperAdmin() == true )
                {
                    $door	= $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No=? AND Disable != 1 LIMIT 1");
                }
                else{
                    $door	= $this->conn->prepare("SELECT A.* FROM Door AS A
                                                                JOIN Host AS B ON A.HostNo=B.No AND (B.ByAdminId = '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                    WHERE A.Site=? AND A.No=? AND A.Disable != 1 LIMIT 1");
                }
				$door->execute(array( $_SESSION['spider_site'], $door_no ));
				$door	= $door->fetch(PDO::FETCH_ASSOC);

				$where	.= " AND Log.Type=1 AND Log.Port IN ('{$door['MasterReader']}', '{$door['SlaveReader']}')";
			}
		}

		if($eventcode == '650') {
			$elevator_no	= $this->input->param('elevator', FALSE);
			if( $elevator_no ) {
                if( $this->is_SuperAdmin() == true )
                {
                    $elevator	= $this->conn->prepare("SELECT Elevator.*, Reader.No AS ReaderNo FROM Elevator INNER JOIN Reader ON Reader.HostNo=Elevator.HostNo AND Reader.Port=Elevator.Port WHERE Elevator.Site=? AND Elevator.No=? AND Elevator.Disable != 1 LIMIT 1");
                }
                else{
                    $elevator	= $this->conn->prepare("SELECT Elevator.*, Reader.No AS ReaderNo 
                                                        FROM Elevator 
                                                        INNER JOIN Reader ON Reader.HostNo=Elevator.HostNo AND Reader.Port=Elevator.Port 
                                                        JOIN Host ON Elevator.HostNo = Host.No AND (Host.ByAdminId = '".$_SESSION['spider_id']."' OR Host.ByAdminId = '' OR Host.ByAdminId IS null)
                                                        WHERE Elevator.Site=? AND Elevator.No=? AND Elevator.Disable != 1 LIMIT 1");    
                }
				$elevator->execute(array( $_SESSION['spider_site'], $elevator_no ));
				$elevator	= $elevator->fetch(PDO::FETCH_ASSOC);

				$where	.= " AND Log.Type=9 AND Log.Port IN ('{$elevator['ReaderNo']}')";
			}
		}

		$cardholder	= $this->input->param('cardholder', FALSE);
		if( $cardholder ) {
			$where .= " AND Log.UserName LIKE ?";
			$params[] = $this->util->parse_search_string($cardholder);
		}

        if( $this->is_SuperAdmin() == true )
        {
            "AND Log.Type <> 7 AND Log.Type <> 8  AND (Log.Type <> 0 OR Log.UserName = '".$_SESSION['spider_id']."')";
        }
        
		return array($where, $params);

/*
		$spider_db_path = DATABASE_DIR.'/Spider.db';
		$this->conn_log->exec("ATTACH DATABASE '{$spider_db_path}' AS Spider");

		$list	= $this->conn_log->prepare("SELECT * FROM Log WHERE (Site=0 OR Site=1) AND Date >= 1370304000 AND Date <= 1370390399 AND EventCode = '400' AND CardNo IN (SELECT Spider.Card.CardNo FROM Spider.CardAccessLevel INNER JOIN Spider.Card ON Spider.Card.No=Spider.CardAccessLevel.CardNo WHERE Spider.CardAccessLevel.Site='1' AND Spider.CardAccessLevel.AccessLevelNo='1') ORDER BY No DESC");
		$list->execute();
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);
*/
	}

	// ----------------------------------------------------------------------------------

   public function select()
	{
		list($where, $params)	= $this->condition_by_search();
		
		$action = $this->input->get('action');
		
		if ($action == 'preview' || $action == 'download') {
			exec(SPIDER_COMM." sysback");
			$logdb = $this->util->get_connect_backup_log_db();
		} else {
			$logdb = $this->conn_log;
		}

		$accesslevel_no	= $this->input->param('accesslevel', FALSE);
		if( $accesslevel_no ) {
			if ($action == 'preview' || $action == 'download') {
				$spider_db_path = $this->util->get_file_backup_db();
			} else {
				$spider_db_path = DATABASE_DIR.'/Spider.db';
			}
			$logdb->exec("ATTACH DATABASE '{$spider_db_path}' AS Spider");
            
            if( $this->is_SuperAdmin() == true )
            {
            	// 2016.08.27 - by sun07 #2102 - AccessLevel과 비교시 카드키로 하지 않고 카드번호로 하던 오류 수정
                $sql = " SELECT Log.*, CardAccess.CardNumber, CardAccess.CardFormatNo, Site.Name AS SiteName, Floor.Name AS FloorName 
                            FROM Log
                            INNER JOIN (
                                SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, Card.CardFormatNo AS CardFormatNo, CardAccessLevel.AccessLevelNo AS AccessLevelNo
                                FROM Card
                                INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                WHERE Card.SelectType=1 AND CardAccessLevel.AccessLevelNo = '{$accesslevel_no}'
                            UNION
                                SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, Card.CardFormatNo AS CardFormatNo, GroupElement.ElementNo AS AccessLevelNo
                                FROM Card
                                INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                INNER JOIN GroupElement ON GroupElement.Site=CardAccessLevel.Site AND GroupElement.GroupNo=CardAccessLevel.AccessLevelNo AND GroupElement.GroupKind=5
                                WHERE Card.SelectType=2 AND GroupElement.ElementNo = '{$accesslevel_no}'
                            ) AS CardAccess ON Log.Site=CardAccess.Site AND Log.CardNo=CardAccess.No 
                            LEFT OUTER JOIN Site ON Log.Site = Site.No
                            LEFT OUTER JOIN Door ON    (Log.Type = 1 AND (Log.Port = Door.MasterReader OR Log.Port = Door.SlaveReader)) 
                                                    OR (Log.Type = 2 AND Log.Port = Door.ContactNo )
                                                    OR (Log.Type = 3 AND Log.Port = Door.RexNo )	
                                                    OR (Log.Type = 6 AND Log.Port = Door.LockNo )
                            LEFT OUTER JOIN AuxOutput ON Log.Type = 4 AND Log.Port = AuxOutput.No
                            LEFT OUTER JOIN AuxInput ON Log.Type = 5 AND Log.Port = AuxInput.No
                            LEFT OUTER JOIN ElevatorRelay ON Log.Type = 10 AND Log.Port = ElevatorRelay.No
                            LEFT OUTER JOIN Floor ON (Door.Floor = Floor.No AND Floor.Site = Log.Site) OR AuxOutput.Floor = Floor.No  OR AuxInput.Floor = Floor.No 	OR ElevatorRelay.Floor = Floor.No ";                        
                            
				$sql_count = "SELECT COUNT(*) 
                                    FROM Log
                                    INNER JOIN (
                                        SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, CardAccessLevel.AccessLevelNo AS AccessLevelNo
                                        FROM Card
                                        INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                        WHERE Card.SelectType=1 AND CardAccessLevel.AccessLevelNo = '{$accesslevel_no}'
                                    UNION
                                        SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, GroupElement.ElementNo AS AccessLevelNo
                                        FROM Card
                                        INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                        INNER JOIN GroupElement ON GroupElement.Site=CardAccessLevel.Site AND GroupElement.GroupNo=CardAccessLevel.AccessLevelNo AND GroupElement.GroupKind=5
                                        WHERE Card.SelectType=2 AND GroupElement.ElementNo = '{$accesslevel_no}'
                                    ) AS CardAccess ON Log.Site=CardAccess.Site AND Log.CardNo=CardAccess.No ";
            }
            else{
                $sql = " SELECT Log.*, CardAccess.CardNumber, CardAccess.CardFormatNo, Site.Name AS SiteName, Floor.Name AS FloorName 
                            FROM Log
                            INNER JOIN (
                                SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, Card.CardFormatNo AS CardFormatNo, CardAccessLevel.AccessLevelNo AS AccessLevelNo
                                FROM Card
                                INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                WHERE Card.SelectType=1 AND CardAccessLevel.AccessLevelNo = '{$accesslevel_no}'
                            UNION
                                SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, Card.CardFormatNo AS CardFormatNo, GroupElement.ElementNo AS AccessLevelNo
                                FROM Card
                                INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                INNER JOIN GroupElement ON GroupElement.Site=CardAccessLevel.Site AND GroupElement.GroupNo=CardAccessLevel.AccessLevelNo AND GroupElement.GroupKind=5
                                WHERE Card.SelectType=2 AND GroupElement.ElementNo = '{$accesslevel_no}'
                            ) AS CardAccess ON Log.Site=CardAccess.Site AND Log.CardNo=CardAccess.No 
                            JOIN  Host ON IFNULL(Log.ClientMAC, '') = (CASE WHEN Host.No = 1 THEN '' ELSE Host.MAC END) AND (Host.ByAdminId = '".$_SESSION['spider_id']."' OR Host.ByAdminId = ''  OR Host.ByAdminId IS null) 
                            LEFT OUTER JOIN Site ON Log.Site = Site.No
                            LEFT OUTER JOIN Door ON    (Log.Type = 1 AND (Log.Port = Door.MasterReader OR Log.Port = Door.SlaveReader)) 
                                                    OR (Log.Type = 2 AND Log.Port = Door.ContactNo )
                                                    OR (Log.Type = 3 AND Log.Port = Door.RexNo )	
                                                    OR (Log.Type = 6 AND Log.Port = Door.LockNo )
                            LEFT OUTER JOIN AuxOutput ON Log.Type = 4 AND Log.Port = AuxOutput.No
                            LEFT OUTER JOIN AuxInput ON Log.Type = 5 AND Log.Port = AuxInput.No
                            LEFT OUTER JOIN ElevatorRelay ON Log.Type = 10 AND Log.Port = ElevatorRelay.No
                            LEFT OUTER JOIN Floor ON (Door.Floor = Floor.No AND Floor.Site = Log.Site) OR AuxOutput.Floor = Floor.No  OR AuxInput.Floor = Floor.No 	OR ElevatorRelay.Floor = Floor.No "; 
                            
                $sql_count = " SELECT COUNT(*) 
                                FROM Log
                                INNER JOIN (
                                    SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, CardAccessLevel.AccessLevelNo AS AccessLevelNo
                                    FROM Card
                                    INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                    WHERE Card.SelectType=1 AND CardAccessLevel.AccessLevelNo = '{$accesslevel_no}'
                                UNION
                                    SELECT Card.Site AS Site, Card.No AS No, Card.CardNo AS CardNumber, Card.SelectType AS SelectType, GroupElement.ElementNo AS AccessLevelNo
                                    FROM Card
                                    INNER JOIN CardAccessLevel ON CardAccessLevel.Site=Card.Site AND CardAccessLevel.CardNo=Card.No
                                    INNER JOIN GroupElement ON GroupElement.Site=CardAccessLevel.Site AND GroupElement.GroupNo=CardAccessLevel.AccessLevelNo AND GroupElement.GroupKind=5
                                    WHERE Card.SelectType=2 AND GroupElement.ElementNo = '{$accesslevel_no}'
                                ) AS CardAccess ON Log.Site=CardAccess.Site AND Log.CardNo=CardAccess.No 
                                JOIN  Host ON IFNULL(Log.ClientMAC, '') = (CASE WHEN Host.No = 1 THEN '' ELSE Host.MAC END) AND (Host.ByAdminId = '".$_SESSION['spider_id']."'  OR Host.ByAdminId = '' OR Host.ByAdminId IS null) ";
            }
		} else {
            $spider_db_path = DATABASE_DIR.'/Spider.db';
            $logdb->exec("ATTACH DATABASE '{$spider_db_path}' AS Spider");
            
            if( $this->is_SuperAdmin() == true )
            {
                $sql = " SELECT Log.*, Card.CardNo AS CardNumber, Card.CardFormatNo AS CardFormatNo, Site.Name AS SiteName, Floor.Name AS FloorName 
                            FROM Log
                            LEFT OUTER JOIN Card ON Card.Site=Log.Site AND Card.No=Log.CardNo 
                            LEFT OUTER JOIN Site ON Log.Site = Site.No
                            LEFT OUTER JOIN Door ON    (Log.Type = 1 AND (Log.Port = Door.MasterReader OR Log.Port = Door.SlaveReader)) 
                                                    OR (Log.Type = 2 AND Log.Port = Door.ContactNo )
                                                    OR (Log.Type = 3 AND Log.Port = Door.RexNo )	
                                                    OR (Log.Type = 6 AND Log.Port = Door.LockNo )
                            LEFT OUTER JOIN AuxOutput ON Log.Type = 4 AND Log.Port = AuxOutput.No
                            LEFT OUTER JOIN AuxInput ON Log.Type = 5 AND Log.Port = AuxInput.No
                            LEFT OUTER JOIN ElevatorRelay ON Log.Type = 10 AND Log.Port = ElevatorRelay.No
                            LEFT OUTER JOIN Floor ON (Door.Floor = Floor.No AND Floor.Site = Log.Site) OR AuxOutput.Floor = Floor.No  OR AuxInput.Floor = Floor.No 	OR ElevatorRelay.Floor = Floor.No "; 

                $sql_count = "SELECT COUNT(*) FROM Log";
            }
            else{
                $sql = " SELECT Log.*, Card.CardNo AS CardNumber, Card.CardFormatNo AS CardFormatNo , Site.Name AS SiteName, Floor.Name AS FloorName 
                            FROM Log
                            JOIN  Host ON IFNULL(Log.ClientMAC, '') = (CASE WHEN Host.No = 1 THEN '' ELSE Host.MAC END) AND (Host.ByAdminId = '".$_SESSION['spider_id']."' OR Host.ByAdminId = ''  OR Host.ByAdminId IS null) 
                            LEFT OUTER JOIN Card ON Card.Site=Log.Site AND Card.No=Log.CardNo 
                            LEFT OUTER JOIN Site ON Log.Site = Site.No
                            LEFT OUTER JOIN Door ON    (Log.Type = 1 AND (Log.Port = Door.MasterReader OR Log.Port = Door.SlaveReader)) 
                                                    OR (Log.Type = 2 AND Log.Port = Door.ContactNo )
                                                    OR (Log.Type = 3 AND Log.Port = Door.RexNo )	
                                                    OR (Log.Type = 6 AND Log.Port = Door.LockNo )
                            LEFT OUTER JOIN AuxOutput ON Log.Type = 4 AND Log.Port = AuxOutput.No
                            LEFT OUTER JOIN AuxInput ON Log.Type = 5 AND Log.Port = AuxInput.No
                            LEFT OUTER JOIN ElevatorRelay ON Log.Type = 10 AND Log.Port = ElevatorRelay.No
                            LEFT OUTER JOIN Floor ON (Door.Floor = Floor.No AND Floor.Site = Log.Site) OR AuxOutput.Floor = Floor.No  OR AuxInput.Floor = Floor.No 	OR ElevatorRelay.Floor = Floor.No";

                $sql_count = "SELECT COUNT(*) FROM Log
                              JOIN  Host ON IFNULL(Log.ClientMAC, '') = (CASE WHEN Host.No = 1 THEN '' ELSE Host.MAC END) AND (Host.ByAdminId = '".$_SESSION['spider_id']."'  OR Host.ByAdminId = '' OR Host.ByAdminId IS null) ";
            }
		}

        $action	= $this->input->get('action', 'search');

		if ($action == 'preview') {
			$list	= $logdb->prepare("{$sql} {$where} ORDER BY Log.No DESC");
			$list->execute($params);

			$vars = array();
			$vars['list']	= $list;
			$vars['rownum']	= 1;

			set_time_limit(0);
			$this->display($vars, 'access_report_preview', 'none');

		} else if ($action == 'download') {
			$list	= $logdb->prepare("{$sql} {$where} ORDER BY Log.No DESC");
			$list->execute($params);

			$filename   = "access_report_" . date("YmdHis") .".csv";

			set_time_limit(0);
			header("Content-Description: File Transfer");
			header("Content-Type: application/octet-stream");
			header("Content-Disposition: attachment; filename=\"".$filename."\"");
			header("Content-Transfer-Encoding: Binary");
			header("Pragma: no-cache; public");
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
			header("Expires: 0");
    
            if($this->is_option(ConstTable::OPTION_PARTITION)) {
                echo $this->lang->common->datetime
                    .','. $this->lang->common->device_name
                    .','. $this->lang->common->cardholder
                    .','. $this->lang->common->card_no
                    .','. $this->lang->site->Name
                    .','. $this->lang->cfloor->Name
                    ."\n";
            }
            else
            {
               echo $this->lang->common->datetime
                    .','. $this->lang->common->device_name
                    .','. $this->lang->common->cardholder
                    .','. $this->lang->common->card_no
                    .','. $this->lang->cfloor->Name
                    ."\n"; 
            }
            
			$rownum = 1;
            if($this->is_option(ConstTable::OPTION_PARTITION)) {
                while( $row = $list->fetch(PDO::FETCH_ASSOC) ) {
                    echo '"'. date('m-d-Y H:i:s', $row['Date']) . '"'
                        .',"'. $row['DeviceName'] . '"'
                        .',"'. $row['UserName'] . '"'
                        .',"'. ($row['CardNumber'] == NULL ? '' : $row['CardNumber']."(".$this->util->GetCardFacilityCode($row['CardFormatNo']).")") . '"'
                        .',"'. $row['SiteName'] . '"'
                        .',"'. $row['FloorName'] . '"'
                        ."\n";
                }
            }
            else
            {
                while( $row = $list->fetch(PDO::FETCH_ASSOC) ) {
                    echo '"'. date('m-d-Y H:i:s', $row['Date']) . '"'
                        .',"'. $row['DeviceName'] . '"'
                        .',"'. $row['UserName'] . '"'
                        .',"'. ($row['CardNumber'] == NULL ? '' : $row['CardNumber']."(".$this->util->GetCardFacilityCode($row['CardFormatNo']).")") . '"'
                        .',"'. $row['FloorName'] . '"'
                        ."\n";
                }
            }

		} else {
			$page	= $this->input->get('page', 1);

			$count	= $logdb->prepare("{$sql_count} {$where}");
			$count->execute($params);
			$count	= $count->fetchColumn();

			$pagination		= new Pagination();
			$page_config	= $GLOBALS['page_config'];
			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$params[]	= $pagination->offset;
			$params[]	= $pagination->row_size;

			$list	= $logdb->prepare("{$sql} {$where} ORDER BY Log.No DESC LIMIT ?, ?");
			
			$list->execute($params);

			$vars = array();
			$vars['page']	= $page;
			$vars['count']	= $count;
			$vars['list']	= $list;
			$vars['pages']	= $pagination->get_pages();
			$vars['rownum']	= $pagination->offset + 1;

			$this->display($vars, 'access_report_search', false);
		}
	}

	// ----------------------------------------------------------------------------------

   public function door_to_assoc()
	{
		$rows	= array();
        if( $this->is_SuperAdmin() == true )
        {
            $list	= $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable != 1 ORDER BY Name ASC");
        }
        else{
            $list	= $this->conn->prepare("SELECT A.* FROM Door AS A
                                            JOIN Host AS B ON A.HostNo=B.No AND (B.ByAdminId = '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                            WHERE A.Site=? AND A.Disable != 1 ORDER BY Name ASC");
        }
		$list->execute(array( $_SESSION['spider_site'] ));

		while( $row = $list->fetch(PDO::FETCH_ASSOC) )
		{
			$rows[$row['No']]	= $row['Name'];
		}

		return $rows;
	}

	// ----------------------------------------------------------------------------------

   public function elevator_to_assoc()
	{
		$rows	= array();

        if( $this->is_SuperAdmin() == true )
        {
            $list	= $this->conn->prepare("SELECT * FROM Elevator WHERE Site=? AND Disable != 1 ORDER BY Name ASC");
        }
        else{
            $list	= $this->conn->prepare("SELECT A.* FROM Elevator AS A
                                            JOIN Host AS B ON A.HostNo=B.No AND (B.ByAdminId = '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                            WHERE A.Site=? AND A.Disable != 1 ORDER BY Name ASC");
        }
        
		$list->execute(array( $_SESSION['spider_site'] ));

		while( $row = $list->fetch(PDO::FETCH_ASSOC) )
		{
			$rows[$row['No']]	= $row['Name'];
		}

		return $rows;
	}

	// ----------------------------------------------------------------------------------

   public function cardholder_to_assoc()
	{
		$rows	= array();

		$list	= $this->conn->prepare("SELECT * FROM CardHolder WHERE Site=? ORDER BY Name ASC");
		$list->execute(array( $_SESSION['spider_site'] ));

		while( $row = $list->fetch(PDO::FETCH_ASSOC) )
		{
			$rows[$row['No']]	= "{$row['FirstName']} {$row['MiddleName']} {$row['LastName']}";
		}

		return $rows;
	}

	// ----------------------------------------------------------------------------------

   public function acceslevel_to_assoc()
	{
		$rows	= array();

        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM AccessLevel WHERE Site = ? ORDER BY Name ASC");
        }
        else{
            $list  = $this->conn->prepare("SELECT Site, No, Name, Mean, ScheduleNo, SelectType  FROM 
                                           (SELECT Z.* From AccessLevel AS Z
                                                       JOIN Door AS A ON A.No IN (SELECT ReaderNo FROM AccessLevelReader WHERE Site=Z.Site AND AccessLevelNo = Z.No AND Z.SelectType = 1)
                                                       JOIN Host AS B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                       Group By Z.No

                                            UNION	   
                                            SELECT Z.* FROM AccessLevel AS Z
                                                       JOIN GroupTable AS A ON A.No IN (SELECT ReaderNo FROM AccessLevelReader WHERE Site=Z.Site AND AccessLevelNo = Z.No AND Z.SelectType = 2)
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)  
                                                       GROUP BY Z.No  )
                                            WHERE Site = ?
                                            ORDER BY Name ASC");
        }
            
		$list->execute(array( $_SESSION['spider_site'] ));

		while( $row = $list->fetch(PDO::FETCH_ASSOC) )
		{
			$rows[$row['No']]	= $row['Name'];
		}

		return $rows;
	}

    // ----------------------------------------------------------------------------------
}


?>
