<?php

include APP_DIR.'/libraries/EventCode.php';

class alarm_map extends controller
{
	public static $last_floor = 1;
	
   public function index()
    {
        $vars['floor']      = $this->to_array_floor();
        $vars['door']       = json_encode($this->to_array_door('1'));
        $vars['aux_input']  = json_encode($this->to_array_input('1'));
        $vars['aux_output'] = json_encode($this->to_array_output('1'));
		$vars['elevator']   = json_encode($this->to_array_elevator('1'));
		
		$vars['is_localtime_display']        = $this->is_localtime_display();
        $vars['ack']        = $this->Ack();
        $vars['arr_door']   = $this->to_array_door2();
        $vars['arr_aoutput']= $this->to_array_aoutput2();
        $vars['arr_elevator']= $this->to_array_elevator2();

		$vars['log_table_error']	= $this->log->is_error_log_table();
		
        $this->display($vars);
    }

   public function door_ajax()
    {
        $key    = $this->input->get('no');
        
        $result['door'] = $this->to_array_door($key);
        $result['aux_input'] = $this->to_array_input($key);
        $result['aux_output'] = $this->to_array_output($key);
   		$result['elevator'] = $this->to_array_elevator($key);

		setcookie('last_floor', $key);
   		
        echo json_encode($result);
    }

   public function door_control()
    {
    	if( $this->is_auth(1, 24) != TRUE)
    	{
    		$this->util->alert($this->lang->user->error_not_permission, TRUE);
    	}
        $sel_door   = $this->input->post('sel_door');
		$lock_mode  = $this->input->post('lock_mode');

        $door   = $this->conn->prepare("SELECT Name, LockMode, Port FROM Door WHERE Site=? AND No = ? AND Disable=0");
        $door->execute( array($_SESSION['spider_site'], $sel_door) );
        $door   = $door->fetch(PDO::FETCH_ASSOC);

        if( $door['LockMode'] > '0' && $door['LockMode'] < '4' )
        {
            $this->util->alert( $this->lang->menu->error_door_controll );
        }
        else if($door['LockMode'] == '4')
        {
            $this->util->alert( $this->lang->menu->error_door_controll_Mantrap );
        }
        else
        {
			$this->log->set_log_device('door', $lock_mode, '0', $door['Port'], $door['Name']);
            exec(SPIDER_COMM." door $sel_door $lock_mode forced");
        }
    }

   public function aoutputc()
    {
    	if( $this->is_auth(1, 25) != TRUE)
    	{
    		$this->util->alert($this->lang->user->error_not_permission, TRUE);
    	}

        $sel_auxoutput  = $this->input->post('sel_auxoutput');
		$onoff   = $this->input->post('onoff');

        if(substr($sel_auxoutput, 0, 2) == 'E-') {
            $sel_auxoutput = substr($sel_auxoutput, 2);

            $aoutput   = $this->conn->prepare("SELECT Name, Port FROM ElevatorRelay WHERE Site=? AND No = ? AND Disable=0");
            $aoutput->execute( array($_SESSION['spider_site'], $sel_auxoutput) );
            $aoutput   = $aoutput->fetch(PDO::FETCH_ASSOC);

            $this->log->set_log_device('elevator', $onoff, '0', $aoutput['Port'], $aoutput['Name']);
            exec(SPIDER_COMM." elevatorout $sel_auxoutput $onoff");
        } else {
            $aoutput   = $this->conn->prepare("SELECT Name, Port FROM AuxOutput WHERE Site=? AND No = ? AND Disable=0");
            $aoutput->execute( array($_SESSION['spider_site'], $sel_auxoutput) );
            $aoutput   = $aoutput->fetch(PDO::FETCH_ASSOC);

            $this->log->set_log_device('aoutput', $onoff, '0', $aoutput['Port'], $aoutput['Name']);
            exec(SPIDER_COMM." auxout $sel_auxoutput $onoff");
        }
    }
    
   public function to_array_floor()
    {
		$floor	= $this->conn->prepare("SELECT No,Name,ImageFile FROM Floor WHERE Site=? ORDER BY No ASC");
		$floor->execute(array($_SESSION['spider_site']));
		$floor	= $floor->fetchAll(PDO::FETCH_ASSOC);
		
		$floor	= json_encode($floor);

		return $floor;
    }
        
   public function to_array_door($key)
    {
    	$site = $_SESSION['spider_site'];
        //Admin By Controller로 추가 2015.05.19 By Zeno
        $HostUser = '';
        if( $this->is_SuperAdmin() == false )
        {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
        
        $door   = $this->conn->query("SELECT A.No AS No,A.Name,A.Position, A.SlaveReader, A.DoorContactState, 
                                             C.Disable AS DoorRex, 
                                             D.Disable AS DoorLock, E.Disable AS DoorContact, IFNULL(F.RelayOn, 2) AS RelayOn, IFNULL(G.RelayOn, 1) AS LockOn,
											 H.No AS HostNo, H.Alive
                                        FROM Door AS A 
                                        JOIN DoorRex AS C ON A.No=C.No 
                                        JOIN DoorLock AS D ON A.No=D.No 
                                        JOIN DoorContact AS E ON A.No=E.No 
                                        JOIN Host AS H ON A.HostNo=H.No 
							 LEFT OUTER JOIN RelayStatus AS F ON A.No=F.No AND F.Type = 1
							 LEFT OUTER JOIN RelayStatus AS G ON A.No=G.No AND G.Type = 3
                                       WHERE A.Site='".$site."' AND A.Disable='0' AND A.Floor='".$key."' ".$HostUser." ORDER BY A.No");
        $door->execute();
        $door   = $door->fetchAll(PDO::FETCH_ASSOC);
        return $door;
    }
    
   public function to_array_door2()
    {
        if( $this->is_SuperAdmin() == true )
        {
            $data   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable='0'");
        }
        else{
            $data   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                       JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                       WHERE A.Site=? AND A.Disable='0' ");
        }
        
        $data->execute(array($_SESSION['spider_site']));
        $data   = $data->fetchAll(PDO::FETCH_ASSOC);
        
        $arr    = array();
        
        foreach( $data as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }
        

        return $arr;
    }
    
   public function to_array_input($key)
    {
        //Admin By Controller
        $HostUser = '';
        if( $this->is_SuperAdmin() == false )
        {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
        
        $input = $this->conn->prepare("SELECT A.*, H.No AS HostNo, H.Alive
                                        FROM AuxInput AS A
                                        JOIN Host AS H ON A.HostNo=H.No 
                                        WHERE A.Site=? AND A.Floor=? and A.Disable='0'".$HostUser);
                             
        $input->execute(array($_SESSION['spider_site'], $key));
        $input = $input->fetchAll(PDO::FETCH_ASSOC);
        return $input;
    }
    
   public function to_array_output($key)
    {
        //Admin By Controller
        $HostUser = '';
        if( $this->is_SuperAdmin() == false )
        {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
        
        $input = $this->conn->prepare("SELECT A.No, A.Name, A.Position, IFNULL(B.RelayOn, 2) AS RelayOn, H.No AS HostNo, H.Alive
                                        FROM AuxOutput A
                                        JOIN Host AS H ON A.HostNo=H.No 
                                        LEFT OUTER JOIN RelayStatus AS B ON A.No = B.No AND B.Type=2
                                        WHERE A.Site=? AND A.Floor=? and A.Disable='0'".$HostUser);
        $input->execute(array($_SESSION['spider_site'], $key));
        $input = $input->fetchAll(PDO::FETCH_ASSOC);
        return $input;
    }
    
   public function to_array_aoutput2()
    {
        if( $this->is_SuperAdmin() == true )
        {
            $data   = $this->conn->prepare("SELECT * FROM AuxOutput WHERE Site=? AND Disable='0'");
        }
        else{
            $data   = $this->conn->prepare("SELECT A.* FROM AuxOutput AS A 
                                                       JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                       WHERE A.Site=? AND A.Disable='0' ");
        }
        
        
        $data->execute(array($_SESSION['spider_site']));
        $data   = $data->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $data as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }

        return $arr;
    }
    
   public function to_array_elevator($key)
	{
        //Admin By Controller
        $HostUser = '';
        if( $this->is_SuperAdmin() == false )
        {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
        
        $input = $this->conn->prepare("SELECT A.No, A.Name, A.Position, IFNULL(B.RelayOn, 2) AS RelayOn, H.No AS HostNo, H.Alive
                                        FROM ElevatorRelay A
                                        JOIN Host AS H ON A.HostNo=H.No 
                                        LEFT OUTER JOIN RelayStatus AS B ON A.No = B.No AND B.Type=4
                                        WHERE A.Site=? AND A.Floor=? and A.Disable='0'".$HostUser);
		$input->execute(array($_SESSION['spider_site'], $key));
		$input = $input->fetchAll(PDO::FETCH_ASSOC);
		return $input;
	}    

   public function to_array_elevator2()
	{
        if( $this->is_SuperAdmin() == true )
        {
            $input = $this->conn->prepare("SELECT * FROM ElevatorRelay WHERE Site=? AND Disable='0'");
        }
        else{
            $input   = $this->conn->prepare("SELECT A.* FROM ElevatorRelay AS A 
                                                       JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                       WHERE A.Site=? AND A.Disable='0' ");
        }
        
		
		$input->execute(array($_SESSION['spider_site']));
		$input = $input->fetchAll(PDO::FETCH_ASSOC);
		return $input;
	}    
        
   public function to_disconnect_door()
    {
		$key	= $this->input->get('hostno');
        
    	$HostUser = '';
        if( $this->is_SuperAdmin() == false )
        {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
        
        $door   = $this->conn->prepare("SELECT A.*, H.No AS HostNo, H.Alive
                                        FROM Door AS A
                                        JOIN Host AS H ON A.HostNo=H.No AND H.Alive = 0
                                        WHERE A.Site=? AND A.HostNo=? AND A.Disable='0'".$HostUser);
        $door->execute(array($_SESSION['spider_site'], $key));
        $door   = $door->fetchAll(PDO::FETCH_ASSOC);

		$json	= array('list'=>$door);
        echo json_encode($json);
    }
    
   public function to_disconnect_input()
    {
		$key	= $this->input->get('hostno');
        
        $HostUser = '';
        if( $this->is_SuperAdmin() == false )
        {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
        
        $input = $this->conn->prepare("SELECT A.*, H.No AS HostNo, H.Alive
										FROM AuxInput AS A
                                        JOIN Host AS H ON A.HostNo=H.No AND H.Alive = 0
                                        WHERE A.Site=? AND A.HostNo=? and A.Disable='0'".$HostUser);
        $input->execute(array($_SESSION['spider_site'], $key));
        $input = $input->fetchAll(PDO::FETCH_ASSOC);

		$json	= array('list'=>$input);
        echo json_encode($json);
    }
    
   public function to_disconnect_output()
    {
		$key	= $this->input->get('hostno');
        
        $HostUser = '';
        if( $this->is_SuperAdmin() == false )
        {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
        
        $input = $this->conn->prepare("SELECT A.*, H.No AS HostNo, H.Alive
										FROM AuxOutput A
                                        JOIN Host AS H ON A.HostNo=H.No AND H.Alive = 0
                                        WHERE A.Site=? AND A.HostNo=? and A.Disable='0'".$HostUser);
        $input->execute(array($_SESSION['spider_site'], $key));
        $input = $input->fetchAll(PDO::FETCH_ASSOC);

		$json	= array('list'=>$input);
        echo json_encode($json);
    }

   public function update()
    {
        $ea = $this->input->post('ea');
        for($i=1;$i<=$ea;$i++){
            $dd = $this->input->post('D_'.$i);
            $da = explode(":",$dd);
            $door   = $this->conn->query("UPDATE Door SET site='".$da[1]."' where No='".$da[0]."'");
            $door->execute();
        }
    }
    
   public function Ack(){
        if( $this->is_SuperAdmin() == true )
        {
            $ack    = $this->conn_log->prepare("SELECT No, UserName, strftime('%Y-%m-%d %H:%M:%S',datetime(date,'unixepoch','localtime')) as dd FROM Log where Site=?, Ack='1' order by no desc limit 5");		
        }
        else{
			
            $ack    = $this->conn_log->prepare("SELECT Log.No, Log.UserName, strftime('%Y-%m-%d %H:%M:%S',datetime(Log.date,'unixepoch','localtime')) as dd 
                                                FROM Log 
                                                JOIN Host ON IFNULL(Log.ClientMAC, '') = (CASE WHEN Host.No = 1 THEN '' ELSE Host.MAC END) AND (Host.ByAdminId = '".$_SESSION['spider_id']."' OR Host.ByAdminId = '' OR Host.ByAdminId IS null)
                                                WHERE  A.Type <> 7 AND A.Type <> 8  AND (A.Type <> 0 OR A.UserName = '".$_SESSION['spider_id']."')
                                                AND Log.Site=?, Log.Ack='1' order by Log.no desc limit 5");
			
        }
		if($ack != false) {
	        $ack->execute(array($_SESSION['spider_site']));
		    $ack    = $ack->fetchAll(PDO::FETCH_ASSOC);
		}
        
        return $ack;
    }

   public function update_ack()
    {
    	$No = $this->input->post('no');
		$msg    = $this->input->post('ack_msg');

		$arr	= explode(',', $No);
		foreach($arr as $No) {
			//usleep(10000);

			$ack   = $this->conn_log->prepare("UPDATE Log SET Ack='1' WHERE No=?");
			$ack->execute(array($No));

			$this->conn_log->exec("INSERT INTO LogAck (No, AckTime, AckIP, AckUser, AckReason) VALUES ('".$No."', '".time()."', '".$_SERVER['REMOTE_ADDR']."', '".$_SESSION['spider_id']."', '".$msg."')");
		
			$data   = $this->conn_log->prepare("SELECT Type, Port FROM Log WHERE No=?");
			$data->execute(array($No));
			$data   = $data->fetch(PDO::FETCH_ASSOC);
			
			$this->log->set_log_device("alarm_map", "ack", $data['Type'], $data['Port'], NULL, $msg);
		}
    }

    // ----------------------------------------------------------------------------------

   public function is_localtime_display() {
		$count	= $this->conn->prepare("SELECT COUNT(*) FROM Controller");
		$count->execute();
		$count	= $count->fetchColumn();
		if($count <= 1) return FALSE;

		//if($_SESSION['spider_model'] == ConstTable::MODEL_ESSENTIAL) return FALSE;
        
        return TRUE;
    }

    // ----------------------------------------------------------------------------------

    public function livestream() {
        $camera = $this->input->get('camera');
        $stream = $this->input->get('stream');

        $command = "spider-command admin livestream ".$camera." ".$stream;
        exec($command, $output, $result);

        $res = ['result' => $result, 'output' => $output];
        echo json_encode($res);
    }

    // ----------------------------------------------------------------------------------

    public function streamcntrlcgicall() {
        $streamingid = $this->input->get('streamingid');
        $status      = $this->input->get('status');

        $command = "spider-command admin streamctrl ".$streamingid." ".$status;
        // print_r($command);exit;
        exec($command, $output, $result);

        $res = ['result' => $result, 'output' => $output];
        echo json_encode($res);
    }

    // ----------------------------------------------------------------------------------
    public function livestreamplaybackcgicall()
    {
        $channel     = $this->input->get('channel');
        $stream      = $this->input->get('stream');
        $currentTime = $this->input->get('currentTime');

        // playstream == first it was playstream changed to livestream now
        $command = "spider-command admin playstream ".$channel." ".$stream." ".'"'.$currentTime.'"';
        // echo $command;exit();
        exec($command, $output, $result);

        $res = array('result' => $result, 'output' => $output);
        // print_r($res);exit;
        echo json_encode($res);
    }

    // ----------------------------------------------------------------------------------
    public function channellivestream()
    {
        $channel = $this->input->get('channel');
        $stream = $this->input->get('stream');
        
        $command = "spider-command admin livestream ".$channel." ".$stream;
        // echo $command;exit;
        exec($command, $output, $result);

        $res = ['result' => $result, 'output' => $output];
        echo json_encode($res);
    }
    

}