<?php
class alarm_set extends controller
{
   public function index() {
		$vars['floor']	= $this->to_array_floor();
		$vars['door']	= json_encode($this->to_array_door('1'));
		$vars['aux_input'] = json_encode($this->to_array_input('1'));
		$vars['aux_output'] = json_encode($this->to_array_output('1'));
		$vars['elevator'] = json_encode($this->to_array_elevator('1'));
		
		$this->display($vars);
	}

   public function door_ajax() {
		$key	= $this->input->get('No');
		$vars['door']	= $this->to_array_door($key);
		$vars['aux_input'] = $this->to_array_input($key);
		$vars['aux_output'] = $this->to_array_output($key);
		$vars['elevator'] = $this->to_array_elevator($key);		
		echo json_encode($vars);
	}

   public function to_array_floor() {
		$floor	= $this->conn->prepare("SELECT No,Name,ImageFile FROM Floor WHERE Site=? ORDER BY No ASC");
		$floor->execute(array($_SESSION['spider_site']));
		$floor	= $floor->fetchAll(PDO::FETCH_ASSOC);
		
		$floor	= json_encode($floor);

		return $floor;
	}
   public function to_array_door($key) {
        //Admin By Controller로 추가 2015.05.19 By Zeno
        $HostUser = '';
        if( $this->is_SuperAdmin() == false ) {
            $HostUser = " AND (H.ByAdminId = '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null) ";
        }
		$door 	= $this->conn->prepare("SELECT A.No AS No,A.Name,A.Position,A.SlaveReader,C.Disable AS DoorRex,
		                                       D.Disable AS DoorLock,E.Disable AS DoorContact 
										  FROM Door AS A
										  JOIN DoorRex AS C ON A.No=c.No 
										  JOIN DoorLock AS D ON A.No=d.No 
										  JOIN DoorContact AS E ON A.No=e.No 
                                          JOIN Host AS H ON A.HostNo = H.No
 										 WHERE A.Site=? AND A.Disable='0' AND A.Floor=? ".$HostUser." ORDER BY A.No");
                                         
        $door->execute(array($_SESSION['spider_site'], $key));
		$door	= $door->fetchAll(PDO::FETCH_ASSOC);
		return $door;
	}

   public function to_array_input($key) {
        
        if( $this->is_SuperAdmin() == true ) {
            $input = $this->conn->prepare("SELECT * FROM AuxInput WHERE Site=? AND Floor=? AND Disable='0'");
        }
        else {
            $input   = $this->conn->prepare("SELECT A.* FROM AuxInput AS A 
                                                       JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                       WHERE A.Site=? AND A.Floor=? AND A.Disable='0' ");
        }
		
        
		$input->execute(array($_SESSION['spider_site'], $key));
		$input = $input->fetchAll(PDO::FETCH_ASSOC);
		return $input;
	}

   public function to_array_output($key) {
        
        if( $this->is_SuperAdmin() == true ) {
            $input = $this->conn->prepare("SELECT * FROM AuxOutput WHERE Site=? AND Floor=? AND Disable='0'");
        }
        else {
            $input   = $this->conn->prepare("SELECT A.* FROM AuxOutput AS A 
                                                       JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                       WHERE A.Site=? AND A.Floor=? AND A.Disable='0' ");
        }
		
		$input->execute(array($_SESSION['spider_site'], $key));
		$input = $input->fetchAll(PDO::FETCH_ASSOC);
		return $input;
	}

   public function to_array_elevator($key) {
        
        if( $this->is_SuperAdmin() == true ) {
            $input = $this->conn->prepare("SELECT * FROM ElevatorRelay WHERE Site=? AND Floor=? AND Disable='0'");
        }
        else {
            $input   = $this->conn->prepare("SELECT A.* FROM ElevatorRelay AS A 
                                                       JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                       WHERE A.Site=? AND A.Floor=? AND A.Disable='0' ");
        }
        		
		$input->execute(array($_SESSION['spider_site'], $key));
		$input = $input->fetchAll(PDO::FETCH_ASSOC);
		return $input;
	}
	
   public function update() {
		$ea	= $this->input->post('ea');
		for($i=1;$i<=$ea;$i++) {
			$dd = $this->input->post('D_'.$i);
			//echo $dd ."    ::";
			$da = explode(":",$dd);
			
			$pos = explode(" ",$da[2]);
			if ( $pos[0] < 0 )    		$pos[0] = "0";
			if ( $pos[0] > 685-34)    	$pos[0] = 685-34;
			if ( $pos[1] < 0 )    		$pos[1] = "0";
			if ( $pos[1] > 340-42)      $pos[1] = 340-42;
			
			if($da[1] == 'D') {
				$door 	= $this->conn->prepare("UPDATE Door Set Position='".$pos[0]." ".$pos[1]."' WHERE No='".$da[0]."'");
				//$door->execute();
				$door->executeSilent();
			} 
			else if($da[1] == 'I') {
				$door 	= $this->conn->prepare("UPDATE AuxInput set Position='".$pos[0]." ".$pos[1]."' WHERE No='".$da[0]."'");
				//$door->execute();
				$door->executeSilent();
			} 
			else if($da[1] == 'O') {
				$door 	= $this->conn->prepare("UPDATE AuxOutput set Position='".$pos[0]." ".$pos[1]."' WHERE No='".$da[0]."'");
				//$door->execute();
				$door->executeSilent();
			} 
			else if($da[1] == 'E') {
				$door 	= $this->conn->prepare("UPDATE ElevatorRelay set Position='".$pos[0]." ".$pos[1]."' WHERE No='".$da[0]."'");
				//$door->execute();
				$door->executeSilent();
			}
		}

		$this->log->set_log();

		$this->util->alert($this->lang->alram_set->sucss_msg);
        $this->util->js('parent.hide_loading();');
	}
}