<?php


class atlevel extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $this->display();
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field      = $this->input->get('f');
        $word       = $this->input->get('w');
        $page       = $this->input->get('p', 1);

        $page_config  = $GLOBALS['page_config'];
        $pagination   = new Pagination();
        
        $attrThreat   = $this->to_threat_status();
        
        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Threat WHERE Site=?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Threat WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Threat WHERE Site=? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], "%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Threat WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], "%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        foreach( $list as $key=>$val )
        {
        	if ($list[$key]['ThreatStatus'] > 0){
	        	$list[$key]['ThreatStatusStr']    = $attrThreat[$list[0]['ThreatStatus']];
        	}else{
	        	$list[$key]['ThreatStatusStr']    = $this->lang->tlevel->NotSet; 
	        	$list[$key]['ThreatStatus'] = 1;
        	}	
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No             = $this->input->post('No');
        $ThreatStatus   = $this->input->post('ThreatStatus', 0);
  
        $list = $this->conn->prepare("Select ThreatStatus From Threat WHERE Site=? AND No=?");
        $list->execute(array($_SESSION['spider_site'],$No));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);
        
        foreach( $list as $key=>$val)
        {
            $check_value = $val['ThreatStatus'];
        }

        $sth    = $this->conn->prepare("UPDATE Threat SET ThreatStatus =? WHERE Site=? AND No=?");

        $values = array($ThreatStatus,$_SESSION['spider_site'],$No);
        if( $sth->execute($values) )
        {
        	//exec(SPIDER_COMM." send db");
            
            exec(SPIDER_COMM." savethreat");
            $this->log->set_log();
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->reload();
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
    }

    // ----------------------------------------------------------------------------------

   public function to_threat_status() 
    {
        $list = $this->conn->prepare("SELECT * FROM ThreatLevel WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['Level']] = $val['ThreatName'];
        }
        return $arr;
    }
}


?>
