<?php 

class backup extends controller
{
	var $arr_plug       = array('0'=>'Off', '1'=>'On');
	var $arr_device     = array('0'=>'SD/USB', '1'=>'FTP'); 
    
    // ----------------------------------------------------------------------------------
   public function index()
    {
        $this->display();
    }

    // ----------------------------------------------------------------------------------
   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM BackupSchedule WHERE No=1");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM BackupSchedule WHERE No=1 ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM BackupSchedule WHEREE No=1 AND $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM BackupSchedule WHERE No=1 AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
        	$val['BackupName']    = $val['Name'];
            $val['EnableStr']     = $this->arr_plug[$val['Enable']];
            $val['DeviceStr']     = $this->arr_device[$val['Device']];
            $val['BackupTimeStr'] = EnumTable::$attrTimeList[$val['BackupTime']];
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
	// ----------------------------------------------------------------------------------
   public function update()
    {        
    	$Name        = strip_tags($this->input->post('Name'));
    	$Enable      = $this->input->post('Enable', '0');
        $DeviceType      = $this->input->post('DeviceType', '0');
        $BackupTime  = $this->input->post('BackupTime');
        $LastBackup = '0';
        $Result = '0';
        
        $sth     = $this->conn->prepare("UPDATE BackupSchedule SET Name=?,Enable=?,BackupTime=?,Device=?,LastBackup=?,Result=? WHERE No=1");
        $values  = array($Name, $Enable, $BackupTime, $DeviceType,$LastBackup,$Result);
        
        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->redirect("/?c=backup");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }
    
   public function _exec()
    {
		$confirm_pw    = $this->input->post('confirm_pw');
		
		// 用户加密 20190731
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
            
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
                $this->util->redirect("/?c=backup");
				exit;
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));
			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
                $this->util->redirect("/?c=backup");
				exit;
			}
		}

        $sel    = $this->input->post('sel');

		$rt  = "0";
		$msg = $this->lang->common->success_complete_backup;
        if( $sel == 'pc' )
        {
			$output = false;
			exec(SPIDER_COMM." backup pc", $output);
			foreach( $output as $line ) 
            {
				$line = trim($line);
				$line_split = explode(':', $line);
				if( strtolower($line_split[0]) == 'complete' ) {
					$filename = trim($line_split[1]);
				}
			}
			
			if(empty($filename)){
				$filename = 'spider-e-backup_'.date("YmdHis").'.tar.gz';
			}
			
            $filepath = '/tmp/backup-tmp/' . $filename;

            header("Content-Description: File Transfer");
            header("Content-Type: application/octet-stream");
            header("Content-Disposition: attachment; filename=\"".$filename."\"");
            header("Content-Transfer-Encoding: Binary");
            header("Pragma: no-cache; public");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Content-Length: " . filesize($filepath));
            header("Expires: 0");

            readfile($filepath);
            
            unlink($filepath);
            $this->log->set_log();
        }
        elseif( $sel == 'sd' )
        {
            // 명령어 실행 추가
            $rt = exec(SPIDER_COMM." backup sd");
            if ($rt != "0")
            	$msg = $this->lang->common->fail_complete_backup_sd;

			if ($rt == "0")
				$this->log->set_log();
			else
				$this->log->set_log('backup', '_execfail');
			
            $this->util->alert($msg);
			$this->util->redirect("/?c=backup");
        }
        elseif( $sel == 'ftp' )
        {
            // 명령어 실행 추가
            // exec("명령어");            
            $rt = exec(SPIDER_COMM." backup ftp");

            if ($rt == "-1")
            	$msg = $this->lang->common->fail_ftp_disable;
            else if ($rt != "0")
            	$msg = $this->lang->common->fail_complete_backup_ftp;

			if ($rt == "0")
				$this->log->set_log();
			else
				$this->log->set_log('backup', '_execfail');
			
            $this->util->alert($msg);
			$this->util->redirect("/?c=backup");
        }
        
    }

    // ----------------------------------------------------------------------------------
}