<?php


class cam_setup extends controller
{
   public function index()
	{
		$vars['arr_door']         = $this->to_array_door();
		$this->display($vars);
	}
	
   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Camera WHERE Site = ?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Camera WHERE Site = ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Camera WHERE Site = ? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Camera WHERE Site = ? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $arr_door         = $this->to_array_door();

        foreach( $list as $key=>$val )
        {
            $val['CameraTypeStr'] = EnumTable::$attrCameraType[$val['CameraType']];
            $val['DoorStr']       = $arr_door[$val['DoorNo']];
			if(empty($val['ETC1']))	$val['ETC1'] = '0';
			$val['EnablePTZStr']  = EnumTable::$attrYesNo[$val['ETC1']];
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }
	
	// ----------------------------------------------------------------------------------

   public function insert()
	{
		$No = $this->conn->prepare("SELECT MAX(No) from Camera WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No    = $No->fetchColumn() + 1;
        
        $Name  	        = strip_tags(trim($this->input->post('Name')));
        $Description 	= strip_tags($this->input->post('Description'));
        
        $DoorNo 		= $this->input->post('DoorNo');
        $BrowserAddr 	= $this->input->post('BrowserAddr');
        $ControlAddr 	= $this->input->post('ControlAddr');
        $IPPort 		= $this->input->post('IPPort');
        $ID 			= $this->input->post('ID');
        $Password 		= $this->input->post('Password');
        $CameraType 	= $this->input->post('CameraType');
        
        $PanScan 		= $this->input->post('PanScan');
        $Pan 			= $this->input->post('Pan');
        $Tilt 			= $this->input->post('Tilt');
        $PanTilt 		= $this->input->post('PanTilt');
        $Zoom 			= $this->input->post('Zoom');
        $Preset 		= $this->input->post('Preset');
        $Brightness 	= $this->input->post('Brightness');
        $Image 			= $this->input->post('Image');
        $Motion 		= $this->input->post('Motion');
        $AssignPreset 	= $this->input->post('AssignPreset');
        
        $Etc1 			= $this->input->post('ETC1');		// Enable PTZ

        if( empty($Name) )          $this->util->alert( $this->lang->alevel->error_name_required, TRUE );
        if( empty($CameraType) )    $this->util->alert( $this->lang->cam_setup->error_cameratype_required, TRUE );
        if( empty($BrowserAddr) )   $this->util->alert( $this->lang->cam_setup->error_browser_required, TRUE );
        if( empty($ControlAddr) )   $this->util->alert( $this->lang->cam_setup->error_control_required, TRUE );
        if( empty($IPPort) )      	$this->util->alert( $this->lang->cam_setup->error_ipport_required, TRUE );

        $sth    = $this->conn->prepare("INSERT INTO Camera (Site,No,Name,Description,DoorNo,BrowserAddr,ControlAddr,IPPort,ID,Password,CameraType,PanScan,Pan,Tilt,PanTilt,Zoom,Preset,Brightness,Image,Motion,AssignPreset,ETC1) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
        $values = array($_SESSION['spider_site'],$No,$Name,$Description,$DoorNo,$BrowserAddr,$ControlAddr,$IPPort,$ID,$Password,$CameraType,$PanScan,$Pan,$Tilt,$PanTilt,$Zoom,$Preset,$Brightness,$Image,$Motion,$AssignPreset,$Etc1);
        if( $sth->execute($values) )
        {
            $this->log->set_log_message($Name);
            $this->util->js('load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
	}
	
    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No             = $this->input->post('No');
        $Name  	        = strip_tags(trim($this->input->post('Name')));
        $Description 	= strip_tags($this->input->post('Description'));
        $DoorNo 		= $this->input->post('DoorNo');
        $BrowserAddr 	= $this->input->post('BrowserAddr');
        $ControlAddr 	= $this->input->post('ControlAddr');
        $IPPort 		= $this->input->post('IPPort');
        $ID 			= $this->input->post('ID');
        $Password 		= $this->input->post('Password');
        $CameraType 	= $this->input->post('CameraType');
        
        $PanScan 		= $this->input->post('PanScan');
        $Pan 			= $this->input->post('Pan');
        $Tilt 			= $this->input->post('Tilt');
        $PanTilt 		= $this->input->post('PanTilt');
        $Zoom 			= $this->input->post('Zoom');
        $Preset 		= $this->input->post('Preset');
        $Brightness 	= $this->input->post('Brightness');
        $Image 			= $this->input->post('Image');
        $Motion 		= $this->input->post('Motion');
        $AssignPreset 	= $this->input->post('AssignPreset');
        
        $Etc1 			= $this->input->post('ETC1');		// Enable PTZ

        if( empty($Name) )          $this->util->alert( $this->lang->alevel->error_name_required, TRUE );
        if( empty($CameraType) )    $this->util->alert( $this->lang->cam_setup->error_cameratype_required, TRUE );
        if( empty($BrowserAddr) )   $this->util->alert( $this->lang->cam_setup->error_browser_required, TRUE );
        if( empty($ControlAddr) )   $this->util->alert( $this->lang->cam_setup->error_control_required, TRUE );
        if( empty($IPPort) )      	$this->util->alert( $this->lang->cam_setup->error_ipport_required, TRUE );

        $sth    = $this->conn->prepare("UPDATE Camera SET Name=?,Description=?,DoorNo=?,BrowserAddr=?,ControlAddr=?,IPPort=?,ID=?,Password=?,CameraType=?,PanScan=?,Pan=?,Tilt=?,PanTilt=?,Zoom=?,Preset=?,Brightness=?,Image=?,Motion=?,AssignPreset=?,ETC1=? WHERE Site=? AND No=?");

        $values = array($Name,$Description,$DoorNo,$BrowserAddr,$ControlAddr,$IPPort,$ID,$Password,$CameraType,$PanScan,$Pan,$Tilt,$PanTilt,$Zoom,$Preset,$Brightness,$Image,$Motion,$AssignPreset,$Etc1,$_SESSION['spider_site'],$No);
        if( $sth->execute($values) )
        {
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
        $No         = $this->input->get('No');
        $Name       = $this->util->GetRecordName('Camera', $No);

        $camera_del = $this->conn->prepare("DELETE FROM Camera WHERE Site = ? AND No=?");
        if($camera_del->execute(array($_SESSION['spider_site'], $No)) )
        {
            $this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

   public function to_array_door()
    {
        $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? and disable=0");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
    }

}