<?php 
class cam_view extends controller
{
   public function index()
	{
		$vars['view'] = $this->input->GET('view');
		if ( $vars['view'] < 1 || $vars['view'] > 4)
			$vars['view'] = 1;
			
		$vars['arr_camlist']  = $this->cam_list();
		$vars['arr_urllist']  = $this->url_list();
        $vars['arr_urlarray'] = $this->to_array_url();
		$vars['cam']          = $this->camview_info();
		$this->display($vars);
	}
	
   public function cam_list()
	{
		if( $_SESSION['spider_type'] == 'spider' ) {
			$list = $this->conn->prepare("SELECT Camera.* FROM Camera WHERE Camera.Site=? ORDER BY Camera.No DESC");
			$list->execute(array($_SESSION['spider_site']));
		} else {
			$list = $this->conn->prepare("SELECT Camera.* FROM Camera JOIN UserRoleCamera ON UserRoleCamera.CameraNo=Camera.No WHERE Camera.Site=? AND UserRoleCamera.UserRole=? ORDER BY Camera.No DESC");
			$list->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole']));
		}
		$list	= $list->fetchALL(PDO::FETCH_ASSOC);
		
		$arr    = array();
		$arr[0] = 'None';
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
	}
	
   public function url_list()
	{
		//$list = $this->conn->prepare("SELECT No, (BrowserAddr || Image) AS Name FROM Camera WHERE Site=?");
		$list = $this->conn->prepare("SELECT * FROM Camera WHERE Site=?");
		$list->execute(array($_SESSION['spider_site']));
		$list	= $list->fetchALL(PDO::FETCH_ASSOC);
		
		$arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']] = $this->build_url($val);
        }

        return $arr;
	}

   public function build_url($parts)
	{
		$url = 'http://';
		if( !empty($parts['ID']) && $parts['CameraType'] != 'IP Camera' ) {
			if( empty($parts['Password']) ) {
				$url .= $parts['ID'].'@';
			} else {
				$url .= $parts['ID'].':'.$parts['Password'].'@';
			}
		}
		$url .= trim($parts['BrowserAddr'], '/');
		if( !empty($parts['IPPort']) ) {
			$url .= ':'.$parts['IPPort'];
		}
		if( !empty($parts['Motion']) ) {
			$url .= '/'.trim($parts['Motion'], '/');
		}

        if ($parts['CameraType'] == 'IP Camera') {
            $url = sprintf($url, $parts['ID'], $parts['Password']);
        }

		return $url;
	}
	
   public function to_array_url()
    {
		//$url	= $this->conn->prepare("SELECT No, (BrowserAddr || Image) AS Name FROM Camera WHERE Site=?");
		$url	= $this->conn->prepare("SELECT * FROM Camera WHERE Site=?");
		$url->execute(array($_SESSION['spider_site']));
		$url	= $url->fetchAll(PDO::FETCH_ASSOC);
		
        foreach( $url as $key=>$val)
        {
			$url[$key]['Name'] = $this->build_url($val);
		}
		
		$url	= json_encode($url);

		return $url;
    }
	
   public function camview_info()
	{
		$list = $this->conn->prepare("SELECT * FROM CameraView WHERE Site=? AND No=1 ORDER BY No DESC");
		$list->execute(array($_SESSION['spider_site']));
		$list	= $list->fetch(PDO::FETCH_ASSOC);

		return $list;
	}
	
   public function select_cam()
	{
		$No         = $this->input->get('No');
				
		$list = $this->conn->prepare("SELECT * FROM Camera WHERE Site=? AND No=? ORDER BY No DESC");
		$list->execute(array($_SESSION['spider_site'], $No));
		$list	= $list->fetch(PDO::FETCH_ASSOC);
		
		echo json_encode($list);
	}
	
	 // ----------------------------------------------------------------------------------

   public function update()
    {
        $Camera_1       = $this->input->post('Camera_1');
        $Camera_2       = $this->input->post('Camera_2');
        $Camera_3       = $this->input->post('Camera_3');
        $Camera_4       = $this->input->post('Camera_4');
        $Camera_5       = $this->input->post('Camera_5');
        $Camera_6       = $this->input->post('Camera_6');
        $Camera_7       = $this->input->post('Camera_7');
        $Camera_8       = $this->input->post('Camera_8');
        $Camera_9       = $this->input->post('Camera_9');
        $Camera_10      = $this->input->post('Camera_10');
        $Camera_11      = $this->input->post('Camera_11');
        $Camera_12      = $this->input->post('Camera_12');
        $Camera_13      = $this->input->post('Camera_13');
        $Camera_14      = $this->input->post('Camera_14');
        $Camera_15      = $this->input->post('Camera_15');
        $Camera_16      = $this->input->post('Camera_16');
        
        $cam = $this->util->GetRecordCount("CameraView", "WHERE Site=".$_SESSION['spider_site']." AND No=1");
        
        if ($cam < 1)
        {
	        $sth    = $this->conn->prepare("INSERT INTO CameraView (Site,No,Camera_1,Camera_2,Camera_3,Camera_4,Camera_5,Camera_6,Camera_7,Camera_8,Camera_9,Camera_10,Camera_11,Camera_12,Camera_13,Camera_14,Camera_15,Camera_16) VALUES (?,1,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
	        $values = array($_SESSION['spider_site'],$Camera_1,$Camera_2,$Camera_3,$Camera_4,$Camera_5,$Camera_6,$Camera_7,$Camera_8,$Camera_9,$Camera_10,$Camera_11,$Camera_12,$Camera_13,$Camera_14,$Camera_15,$Camera_16);
        }
        else
        {
	        $sth    = $this->conn->prepare("UPDATE CameraView SET Camera_1=?, Camera_2=?, Camera_3=?, Camera_4=?, Camera_5=?, Camera_6=?, Camera_7=?, Camera_8=?, Camera_9=?, Camera_10=?, Camera_11=?, Camera_12=?, Camera_13=?, Camera_14=?, Camera_15=?, Camera_16=? WHERE Site=? AND No=1");
	        $values = array($Camera_1,$Camera_2,$Camera_3,$Camera_4,$Camera_5,$Camera_6,$Camera_7,$Camera_8,$Camera_9,$Camera_10,$Camera_11,$Camera_12,$Camera_13,$Camera_14,$Camera_15,$Camera_16,$_SESSION['spider_site']);
        }
        if( $sth->execute($values) )
        {
            $this->log->set_log();
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->reload();
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
	}
	
	 // ----------------------------------------------------------------------------------

   public function camera_info_for_door()
    {
		$result = array(
			'exists' => false,
			'src' => 'about:blank'
		);

		$No = $this->input->get('door_no');

		$list = $this->conn->prepare("SELECT * FROM Camera WHERE Site=? AND DoorNo=? ORDER BY No DESC");
		$list->execute(array($_SESSION['spider_site'], $No));
		if($camera = $list->fetch(PDO::FETCH_ASSOC)) {
			$result['exists'] = true;
			$result['src'] = $this->build_url($camera);
		}

		echo json_encode($result);
    }

	 // ----------------------------------------------------------------------------------

}


