<?php

include APP_DIR.'/libraries/Uploader.php';

class card_holder extends controller
{
    // ----------------------------------------------------------------------------------
    var $max_field = 0;
    var $max_user = 0;

   public function index()
    {
    	$this->max_field = $this->util->GetLimitCount(ConstTable::MAX_USERDEFINE_1, 
		                                       ConstTable::MAX_USERDEFINE_2, 
                                               ConstTable::MAX_USERDEFINE_3,
                                               ConstTable::MAX_USERDEFINE_4);
        		                               
        $vars['userdefine']  = $this->to_userdefine();
        $vars['arr_threat']  = $this->to_array_threat();
        $vars['arr_webuser'] = array(''=>'None') + $this->to_array_webuser();
		
		if( $this->input->get('wizard') == '1' )	$this->display($vars, '', 'none');
		else								$this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function filter_to_conditions($filters)
	{
		$conditions		= array(
			'where'		=> '',
			'params'	=> array()
		);
		$card_conditions	= array(
			'where'		=> 'WHERE Card.Site = User.Site AND Card.UserNo = User.No',
			'params'	=> array()
		);
		$exists_card_conditions = false;

		$conditions['where']		= 'WHERE User.Site = ?';
		$conditions['params'][]	= $_SESSION['spider_site'];

		if( !empty($filters['firstname']) ) {
			$conditions['where']  .= ' AND User.FirstName LIKE ?';
            //$conditions['params'][] = $this->util->parse_search_string($filters['firstname']) . '%';
            $conditions['params'][] = $this->util->parse_search_string($filters['firstname']);
		}

		if( !empty($filters['lastname']) ) {
			$conditions['where'] .= ' AND User.LastName LIKE ?';
            //$conditions['params'][] = $this->util->parse_search_string($filters['lastname']) . '%';
            $conditions['params'][] = $this->util->parse_search_string($filters['lastname']);
		}

		if( !empty($filters['no']) ) {
			$conditions['where']		.= ' AND User.No LIKE ?';
			$conditions['params'][]	= $this->util->parse_search_string($filters['no']);
		}

		if( !empty($filters['card']) ) {
			$exists_card_conditions = true;
			$card_conditions['where']		.= ' AND Card.CardNo LIKE ?';
			$card_conditions['params'][]	= $this->util->parse_search_string($filters['card']);
		}

        /* 2018.09.28 CJMOON 검색필드 추가 */
        if(!empty($filters['userdefine1']))
        {
            $conditions['where']		.= ' AND User.UserDefine1 LIKE ?';
            $conditions['params'][]	= $this->util->parse_search_string($filters['userdefine1']);
        }

                
        if( !empty($filters['accesslevel']) ) 
        {
			$single_cards = $this->conn->prepare("SELECT CardAccessLevel.CardNo FROM CardAccessLevel INNER JOIN AccessLevel ON AccessLevel.Site = CardAccessLevel.Site AND AccessLevel.No = CardAccessLevel.AccessLevelNo WHERE CardAccessLevel.Site = ? AND AccessLevel.Name LIKE ?");
			$single_cards->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($filters['accesslevel'])));
			$single_cards  = $single_cards->fetchAll(PDO::FETCH_COLUMN);

			$group_cards = $this->conn->prepare("SELECT CardAccessLevel.CardNo FROM CardAccessLevel INNER JOIN GroupTable ON GroupTable.Site = CardAccessLevel.Site AND GroupTable.No = CardAccessLevel.AccessLevelNo WHERE CardAccessLevel.Site = ? AND GroupTable.Name LIKE ?");
			$group_cards->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($filters['accesslevel'])));
			$group_cards  = $group_cards->fetchAll(PDO::FETCH_COLUMN);

			$cards	= array_merge($single_cards, $group_cards);

			if( count($cards) > 0 ) {
				$exists_card_conditions = true;
				$card_conditions['where']		.= " AND Card.No IN (". implode(',', $cards) .")";
			} else {
				$exists_card_conditions = true;
				$card_conditions['where']		.= " AND 1 = 0";
			}
        }
        
		if( $exists_card_conditions ) {
			$conditions['where']		.= " AND (SELECT COUNT(*) FROM Card {$card_conditions['where']}) > 0";
			foreach( $card_conditions['params'] as $index=>$value ) {
				$conditions['params'][]	= $value;
			}
		}

		return $conditions;
	}

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $unlimited  = $this->input->get('unlimited', 0);
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        // yhoh 20210322
        $sort   = $this->input->get('s'); 
        $order  = $this->input->get('o'); 
        if ($sort == 1)
        {
            if ($order == 1)
                $orderby = " ORDER BY User.FirstName DESC, User.LastName DESC";
            else // default
                $orderby = " ORDER BY User.FirstName, User.LastName";
        }
        else if ($sort == 2)
        {
            if ($order == 1)
                $orderby = " ORDER BY User.LastName DESC, User.FirstName DESC";
            else // default
                $orderby = " ORDER BY User.LastName, User.FirstName";
        }
        else // default
        {
            if ($order == 1)
                $orderby = " ORDER BY User.No";
            else // default
                $orderby = " ORDER BY User.No DESC";
        }

        $filters	= array();
		$filters['firstname']	= $this->input->get('filter_firstname');
		$filters['lastname']	= $this->input->get('filter_lastname');
		$filters['no']			= $this->input->get('filter_no');
		$filters['card']		= $this->input->get('filter_card');
		$filters['accesslevel']	= $this->input->get('filter_accesslevel');
        $filters['userdefine1']	= $this->input->get('filter_userdefine1');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();
		$conditions		= $this->filter_to_conditions($filters);

		$count  = $this->conn->prepare(
			"SELECT COUNT(User.No)" .
			"	FROM User" .
			"	{$conditions['where']}"
		);
		$count->execute($conditions['params']);
		$count  = $count->fetchColumn();

		$page_config['current_page']    = $page;
		$page_config['total_row']       = $count;
		$pagination->init($page_config);

		//echo "/*\n{$conditions['where']}\n*/\n";
		//echo "/*\n";
		//var_dump($conditions['params']);
		//echo "\n*/\n";
		$conditions['params'][]	= $pagination->offset;
		$conditions['params'][]	= $pagination->row_size;

		$list   = $this->conn->prepare(
			"SELECT User.*" .
			"	FROM User" .
            "	{$conditions['where']}" .
        	$orderby .
			"	LIMIT ?, ?"
		);
		$list->execute($conditions['params']);
		$list   = $list->fetchAll(PDO::FETCH_ASSOC);

/*
        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM User WHERE Site=?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();
            
            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);
            
            $list   = $this->conn->prepare("SELECT * FROM User WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));

            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
		else if($field == 'User.No')
		{
			$count  = $this->conn->prepare("SELECT COUNT(*) FROM User WHERE Site=? AND $field = ?");
	        $count->execute(array($_SESSION['spider_site'], $word));
            $count  = $count->fetchColumn();
            
            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND $field = ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $word, $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
		}
        else
        {
			$count  = $this->conn->prepare("SELECT COUNT(*) FROM User WHERE Site=? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], "%$word%"));
            $count  = $count->fetchColumn();
            
            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], "%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
*/
        $arr_threat  = array(''=>'None') + $this->to_array_threat();
        $arr_webuser = array(''=>'None') + $this->to_array_webuser();

        foreach( $list as $key=>$val )
        {
        	$val['No2']             = $val['No'];
            $val['AdaName']         = EnumTable::$attrADA[$val['Ada']];
            $val['ExemptName']      = EnumTable::$attrExempt[$val['Exempt']];
            $val['WEBLevelName']    = $this->get_webuser_str($val['WEBLevel']);
            $val['ThreatLevelName'] = $arr_threat[$val['ThreatLevel']];
            $val['ImageURL']        = empty($val['ImageFile']) ? '' : USER_IMG.'/'.$val['ImageFile'];
            $val['Name']            = $val['FirstName']." ".$val['LastName'];;
            $val['CardList']        = $this->get_cardlist_str($val['No']);
            $val['AccessLevelList'] = $this->get_accesslevellist_str($val['No']);
            $list[$key] = $val;
        }

        $result['field']   = $field;
        $result['word']    = $word;
        $result['page']    = $page=="" ? 1 : $page;
        $result['view']    = $view;
        $result['pages']   = $pagination->get_pages();
        $result['rowsize'] = $pagination->row_size;
        $result['count']   = $count;
        $result['list']    = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function insert()
    {
		/*
    	$this->max_user  = $this->util->GetLimitCount(ConstTable::MAX_USER_1, 
		                                       ConstTable::MAX_USER_2, 
        		                               ConstTable::MAX_USER_3);
		*/
		$this->max_user	= EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][2];
    	
    	if ($this->max_user <= $this->util->GetRecordCount('User'))
    	{
    		$this->util->alert($this->lang->addmsg->error_limit_over_user);
    		$this->util->js('parent.parent.hide_loading();');
        	exit;
    	}
    	
		$No  = $this->conn->prepare("SELECT IFNULL(MAX(IFNULL(No, 0))+1, 1) FROM User WHERE Site=?");
		$No->execute(array($_SESSION['spider_site']));
		$No  = $No->fetchColumn();    	
    	
        //$No           = $this->input->post('No');
        $ID           = $this->input->post('ID');
        $Password     = $this->input->post('Password');
        $FirstName    = strip_tags(trim($this->input->post('FirstName')));
        $MiddleName   = strip_tags(trim($this->input->post('MiddleName')));
        $LastName     = strip_tags(trim($this->input->post('LastName')));
        $Phone        = strip_tags($this->input->post('Phone'));
        $PhoneExt     = strip_tags($this->input->post('PhoneExt'));
        $CellPhone    = strip_tags($this->input->post('CellPhone'));
        $Email        = strip_tags($this->input->post('Email'));
        $ImageFile    = $this->input->post('ImageFile');
        $Ada          = $this->input->post('Ada');
        if ($Ada != "1")
            $Ada = "0";
        $ThreatLevel  = $this->input->post('ThreatLevel');
		if (empty($ThreatLevel))
			$ThreatLevel = 1;
        $WEBLevel     = $this->input->post('WEBLevel');
        $Date         = $this->input->post('Date'); 

        $UserDefine1  = strip_tags($this->input->post('UserDefine1'));
        $UserDefine2  = strip_tags($this->input->post('UserDefine2'));
        $UserDefine3  = strip_tags($this->input->post('UserDefine3'));
        $UserDefine4  = strip_tags($this->input->post('UserDefine4'));
        $UserDefine5  = strip_tags($this->input->post('UserDefine5'));
        $UserDefine6  = strip_tags($this->input->post('UserDefine6'));
        $UserDefine7  = strip_tags($this->input->post('UserDefine7'));
        $UserDefine8  = strip_tags($this->input->post('UserDefine8'));
        $UserDefine9  = strip_tags($this->input->post('UserDefine9'));
        $UserDefine10 = strip_tags($this->input->post('UserDefine10'));
        $UserDefine11 = strip_tags($this->input->post('UserDefine11'));
        $UserDefine12 = strip_tags($this->input->post('UserDefine12'));
        $UserDefine13 = strip_tags($this->input->post('UserDefine13'));
        $UserDefine14 = strip_tags($this->input->post('UserDefine14'));
        $UserDefine15 = strip_tags($this->input->post('UserDefine15'));
        $UserDefine16 = strip_tags($this->input->post('UserDefine16'));
        $UserDefine17 = strip_tags($this->input->post('UserDefine17'));
        $UserDefine18 = strip_tags($this->input->post('UserDefine18'));
        $UserDefine19 = strip_tags($this->input->post('UserDefine19'));
        $UserDefine20 = strip_tags($this->input->post('UserDefine20'));
    
    	if( empty($No) )
        {
        	$this->util->alert( $this->lang->addmsg->error_no_required);
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        /*
        if( empty($FirstName) )     
        {
        	$this->util->alert( $this->lang->user->error_f_name_required );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        */
        if( empty($LastName) )      
        {
        	$this->util->alert( $this->lang->user->error_l_name_required );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        /*if( empty($Phone) )         
        {
        	$this->util->alert( $this->lang->user->error_phone_required );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        */
        // yhoh 20210218
        $Email = trim($Email);
        if( !empty($Email) && !filter_var($Email, FILTER_VALIDATE_EMAIL) )      
        {
        	$this->util->alert( "Invalid Email Format" );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }

        if( (($_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE || 
			  $_SESSION['spider_model'] == ConstTable::MODEL_GIANT)) && empty($ThreatLevel) )   
        {
	        $this->util->alert( $this->lang->user->error_T_level_required );
	        $this->util->js('parent.parent.hide_loading();', TRUE, TRUE);
	        exit;
	    }
        //if(!empty($WEBLevel) && $this->check_webuser($WEBLevel) )   $this->util->alert( $this->lang->user->error_web_level_duplicate, TRUE );


        
        if($_FILES['upload_file']['name'] == "" && $SnapShotFile != "")
        {
            $ImageFile = $SnapShotFile;
        }
        else
        {
            $ImageFile = $this->receive($No);//null
        }
        

        if( $ImageFile === FALSE )
        {
            $this->util->js('parent.parent.hide_loading();');
            exit;
        }

        $sth = $this->conn->prepare("INSERT INTO User (Site,No,ID,Password,FirstName,Middlename,LastName,Phone,PhoneExt,CellPhone,Email,ImageFile,Ada,ThreatLevel,WEBLevel,Date,UserDefine1,UserDefine2,UserDefine3,UserDefine4,UserDefine5,UserDefine6,UserDefine7,UserDefine8,UserDefine9,UserDefine10,UserDefine11,UserDefine12,UserDefine13,UserDefine14,UserDefine15,UserDefine16,UserDefine17,UserDefine18,UserDefine19,UserDefine20) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");

        $values = array($_SESSION['spider_site'],$No,$ID,$Password,$FirstName,$MiddleName,$LastName,$Phone,$PhoneExt,$CellPhone,$Email,$ImageFile,$Ada,$ThreatLevel,$WEBLevel,$Date,$UserDefine1,$UserDefine2,$UserDefine3,$UserDefine4,$UserDefine5,$UserDefine6,$UserDefine7,$UserDefine8,$UserDefine9,$UserDefine10,$UserDefine11,$UserDefine12,$UserDefine13,$UserDefine14,$UserDefine15,$UserDefine16,$UserDefine17,$UserDefine18,$UserDefine19,$UserDefine20);
        if( $sth->execute($values) )
        {
        	 $this->log->set_log_message($FirstName .' '. $LastName);
             //exec(SPIDER_COMM." send db");
             
           	 $this->util->js("parent.parent.$('#form_search').trigger('reset'); parent.$('#form_search').trigger('reset');");
             $this->util->js("parent.parent.load_list('', '', '', '{$No}');");
             //$this->util->js('parent.parent.load_list_edit_search("'.$No.'");'); 
             $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
      	$this->util->js('parent.parent.hide_loading();');
      	$this->util->js('parent.hide_loading();');
    }

    // ----------------------------------------------------------------------------------

   public function insert_flash_data($UserNo)
    {
        $cards  = $this->util->getFlashData('cards');

        $No = $this->conn->prepare("SELECT MAX(No) FROM Card WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No = $No->fetchColumn() + 1;

        foreach( $cards as $card ) {

            $sth    = $this->conn->prepare("INSERT INTO Card (Site,No,CardNo,CardFormatNo,CardStatus,KeyNumber,SelectType,NeverExpire,Reason,ActDate,ExpDate,UserNo,ReaderNo,CardType) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $values = array($_SESSION['spider_site'],$No,$card['CardNo'],$card['CardFormatNo'],$card['CardStatus'],$card['KeyNumber'],$card['SelectType'],$card['NeverExpire'],$card['Reason'],$card['ActDate'],$card['ExpDate'],$UserNo,$card['ReaderNo'],$card['CardType']);
            
            if( $sth->execute($values) )
            {
                $Name = $this->util->GetCardName($No);
				/*
                2018.10.29 : wtkim
                버그내용 : 로그 이벤트 2번 발생->불필요한 로그가 생성 됨.
                수정내용 : 해당 구문 제거 함.
                */
                //$this->log->set_log('card', 'insrt', $Name); 2018.12.03 CJMOON Bug Fix

                $CALNo = $this->conn->prepare("SELECT MAX(No) FROM CardAccessLevel WHERE Site=?");
                $CALNo->execute(array($_SESSION['spider_site']));
                $CALNo  = $CALNo->fetchColumn() + 1;
                $sth    = $this->conn->prepare("INSERT INTO CardAccessLevel (Site,No,CardNo,AccessLevelNo) VALUES (?,?,?,?)");
                
                foreach( $card['AccessLevel'] as $value )
                {
                    $sth->execute( array($_SESSION['spider_site'], $CALNo, $No, $value) );
                    $CALNo = $CALNo + 1;
                }
            }

            $No++;

        }
        
        $this->util->setFlashData('cards', array());
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No           = $this->input->post('No');
        $ID           = $this->input->post('ID');
        $Password     = $this->input->post('Password');
        $FirstName    = strip_tags(trim($this->input->post('FirstName')));
        $MiddleName   = strip_tags(trim($this->input->post('MiddleName')));
        $LastName     = strip_tags(trim($this->input->post('LastName')));
        $Phone        = strip_tags($this->input->post('Phone'));
        $PhoneExt     = strip_tags($this->input->post('PhoneExt'));
        $CellPhone    = strip_tags($this->input->post('CellPhone'));
        $Email        = strip_tags($this->input->post('Email'));
        $ImageFile    = $this->input->post('ImageFile');

        $SnapShotFile = $this->input->post('SnapShotFile');
        
        $Ada          = $this->input->post('Ada');
        if ($Ada != "1")
            $Ada = "0";
        $Exempt       = $this->input->post('Exempt');
        if ($Exempt != "1")
            $Exempt = "0";
		
        $ThreatLevel  = $this->input->post('ThreatLevel');
		if (empty($ThreatLevel))
			$ThreatLevel = 1;
        $WEBLevel     = $this->input->post('WEBLevel');
        $Date         = $this->input->post('Date');

        $UserDefine1  = strip_tags($this->input->post('UserDefine1'));
        $UserDefine2  = strip_tags($this->input->post('UserDefine2'));
        $UserDefine3  = strip_tags($this->input->post('UserDefine3'));
        $UserDefine4  = strip_tags($this->input->post('UserDefine4'));
        $UserDefine5  = strip_tags($this->input->post('UserDefine5'));
        $UserDefine6  = strip_tags($this->input->post('UserDefine6'));
        $UserDefine7  = strip_tags($this->input->post('UserDefine7'));
        $UserDefine8  = strip_tags($this->input->post('UserDefine8'));
        $UserDefine9  = strip_tags($this->input->post('UserDefine9'));
        $UserDefine10 = strip_tags($this->input->post('UserDefine10'));
        $UserDefine11 = strip_tags($this->input->post('UserDefine11'));
        $UserDefine12 = strip_tags($this->input->post('UserDefine12'));
        $UserDefine13 = strip_tags($this->input->post('UserDefine13'));
        $UserDefine14 = strip_tags($this->input->post('UserDefine14'));
        $UserDefine15 = strip_tags($this->input->post('UserDefine15'));
        $UserDefine16 = strip_tags($this->input->post('UserDefine16'));
        $UserDefine17 = strip_tags($this->input->post('UserDefine17'));
        $UserDefine18 = strip_tags($this->input->post('UserDefine18'));
        $UserDefine19 = strip_tags($this->input->post('UserDefine19'));
        $UserDefine20 = strip_tags($this->input->post('UserDefine20'));

    	if( empty($No) )
        {
        	$this->util->alert( $this->lang->addmsg->error_no_required );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        /*
		if( empty($FirstName) )     
        {
        	$this->util->alert( $this->lang->user->error_f_name_required );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        */
        if( empty($LastName) )      
        {
        	$this->util->alert( $this->lang->user->error_l_name_required );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        /*if( empty($Phone) )         
        {
        	$this->util->alert( $this->lang->user->error_phone_required );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }
        */
        // yhoh 20210218
        $Email = trim($Email);
        if( !empty($Email) && !filter_var($Email, FILTER_VALIDATE_EMAIL) )      
        {
        	$this->util->alert( "Invalid Email Format" );
        	$this->util->js('parent.parent.hide_loading();');
        	exit;
        }

        if( ($_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE || 
			 $_SESSION['spider_model'] == ConstTable::MODEL_GIANT) && empty($ThreatLevel))
        {
	        $this->util->alert( $this->lang->user->error_T_level_required );
	        $this->util->js('parent.parent.hide_loading();');
	        exit;
	    }
        //if(!empty($WEBLevel) && $this->check_webuser($WEBLevel, $No) )  $this->util->alert( $this->lang->user->error_web_level_duplicate, TRUE );

        $User   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND No=?");
        $User->execute(array($_SESSION['spider_site'], $No));
        $User   = $User->fetch(PDO::FETCH_ASSOC);

		if($_FILES['upload_file']['name'] == "" && $SnapShotFile != "")
			$ImageFile = $SnapShotFile;
		else
			$ImageFile = $this->receive($No);
			
        if( $ImageFile === FALSE )
        {
            $this->util->js('parent.parent.hide_loading();');
            exit;
        }
        
        if( empty($ImageFile) ) $ImageFile = $User['ImageFile'];
        if( !empty($User['ImageFile']) && $User['ImageFile'] != $ImageFile )
        {
            unlink(USER_IMG.'/'.$User['ImageFile']);
        }

        $sth = $this->conn->prepare("UPDATE User SET ID=?,Password=?,FirstName=?,MiddleName=?,LastName=?,Phone=?,PhoneExt=?,CellPhone=?,Email=?,ImageFile=?,Ada=?,Exempt=?,ThreatLevel=?,WEBLevel=?,Date=?,UserDefine1=?,UserDefine2=?,UserDefine3=?,UserDefine4=?,UserDefine5=?,UserDefine6=?,UserDefine7=?,UserDefine8=?,UserDefine9=?,UserDefine10=?,UserDefine11=?,UserDefine12=?,UserDefine13=?,UserDefine14=?,UserDefine15=?,UserDefine16=?,UserDefine17=?,UserDefine18=?,UserDefine19=?,UserDefine20=? WHERE Site=? AND No=?");

        $values = array($ID,$Password,$FirstName,$MiddleName,$LastName,$Phone,$PhoneExt,$CellPhone,$Email,$ImageFile,$Ada,$Exempt,$ThreatLevel,$WEBLevel,$Date,$UserDefine1,$UserDefine2,$UserDefine3,$UserDefine4,$UserDefine5,$UserDefine6,$UserDefine7,$UserDefine8,$UserDefine9,$UserDefine10,$UserDefine11,$UserDefine12,$UserDefine13,$UserDefine14,$UserDefine15,$UserDefine16,$UserDefine17,$UserDefine18,$UserDefine19,$UserDefine20,$_SESSION['spider_site'], $No);
        if( $sth->execute($values) )
        {
            $this->log->set_log_message($FirstName .' '. $LastName);
            //exec(SPIDER_COMM." send db");
            
            $this->util->js("parent.parent.$('#form_search').trigger('reset');");
            $this->util->js('parent.parent.update_list("'.$No.'");'); 
            //$this->util->js('parent.parent.load_list_edit_search("'.$No.'");'); 
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
        $this->util->js('parent.parent.hide_loading();');
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
        $No     = $this->input->get('no');
        $Name   = $this->util->GetCardHolderName($No);
        
        $delImage = $this->conn->prepare("SELECT ImageFile FROM User WHERE Site=? AND No=?");
        $delImage->execute(array($_SESSION['spider_site'], $No));
        $delImage = $delImage->fetchColumn();
        
        if( !empty($delImage) )
        {
            unlink(USER_IMG.'/'.$delImage);
        }

        $User   = $this->conn->prepare("DELETE FROM User WHERE Site=? AND No=?");
        
        if( $User->execute(array($_SESSION['spider_site'], $No)) )
        {
			//CJMOON BUG
	        //$acc_del   = $this->conn->prepare("DELETE FROM CardAccessLevel WHERE Site=? AND No In (SELECT A.No FROM CardAccessLevel A, Card B WHERE A.CardNo=B.No AND B.UserNo = ?)");
			$acc_del   = $this->conn->prepare("DELETE FROM CardAccessLevel WHERE Site=? AND rowid In (SELECT A.rowid FROM CardAccessLevel A, Card B WHERE A.CardNo=B.No AND B.UserNo = ?)");
			
	        if ($acc_del->execute(array($_SESSION['spider_site'], $No)))			
	        {
	        	$card_del = $this->conn->query("DELETE FROM Card WHERE Site=? AND UserNo=?");
	            $card_del->execute(array($_SESSION['spider_site'], $No));
	        }
	        else
	        {
	        	$this->util->alert($this->lang->common->error_delete);
	        }
            
			$group_del = $this->conn->query("DELETE FROM GroupElement WHERE Site=? AND GroupKind=? AND ElementNo=?");
			$group_del->execute(array($_SESSION['spider_site'], ConstTable::GROUP_USER, $No));

            $this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->delete_completed );
            //exec(SPIDER_COMM." send db");
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete_all()
    {
        $list = $this->conn->prepare("SELECT * FROM User WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
		while($row = $list->fetch(PDO::FETCH_ASSOC)) {
			if( !empty($row['ImageFile']) ) {
				unlink(USER_IMG.'/'.$row['ImageFile']);
			}
		}

		$User   = $this->conn->prepare("DELETE FROM User WHERE Site=?");
		$User->execute(array($_SESSION['spider_site']));

		$CardAccessLevel   = $this->conn->prepare("DELETE FROM CardAccessLevel WHERE Site=?");
		$CardAccessLevel->execute(array($_SESSION['spider_site']));

		$Card   = $this->conn->prepare("DELETE FROM Card WHERE Site=?");
		$Card->execute(array($_SESSION['spider_site']));

		$this->log->set_log();
        $this->util->alert( $this->lang->common->delete_completed );
		//exec(SPIDER_COMM." send db");
    }

    // ----------------------------------------------------------------------------------

   public function delete_image()
    {
        $No     = $this->input->get('no');
                
        $delImage = $this->conn->prepare("SELECT ImageFile FROM User WHERE Site=? AND No=?");
        $delImage->execute(array($_SESSION['spider_site'], $No));
        $delImage = $delImage->fetchColumn();
        
        if( !empty($delImage) )
        {
            @unlink(USER_IMG.'/'.$delImage);
        }

        $User   = $this->conn->prepare("UPDATE User SET ImageFile='' WHERE Site=? AND No=?");
        
        if( $User->execute(array($_SESSION['spider_site'], $No)) )
        {
            //exec(SPIDER_COMM." send db");
            $this->util->js('update_list("'.$No.'")');
        }
        else
        {
            //$this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

   public function receive($No)
    {
        if( !is_uploaded_file($_FILES['upload_file']['tmp_name']) ) return "";

        $uploader                   = new Uploader();
		$sub_dir					= ($No > 10000 ? (($No - 1) - (($No - 1) % 10000)) : '');
        $uploader->upload_dir       = ($sub_dir == '' ? USER_IMG : USER_IMG .'/'. $sub_dir);

        if( $uploader->do_upload('upload_file', 1024000) )
        {
            return ($sub_dir == '' ? $uploader->save_file['basename'] : $sub_dir . '/' . $uploader->save_file['basename']);
        }
        else
        {
            $this->util->alert($this->lang->addmsg->error_upload);	//$this->util->alert( "Image File Upload Error : ".$uploader->get_errors() );
            return FALSE;
        }
    }

    // ----------------------------------------------------------------------------------

   public function to_array_threat()
    {
        $list = $this->conn->prepare("SELECT * FROM ThreatLevel WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['Level']] = $val['ThreatName'];
        }
        return $arr;
    }

   public function to_userdefine()
    {
        $list   = $this->conn->prepare("SELECT * FROM UserDefined WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        //$result = json_encode($list);

        return $list[0];
    }

   public function get_webuser_str($no)
    {
        $list   = $this->conn->prepare("SELECT WebUser.*, UserRole.Name AS UserRoleName FROM WebUser JOIN UserRole ON UserRole.No=WebUser.UserRole WHERE WebUser.Site=? AND WebUser.No=?");
        $list->execute(array($_SESSION['spider_site'],$no));
        $list   = $list->fetch(PDO::FETCH_ASSOC);

        if( empty($list) )  return '';
        //else                return '['. $list['No'] .'] '. $list['Name'];
        else                return '['. $list['UserRoleName'].'] '. $list['Name'];
    }

   public function to_array_webuser()
    {
        $list   = $this->conn->prepare("SELECT WebUser.*, UserRole.Name AS UserRoleName FROM WebUser JOIN UserRole ON UserRole.No=WebUser.UserRole WHERE WebUser.Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        
        foreach( $list as $key=>$val)
        {
            //$arr[$val['No']]    = '['. $val['Type'] .'] '. $val['Name'];
            $arr[$val['No']]    = '['. $val['UserRoleName'] .'] '. $val['Name'];
        }
        return $arr;
    }

   public function check_webuser($level, $no=NULL)
    {
        if( empty($no) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM User WHERE Site=? AND WEBLevel=?");
            $count->execute(array($_SESSION['spider_site'], $level));
            $count  = $count->fetchColumn();
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM User WHERE Site=? AND No=? AND WEBLevel=?");
            $count->execute(array($_SESSION['spider_site'], $no, $level));
            $count  = $count->fetchColumn();
        }

        return ($count > 0 ? true : false);
    }
    
   public function get_cardlist_str($no)
    {
    	$list   = $this->conn->prepare("SELECT CardNo, CardFormatNo FROM Card WHERE Site=? AND UserNo=?");
        $list->execute(array($_SESSION['spider_site'], $no));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $liststr = "";
        foreach( $list as $key=>$val)
        {
        	if ($liststr != "")
        		$liststr = $liststr.", ";
        	$liststr = ($liststr.$val['CardNo'] == NULL ? '' : $liststr.$val['CardNo']."(".$this->util->GetCardFacilityCode($val['CardFormatNo']).")");
        }
        return $liststr;    	
    }
    
   public function get_accesslevellist_str($no)
    {
		$list   = $this->conn->prepare("SELECT * FROM Card WHERE Site=? AND UserNo=?");
		$list->execute(array($_SESSION['spider_site'], $no));
		$list   = $list->fetchAll(PDO::FETCH_ASSOC);

		$liststr = array();
        foreach( $list as $key=>$val)
        {
            $access = $val['SelectType'] == '2' ? $this->get_groupaccess_str($val['No']) : $this->get_access_str($val['No']);
			foreach( $access as $access_name )
			{
				if( !in_array($access_name, $liststr) )
					$liststr[] = $access_name;
			}
        }

		$result = array_unique($liststr);
		return implode(',', $liststr);
		/*
    	$list   = $this->conn->prepare("SELECT DISTINCT A.AccessLevelNo, B.Name FROM CardAccessLevel A, AccessLevel B WHERE A.Site=? AND A.CardNo IN (SELECT No FROM Card WHERE Site=? AND UserNo=?) AND B.Site=? AND A.AccessLevelNo = B.No");
        $list->execute(array($_SESSION['spider_site'], $_SESSION['spider_site'], $no, $_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $liststr = "";
        foreach( $list as $key=>$val)
        {
        	if ($liststr != "")
        		$liststr = $liststr.", ";
        		
        	$liststr = $liststr.$val['Name'];
        }
        return $liststr;    	
        
    	
    	return "";
		*/
    }    

    // ----------------------------------------------------------------------------------

   public function get_groupaccess_str($No)
    {
        $arr    = array();

        $list   = $this->conn->prepare("SELECT * FROM CardAccessLevel WHERE Site=? AND CardNo = ?");
        $list->execute(array($_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        foreach( $list as $val )
        {
            $arr[]  = $val['AccessLevelNo'];
        }
        $arr_str    = implode(',', $arr);

        $arr    = array();
        $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND No IN ($arr_str)");
        $list->execute(array($_SESSION['spider_site'],ConstTable::GROUP_ACCESS_LEVEL));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        foreach( $list as $val )
        {
            $arr[]  = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function get_access_str($No)
    {
        $arr    = array();

        $list   = $this->conn->prepare("SELECT * FROM CardAccessLevel WHERE Site=? AND CardNo = ?");
        $list->execute(array($_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        foreach( $list as $val )
        {
            $arr[]  = $val['AccessLevelNo'];
        }
        $arr_str    = implode(',', $arr);

        $arr    = array();
        $list   = $this->conn->prepare("SELECT * FROM AccessLevel WHERE Site=? AND No IN ($arr_str)");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        foreach( $list as $val )
        {
            $arr[]  = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function check_max_count()
	{
		$this->max_user	= EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][2];
    	
    	if ($this->max_user <= $this->util->GetRecordCount('User'))
    	{
			//$this->util->js('close_new();');
    		$this->util->alert($this->lang->addmsg->error_limit_over_user);
    	} else {
			$this->util->js('open_new();');
		}
	}

    // ----------------------------------------------------------------------------------

    public function preview()
	{
		$vars	= array();

		$filters	= array();
		$filters['firstname']	= $this->input->get('filter_firstname');
		$filters['lastname']	= $this->input->get('filter_lastname');
		$filters['no']			= $this->input->get('filter_no');
		$filters['card']		= $this->input->get('filter_card');
		$filters['accesslevel']	= $this->input->get('filter_accesslevel');
        $filters['userdefine1']	= $this->input->get('filter_userdefine1');

		$conditions		= $this->filter_to_conditions($filters);

		$list   = $this->conn->prepare(
			"SELECT User.*" .
			"	FROM User" .
			"	{$conditions['where']}" .
			"	ORDER BY User.No DESC"
		);
		$list->execute($conditions['params']);

		$vars['list']			= $list;

		$this->display($vars, 'card_holder_preview', 'none');
    }
    
    public function credential()
	{
        //모바일
        //$count  = $this->conn->prepare("select no from cardformat where Name='Mobile Credential Dummy' AND Mean='Dummy Format' AND TotalBitLength=36 AND FacilityCode=1");
        //$count  = $this->conn->prepare("select no from cardformat where TotalBitLength=36 AND FacilityCode=231");
		$count  = $this->conn->prepare("select no from cardformat where Name='Mobile Credential 36 bit'"); // yhoh 20201124
		$count->execute();
		$count  = $count->fetchColumn();

        $list   = $this->conn->prepare("select a.* from user as a, card as b where b.UserNo = a.No AND b.CardFormatNo=? AND b.CardNo='0' ORDER BY a.No");


		$list->execute(array($count));
        $vars['list'] = $list;

		$this->display($vars, 'card_holder_credential', 'none');
    }

    public function onetimekeyall()
	{
        //모바일
        //$count  = $this->conn->prepare("select no from cardformat where Name='Mobile Credential Dummy' AND Mean='Dummy Format' AND TotalBitLength=36 AND FacilityCode=1");
        $count  = $this->conn->prepare("select no from cardformat where TotalBitLength=26 AND FacilityCode=241");
		$count->execute();
		$count  = $count->fetchColumn();

        $list   = $this->conn->prepare("select a.* from user as a, card as b where b.UserNo = a.No AND b.CardFormatNo=? ORDER BY a.No");


		$list->execute(array($count));
        $vars['list'] = $list;

		$this->display($vars, 'card_holder_onetime', 'none');
    }
	
    public function snapshot() 
	{
		$this->display(array(), 'card_holder_snapshot', 'none');
	}

    public function send_email() 
	{
        

        $id  = $this->input->get('UserId');
        $email   = $this->input->get('Email');
        $confirm_pw   = $this->input->get('Password');
        $card_number  = $this->conn->prepare("select cardno from card where userno=?");
		$card_number->execute(array($id));
        $card_number  = $card_number->fetchColumn();
        exec(SPIDER_COMM." credential single ".$id." ".$card_number." ".$email);

    }
    
    public function check_password()
	{
        $confirm_pw   = $this->input->get('Password');
        $val = 1;

        if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
			$ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
                $val = 0;
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
			$webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));
			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
                $val = 0;
			}
        }

        echo json_encode($val);
    }

    public function check_id()
	{
        $confirm_id   = $this->input->get('Id');
        //모바일
        //$count  = $this->conn->prepare("select no from cardformat where Name='Mobile Credential Dummy' AND Mean='Dummy Format' AND TotalBitLength=36 AND FacilityCode=1");
        //$count  = $this->conn->prepare("select no from cardformat where TotalBitLength=36 AND FacilityCode=231");
		$count  = $this->conn->prepare("select no from cardformat where Name='Mobile Credential 36 bit'"); // yhoh 20201124
		$count->execute();
        $count  = $count->fetchColumn();
        
        $list   = $this->conn->prepare("select COUNT(*) as Count,No  from card where UserNo=? AND CardFormatNo=?");
        $list->execute(array($confirm_id,$count));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);


        $result['list']     = $list;

        echo json_encode($result);
    }

    public function check_id_onetime()
	{
        $confirm_id   = $this->input->get('Id');
        $count  = $this->conn->prepare("select no from cardformat where TotalBitLength=26 AND FacilityCode=241");
		$count->execute();
        $count  = $count->fetchColumn();
        
        $list   = $this->conn->prepare("select COUNT(*) as Count, No, CardNo  from card where UserNo=? AND CardFormatNo=?");
        $list->execute(array($confirm_id,$count));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);


        $result['list']     = $list;

        echo json_encode($result);
    }


    public function insert_oneclick()
    {
        $No   = $this->input->post("No");
        $ID   = $this->input->post("ID");
        $Password   = $this->input->post("Password");
        $LastName   = $this->input->post("LastName");
        $FirstName   = $this->input->post("FirstName");
        $MiddleName   = $this->input->post("MiddleName");
        $Phone   = $this->input->post("Phone");
        $PhoneExt   = $this->input->post("PhoneExt");
        $CellPhone   = $this->input->post("CellPhone");
        $Email   = $this->input->post("Email");
        $Ada   = $this->input->post("Ada");
        $Exempt   = $this->input->post("Exempt");
        $ThreatLevel   = $this->input->post("ThreatLevel");
        $WEBLevel   = $this->input->post("WEBLevel");
        $Date   = $this->input->post("Date");
        $ImageFile   = $this->input->post("ImageFile");
        $UserDefine1   = $this->input->post("UserDefine1");
        $UserDefine2   = $this->input->post("UserDefine2");
        $UserDefine3   = $this->input->post("UserDefine3");
        $UserDefine4   = $this->input->post("UserDefine4");
        $UserDefine5   = $this->input->post("UserDefine5");
        $UserDefine6   = $this->input->post("UserDefine6");
        $UserDefine7   = $this->input->post("UserDefine7");
        $UserDefine8   = $this->input->post("UserDefine8");
        $UserDefine9   = $this->input->post("UserDefine9");
        $UserDefine10   = $this->input->post("UserDefine10");
        $UserDefine11  = $this->input->post("UserDefine11");
        $UserDefine12   = $this->input->post("UserDefine12");
        $UserDefine13   = $this->input->post("UserDefine13");
        $UserDefine14   = $this->input->post("UserDefine14");
        $UserDefine15   = $this->input->post("UserDefine15");
        $UserDefine16   = $this->input->post("UserDefine16");
        $UserDefine17   = $this->input->post("UserDefine17");
        $UserDefine18   = $this->input->post("UserDefine18");
        $UserDefine19   = $this->input->post("UserDefine19");
        $UserDefine20   = $this->input->post("UserDefine20");
        
        /*
        if($_FILES['upload_file']['name'] == "" && $SnapShotFile != "")
        {
            $ImageFile = $SnapShotFile;
        }
        else
        {
            $ImageFile = $this->receive($No);//null
        }
        */
        
        $this->receive($No);

        if( $ImageFile === FALSE )
        {
            $this->util->js('parent.parent.hide_loading();');
            exit;
        }
        
        $sth = $this->conn->prepare("INSERT INTO User (Site,No,ID,Password,FirstName,Middlename,LastName,Phone,PhoneExt,CellPhone,Email,ImageFile,Ada,ThreatLevel,WEBLevel,Date,UserDefine1,UserDefine2,UserDefine3,UserDefine4,UserDefine5,UserDefine6,UserDefine7,UserDefine8,UserDefine9,UserDefine10,UserDefine11,UserDefine12,UserDefine13,UserDefine14,UserDefine15,UserDefine16,UserDefine17,UserDefine18,UserDefine19,UserDefine20) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");

        $values = array($_SESSION['spider_site'],$No,$ID,$Password,$FirstName,$MiddleName,$LastName,$Phone,$PhoneExt,$CellPhone,$Email,$ImageFile,$Ada,$ThreatLevel,$WEBLevel,$Date,$UserDefine1,$UserDefine2,$UserDefine3,$UserDefine4,$UserDefine5,$UserDefine6,$UserDefine7,$UserDefine8,$UserDefine9,$UserDefine10,$UserDefine11,$UserDefine12,$UserDefine13,$UserDefine14,$UserDefine15,$UserDefine16,$UserDefine17,$UserDefine18,$UserDefine19,$UserDefine20);
        if( $sth->execute($values) )
        {

            //$this->log->set_log_message($FirstName .' '. $LastName);
           	//$this->util->js("parent.parent.$('#form_search').trigger('reset'); parent.$('#form_search').trigger('reset');");
            //$this->util->js('parent.parent.load_list_edit_search("'.$No.'");'); 

            //$this->util->js("parent.parent.$('#form_search').trigger('reset'); parent.$('#form_search').trigger('reset');");

            //$this->util->alert( $this->lang->common->save_completed );
            $val = 1;
        }
        else
        {
            //$this->util->alert($this->lang->common->error_insert);
            $val = 0;
        }

      	//$this->util->js('parent.parent.hide_loading();');
        //$this->util->js('parent.hide_loading();');
          
        //$this->util->js('parent.parent.load_list_edit_search("'.$No.'");');

        

        echo json_encode($val);
        
    }


}

?>