<?php
class certificate extends controller
{

    var $arr_ip_type    = array('0'=>'DHCP', '1'=>'Static');
    var $arr_d_server   = array('1'=>'dyndns.org');
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

    // ----------------------------------------------------------------------------------

   public function index()
    {
	    $vars = array();
		if( $this->input->get('wizard') == '1' )	$this->display($vars, '', 'none');
		else								$this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            //$count  = $this->conn->prepare("SELECT COUNT(*) FROM NetworkInfo");
            $count  = $this->net_work->prepare("SELECT COUNT(*) FROM Network");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            //$list   = $this->conn->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM NetworkInfo ORDER BY No DESC LIMIT ?, ?");
            $list   = $this->net_work->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM Network ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            //$count  = $this->conn->prepare("SELECT COUNT(*) FROM NetworkInfo WHERE $field LIKE ?");
            $count  = $this->net_work->prepare("SELECT COUNT(*) FROM Network WHERE $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            //$list   = $this->conn->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM NetworkInfo WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list   = $this->net_work->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM Network WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

		$network_info	= $this->network_info();

        foreach( $list as $key=>$val )
        {
			if($val['IPType'] == '0') {
				$val['IPAddress']	= $network_info['addr'];
				$val['Subnet']	= $network_info['mask'];
				$val['Gateway']	= $network_info['bcast'];
			}

            $val['IPTypeStr']       = $this->arr_ip_type[$val['IPType']];
            $val['HTTPSStr']        = ($val['HTTPS'] == '' ? 'Off' : $this->arr_plug[$val['HTTPS']]);


            
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
        
    }

   public function cert_info()
   {
        exec(SPIDER_COMM." certinfo subj", $output);
        $str	= @$output[count($output)-2];
        
        $strTok =explode(',' , $str);

        $arr_C = explode('=' , $strTok[0]);
        $arr_O = explode('=' , $strTok[1]);
        $arr_CN = explode('=' , $strTok[2]);
        
        if(strcmp($arr_O[0] , "ST="))
        {
            $vars['C'] = "US";
            $vars['O'] = "Global"; //company
            $vars['CN'] = "GlobalSystem";
        }
        else
        {
            $vars['C'] = trim($arr_C[2]);
            $vars['O'] = trim($arr_O[1]); //company
            $vars['CN'] = trim($arr_CN[1]);
        }
                
        exec(SPIDER_COMM." certinfo add", $output);
        $str	= @$output[count($output)-2];

        
        $strTok2 =explode(',' , $str);
        $strTok2[0] = trim($strTok2[0]);
        $strTok2[1] = trim($strTok2[1]);
        $strTok2[2] = trim($strTok2[2]);
        
        $local = explode(':' , $strTok2[0]);
        $rmc = explode(':' , $strTok2[1]);
        $public = explode(':' , $strTok2[2]);

        $vars['localip'] = trim($local[1]);

        if($vars['localip'] == null)
        {
            $vars['localip'] = "asdfg";
        }
        else
        {
            $vars['localip'] = "112233";
        }
        
        if($rmc[0] == 'DNS')
        {
            $vars['RMC'] = array('dns',trim($rmc[1]));
        }
        else
        {
            $vars['RMC'] = array('ip',trim($rmc[1]));
        }
        if($public[0] == 'DNS')
        {            
            $vars['Public'] = array('dns',trim($public[1]));
        }
        else
        {
            $vars['Public'] = array('ip',trim($public[1]));
        }
        echo json_encode($vars);
   }

//----------------------------------------------------------------------------------
   public function update1()
   {
        $confirm_pw    = $this->input->post('confirm_pw');

		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				exit;
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));

			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				exit;
			}
        }
        $save_type = $this->input->post('save_type');

		if( $save_type  == 'reboot' )
		{
            exec("/spider/bin/cp -a /tmp/SpiderDB/* /spider/database/.");
            exec(SPIDER_COMM." sysback");
            
            $this->log->set_log('reset', 'reset');
            exec(SPIDER_COMM." shutdown Flags"); 
            $this->util->alert($this->lang->common->save_completed_reset);
            $this->util->redirect('/?c=user&m=logout');
		}
		else
		{
            $Country     = $this->input->post('Country');
            $Corporate   = $this->input->post('Corporate'); //o
            $IP1         = $this->input->post('IP1');
            $IP2         = $this->input->post('IP2');
            $IP3         = $this->input->post('IP3');
            $type1 = $this->input->post('Type1');
            $type2 = $this->input->post('Type2');

            //$info_out	= $this->network_info();
            //$IP1 = $info_out['addr']; //localip
            //$IP1 = "IP.1=".$IP1;

            if($IP1 != NULL)
            {
                $check = $this->check_ip($IP1);
                if($check != 1)
                {
                    Util::alert("Please enter your IP address correctly");
                    exit;
                }
            }
            else
            {
                Util::alert("Please enter your IP address correctly");
                exit;
            }

            $IP1 = "IP.1=".$IP1;

            if($type1 == 1){
                $IP2 = "DNS.1=".$IP2;
            }else{
                if($IP2 != NULL)
                {
                    $check = $this->check_ip($IP2);
                    if($check != 1)
                    {
                        Util::alert("Please enter your IP address correctly");
                        exit;
                    }
                }
                $IP2 = "IP.2=".$IP2;
            }

            if($type2 == 1){
                $IP3 = "DNS.2=".$IP3;
            }else{
                if($IP3 != NULL)
                {
                    $check = $this->check_ip($IP3);
                    if($check != 1)
                    {
                        Util::alert("Please enter your IP address correctly");
                        exit;
                    }
                }
                $IP3 = "IP.3=".$IP3;
            }

            if($Corporate == '' || $Corporate == NULL)
            {
                $this->util->alert("Please enter company item");
                exit;
            }
            
            switch($Country)
            {
                case 0: $Comm='US'; break;
                case 1: $Comm='KR'; break;
                case 2: $Comm='CN'; break;
            }

            $oem_name = $_ENV["NEPTUNE_MODE"]; // o
            exec(SPIDER_COMM." selfcertup '".$Comm."' '".$Corporate."' '".$Corporate."' '".$IP1."' '".$IP2."' '".$IP3."'");
            Util::alert("The certificate has been issued.\\nWhen you reboot the system, the issued certificate is applied.");
        }
    
    }

   // ----------------------------------------------------------------------------------

    public function cert()
    {
        //-----BEGIN CERTIFICATE-----
        $content = file_get_contents(ROOT_DIR.'/usr/local/lighttpd/cert/sicunet.crt');

        $pos = strpos($content, '-----BEGIN CERTIFICATE-----');

        $vars['privatekey']  = substr($content, 0, $pos);
        $vars['certificate'] = substr($content, $pos);

		$this->display($vars, 'ipset_cert', 'none');
    }
    
    // ----------------------------------------------------------------------------------
    
   public function network_info()
	{
		//exec(SPIDER_COMM.' cmd ifconfig', $lines);
		exec(SPIDER_COMM.' ifconfig', $lines);
		$output	= implode("\n", $lines);

		$match  = "/^.*addr:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})";
		$match .= ".*Bcast:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})";
		$match .= ".*Mask:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}).*$/im";
		if(!preg_match($match, $output, $matches))
			return false;

		$values = array(
			'addr'	=> $matches[1],
			//'bcast'	=> $matches[2],
			'mask'	=> $matches[3]
		);

		$lines = '';
		$output = array();
		$matches = array();

		exec(SPIDER_COMM.' getroute', $lines);
		
		foreach( $lines as $line )
		{
			$line		= strtolower(trim($line));
			$action		= explode(':', $line);
			$status		= trim(@$action[0]);

			if( strpos($status, 'result') === 0 ) {
				$values['bcast']	= trim($action[1]);
				break;
			}
		}

		return $values;
	}

    // ----------------------------------------------------------------------------------

   public function check_ip($ip) 
	{
		$values = true;
		$match = "/^(([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]).){3}([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/";
		
	    if(empty($ip)) 
		{
			$values = false;
		}
		else if(!preg_match($match, $ip))
		{
			$values = false;
		}
		
		return $values;
	}
}
?>