<?php


include APP_DIR.'/libraries/Uploader.php';


class cfloor extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $this->display();
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();
        
        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Floor WHERE Site=?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Floor WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Floor WHERE Site=? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Floor WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['file']     = $val['ImageFile'];
            $val['file_url'] = empty($val['file']) ? '' : FLOOR_URL.'/'.$val['file'];
            $list[$key] = $val;
        }

        $result['field']    = $field;
        $result['word']     = $word;
        $result['page']     = $page;
        $result['view']     = $view;
        $result['pages']    = $pagination->get_pages();
        $result['count']    = $count;
        $result['list']     = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function insert()
    {
        $No = $this->conn->prepare("SELECT MAX(No) FROM Floor WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No = $No->fetchColumn() + 1;
        
        $Name           = strip_tags(trim($this->input->post('Name')));
        $Mean           = strip_tags($this->input->post('Mean'));
        $ImageFile      = $this->input->post('upload_file');

        if( empty($Name) ) {
            $this->util->js('parent.hide_loading()');
            $this->util->alert( $this->lang->menu->error_name_required, TRUE );
        }

        $ImageFileSend = $this->receive();
        if( $ImageFileSend === FALSE )      
        {
            exit;
        }

        $sth    = $this->conn->prepare("INSERT INTO Floor (Site,No,Name,Mean,ImageFile) VALUES (?,?,?,?,?)");

        $values = array($_SESSION['spider_site'],$No,$Name,$Mean,$ImageFileSend);
        if( $sth->execute( $values ) )
        {
        	//exec(SPIDER_COMM." send db");
            $this->log->set_log();
            $this->util->js('parent.load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }

        $this->util->js('parent.hide_loading()');
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No             = $this->input->post('No');
        $Name           = strip_tags(trim($this->input->post('Name')));
        $Mean           = strip_tags($this->input->post('Mean'));
        $ImageFile      = $this->input->post('upload_file');
        
        if( empty($Name) ) {
            $this->util->js('parent.hide_loading()');
            $this->util->alert( $this->lang->menu->error_name_required, TRUE );
        }

		if ( is_file($_FILES['upload_file']['tmp_name']) )
		{
	        $cfloor = $this->conn->prepare("SELECT * FROM Floor WHERE Site=? AND No=?");
	        $cfloor->execute(array($_SESSION['spider_site'], $No));
	        $cfloor = $cfloor->fetch(PDO::FETCH_ASSOC);
	
	        $ImageFileSend = $this->receive();
	        if( $ImageFileSend === FALSE )      exit;
	
	        if( empty($ImageFileSend) ) $ImageFileSend = $ctrl['ImageFileSend'];
	
	        if( !empty($cfloor['file']) && $cfloor['file'] != $ImageFile )
	        {
	            unlink(FLOOR_DIR.'/'.$cfloor['file']);
	        }

	        $sth    = $this->conn->prepare("UPDATE Floor SET Name=?,Mean=?,ImageFile=? WHERE Site=? AND No=?");
		    $values = array($Name,$Mean,$ImageFileSend,$_SESSION['spider_site'],$No);
		}
		else
		{
			$sth    = $this->conn->prepare("UPDATE Floor SET Name=?,Mean=? WHERE Site=? AND No=?");
		    $values = array($Name,$Mean,$_SESSION['spider_site'],$No);
		}
        if( $sth->execute($values) )
        {
        	//exec(SPIDER_COMM." send db");
            $this->log->set_log();
            $this->util->js('parent.update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }

        $this->util->js('parent.hide_loading()');
    }

    // ----------------------------------------------------------------------------------

   public function check_dependency()
    {
        $no     = $this->input->get('no');

        $item   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Floor=?");
        $item->execute(array($_SESSION['spider_site'], $no));
        if( $item = $item->fetchAll(PDO::FETCH_ASSOC) )
		{
			$this->util->js('confirm_dependency()', TRUE);
		}

        $item   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site=? AND Floor=?");
        $item->execute(array($_SESSION['spider_site'], $no));
        if( $item = $item->fetchAll(PDO::FETCH_ASSOC) )
		{
			$this->util->js('confirm_dependency()', TRUE);
		}

        $item   = $this->conn->prepare("SELECT * FROM AuxInput WHERE Site=? AND Floor=?");
        $item->execute(array($_SESSION['spider_site'], $no));
        if( $item = $item->fetchAll(PDO::FETCH_ASSOC) )
		{
			$this->util->js('confirm_dependency()', TRUE);
		}

        $item   = $this->conn->prepare("SELECT * FROM AuxOutput WHERE Site=? AND Floor=?");
        $item->execute(array($_SESSION['spider_site'], $no));
        if( $item = $item->fetchAll(PDO::FETCH_ASSOC) )
		{
			$this->util->js('confirm_dependency()', TRUE);
		}

		$this->util->js('del_data_prepass()', TRUE);
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
        $No     = $this->input->get('no');

        $cfloor = $this->conn->prepare("SELECT * FROM Floor WHERE Site=? AND No=?");
        $cfloor->execute(array($_SESSION['spider_site'], $No));
        $cfloor = $cfloor->fetch(PDO::FETCH_ASSOC);

        if( !empty($cfloor['file']) )
        {
            unlink(FLOOR_DIR.'/'.$cfloor['file']);
        }

        $sth    = $this->conn->prepare("DELETE FROM Floor WHERE Site=? AND No=?");

        if( $sth->execute(array($_SESSION['spider_site'], $No)) )
        {
        	//exec(SPIDER_COMM." send db");
            $this->log->set_log();
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete_image()
    {
        $No     = $this->input->get('no');
                
        $delImage = $this->conn->prepare("SELECT ImageFile FROM Floor WHERE Site=? AND No=?");
        $delImage->execute(array($_SESSION['spider_site'], $No));
        $delImage = $delImage->fetchColumn();
        
        if( !empty($delImage) )
        {
            @unlink(USER_IMG.'/'.$delImage);
        }

        $Floor   = $this->conn->prepare("UPDATE Floor SET ImageFile='' WHERE Site=? AND No=?");
        
        if( $Floor->execute(array($_SESSION['spider_site'], $No)) )
        {
            //exec(SPIDER_COMM." send db");
            $this->util->js('update_list("'.$No.'")');
        }
        else
        {
            //$this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

   public function receive()
    {
        if( ! is_uploaded_file($_FILES['upload_file']['tmp_name']) )	return "";

        $uploader                   = new Uploader();
        $uploader->upload_dir       = FLOOR_DIR;

        if( $uploader->do_upload('upload_file') )
        {
            return $uploader->save_file['basename'];
        }
        else
        {
            $this->util->alert($this->lang->addmsg->error_upload);
            return FALSE;
        }
    }

    // ----------------------------------------------------------------------------------

}


?>