<?php


class client extends controller
{
    // ----------------------------------------------------------------------------------

   public function index()
    {
	    $vars = array();
        $this->display($vars, '', 'client');
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->net_work->prepare("SELECT COUNT(*) FROM Network");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->net_work->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM Network ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->net_work->prepare("SELECT COUNT(*) FROM Network WHERE $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->net_work->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM Network WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
		$network_info	= $this->network_info();

        foreach( $list as $key=>$val )
        {
			if($val['IPType'] == '0') {
				$val['IPAddress']	= $network_info['addr'];
				$val['Subnet']	= $network_info['mask'];
				$val['Gateway']	= $network_info['bcast'];
			}

            $val['IPTypeStr']   = EnumTable::$attrIPType[$val['IPType']];
            //$val['HTTPSStr']    = ($val['HTTPS'] == '' ? 'Off' : $this->arr_plug[$val['HTTPS']]);
            $val['HTTPSStr']    = ($val['HTTPS'] == '1' ? 'On' : 'Off');
            $val['ServerIP']    = $this->get_serverip($val['No']);
            $val['ServerFTP']   = $this->get_serverftpport($val['No']);
            
            $login   = $this->conn->prepare("SELECT ID, Password FROM Controller WHERE No=?");
            $login->execute(array($val['No']));
            $login   = $login->fetchAll(PDO::FETCH_ASSOC);
            
            foreach( $login as $logkey=>$logval )
            {
  				$val['ID']           = $logval['ID'];
//                $val['Password']     = $logval['Password'];
                $val['Password']     = '';
	            $val['PrevID']       = $logval['ID'];
 				$val['PasswordStr']  = $logval['Password'];
   				$list[$logkey]       = $logval;
   			}
        	            
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function network_info()
	{
		//exec(SPIDER_COMM.' cmd ifconfig', $lines);
		exec(SPIDER_COMM.' ifconfig', $lines);

		$output	= implode("\n", $lines);

		$match  = "/^.*addr:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})";
		$match .= ".*Bcast:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})";
		$match .= ".*Mask:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}).*$/im";
		if(!preg_match($match, $output, $matches))
			return false;

		$values = array(
			'addr'	=> $matches[1],
			'bcast'	=> $matches[2],
			'mask'	=> $matches[3]
		);

		$lines = '';
		$output = array();
		$matches = array();

		//exec(SPIDER_COMM.' cmd route | grep default', $lines);
		exec(SPIDER_COMM.' route', $lines);
		$output	= implode("\n", $lines);

		$match  = "/([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})/im";
		if(preg_match($match, $output, $matches)) {
			$values['bcast']	= $matches[1];
		}

		return $values;
	}

    // ----------------------------------------------------------------------------------
   public function update()
    {
        $No         = $this->input->post('No');
        $IPType     = $this->input->post('IPType', '0');
        $IPAddress  = trim($this->input->post('IPAddress'));
        $Subnet     = trim($this->input->post('Subnet'));
        $Gateway    = trim($this->input->post('Gateway'));
        $DNS1       = trim($this->input->post('DNS1'));
        $DNS2       = trim($this->input->post('DNS2'));
        $HTTPPort   = $this->input->post('HTTPPort', '80');
        $HTTPS      = $this->input->post('HTTPS');
        $HTTPSPort  = $this->input->post('HTTPSPORT', '443');

        $ServerIP   = trim($this->input->post('ServerIP'));
        $ServerFTP  = trim($this->input->post('ServerFTP', '21'));
        
   		$ID		         = $this->input->post('ID');
   		$PrevID          = $this->input->post('PrevID');
		$Password        = $this->input->post('Password');
//      CMS API 호환성 문제로 인하여 사용 중지 함.        
//		$PrevPassword    = $this->input->post('PrevPassword');
		
		if( empty($ID) )          			$this->util->alert( $this->lang->ctrl->error_id_required, TRUE );
		if( empty($Password) )          	$this->util->alert( $this->lang->ctrl->error_pw_required, TRUE );
		
		if( $PrevID != $ID )				$this->util->alert( $this->lang->ctrl->error_not_matched_id, TRUE );
        //CMS API 호환성 문제로 인하여 사용 중지 함.
		//if( $PrevPassword != $Password )	$this->util->alert( $this->lang->ctrl->error_not_matched_pw, TRUE );
		//if( $PrevPassword != base64_encode( hash('sha256', $Password, true)) )	$this->util->alert( $this->lang->ctrl->error_not_matched_pw, TRUE );

        if (!filter_var($ServerIP, FILTER_VALIDATE_IP) === true) {
            $this->util->alert( $this->lang->client->error_ip_add_required, TRUE );
        }        
        
        if( empty($ServerFTP) )    			$this->util->alert( $this->lang->client->error_port_required, TRUE );

		if(empty($HTTPPort)) {
			$HTTPPort = '80';
		}

		if(empty($HTTPS)) {
			$HTTPS = '0';
		}

		if(empty($HTTPSPort)) {
			$HTTPSPort = '443';
		}

        if( $HTTPPort == '20000' || $HTTPPort == '20001' || $HTTPSPort == '20000' || $HTTPSPort == '20001' ){
            $this->util->alert( $this->lang->network->error_port_allowed, TRUE );
        }

        if( $IPType == '1' )
        {
            if (!filter_var($IPAddress, FILTER_VALIDATE_IP) === true) {
                $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
            }
            
            if (!filter_var($Subnet, FILTER_VALIDATE_IP) === true) {
                $this->util->alert( $this->lang->network->error_subnet_required, TRUE );
            }
            
            if (!filter_var($Gateway, FILTER_VALIDATE_IP) === true) {
                $this->util->alert( $this->lang->network->error_gateway_required, TRUE );
            }
        
            if( !empty($DNS1) ) {
                
                if (!filter_var($DNS1, FILTER_VALIDATE_IP) === true) {
                    $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
                }
            }
            
            if( !empty($DNS2) ) {
                if (!filter_var($DNS2, FILTER_VALIDATE_IP) === true) {
                    $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
                }
            }
            
            $sth    = $this->net_work->prepare("UPDATE Network SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=?,ServerIP=?,ServerFTPPort=? WHERE No=?");
            $values = array($IPType,$IPAddress,$Subnet,$Gateway,$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$ServerIP,$ServerFTP,$No);
        }
        else
        {
            $sth    = $this->net_work->prepare("UPDATE Network SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=?,ServerIP=?,ServerFTPPort=? WHERE No=?");
            $values = array($IPType,'','','',$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$ServerIP,$ServerFTP,$No);            
        }

        if( $sth->execute($values) )
        {
            if( $IPType == '1' )
            {
                $sth    = $this->conn->prepare("UPDATE NetworkInfo SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=? WHERE No=?");
                $values = array($IPType,$IPAddress,$Subnet,$Gateway,$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$No);
            }
            else
            {
                $sth    = $this->conn->prepare("UPDATE NetworkInfo SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=? WHERE No=?");
                $values = array($IPType,'','','',$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$No);
            }

            if( $sth->execute($values) )
            {
            	exec("/spider/bin/cp -a /tmp/SpiderDB/Network.db /spider/database/Network.db");

                $this->log->set_log(NULL, 'update');
                if( $IPType == '1' && $HTTPS == '1' )
                    exec(SPIDER_COMM." selfcertup 'US' 'SelfSignedClient' 'SelfSignedClient' 'IP.1=".$IPAddress."' '' ''");                
                exec (SPIDER_COMM." nconf start");
                exec (SPIDER_COMM." reboot");
                // yhoh 20210218		
                //$this->util->alert( $this->lang->common->save_completed );
                $this->util->alert("The client password will be reset to match the server after it is connected to the server.");
                $this->util->redirect("/?c=client");
            }
            else
            {
                $this->util->alert($this->lang->common->error_update);
            }
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }
    
    // ----------------------------------------------------------------------------------
   public function restart()
    {
		$confirm_pw    = $this->input->post('confirm_pw');
		$save_type     = $this->input->post('save_type');

		$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
        //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
        $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
        
		if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
		{
			$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
		}

    	$this->log->set_log('client', 'reset');
    	
        exec(SPIDER_COMM." shutdown Flags");
    }
    
    // ----------------------------------------------------------------------------------
   public function get_serverip($No)
    {
        $arr    = array();
        
        $serverinfo   = $this->net_work->prepare("SELECT ServerIP FROM Network WHERE No=1");
        $serverinfo->execute();
        $serverip     = $serverinfo->fetchColumn();

        return $serverip;
    }
    
   public function get_serverftpport($No)
    {
        $arr    = array();
        
        $serverinfo   = $this->net_work->prepare("SELECT ServerFTPPort FROM Network WHERE No=1");
        $serverinfo->execute();
        $serverport   = $serverinfo->fetchColumn();

        return $serverport;
    }

    // ----------------------------------------------------------------------------------
   public function fdefault()
    {
		$confirm_pw    = $this->input->post('confirm_pw');
		
		// 用户加密 20190731
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw,  false), $_SESSION['spider_site']));
			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}

        // ¸í·É¾î ½ÇÇà Ãß°¡
        // exec("¸í·É¾î");
        exec(SPIDER_COMM." factory");

        $this->util->alert($this->lang->common->success_complete_factory);
        $this->util->redirect("/?c=client");
    }

}
?>