<?php


include APP_DIR.'/libraries/CirciutType.php';


class dcontact extends controller
{

	// ----------------------------------------------------------------------------------

   public function index()
	{
		$this->display();
	}

	// ----------------------------------------------------------------------------------

   public function select()
	{
		$field	= $this->input->get('f');
		$word	= $this->input->get('w');
		$page	= $this->input->get('p', 1);
		$view	= $this->input->get('v');

		$page_config	= $GLOBALS['page_config'];
		$pagination		= new Pagination();

		if( empty($field) || empty($word) )
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM DoorContact");
			$count->execute();
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM DoorContact ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}
		else
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM DoorContact WHERE $field LIKE ?");
			$count->execute(array($this->util->parse_search_string($word)));
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM DoorContact WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}

		foreach( $list as $key=>$val)
		{
			$val['disable_str']	= ($val['Disable'] == "1" ? 'Off' : 'On');
			$val['AlarmStr']	= ($val['Alarm'] == "1" ? 'Off' : 'On');
			$val['TypeStr']		= CirciutType::$attrs[$val['Type']];
			$list[$key]	= $val;
		}

		$result['field']		= $field;
		$result['word']			= $word;
		$result['page']			= $page;
		$result['view']			= $view;
		$result['pages']		= $pagination->get_pages();
		$result['count']		= $count;
		$result['list']			= $list;

		echo json_encode($result);
	}

	// ----------------------------------------------------------------------------------

   public function update()
	{
		$No				= $this->input->post('No');
		$Disable		= $this->input->post('Disable', '0');
		$Alarm			= $this->input->post('Alarm', '0');
		$Name			= $this->input->post('Name');
		$Mean			= $this->input->post('Mean');
		$Type			= $this->input->post('Type');

		if($typ == '8')
		{
			$NormalLow		    = $this->input->post('NormalLow');
			$NormalHigh		    = $this->input->post('NormalHigh');
			$TroubleOpenLow	    = $this->input->post('TroubleOpenLow');
			$TroubleOpenHigh	= $this->input->post('TroubleOpenHigh');
			$TroubleShortLow	= $this->input->post('TroubleShortLow');
			$TroubleShortHigh   = $this->input->post('TroubleShortHigh');
			$Alarm1Low		    = $this->input->post('Alarm1Low');
			$Alarm1High		    = $this->input->post('Alarm1High');
			$Alarm2Low		    = $this->input->post('Alarm2Low');
			$Alarm2High		    = $this->input->post('Alarm2High');
		}
		else
		{
			$NormalLow		    = CirciutType::$sub_attrs[$Type]['NormalLow'];
			$NormalHigh		    = CirciutType::$sub_attrs[$Type]['NormalHigh'];
			$TroubleOpenLow	    = CirciutType::$sub_attrs[$Type]['TroubleOpenLow'];
			$TroubleOpenHigh	= CirciutType::$sub_attrs[$Type]['TroubleOpenHigh'];
			$TroubleShortLow	= CirciutType::$sub_attrs[$Type]['TroubleShortLow'];
			$TroubleShortHigh   = CirciutType::$sub_attrs[$Type]['TroubleShortHigh'];
			$Alarm1Low		    = CirciutType::$sub_attrs[$Type]['Alarm1Low'];
			$Alarm1High		    = CirciutType::$sub_attrs[$Type]['Alarm1High'];
			$Alarm2Low		    = CirciutType::$sub_attrs[$Type]['Alarm2Low'];
			$Alarm2High		    = CirciutType::$sub_attrs[$Type]['Alarm2High'];
		}

		if( empty($Name) )		$this->util->alert( $this->lang->dcontact->error_name_required, TRUE );

		$sth	= $this->conn->prepare("UPDATE DoorContact SET Disable=?,Alarm=?,Name=?,Mean=?,Floor=?,Type=?,NormalLow=?,NormalHigh=?,TroubleOpenLow=?,TroubleOpenHigh=?,TroubleShortLow=?,TroubleShortHigh=?,Alarm1Low=?,Alarm1High=?,Alarm2Low=?,Alarm2High=? WHERE No=?");

		$values	= array($Disable,$Alarm,$Name,$Mean,$Type,$NormalLow,$NormalHigh,$TroubleOpenLow,$TroubleOpenHigh,$TroubleShortLow,$TroubleShortHigh,$Alarm1Low,$Alarm1High,$Alarm2Low,$Alarm2High,$No);
		if( $sth->execute($values) )
		{
			$this->log->set_log();
			$this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
		}
		else
		{
			$this->util->alert($this->lang->common->error_update);
		}
	}

	// ----------------------------------------------------------------------------------

   public function delete()
	{
	}

	// ----------------------------------------------------------------------------------

   public function disable()
	{
		$No				= $this->input->post('No');
		$Disable		= $this->input->post('Disable', '0');

		$sth	= $this->conn->prepare("UPDATE DoorContact SET Disable=? WHERE No=?");

		if( $sth->execute( array($disable,$No) ) )
		{
			$this->log->set_log(NULL, 'disable');
			$this->util->alert($this->lang->common->success_update);
		}
		else
		{
			$this->util->alert($this->lang->common->error_update);
		}
	}

	// ----------------------------------------------------------------------------------

}


?>