<?php 
class debugmanagement extends controller
{
    // ----------------------------------------------------------------------------------

   public function index()
    {
    	$this->display();
    }
    
   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

    	$var['ConsoleStr'] = "OFF";
		$var['FileStr']    = "OFF";
		
        exec(SPIDER_COMM." debug status", $lines);
		foreach( $lines as $line )
		{
			$line			= strtoupper(trim($line));
			$action			= explode(':', $line);
			$status			= trim(@$action[0]);
			
			if (strpos($status, 'RESULT') === 0) 
			{
				$token			= explode(',', $action[1]);
				$var['ConsoleStr'] = $token[0];
				$var['FileStr']    = $token[1];
				
				if ($var['ConsoleStr'] === "ON")
					$var['Console'] = "1";
				else
					$var['Console'] = "0";
				
				if ($var['FileStr'] === "ON")
					$var['File'] = "1";
				else
					$var['File'] = "0";
				
				//$val['LogFileList'] = $this->get_loglist();
				$list[0] = $var;
			}
		}
		
		$result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
    // ----------------------------------------------------------------------------------
   public function update()
    {
    	$console    = $this->input->post('Console');
    	$file		= $this->input->post('File');
    	
    	if ($console == "1")
    	{
    		$var['ConsoleStr'] = "ON";
    		exec(SPIDER_COMM." debug console on");
    	}
    	else
    	{
    		$var['ConsoleStr'] = "OFF";
    		exec(SPIDER_COMM." debug console off");
    	}
    		
    	if ($file == "1")
    	{
    		$var['FileStr']  = "ON";
	    	exec(SPIDER_COMM." debug file on");
	    }
	    else
	    {
	    	$var['FileStr']  = "OFF";
	    	exec(SPIDER_COMM." debug file off");
	    }
	    
	    $this->util->alert( $this->lang->common->save_completed );
	    $this->util->reload();
    }

    // ----------------------------------------------------------------------------------
   public function download()
    {
    	$log_file_name	= $this->input->post('log_file_name');
    	$log_pull_path	= "/spider/web/webroot/log/".$log_file_name;
    	
    	header("Content-Description: File Transfer");
        header("Content-Type: application/octet-stream");
        header("Content-Disposition: attachment; filename=\"".$log_file_name."\"");
        header("Content-Transfer-Encoding: Binary");
        header("Pragma: no-cache; public");
        header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header("Content-Length: " . filesize($log_pull_path));
        header("Expires: 0");

        readfile($log_pull_path);
    }    
    
    // ----------------------------------------------------------------------------------
   public function reset()
    {
		exec(SPIDER_COMM." debug clean");
		$this->util->reload();
    }

	// ----------------------------------------------------------------------------------
   public function get_loglist()
    {
		$list = array();

		exec(SPIDER_COMM." debug list", $output);
		foreach( $output as $line )
		{
			$line = trim($line);
			$action			= explode(':', $line);
			$status			= trim(@$action[0]);
			
			if (strpos($status, 'LIST') === 0) 
			{
				$name_split = explode('.', $action[1]);
				$this->util->alert("LIST : ".$name_split[0]);
				if( $name_split[(count($name_split) - 1)] == 'log' ) {
					$list[] = $action[1];
				}
			}
		}

        return $list;
    } 
    
    
    // ----------------------------------------------------------------------------------
   public function file_list()
    {
    	echo json_encode($this->_file_list());
    }
    
   public function _file_list()
    {
		$files = array();
		$output = array();
		
		exec(SPIDER_COMM." debug list", $output);
		foreach( $output as $line )
		{
			$line = trim($line);
			$action			= explode(':', $line);
			$status			= trim(@$action[0]);
			
			if (strpos($status, 'LIST') === 0) 
			{
				$name_split = explode('.', $action[1]);
				if( $name_split[(count($name_split) - 1)] == 'log' ) {
					$files[] = $action[1];
				}
			}
		}

		return $files;
    }

}