<?php


include APP_DIR.'/libraries/State.php';


class dlock extends controller
{

	// ----------------------------------------------------------------------------------

   public function index()
	{
		$vars['arr_state']	= $this->to_array_state();
		$this->display($vars);
	}

	// ----------------------------------------------------------------------------------

   public function select()
	{
		$field	= $this->input->get('f');
		$word	= $this->input->get('w');
		$page	= $this->input->get('p', 1);
		$view	= $this->input->get('v');

		$page_config	= $GLOBALS['page_config'];
		$pagination		= new Pagination();

		if( empty($field) || empty($word) )
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM Door_lock");
			$count->execute();
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM Door_lock ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}
		else
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM Door_lock WHERE $field LIKE ?");
			$count->execute(array($this->util->parse_search_string($word)));
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM Door_lock WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}

		$arr_state	= $this->to_array_state();

		foreach( $list as $key=>$val)
		{
			$val['disable_str']	= ($val['disable'] == "1" ? 'Off' : 'On');
			$val['alram_str']	= ($val['alram'] == "1" ? 'Off' : 'On');
			$val['State_str']	= State::$attrs[$val['State']];
			$list[$key]	= $val;
		}

		$result['field']		= $field;
		$result['word']			= $word;
		$result['page']			= $page;
		$result['view']			= $view;
		$result['pages']		= $pagination->get_pages();
		$result['count']		= $count;
		$result['list']			= $list;

		echo json_encode($result);
	}

	// ----------------------------------------------------------------------------------

   public function update()
	{
		$No				= $this->input->post('No');
		$disable		= $this->input->post('disable', '0');
		$alram			= $this->input->post('alram', '0');
		$name			= $this->input->post('name');
		$mean			= $this->input->post('mean');
		$State			= $this->input->post('State');

		if( empty($name) )		$this->util->alert( $this->lang->dlock->error_name_required, TRUE );

		$sth	= $this->conn->prepare("UPDATE Door_lock SET disable=?,alram=?,name=?,mean=?,State=? WHERE No=?");

		$values	= array($disable,$alram,$name,$mean,$State,$No);
		if( $sth->execute($values) )
		{
			$this->log->set_log();
			$this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
		}
		else
		{
			$this->util->alert($this->lang->common->error_update);
		}
	}

	// ----------------------------------------------------------------------------------

   public function delete()
	{
	}

	// ----------------------------------------------------------------------------------

   public function disable()
	{
		$No				= $this->input->post('No');
		$disable		= $this->input->post('disable', '0');

		$sth	= $this->conn->prepare("UPDATE Door_lock SET disable=? WHERE No=?");

		if( $sth->execute( array($disable,$No) ) )
		{
			$this->log->set_log(NULL, 'disable');
			$this->util->alert($this->lang->common->success_update);
		}
		else
		{
			$this->util->alert($this->lang->common->error_update);
		}
	}

	// ----------------------------------------------------------------------------------

   public function to_array_state()
	{
		$arr_state	= array('1'=>'Not Energized');

		return $arr_state;
	}

	// ----------------------------------------------------------------------------------

}


?>