<?php

include APP_DIR.'/libraries/CirciutType1.php';

class door extends controller
{
    public $attrTimeAnti           = array('0'=>'No', '1'=>'Yes');
    public $attrRoomAnti           = array('0'=>'No', '1'=>'Yes');
    public $attrZoneAnti           = array('0'=>'false', '1'=>'true');
    public $attrAbsenceAnti        = array('0'=>'false', '1'=>'true');
    public $attrTwoManRule         = array('0'=>'No', '1'=>'Yes');
    public $attrFirstManRule       = array('0'=>'No', '1'=>'Yes');
    public $attrFirstManEveryDay   = array('0'=>'No', '1'=>'Yes');
    public $attrManagerIn          = array('0'=>'No', '1'=>'Yes');
    public $attrTimeAntiType       = array('0'=>'Deny', '1'=>'Grant');
    public $attrRoomAntiType       = array('0'=>'Deny', '1'=>'Grant');
    public $attrZoneAntiType       = array('0'=>'Deny', '1'=>'Grant');
    public $attrAbsenceType        = array('0'=>'Deny', '1'=>'Grant');

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $vars['attrFloor']      = $this->to_array_floor();
        $vars['attrReader']     = $this->to_array_reader();
        $vars['attrThreat']     = $this->to_threat_level();
        $vars['attrCardFormat'] = $this->to_array_card_format();
        $vars['arr_schedule']   = $this->to_array_schedule();
        $vars['attrRegion']     = $this->to_array_region();
        
		if( $this->input->get('wizard') == '1' )	$this->display($vars, '', 'none');
		else								$this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');
        
        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=? AND Disable='0'");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' ");
            }
        
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable='0' ORDER BY No DESC LIMIT ?, ?");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' 
                                                           ORDER BY A.No DESC LIMIT ?, ?");
            }
            
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=? AND Disable='0' AND $field LIKE ?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' 
                                                           AND A.$field LIKE ? ");
            }
            
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable='0' AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' 
                                                           AND A.$field LIKE ? 
                                                           ORDER BY A.No DESC LIMIT ?, ?");
            }
            
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $attrFloor      = $this->to_array_floor();
        //$attrReader     = $this->to_array_reader();
        $attrThreat     = $this->to_threat_level();
        $attrCardFormat = $this->to_array_card_format();
        $attrRegion     = $this->to_array_region();
        $door_contact   = $this->to_door_contact();
        $door_rex       = $this->to_door_rex();
        $arr_schedule       = $this->to_array_schedule();

        foreach( $list as $key=>$val )
        {
	        foreach($val as $kk=>$vv){
		        if($vv === null){
			        $val[$kk] = 0;
		        }
	        }
	        
            $MasterReader   = $this->get_reader( $val['MasterReader'] );
            $SlaveReader    = $this->get_reader( $val['SlaveReader'] );
            $DoorContact    = $this->get_doorcontact( $val['No'] );
            $DoorRex        = $this->get_doorrex( $val['No'] );
            $DoorLock       = $this->get_doorlock( $val['No'] );

            $val['DoorContactName'] = $DoorContact["Name"];
            $val['DoorRexName']     = $DoorRex["Name"];
            $val['DoorLockName']    = $DoorLock["Name"];

            $val['ManTrapModeStr']    = EnumTable::$attrManTrapMode[$val["ManTrapMode"]];
            if( $val['PairDoorNo'] ) {
                $PairDoor   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No=?");
                $PairDoor->execute(array($_SESSION['spider_site'], $val['PairDoorNo']));
                $PairDoor   = $PairDoor->fetch(PDO::FETCH_ASSOC);
                $val['PairDoorName']    = $PairDoor["Name"];
            }
            $val['IsExteriorStr']    = $val["IsExterior"] == '1' ? '(Exterior)' : '';

            $val['FloorStr']            = $attrFloor[$val['Floor']];            
            $val['HeldOpenTimeStr']     = $val['HeldOpenTime']." (sec)";
            $val['AdaOpenTimeStr']      = $val['AdaOpenTime']." (sec)";

            if ($val['StrikeTime'] >= 0)
            {
            	$val['ReLockValue']     = 1;
	            $val['ReLockStr']       = $this->lang->addmsg->relock_on_yes;
	        }
	        else
	    	{
	    		$val['ReLockValue']     = 0;
	        	$val['ReLockStr']       = $this->lang->addmsg->relock_on_no;
	        }

			$val['LockTimeStr']         = $val['LockTime']." (sec)";
            $val['ExtendedEnableStr']   = EnumTable::$attrYesNo[$val['ExtendedEnable']];
            $val['ExtendedLockTimeStr'] = $val['ExtendedLockTime']." (min)";
			
            $val['DisableStr']          = EnumTable::$attrOnOff[$val['Disable']];
            $val['AlarmStr']            = EnumTable::$attrOnOff[$val['Alarm']];

            $val['ReaderFunctionStr']   = EnumTable::$attrReaderFunc[$val['ReaderFunction']];
            $val['MasterReaderName']    = $MasterReader["Name"];
            $val['MasterReaderType']    = $MasterReader["Type"];
            $val['MasterReaderTypeStr'] = EnumTable::$attrReaderType[$MasterReader['Type']];
            $val['MasterCardFormat']    = $MasterReader["CardFormatNo"];
            $val['MasterReaderRegionNo']    = $MasterReader["RegionNo"];
            $val['MasterReaderRegionStr']   = $attrRegion[$MasterReader["RegionNo"]];
            $val['SlaveReaderName']     = $SlaveReader["Name"];
            $val['SlaveReaderType']     = $SlaveReader["Type"];
            $val['SlaveReaderTypeStr']  = EnumTable::$attrReaderType[$SlaveReader['Type']];
            $val['SlaveCardFormat']     = $SlaveReader["CardFormatNo"];
            $val['SlaveReaderRegionNo']    = $SlaveReader["RegionNo"];
            $val['SlaveReaderRegionStr']   = $attrRegion[$SlaveReader["RegionNo"]];

            $val['CircuitTypeStr']      = CirciutType::$attrs[$door_contact[$val['ContactNo']]['Type']];
            $val['CircuitType']         = $door_contact[$val['ContactNo']]['Type'];

            $val['DoorContactEnable']   = $door_contact[$val['ContactNo']]['Disable'] == '1' ? '0' : '1';
            $val['DoorContactEnableStr']    = EnumTable::$attrYesNo[$val['DoorContactEnable']];
			
            $val['TimeAntiStr']         = $this->attrTimeAnti[$val['TimeAnti']];
            $val['RoomAntiStr']         = $this->attrRoomAnti[$val['RoomAnti']];
            $val['ZoneAntiStr']         = $this->attrZoneAnti[$val['ZoneAnti']];
            $val['Absence']             = $this->attrAbsenceAnti[$val['Absence']];

            $val['TimeAntiTypeStr']     = $this->attrTimeAntiType[$val['TimeAntiType']];
            $val['RoomAntiTypeStr']     = $this->attrRoomAntiType[$val['RoomAntiType']];
            $val['ZoneAntiTypeStr']     = $this->attrZoneAntiType[$val['ZoneAntiType']];
            $val['AbsenceTypeStr']      = $this->attrAbsenceType[$val['AbsenceType']];
            //$val['ZoneAntiReaderStr']   = $arr_reader["infor"][$val['ZoneAntiReader']];
            
            $val['TimeAntiTimeStr']     = $val['TimeAntiTime']." (sec)";
            $val['RoomAntiTimeStr']     = $val['RoomAntiTime']." (sec)";

            //$val['ReaderStr']           = $arr_reader["infor"][$val['MasterReader']];
            $val['UserList']            = $this->get_user_select($val['No']);
            $val['UserListStr']         = $this->get_user_select_str($val['No']);
            
            $val['DoorContactStateStr'] = EnumTable::$attrState[$val['DoorContactState']];
            $val['RexCircuitTypeStr']   = CirciutType::$attrs[$door_rex[$val['RexNo']]['Type']];
            $val['RexCircuitType']      = $door_rex[$val['RexNo']]['Type'];
            $val['RexAlarmStr']			= EnumTable::$attrOnOff[$door_rex[$val['RexNo']]['Alarm']];
            $val['RexAlarm']			= ($door_rex[$val['RexNo']]['Alarm'] == '0' ? '1' : '0');
            $val['LockModeStr']         = EnumTable::$attrLockMode[$val['LockMode']];
            $val['ThreatLevelStr']      = $attrThreat[$val['ThreatLevel']];
            $val['ThreatIgnoreRex']     = ($val['ThreatIgnoreRex'] == '1' ? '1' : '0');
            $val['ThreatIgnoreRexStr']  = EnumTable::$attrYesNo[$val['ThreatIgnoreRex']];

            $val['Client']              = $this->get_client($val['HostNo']);

            // Door Status Alarm Output
            $val['ForcedEnableStr']     = EnumTable::$attrYesNo[$val['ForcedEnable']];
            $val['HeldEnableStr']       = EnumTable::$attrYesNo[$val['HeldEnable']];
            $val['ShuntEnableStr']      = EnumTable::$attrYesNo[$val['ShuntEnable']];
			$val['AlarmofftypeStr']      = EnumTable::$attrYesNo[$val['Alarmofftype']];
			if(empty($val['PF_AuxOutputNo'])){
				$val['PF_AuxOutputNo'] = $val['No'];
			}
            $output = $this->get_output($val['PF_AuxOutputNo']);
            $val['PF_AuxOutputName']    = $output['Name'];
			if(empty($val['AS_AuxOutputNo'])){
				$val['AS_AuxOutputNo'] = $val['No'];
			}
            $output = $this->get_output($val['AS_AuxOutputNo']);
            $val['AS_AuxOutputName']    = $output['Name'];
            $val['BuzzerForcedEnableStr']     = EnumTable::$attrYesNo[$val['BuzzerForcedEnable']];
            $val['BuzzerHeldEnableStr']       = EnumTable::$attrYesNo[$val['BuzzerHeldEnable']];

            // Intercom
            $val['IntercomEnableStr'] = EnumTable::$attrYesNo[$val['IntercomEnable']];
            if(empty($val['IntercomAuxInputNo'])){
				$val['IntercomAuxInputNo'] = $val['No'];
			}
            $input = $this->get_input($val['IntercomAuxInputNo']);
            $val['IntercomAuxInputName'] = $input['Name'];

            // Occupancy
            $val['OccupancyEnableStr'] = EnumTable::$attrYesNo[$val['OccupancyEnable']];
            if(empty($val['OccupancyAuxInputNo'])){
				$val['OccupancyAuxInputNo'] = $val['No'];
			}
            $input = $this->get_input($val['OccupancyAuxInputNo']);
            $val['OccupancyAuxInputName'] = $input['Name'];
            $val['OccupancyCheckTimeStr'] = $val['OccupancyCheckTime']." (sec)";
            $val['OccupancyCheckTime2Str'] = $val['OccupancyCheckTime2']." (sec)";

            // Burglar
            $val['BurglarEnableStr'] = EnumTable::$attrYesNo[$val['BurglarEnable']];
            if(empty($val['BurglarAuxOutputNo'])){
				$val['BurglarAuxOutputNo'] = $val['No'];
			}
            $output = $this->get_output($val['BurglarAuxOutputNo']);
            $val['BurglarAuxOutputName'] = $output['Name'];
            if(empty($val['BurglarAuxInputNo'])){
				$val['BurglarAuxInputNo'] = $val['No'];
			}
            $input = $this->get_input($val['BurglarAuxInputNo']);
            $val['BurglarAuxInputName'] = $input['Name'];
            $val['BurglarZoneEnableStr'] = EnumTable::$attrYesNo[$val['BurglarZoneEnable']];
            if(empty($val['BurglarZoneInputNo'])){
				$val['BurglarZoneInputNo'] = $val['No'];
			}
            $input = $this->get_input($val['BurglarZoneInputNo']);
            $val['BurglarZoneInputName'] = $input['Name'];

            $val['FirstManRuleStr']     = $this->attrFirstManRule[$val['FirstManRule']];
			$val['FirstManSelectTypeName']	= EnumTable::$attrGroup[$val['FirstManSelectType']];
            $val['FirstManUserList']    = $this->get_f_user_select($val['No'], $val['FirstManSelectType']);
            $val['FirstManUserStr']     = $this->get_f_user_select_str($val['No'], $val['FirstManSelectType']);
            $val['GracePeriodStr']		= $val['GracePeriod'] .' '. $this->lang->common->minutes;
			if(!empty($val['FirstManReverse'])){
				$val['FirstManScheduleNo1']		= $val['FirstManReverse'];
			}else{
				$val['FirstManScheduleNo1']		= '';
			}
            $val['FirstManScheduleName1']	= $arr_schedule[$val['FirstManScheduleNo1']];
			$val['FirstManScheduleNo2']		= $val['FirstManSchedule2'];
			if(!empty($val['FirstManScheduleNo2'])){
				$val['FirstManScheduleName2']	= $arr_schedule[$val['FirstManScheduleNo2']];
			}else{
				$val['FirstManScheduleName2']		= '';
			}
			$val['FirstManScheduleNo3']		= $val['FirstManSchedule3'];
			if(!empty($val['FirstManScheduleNo3'])){
				$val['FirstManScheduleName3']	= $arr_schedule[$val['FirstManScheduleNo3']];
			}else{
				$val['FirstManScheduleName3']		= '';
			}

            $val['ManagerInStr']        = $this->attrManagerIn[$val['ManagerInRule']]; 
			$val['ManagerInTimeStr']    = $this->get_time_str($val['ManagerInReverse'], $val['ManagerInBeginHour'], $val['ManagerInBeginMin'], $val['ManagerInEndHour'], $val['ManagerInEndMin']);
			$val['ManagerInSelectTypeName']	= EnumTable::$attrGroup[$val['ManagerInSelectType']];
            $val['ManagerList']         = $this->get_manager_select($val['No'], $val['ManagerInSelectType']);
            $val['ManagerListStr']      = $this->get_manager_select_str($val['No'], $val['ManagerInSelectType']);
			$val['ManagerInScheduleNo1']	= $val['ManagerInReverse'];
			if(!empty($val['ManagerInScheduleNo1'])){
				$val['ManagerInScheduleName1']	= $arr_schedule[$val['ManagerInScheduleNo1']];
			}else{
				$val['ManagerInScheduleName1']		= '';
			}
			$val['ManagerInScheduleNo2']	= $val['ManagerInSchedule2'];
			if(!empty($val['ManagerInScheduleNo2'])){
				$val['ManagerInScheduleName2']	= $arr_schedule[$val['ManagerInScheduleNo2']];
			}else{
				$val['ManagerInScheduleName2']		= '';
			}
			$val['ManagerInScheduleNo3']	= $val['ManagerInSchedule3'];
			if(!empty($val['ManagerInScheduleNo3'])){
				$val['ManagerInScheduleName3']	= $arr_schedule[$val['ManagerInScheduleNo3']];
			}else{
				$val['ManagerInScheduleName3']		= '';
			}

            $val['TwoManRuleStr']       = $this->attrTwoManRule[$val['TwoManRule']];
            if ($val['TwoManTime'] == "")
            	$val['TwoManTime'] = 3;            
            $val['TwoManTimeStr']       = $val['TwoManTime']." (sec)";
			$val['TwoMan1SelectTypeName']	= EnumTable::$attrGroup[$val['TwoMan1SelectType']];
            $val['TwoMan1UserList']     = $this->get_t_user_select($val['No'], $val['TwoMan1SelectType']);
            $val['TwoMan1UserStr']      = $this->get_t_user_select_str($val['No'], $val['TwoMan1SelectType']);
			$val['TwoMan2SelectTypeName']	= EnumTable::$attrGroup[$val['TwoMan2SelectType']];
            $val['TwoMan2UserList']     = $this->get_t2_user_select($val['No'], $val['TwoMan2SelectType']);
            $val['TwoMan2UserStr']      = $this->get_t2_user_select_str($val['No'], $val['TwoMan2SelectType']);
            
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }
    
   public function find()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        
        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=? AND Disable='0'");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' ");
            }
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable='0' ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' 
                                                           ORDER BY A.No DESC");
            }
            
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=? AND Disable='0' AND $field LIKE ?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' 
                                                           AND A.$field LIKE ? ");
            }
            
            $count->execute(array($_SESSION['spider_site'], "%".$word."%"));
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable='0' AND $field LIKE ? ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable='0' 
                                                           AND A.$field LIKE ? 
                                                           ORDER BY A.No DESC");
            }
            $list->execute(array($_SESSION['spider_site'], "%".$word."%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
   public function find2()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        
        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Disable='0'");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Disable='0' ");
            }
            
            $count->execute();
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE Disable='0' ORDER BY No DESC");
            }
            else{
                $list  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Disable='0' 
                                                           ORDER BY A.No DESC ");
            }
            
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE $field LIKE ? AND Disable='0'");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Disable='0' 
                                                           AND A.$field LIKE ? ");
            }
            
            $count->execute(array("%".$word."%"));
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE $field LIKE ? AND Disable='0' ORDER BY No DESC");
            }
            else{
                $count  = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Disable='0' 
                                                           AND A.$field LIKE ? 
                                                           ORDER BY A.No DESC)");
            }
            $list->execute(array("%".$word."%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

   public function get_time_str($Reverse, $StartHour, $StartMin, $EndHour, $EndMin)
    {
        $retStr = "";
        
        if ($Reverse > 0)
        {
            $retStr = sprintf("~%02d:%02d, %02d:%02d~", $StartHour, $StartMin, $EndHour, $EndMin);
        }
        else
        {
            $retStr = sprintf("%02d:%02d ~ %02d:%02d", $StartHour, $StartMin, $EndHour, $EndMin);
        }

        return $retStr;
    }
    
    // ----------------------------------------------------------------------------------

   public function insert()
    {
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No                 = $this->input->post('No');        
        $Disable            = $this->input->post('Ddisable', 0);
        $Alarm              = $this->input->post('Alarm', 0);
        $Name               = strip_tags(trim($this->input->post('Name')));
        $Name               = str_replace("'", " ", $Name);
        $Mean               = strip_tags($this->input->post('Mean'));
        $Floor              = $this->input->post('Floor', 0);
        $ReaderFunction     = $this->input->post('ReaderFunction', 0);
        $MasterReader       = $this->input->post('MasterReader');
        $MasterReaderName   = strip_tags($this->input->post('MasterReaderName'));
        $MasterReaderType   = $this->input->post('MasterReaderType', 0);
        $SlaveReader        = $this->input->post('SlaveReader');
        $SlaveReaderName    = strip_tags($this->input->post('SlaveReaderName'));
        $SlaveReaderType    = $this->input->post('SlaveReaderType', 0);
        $MasterReaderRegionNo   = $this->input->post('MasterReaderRegionNo', 0);
        $SlaveReaderRegionNo    = $this->input->post('SlaveReaderRegionNo', 0);
        $MasterCardFormat   = $this->input->post('MasterCardFormat', 0);
        $SlaveCardFormat    = $this->input->post('SlaveCardFormat', 0);
        $DoorContact        = $this->input->post('DoorContact', 0);
        $DoorContactName    = strip_tags($this->input->post('DoorContactName'));
        $DoorLock           = $this->input->post('DoorLock', 0);
        $DoorLockName       = strip_tags($this->input->post('DoorLockName'));
        $DoorRex            = $this->input->post('DoorRex', 0);
        $DoorRexName        = strip_tags($this->input->post('DoorRexName'));
        $ThreatLevel        = $this->input->post('ThreatLevel', 0);
        $DoorContactEnable  = $this->input->post('DoorContactEnable', 0);
        $HeldOpenTime       = $this->input->post('HeldOpenTime', 0);
        $AdaOpenTime        = $this->input->post('AdaOpenTime', 0);
        $LockMode           = $this->input->post('LockMode', 0);
        $ReLockValue        = $this->input->post('ReLockValue', 0);

		if ($ReLockValue == 0)
        	$StrikeTime = -1;
		else
			$StrikeTime = 0;

        $LockTime           = $this->input->post('LockTime', 0);
        $ExtendedEnable     = $this->input->post('ExtendedEnable', 0);
        $ExtendedLockTime   = $this->input->post('ExtendedLockTime', 0);
        $TimeAnti           = $this->input->post('TimeAnti', 0);
        $TimeAntiType       = $this->input->post('TimeAntiType', 0);
        $TimeAntiTime       = $this->input->post('TimeAntiTime', 0);
        $RoomAnti           = $this->input->post('RoomAnti', 0);
        $RoomAntiType       = $this->input->post('RoomAntiType', 0);
        $RoomAntiTime       = $this->input->post('RoomAntiTime', 0);
        $ZoneAnti           = $this->input->post('ZoneAnti', 0);
        $ZoneAntiType       = $this->input->post('ZoneAntiType', 0);
        $ZoneAntiReader     = $this->input->post('ZoneAntiReader', 0);
        $ZoneAntiTime       = $this->input->post('ZoneAntiTime', 0);
        $Absence            = $this->input->post('Absence', 0);
        $AbsenceType        = $this->input->post('AbsenceType', 0);
        $DoorContactState   = $this->input->post('DoorContactState');
        $Position           = $this->input->post('Position');
        
        $RexCircuitType     = $this->input->post('RexCircuitType');
		$RexAlarm			= $this->input->post('RexAlarm', '1');
        $CiruitType         = $this->input->post('CircuitType');
        $ThreatLevel        = $this->input->post('ThreatLevel');
        $ThreatIgnoreRex    = $this->input->post('ThreatIgnoreRex', 0);

        $TwoManRule         = $this->input->post('TwoManRule', 0);
        $TwoManTime         = $this->input->post('TwoManTime', 6);
		$TwoMan1SelectType  = $this->input->post('TwoMan1SelectType', 1);
        $TwoMan1UserList    = $this->input->post('TwoMan1UserList1', array());
		$TwoMan2SelectType  = $this->input->post('TwoMan2SelectType', 1);
        $TwoMan2UserList    = $this->input->post('TwoMan2UserList1', array());

        $FirstManRule       = $this->input->post('FirstManRule', 0);
        $GracePeriod        = $this->input->post('GracePeriod', 0);
        $FirstManScheduleNo1    = $this->input->post('FirstManScheduleNo1', 0);
        $FirstManScheduleNo2    = $this->input->post('FirstManScheduleNo2', 0);
        $FirstManScheduleNo3    = $this->input->post('FirstManScheduleNo3', 0);
		$FirstManSelectType = $this->input->post('FirstManSelectType', 1);
        $FirstManUserList   = $this->input->post('FirstManUserList1', array());
        
        $ManagerInRule      = $this->input->post('ManagerInRule', 0);
        $ManagerInScheduleNo1    = $this->input->post('ManagerInScheduleNo1', 0);
        $ManagerInScheduleNo2    = $this->input->post('ManagerInScheduleNo2', 0);
        $ManagerInScheduleNo3    = $this->input->post('ManagerInScheduleNo3', 0);
		$ManagerInSelectType = $this->input->post('ManagerInSelectType', 1);
        $ManagerList        = $this->input->post('ManagerList1', array());
        
        $UserList           = $this->input->post('UserList', array());

        $ForcedEnable       = $this->input->post('ForcedEnable', 0);
        $HeldEnable         = $this->input->post('HeldEnable', 0);
        $ShuntEnable        = $this->input->post('ShuntEnable', 0);
        $Alarmofftype        = $this->input->post('Alarmofftype', 0);
        $PF_AuxOutputNo     = $this->input->post('PF_AuxOutputNo', 0);
        $AS_AuxOutputNo     = $this->input->post('AS_AuxOutputNo', 0);
        $BuzzerForcedEnable       = $this->input->post('BuzzerForcedEnable', 0);
        $BuzzerHeldEnable         = $this->input->post('BuzzerHeldEnable', 0);
        
        $IntercomEnable     = $this->input->post('IntercomEnable', 0);
        $IntercomAuxInputNo   = $this->input->post('IntercomAuxInputNo', 0);

        $OccupancyEnable     = $this->input->post('OccupancyEnable', 0);
        $OccupancyAuxInputNo   = $this->input->post('OccupancyAuxInputNo', 0);
        $OccupancyCheckTime     = $this->input->post('OccupancyCheckTime', 0);
        $OccupancyCheckTime2     = $this->input->post('OccupancyCheckTime2', 0);

        $BurglarEnable     = $this->input->post('BurglarEnable', 0);
        $BurglarAuxOutputNo   = $this->input->post('BurglarAuxOutputNo', 0);
        $BurglarAuxInputNo   = $this->input->post('BurglarAuxInputNo', 0);
        $BurglarZoneEnable     = $this->input->post('BurglarZoneEnable', 0);
        $BurglarZoneInputNo   = $this->input->post('BurglarZoneInputNo', 0);

        if( empty($Name) ) $this->util->alert( $this->lang->menu->error_name_required, TRUE );
        
        $MasterIsMuster = '0';
        if( $MasterReaderRegionNo != '0')
        {
            $MasterMuster = $this->conn->prepare("SELECT OnlyMuster FROM Region WHERE No = '".$MasterReaderRegionNo."'");
            $MasterMuster->execute();
            $MasterIsMuster = $MasterMuster->fetchColumn();
        }
        
        $SlaveIsMuster = '0';
        if( $SlaveReaderRegionNo != '0' )
        {
            $SlaveMuster = $this->conn->prepare("SELECT OnlyMuster FROM Region WHERE No = '".$SlaveReaderRegionNo."'");
            $SlaveMuster->execute();
            $SlaveIsMuster = $SlaveMuster->fetchColumn();
        }
        
        if( $MasterIsMuster == '0' && $SlaveIsMuster == '0' )
        {
            if( $MasterReaderRegionNo != '0' || $SlaveReaderRegionNo != '0')
            {
                if( $MasterReaderRegionNo == $SlaveReaderRegionNo )
                {
                    $this->util->alert( $this->lang->door->error_region_duplicte, TRUE );
                }
            }
            
            if( $MasterReaderRegionNo != '0' && $SlaveReaderRegionNo == '0')
            {
                $this->util->alert( $this->lang->door->error_region_not_allowed, TRUE );
            }
        }
        else
        {
            if( $MasterReaderRegionNo != $SlaveReaderRegionNo )
            {
                $this->util->alert( $this->lang->door->error_region_not_same_muster, TRUE );
            }
        }

        if( $ForcedEnable != TRUE && $HeldEnable != TRUE)
        {
            $PF_AuxOutputNo = 0;
        }
        if( $ShuntEnable != TRUE )
        {
            $AS_AuxOutputNo = 0;
        }
        if( $IntercomEnable != TRUE )
        {
            $IntercomAuxInputNo = 0;
        }
        if( $OccupancyEnable != TRUE )
        {
            $OccupancyAuxInputNo = 0;
        }
        if( $BurglarEnable != TRUE )
        {
            $BurglarAuxOutputNo = 0;
            $BurglarAuxInputNo = 0;
			$BurglarZoneEnable = FALSE;
			$BurglarZoneInputNo = 0;
        }
        if( $BurglarZoneEnable != TRUE )
        {
            $BurglarZoneInputNo = 0;
        }

        $RuleCount = 0;
        if( !empty($TimeAnti) )
        {
            $RuleCount++;
        }
        
        if( !empty($RoomAnti) )
        {
            $RuleCount++;
        }

        if( $RuleCount > 1 )
        {
            $this->util->alert( $this->lang->door->error_too_many_rule, TRUE );
        }

        if( !empty($ManagerInRule) && !empty($TwoManRule) )
        {
            $this->util->alert( $this->lang->door->error_too_many_rule, TRUE );
        }

        if( !empty($TwoManRule) && (!empty($ManagerInRule) || !empty($FirstManRule)))
        {
            $this->util->alert( $this->lang->door->error_too_many_rule, TRUE );
        }

        foreach( $TwoMan1UserList as $user ) 
        {
			if( in_array($user, $TwoMan2UserList) ) {
				$this->util->alert( $this->lang->door->error_too_many_rule_same, TRUE );
			}
		}

        if( !empty($FirstManRule) ) 
        {
            if( empty($FirstManScheduleNo1) && empty($FirstManScheduleNo2) && empty($FirstManScheduleNo3) )
                $this->util->alert( $this->lang->door->error_required_firstman_rule_schedule, TRUE );
			if( !empty($FirstManScheduleNo1) && ($FirstManScheduleNo1 == $FirstManScheduleNo2 || $FirstManScheduleNo1 == $FirstManScheduleNo3) )
                $this->util->alert( $this->lang->door->error_duplicate_firstman_rule_schedule, TRUE );
			if( !empty($FirstManScheduleNo2) && $FirstManScheduleNo2 == $FirstManScheduleNo3 )
                $this->util->alert( $this->lang->door->error_duplicate_firstman_rule_schedule, TRUE );
			if( count($FirstManUserList) < 1 )						$this->util->alert( $this->lang->door->error_required_firstman_rule_user, TRUE );
		}

		if( !empty($ManagerInRule) ) {
			if( empty($ManagerInScheduleNo1) && empty($ManagerInScheduleNo2) && empty($ManagerInScheduleNo3) )
                $this->util->alert( $this->lang->door->error_required_manager_rule_schedule, TRUE );
			if( !empty($ManagerInScheduleNo1) && ($ManagerInScheduleNo1 == $ManagerInScheduleNo2 || $ManagerInScheduleNo1 == $ManagerInScheduleNo3) )
                $this->util->alert( $this->lang->door->error_duplicate_manager_rule_schedule, TRUE );
			if( !empty($ManagerInScheduleNo2) && $ManagerInScheduleNo2 == $ManagerInScheduleNo3 )
                $this->util->alert( $this->lang->door->error_duplicate_manager_rule_schedule, TRUE );
			if( count($ManagerList) < 1 )				$this->util->alert( $this->lang->door->error_required_manager_rule_user, TRUE );
		}

		if( !empty($TwoManRule) ) {
			if( count($TwoMan1UserList) < 1 )		$this->util->alert( $this->lang->door->error_required_twoman_rule_user, TRUE );
			if( count($TwoMan2UserList) < 1 )		$this->util->alert( $this->lang->door->error_required_twoman_rule_user, TRUE );
		}

        // ±âÁ¸ Door Á¤º¸
        $tmpDoor   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No = ?");
        $tmpDoor->execute(array($_SESSION['spider_site'], $No));
        $tmpDoor   = $tmpDoor->fetch(PDO::FETCH_ASSOC);

        $LockMode    = $this->input->post('LockMode', $tmpDoor['LockMode']);
        $PairDoorNo  = $this->input->post('PairDoorNo', $tmpDoor['PairDoorNo']);
        $ManTrapMode = $this->input->post('ManTrapMode', $tmpDoor['ManTrapMode']);
    
		if($TwoManRule != '1')
		{
            $TempClear  = $this->net_work->prepare("UPDATE TwoManTemp SET Date=0 WHERE DoorNo=?");
            $TempClear->execute(array($No));
		}

        if($ZoneAnti == '1')
        {
            $ZoneReader = $this->conn->prepare("SELECT ZoneAntiReader FROM Door WHERE No = '".$No."'");
            $ZoneReader->execute();
            $ZoneReader = $ZoneReader->fetchColumn();
            
            if($ZoneReader !== $Z_anti_reader)
            {
                $z_reader = $this->conn->prepare("UPDATE Reader SET Anti= '' WHERE No = '".$ZoneReader."'");
                $z_reader->execute();
                
                $z_in_reader = $this->conn->prepare("UPDATE Reader SET Anti= '1' WHERE No = '".$ZoneAntiReader."'");
                $z_in_reader->execute();
            }
        }
        else
        {
            $ZoneReader = $this->conn->prepare("SELECT ZoneAntiReader FROM Door WHERE No = '".$No."'");
            $ZoneReader->execute();
            $ZoneReader = $ZoneReader->fetchColumn();
            
            if($ZoneReader)
            {
                $z_reader   = $this->conn->prepare("UPDATE Reader SET Anti= '' WHERE No = '".$ZoneReader."'");
                $z_reader->execute();
            }
        }
        if($DoorContactState)
        {
            $updte_lock  = $this->conn->prepare("UPDATE DoorLock SET Name=?, State=? WHERE No=?");
            $updte_lock->execute(array($DoorLockName, $DoorContactState, $No));
        }
        else
        {
            $updte_lock  = $this->conn->prepare("UPDATE DoorLock SET Name=? WHERE No=?");
            $updte_lock->execute(array($DoorLockName, $No));
        }
        if($RexCircuitType)
        {
            $updte_rex  = $this->conn->prepare("UPDATE DoorRex SET Name=?, Type=?, Alarm=? WHERE No=?");
            $updte_rex->execute(array($DoorRexName, $RexCircuitType, $RexAlarm, $No));
        }
        else
        {
            $updte_rex  = $this->conn->prepare("UPDATE DoorRex SET Name=? WHERE No=?");
            $updte_rex->execute(array($DoorRexName, $No));
        }
        
        // #2088 Door Lock Mode °¡ Man Trap ÀÎ °æ¿ì¿¡´Â Door Contact À» ¹«Á¶°Ç Enable True ·Î ¼³Á¤ÇÔ (Pair Door±îÁö)
        $DoorContactDisable = (($DoorContactEnable == '1' || $LockMode == '4')? '0' : '1');
        $updte_contact  = $this->conn->prepare("UPDATE DoorContact SET Name=?, Disable=?, Type=? WHERE No=?");
        $updte_contact->execute(array($DoorContactName,$DoorContactDisable,$CiruitType,$No));

        $master_reader   = $this->conn->prepare("UPDATE Reader SET Name='".$MasterReaderName."', Type='".$MasterReaderType."', CardFormatNo='".$MasterCardFormat."', RegionNo='".$MasterReaderRegionNo."', OppRegionNo='".$SlaveReaderRegionNo."' WHERE No = '".$MasterReader."'");
        $master_reader->execute();

        $slave_reader   = $this->conn->prepare("UPDATE Reader SET Name='".$SlaveReaderName."', Type='".$SlaveReaderType."', CardFormatNo='".$SlaveCardFormat."', RegionNo='".$SlaveReaderRegionNo."', OppRegionNo='".$MasterReaderRegionNo."' WHERE No = '".$SlaveReader."'");
        $slave_reader->execute();
        
        $sth    = $this->conn->prepare("UPDATE Door 
                                           SET Disable=?,Alarm=?,Name=?,Mean=?,Floor=?,ReaderFunction=?,ThreatLevel=?,ThreatIgnoreRex=?,
                                               HeldOpenTime=?,AdaOpenTime=?,LockTime=?,ExtendedEnable=?,ExtendedLockTime=?,
                                               TimeAnti=?,TimeAntiType=?,TimeAntiTime=?,
                                               RoomAnti=?,RoomAntiType=?,RoomAntiTime=?,
                                               ZoneAnti=?,ZoneAntiType=?,ZoneAntiReader=?,ZoneAntiTime=?,
                                               Absence=?,AbsenceType=?,
                                               StrikeTime=?,DoorContactState=?,LockMode=?,
                                               TwoManRule=?,TwoManTime=?,
                                               FirstManRule=?,GracePeriod=?,FirstManReverse=?,FirstManSchedule2=?,FirstManSchedule3=?,
                                               ManagerInRule=?,ManagerInReverse=?,ManagerInSchedule2=?,ManagerInSchedule3=?,
											   FirstManSelectType=?,ManagerInSelectType=?,TwoMan1SelectType=?,TwoMan2SelectType=?,
                                               ForcedEnable=?,HeldEnable=?,ShuntEnable=?,PF_AuxOutputNo=?,AS_AuxOutputNo=?,Alarmofftype=?,
                                               BuzzerForcedEnable=?,BuzzerHeldEnable=?,IntercomEnable=?,IntercomAuxInputNo=?,
                                               OccupancyEnable=?,OccupancyAuxInputNo=?,OccupancyCheckTime=?,OccupancyCheckTime2=?,
                                               BurglarEnable=?,BurglarAuxOutputNo=?,BurglarAuxInputNo=?,BurglarZoneEnable=?,BurglarZoneInputNo=?,
                                               IsExterior=0,ManTrapMode=0,PairDoorNo=0
											   WHERE No=?");

        $values = array($Disable,$Alarm,$Name,$Mean,$Floor,$ReaderFunction,$ThreatLevel,$ThreatIgnoreRex,
                        $HeldOpenTime,$AdaOpenTime,$LockTime,$ExtendedEnable,$ExtendedLockTime,
                        $TimeAnti,$TimeAntiType,$TimeAntiTime,
                        $RoomAnti,$RoomAntiType,$RoomAntiTime,
                        $ZoneAnti,$ZoneAntiType,$ZoneAntiReader,$ZoneAntiTime,
                        $Absence,$AbsenceType,
                        $StrikeTime,$DoorContactState,$LockMode,
                        $TwoManRule,$TwoManTime,
                        $FirstManRule,$GracePeriod,$FirstManScheduleNo1,$FirstManScheduleNo2,$FirstManScheduleNo3,
                        $ManagerInRule,$ManagerInScheduleNo1,$ManagerInScheduleNo2,$ManagerInScheduleNo3,
						$FirstManSelectType,$ManagerInSelectType,$TwoMan1SelectType,$TwoMan2SelectType,
                        $ForcedEnable,$HeldEnable,$ShuntEnable,$PF_AuxOutputNo,$AS_AuxOutputNo,$Alarmofftype,
                        $BuzzerForcedEnable,$BuzzerHeldEnable,$IntercomEnable,$IntercomAuxInputNo,
                        $OccupancyEnable,$OccupancyAuxInputNo,$OccupancyCheckTime,$OccupancyCheckTime2,
                        $BurglarEnable,$BurglarAuxOutputNo,$BurglarAuxInputNo,$BurglarZoneEnable,$BurglarZoneInputNo,
						$No);

        if( $sth->execute($values) )
        {
            $Port           = $this->input->post('Port', 0);
            $HostNo         = $this->input->post('HostNo', 0);
            $IsExterior     = $this->input->post('IsExterior', 0);
            $PairDoorNo     = $this->input->post('PairDoorNo', $tmpDoor['PairDoorNo']);
            $ManTrapMode    = $this->input->post('ManTrapMode', $tmpDoor['ManTrapMode']);

            if( $Port == '1' ) {
                $mantrap  = $this->conn->prepare("UPDATE Door SET LockMode=0, IsExterior=0, ManTrapMode=0, PairDoorNo=0 WHERE Site=? AND HostNo=? AND LockMode=4");
                $mantrap->execute(array($_SESSION['spider_site'],$HostNo));

                if( $LockMode == '4' ) {
                    $mantrap  = $this->conn->prepare("UPDATE Door SET LockMode=?, IsExterior=?, ManTrapMode=?, PairDoorNo=? WHERE Site=? AND No=?");
                    $mantrap->execute(array($LockMode,$IsExterior,$ManTrapMode,$PairDoorNo,$_SESSION['spider_site'],$No));

                    $PairExterior   = $IsExterior == '1' ? '0' : '1';

                    $mantrap  = $this->conn->prepare("UPDATE Door SET LockMode=?, IsExterior=?, ManTrapMode=?, PairDoorNo=? WHERE Site=? AND No=?");
                    $mantrap->execute(array($LockMode,$PairExterior,$ManTrapMode,$No,$_SESSION['spider_site'],$PairDoorNo));
                    
                    // #2088 Lock Mode °¡ Man Trap ÀÎ °æ¿ì Pair Door ÀÇ Door Contact µµ Enable True ·Î ÇÑ´Ù.
			        $pair_contact  = $this->conn->prepare("UPDATE DoorContact SET Disable=0 WHERE Site=? AND No=?");
			        $pair_contact->execute(array($_SESSION['spider_site'],$PairDoorNo));
                }
            }

            $sth    = $this->conn->prepare("DELETE FROM AbsenceAnti WHERE DoorNo=?");
            $sth->execute( array($No) );

            $sth    = $this->conn->prepare("INSERT INTO AbsenceAnti (DoorNo,UserNo) VALUES (?,?)");
            foreach( $UserList as $value )
            {
                $sth->execute( array($No, $value) );
            }

            $sth    = $this->conn->prepare("DELETE FROM TwoManRule WHERE DoorNo=?");
            $sth->execute( array($No) );

            $sth    = $this->conn->prepare("INSERT INTO TwoManRule (DoorNo,UserNo1) VALUES (?,?)");
            foreach( $TwoMan1UserList as $value )
            {
                $sth->execute( array($No, $value) );
            }

            $sth    = $this->conn->prepare("INSERT INTO TwoManRule (DoorNo,UserNo2) VALUES (?,?)");
            foreach( $TwoMan2UserList as $value )
            {
                $sth->execute( array($No, $value) );
            }

            $sth    = $this->conn->prepare("DELETE FROM FirstManIn WHERE DoorNo=?");
            $sth->execute( array($No) );

            $sth    = $this->conn->prepare("INSERT INTO FirstManIn (DoorNo,FirstManUserNo) VALUES (?,?)");
            foreach( $FirstManUserList as $value )
            {
                $sth->execute( array($No, $value) );
            }

            $TempClear  = $this->net_work->prepare("UPDATE FirstManTemp SET Date=0 WHERE DoorNo=? AND FirstManUserNo NOT IN (".implode(',', $FirstManUserList).")");
            $TempClear->execute(array($No));

            $sth    = $this->conn->prepare("DELETE FROM ManagerIn WHERE DoorNo=?");
            $sth->execute( array($No) );

            $sth    = $this->conn->prepare("INSERT INTO ManagerIn (DoorNo,UserNo) VALUES (?,?)");
            foreach( $ManagerList as $value )
            {
                $sth->execute( array($No, $value) );
            }
            
            $TempClear  = $this->net_work->prepare("UPDATE ManagerIn SET TagDate=0 WHERE DoorNo=? AND UserNo NOT IN (".implode(',', $ManagerList).")");
            $TempClear->execute(array($No));

			$this->log->set_log_message($Name);	            
	        $this->util->js('update_list("'.$No.'"); init_view();');
            
            $this->util->alert( $this->lang->common->save_completed );
	            
            exec(SPIDER_COMM." adc door $No");
            if( $LockMode == 4 ) {  // Man Trap ÀÏ¶§
                exec(SPIDER_COMM." door $No ".strtolower( str_replace(' ', '', EnumTable::$attrLockMode[$LockMode]) )." ".$ManTrapMode );
                exec(SPIDER_COMM." door $PairDoorNo ".strtolower( str_replace(' ', '', EnumTable::$attrLockMode[$LockMode]) )." ".$ManTrapMode );
                if( $tmpDoor['PairDoorNo'] != '0' && $tmpDoor['PairDoorNo'] != $PairDoorNo ) {
                    exec(SPIDER_COMM." door {$tmpDoor['PairDoorNo']} ".strtolower( str_replace(' ', '', EnumTable::$attrLockMode[0]) ) );
                }
            } else {
                exec(SPIDER_COMM." door $No ".strtolower( str_replace(' ', '', EnumTable::$attrLockMode[$LockMode]) ) );
                if( $tmpDoor['PairDoorNo'] != '0' ) {
                    exec(SPIDER_COMM." door {$tmpDoor['PairDoorNo']} ".strtolower( str_replace(' ', '', EnumTable::$attrLockMode[$LockMode]) ) );
                }
            }
            exec(SPIDER_COMM." checkinfirstman $No");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
    }

    // ----------------------------------------------------------------------------------
   public function get_input($No) {
        $input  = $this->conn->prepare("SELECT * FROM AuxInput WHERE Site=? AND No=?");
        $input->execute(array($_SESSION['spider_site'], $No));
        $input  = $input->fetch(PDO::FETCH_ASSOC);

        return $input;
    }

    // ----------------------------------------------------------------------------------

   public function get_output($No)
    {
        $output  = $this->conn->prepare("SELECT * FROM AuxOutput WHERE Site=? AND No=?");
        $output->execute(array($_SESSION['spider_site'], $No));
        $output  = $output->fetch(PDO::FETCH_ASSOC);

        return $output;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_floor()
    {
        $cfloor = $this->conn->prepare("SELECT * FROM Floor WHERE Site=?");
        $cfloor->execute(array($_SESSION['spider_site']));
        $cfloor = $cfloor->fetchAll(PDO::FETCH_ASSOC);

        $arr_floor  = array();
        foreach( $cfloor as $key=>$val)
        {
            $arr_floor[$val['No']]  = $val['Name'];
        }

        return $arr_floor;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_reader()
    {
        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM Reader WHERE Site=?");
        }
        else{
            $list   = $this->conn->prepare("SELECT A.* FROM Reader AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? ");
        }
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr  = array();
        $arr1 = array();
        $arr2 = array();
        $arr3 = array();

        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
            $arr1[$val['No']]   = $val['Type'];
            $arr2[$val['No']]   = EnumTable::$attrReaderType[$val['Type']];
            $arr3[$val['No']]   = $val['CardFormatNo'];
        }

        $Aarr = array("infor"=> $arr, "Type" => $arr1, "TypeStr" => $arr2, "CardFormatNo" => $arr3);

        return $Aarr;
    }

   public function to_door_contact()
    {
        if( $this->is_SuperAdmin() == true )
        {
            $contactlist = $this->conn->prepare("SELECT * FROM DoorContact WHERE Site=?");
        }
        else{
            $contactlist = $this->conn->prepare("SELECT A.* FROM DoorContact AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? ");
        }
        $contactlist->execute(array($_SESSION['spider_site']));
        $contactlist = $contactlist->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $contactlist as $key=>$val)
        {
            $arr[$val['No']]  = $val;
        }
        
        return $arr;
    }
    
   public function to_door_rex()
    {
        if( $this->is_SuperAdmin() == true )
        {
            $rexlist = $this->conn->prepare("SELECT * FROM DoorRex WHERE Site=?");
        }
        else{
            $rexlist = $this->conn->prepare("SELECT A.* FROM DoorRex AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? ");
        }
        $rexlist->execute(array($_SESSION['spider_site']));
        $rexlist = $rexlist->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $rexlist as $key=>$val)
        {
            $arr[$val['No']]  = $val;
        }
        
        return $arr;
    }   
    
   public function to_threat_level()
    {
        $threatlist = $this->conn->prepare("SELECT * FROM ThreatLevel WHERE Site=?");
        $threatlist->execute(array($_SESSION['spider_site']));
        $threatlist = $threatlist->fetchAll(PDO::FETCH_ASSOC);
        
        $arr_threat = array();
        foreach( $threatlist as $key=>$val)
        {
            $arr_threat[$val['Level']]  = $val['ThreatName'];
        }

        return $arr_threat;
    }
    
    // ----------------------------------------------------------------------------------

   public function get_user_select($No)
    {
        $list   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND No IN (SELECT UserNo FROM AbsenceAnti WHERE DoorNo = ?)");
        $list->execute(array($_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        return $list;
    }

    // ----------------------------------------------------------------------------------

   public function get_user_select_str($No)
    {
        $arr    = array();
        $list   = $this->get_user_select($No);
        foreach( $list as $val )
        {
            $arr[]  = $val['FirstName'] .' '. $val['MiddleName'] .' '. $val['LastName'];
        }

        return implode(',', $arr);
    }

    // ----------------------------------------------------------------------------------

   public function get_user_to_options()
    {
		$options = array();
/*
        $list   = $this->conn->prepare("SELECT No, FirstName, MiddleName, LastName FROM User WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

		foreach( $list as $item ) {
			$options[$item['No']] = $item['FirstName'] .' '. $item['MiddleName'] .' '. $item['LastName'];
		}
*/
        return $options;
    }

    // ----------------------------------------------------------------------------------

   public function get_f_user_select($No, $SelectType)
    {
		$list = array();

		if($SelectType == ConstTable::INDIVIDUAL) {
	        $list   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND No IN (SELECT FirstManUserNo FROM FirstManIn WHERE DoorNo = ?)");
		    $list->execute(array($_SESSION['spider_site'], $No));
			$list   = $list->fetchAll(PDO::FETCH_ASSOC);
		} else if($SelectType == ConstTable::GROUP) {
	        $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND No IN (SELECT FirstManUserNo FROM FirstManIn WHERE DoorNo = ?)");
		    $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_USER, $No));
			$list   = $list->fetchAll(PDO::FETCH_ASSOC);
		}

        return $list;
    }

   public function get_f_user_select_str($No, $SelectType)
    {
        $arr    = array();
        $list   = $this->get_f_user_select($No, $SelectType);
        foreach( $list as $val )
        {
			if($SelectType == ConstTable::INDIVIDUAL) {
	            $arr[]  = $val['FirstName'] .' '. $val['MiddleName'] .' '. $val['LastName'];
			} else if($SelectType == ConstTable::GROUP) {
				$arr[]  = $val['Name'];
			}
        }

        return implode(',', $arr);
    }
    
    // ----------------------------------------------------------------------------------

   public function get_manager_select($No, $SelectType)
    {
		$list = array();

		if($SelectType == ConstTable::INDIVIDUAL) {
	        $list   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND No IN (SELECT UserNo FROM ManagerIn WHERE DoorNo = ?)");
		    $list->execute(array($_SESSION['spider_site'], $No));
			$list   = $list->fetchAll(PDO::FETCH_ASSOC);
		} else if($SelectType == ConstTable::GROUP) {
	        $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND No IN (SELECT UserNo FROM ManagerIn WHERE DoorNo = ?)");
		    $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_USER, $No));
			$list   = $list->fetchAll(PDO::FETCH_ASSOC);
		}

        return $list;
    }

    // ----------------------------------------------------------------------------------

   public function get_manager_select_str($No, $SelectType)
    {
        $arr    = array();
        $list   = $this->get_manager_select($No, $SelectType);
        foreach( $list as $val )
        {
			if($SelectType == ConstTable::INDIVIDUAL) {
	            $arr[]  = $val['FirstName'] .' '. $val['MiddleName'] .' '. $val['LastName'];
			} else if($SelectType == ConstTable::GROUP) {
				$arr[]  = $val['Name'];
			}
        }

        return implode(',', $arr);
    }    

    // ----------------------------------------------------------------------------------

   public function get_t_user_select($No, $SelectType)
    {
        $list = array();
        $SiteNo = $_SESSION['spider_site'];       

		if($SelectType == ConstTable::INDIVIDUAL) {
            
            $list   = $this->conn->prepare("SELECT No, IFNULL(FirstName,'') AS FirstName, IFNULL(MiddleName,'') AS MiddleName, IFNULL(LastName,'') AS LastName FROM User WHERE Site=".$SiteNo." AND No IN (SELECT UserNo1 FROM TwoManRule WHERE DoorNo =?)");
            $list->execute(array($No));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);

		} else if($SelectType == ConstTable::GROUP) {
	        $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND No IN (SELECT UserNo1 FROM TwoManRule WHERE DoorNo = ?)");
		    $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_USER, $No));
			$list   = $list->fetchAll(PDO::FETCH_ASSOC);
		}

        return $list;
    }

    // ----------------------------------------------------------------------------------

   public function get_t_user_select_str($No, $SelectType)
    {
        $arr    = array();
        $list   = $this->get_t_user_select($No, $SelectType);
        foreach( $list as $val )
        {
			if($SelectType == ConstTable::INDIVIDUAL) {
	            $arr[]  = $val['FirstName'] .' '. $val['MiddleName'] .' '. $val['LastName'];
			} else if($SelectType == ConstTable::GROUP) {
				$arr[]  = $val['Name'];
			}
        }

        return implode(',', $arr);
    }

    
    // ----------------------------------------------------------------------------------

   public function get_t2_user_select($No, $SelectType)
    {
        $list = array();
        $SiteNo = $_SESSION['spider_site'];

		if($SelectType == ConstTable::INDIVIDUAL) {
            $list   = $this->conn->prepare("SELECT No, IFNULL(FirstName,'') AS FirstName, IFNULL(MiddleName,'') AS MiddleName, IFNULL(LastName,'') AS LastName FROM User WHERE Site=".$SiteNo." AND No IN (SELECT UserNo2 FROM TwoManRule WHERE DoorNo =?)");        
            $list->execute(array($No));
            
			$list   = $list->fetchAll(PDO::FETCH_ASSOC);
		} else if($SelectType == ConstTable::GROUP) {
	        $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND No IN (SELECT UserNo2 FROM TwoManRule WHERE DoorNo = ?)");
		    $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_USER, $No));
			$list   = $list->fetchAll(PDO::FETCH_ASSOC);
		}

        return $list;
    }

    // ----------------------------------------------------------------------------------

   public function get_t2_user_select_str($No, $SelectType)
    {
        $arr    = array();
        $list   = $this->get_t2_user_select($No, $SelectType);
        foreach( $list as $val )
        {
			if($SelectType == ConstTable::INDIVIDUAL) {
	            $arr[]  = $val['FirstName'] .' '. $val['MiddleName'] .' '. $val['LastName'];
			} else if($SelectType == ConstTable::GROUP) {
				$arr[]  = $val['Name'];
			}
        }

        return implode(',', $arr);
    }

    // ----------------------------------------------------------------------------------

   public function get_client($HostNo)
    {
        $list   = $this->conn->prepare("SELECT Name FROM Controller WHERE No = ?");
        $list->execute(array($HostNo));
        $name   = $list->fetchColumn();

        return $name;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_card_format()
    {
        $list   = $this->conn->prepare("SELECT * FROM CardFormat");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------
    
   public function to_array_schedule()
    {
        $list   = $this->conn->prepare("SELECT * FROM Schedule WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array(''=>'');
        foreach ($list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------
    
   public function to_array_region()
    {
        $list   = $this->conn->prepare("SELECT * FROM Region WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array('0'=>$this->lang->door->uncontrolled_space);
        foreach ($list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------
    
   public function get_reader($no)
    {
        $list   = $this->conn->prepare("SELECT * FROM Reader WHERE Site=? AND No=?");
        $list->execute(array($_SESSION['spider_site'], $no));
        $row   = $list->fetch(PDO::FETCH_ASSOC);

        return $row;
    }

    // ----------------------------------------------------------------------------------

   public function get_doorcontact($no)
    {
        $list   = $this->conn->prepare("SELECT * FROM DoorContact WHERE Site=? AND No=?");
        $list->execute(array($_SESSION['spider_site'], $no));
        $row   = $list->fetch(PDO::FETCH_ASSOC);

        return $row;
    }

    // ----------------------------------------------------------------------------------

   public function get_doorrex($no)
    {
        $list   = $this->conn->prepare("SELECT * FROM DoorRex WHERE Site=? AND No=?");
        $list->execute(array($_SESSION['spider_site'], $no));
        $row   = $list->fetch(PDO::FETCH_ASSOC);

        return $row;
    }

    // ----------------------------------------------------------------------------------

   public function get_doorlock($no)
    {
        $list   = $this->conn->prepare("SELECT * FROM DoorLock WHERE Site=? AND No=?");
        $list->execute(array($_SESSION['spider_site'], $no));
        $row   = $list->fetch(PDO::FETCH_ASSOC);

        return $row;
    }

    // ----------------------------------------------------------------------------------

}


?>