<?php


include APP_DIR.'/libraries/Reverse.php';

class dvr_setup extends controller
{

	// ----------------------------------------------------------------------------------

   public function dvr_setup()
	{
		parent::controller();
/*
		if(!$this->is_option(ConstTable::OPTION_NVR)) {
            $this->util->alert($this->lang->menu->error_not_permission);
            $this->util->back();
            exit;
		}
*/
    }

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $this->display();
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM DVR WHERE Site=? AND ViewerType=1");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM DVR WHERE Site=? AND ViewerType=1 ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM DVR WHERE Site=? AND ViewerType=1 AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM DVR WHERE Site=? AND ViewerType=1 AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['BrandStr'] = EnumTable::$attrDvrType[$val['Brand']];
            $val['ViewerTypeStr'] = EnumTable::$attrDvrViewerType[$val['ViewerType']];
            $val['DeliverEventStr'] = EnumTable::$attrYesNo[$val['DeliverEvent']];
            $val['DeliverRecordStr'] = EnumTable::$attrYesNo[$val['DeliverRecord']];
            $val['Channels'] = $this->get_channels($val['No']);
            $list[$key] = $val;
        }

        $result['field']    = $field;
        $result['word']     = $word;
        $result['page']     = $page;
        $result['view']     = $view;
        $result['pages']    = $pagination->get_pages();
        $result['count']    = $count;
        $result['list']     = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function insert()
    {
        $No = $this->conn->prepare("SELECT MAX(No) FROM DVR WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No = $No->fetchColumn() + 1;
        
        $Name	        = strip_tags(trim($this->input->post('Name')));
        $Name           = str_replace("'", "", $Name);
		$Mean	        = strip_tags($this->input->post('Mean'));
		$Mean           = str_replace("'", "", $Mean);
		$Brand	        = $this->input->post('Brand');
		$IP		        = $this->input->post('IP');
		$LivePort       = $this->input->post('LivePort');
		$SearchPort     = $this->input->post('SearchPort');
		$HttpID	        = $this->input->post('HttpID');
		$HttpPassword   = $this->input->post('HttpPassword');
		$FtpPort	    = $this->input->post('FtpPort');
		$FtpID		    = $this->input->post('FtpID');
		$FtpPassword	= $this->input->post('FtpPassword');
		$EventPort 	    = $this->input->post('EventPort');
		$PublicIP 	    = $this->input->post('PublicIP');
		$PublicHttpPort = $this->input->post('PublicHttpPort');
		$ViewerType	    = $this->input->post('ViewerType');
		$DeliverEvent   = $this->input->post('DeliverEvent');
		$DeliverRecord  = $this->input->post('DeliverRecord');
		$MaxChannel	    = $this->input->post('MaxChannel');
		$Channels	    = $this->input->post('Channels', array());

        if( empty($Name) )      		$this->util->alert( $this->lang->holiday->error_name_required, TRUE );
        
        //2015.06.02 by Zeno 
        if( empty($IP) )      			$this->util->alert( $this->lang->addmsg->dvr_ip_required, TRUE );
        
        
        if( empty($LivePort) )      	$this->util->alert( $this->lang->addmsg->dvr_live_port_required, TRUE );
        if( empty($SearchPort) )      	$this->util->alert( $this->lang->addmsg->dvr_search_port_required, TRUE );
        if( empty($HttpID) )      		$this->util->alert( $this->lang->addmsg->dvr_http_id_required, TRUE );
        //if( empty($HttpPassword) )      $this->util->alert( $this->lang->addmsg->dvr_http_password_required, TRUE );
        if( empty($EventPort) )      	$this->util->alert( $this->lang->addmsg->dvr_event_port_required, TRUE );
        if( empty($ViewerType) )      	$this->util->alert( $this->lang->addmsg->dvr_viewer_type_required, TRUE );
        if( empty($MaxChannel) )      	$this->util->alert( $this->lang->addmsg->dvr_max_channel_required, TRUE );
        
        $sth = $this->conn->prepare("INSERT INTO DVR (Site,No,Name,Mean,Brand,IP,LivePort,SearchPort,HttpID,HttpPassword,FtpPort,FtpID,FtpPassword,EventPort,PublicIP,PublicHttpPort,ViewerType,DeliverEvent,DeliverRecord,MaxChannel) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
        if( $sth->execute(array($_SESSION['spider_site'], $No, $Name, $Mean, $Brand, $IP, $LivePort, $SearchPort, $HttpID, $HttpPassword, $FtpPort, $FtpID, $FtpPassword, $EventPort, $PublicIP, $PublicHttpPort, $ViewerType, $DeliverEvent, $DeliverRecord, $MaxChannel)) )
        {
            $this->update_channel($No, $Channels, $MaxChannel);

            $this->log->set_log_message($Name);
            $this->util->js('load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No	            = $this->input->post('No');
        $Name	        = strip_tags(trim($this->input->post('Name')));
        $Name           = str_replace("'", "", $Name);
		$Mean	        = strip_tags($this->input->post('Mean'));
		$Mean           = str_replace("'", "", $Mean);
		$Brand	        = $this->input->post('Brand');
		$IP		        = $this->input->post('IP');
		$LivePort       = $this->input->post('LivePort');
		$SearchPort     = $this->input->post('SearchPort');
		$HttpID	        = $this->input->post('HttpID');
		$HttpPassword   = $this->input->post('HttpPassword');
		$FtpPort	    = $this->input->post('FtpPort');
		$FtpID		    = $this->input->post('FtpID');
		$FtpPassword	= $this->input->post('FtpPassword');
		$EventPort 	    = $this->input->post('EventPort');
		$PublicIP 	    = $this->input->post('PublicIP');
		$PublicHttpPort = $this->input->post('PublicHttpPort');
		$ViewerType	    = $this->input->post('ViewerType');
		$DeliverEvent   = $this->input->post('DeliverEvent');
		$DeliverRecord  = $this->input->post('DeliverRecord');
		$MaxChannel	    = $this->input->post('MaxChannel');
		$Channels	    = $this->input->post('Channels', array());
		
        if( empty($Name) )      		$this->util->alert( $this->lang->holiday->error_name_required, TRUE );
        
        if( empty($IP) )      			$this->util->alert( $this->lang->addmsg->dvr_ip_required, TRUE );
        
        if( empty($LivePort) )      	$this->util->alert( $this->lang->addmsg->dvr_live_port_required, TRUE );
        if( empty($SearchPort) )      	$this->util->alert( $this->lang->addmsg->dvr_search_port_required, TRUE );
        if( empty($HttpID) )      		$this->util->alert( $this->lang->addmsg->dvr_http_id_required, TRUE );
        //if( empty($HttpPassword) )      $this->util->alert( $this->lang->addmsg->dvr_http_password_required, TRUE );
        if( empty($EventPort) )      	$this->util->alert( $this->lang->addmsg->dvr_event_port_required, TRUE );
        if( empty($ViewerType) )      	$this->util->alert( $this->lang->addmsg->dvr_viewer_type_required, TRUE );
        if( empty($MaxChannel) )      	$this->util->alert( $this->lang->addmsg->dvr_max_channel_required, TRUE );
        
		
		$sth = $this->conn->prepare("UPDATE DVR SET Name=?, Mean=?, Brand=?, IP=?, LivePort=?, SearchPort=?, HttpID=?, HttpPassword=?, FtpPort=?, FtpID=?, FtpPassword=?, EventPort=?, PublicIP=?, PublicHttpPort=?, ViewerType=?, DeliverEvent=?, DeliverRecord=?, MaxChannel=? WHERE Site=? AND No=?");
		$values = array($Name, $Mean, $Brand, $IP, $LivePort, $SearchPort, $HttpID, $HttpPassword, $FtpPort, $FtpID, $FtpPassword, $EventPort, $PublicIP, $PublicHttpPort, $ViewerType, $DeliverEvent, $DeliverRecord, $MaxChannel, $_SESSION['spider_site'], $No);
		
	    if( $sth->execute($values) ) 
        {
            $this->update_channel($No, $Channels, $MaxChannel);

            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update_channel($DvrNo, $Channels, $MaxChannel)
    {
		for($i=0; $i<$MaxChannel; $i++) {
			$Channel	= $i + 1;
			$Name		= $Channels[$i];

			$row	= $this->conn->prepare("SELECT * FROM DVRChannel WHERE Type=1 AND DvrNo=? AND Channel=?");
			$row->execute(array($DvrNo, $Channel));
			$row	= $row->fetch(PDO::FETCH_ASSOC);
			if($row) {
				$sth	= $this->conn->prepare("UPDATE DVRChannel SET Name=? WHERE No=?");
				$sth->execute(array($Name, $row['No']));
			} else {
				$sth	= $this->conn->prepare("INSERT INTO DVRChannel (Name,DvrNo,Channel,Type) VALUES (?,?,?,1)");
				$sth->execute(array($Name, $DvrNo, $Channel));
			}
		}

		$sth    = $this->conn->prepare("DELETE FROM DVRChannel WHERE Type=1 AND DvrNo=? AND Channel>?");
		$sth->execute( array($DvrNo, $MaxChannel) );
    }

    // ----------------------------------------------------------------------------------

   public function get_channels($DvrNo)
    {
		$arr	= array();

		$channels   = $this->conn->prepare("SELECT * FROM DVRChannel WHERE Type=1 AND DvrNo=? ORDER BY Channel ASC");
		$channels->execute(array($DvrNo));
		while($channel = $channels->fetch(PDO::FETCH_ASSOC)) {
			$arr[$channel['No']] = $channel['Name'];
		}

		return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
        $No        = $this->input->get('No');
        $Name      = $this->util->GetRecordName('DVR', $No);

        $sth       = $this->conn->prepare("DELETE FROM DVR WHERE Site=? AND No=?");
        if( $sth->execute(array($_SESSION['spider_site'], $No)) )
        {
			$sth       = $this->conn->prepare("DELETE FROM DVRChannel WHERE Type=1 AND DvrNo=?");
			$sth->execute(array($No));

			$this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------
}


?>