<?php


class elevator extends controller
{
	var $attrLockMode           = array('0'=>'Normal', '1'=>'Lock');
    var $attrExtended           = array('0'=>'Default', '1'=>'Extended');
	    
    // ----------------------------------------------------------------------------------

   public function index()
    {
        $this->attrExtended['0']    = $this->lang->elevator->DefaultClientHelpStr;
        $this->attrExtended['1']    = $this->lang->elevator->ExtendedClientHelpStr;

        $vars['attrFloor']      = $this->to_array_floor();
        $vars['attrThreat']     = $this->to_threat_level();
        $vars['attrReader']     = $this->to_array_reader();
        $vars['attrCardFormat'] = $this->to_array_card_format();
        $vars['attrElevatorMaster'] = $this->to_array_elevator_master();
                
        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Elevator WHERE Site = ? AND Disable=0");
            }
            else{
                 $count = $this->conn->prepare("SELECT COUNT(*) FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 ");
                
            }

            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 ORDER BY No DESC LIMIT ?, ?");
            }
            else{
                 $list = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           ORDER BY A.No DESC LIMIT ?, ?");
                
            }
            
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Elevator WHERE Site = ? AND Disable=0 AND $field LIKE ?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND A.$field LIKE ?");
            }
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND A.$field LIKE ?
                                                           ORDER BY A.No DESC LIMIT ?, ?");
            }
            
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $attrFloor      = $this->to_array_floor();
        $attrThreat     = $this->to_threat_level();
        $attrReader     = $this->to_array_reader();
        $attrCardFormat = $this->to_array_card_format();
        
        foreach( $list as $key=>$val )
        {
            $val['FloorStr']       = $attrFloor[$val['Floor']];
            $val['LockModeStr']    = $this->attrLockMode[$val['Lock']];
            $val['ThreatLevelStr'] = $attrThreat[$val['ThreatLevel']];            
            
            $val['ReaderType']     = $attrReader["Type"][$val['HostNo']];
            $val['ReaderTypeStr']  = $attrReader["TypeStr"][$val['HostNo']];
            $val['CardFormat']     = $attrReader["CardFormatNo"][$val['HostNo']];

            if($val['Extended'] == '1') {
                $val['ExtendedStr'] = $this->lang->elevator->ElevatorClientExtension;
                $elevator = $this->get_elevator($val['MasterElevator']);
                $val['MasterElevatorName'] = $elevator['Name'];
            } else {
                $val['ExtendedStr'] = $this->lang->elevator->ElevatorClient;
            }
            
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }
    
    // ----------------------------------------------------------------------------------

   public function select_master()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 AND Extended=0 ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND   A.Extended=0 
                                                           ORDER BY A.No DESC");
            }
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 AND Extended=0 AND $field LIKE ? ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND   A.Extended=0 
                                                           AND   A.$field LIKE ? 
                                                           ORDER BY A.No DESC");
            }
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['OutputCount']       = $this->get_output_count($val['No']);

            $list[$key] = $val;
        }

        $result['list']  = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find2()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        
        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay WHERE Site = ? AND Disable='0'");
            }
            else{
                $count   = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site = ?   
                                                           AND A.Disable='0' ");
            }
            
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM ElevatorRelay WHERE Site = ? AND Disable='0' ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM ElevatorRelay AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE Site = ? 
                                                           AND   A.Disable='0' 
                                                           ORDER BY A.No DESC ");
            }
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay WHERE Disable='0' AND $field LIKE ?");
            }
            else{
                $count   = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           AND   A.Disable='0' 
                                                           AND A.$field LIKE ? ");
            }
            $count->execute(array("%".$word."%"));
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM ElevatorRelay WHERE Disable='0' AND $field LIKE ? ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM ElevatorRelay AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           AND   A.Disable='0' 
                                                           AND A.$field LIKE ? 
                                                           ORDER BY A.No DESC ");
            }
            
            $list->execute(array("%".$word."%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
    //2015.05.19 Elevator Master만 리스트를 가져온다. By Zeno
   public function find3()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        
        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Elevator WHERE Disable='0'");
            }
            else{
                $count   = $this->conn->prepare("SELECT COUNT(*) FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           AND   A.Disable='0' ");
            }
            
            $count->execute();
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Disable='0' ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           AND   A.Disable='0' 
                                                           ORDER BY A.No DESC ");
            }
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Elevator WHERE Disable='0' AND $field LIKE ?");
            }
            else{
                $count   = $this->conn->prepare("SELECT COUNT(*) FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           AND   A.Disable='0'
                                                           AND   A.$field LIKE ?");
            }
            
            $count->execute(array("%".$word."%"));
            $count  = $count->fetchColumn();

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Disable='0' AND $field LIKE ? ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           AND   A.Disable='0' 
                                                           AND   A.$field LIKE ? 
                                                           ORDER BY A.No DESC ");
            }
            $list->execute(array("%".$word."%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
    // ----------------------------------------------------------------------------------

   public function insert()
    {
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No           = $this->input->post('No');
        $Name         = strip_tags(trim($this->input->post('Name')));
        $Name         = str_replace("'", " ", $Name);
        $Mean         = strip_tags($this->input->post('Mean'));
        $ReaderType   = $this->input->post('ReaderType', 0);
        $CardFormat   = $this->input->post('CardFormat', 0);
        $Lock         = $this->input->post('Lock');
        $ThreatLevel  = $this->input->post('ThreatLevel');
        $Floor        = $this->input->post('Floor');
        $Extended        = $this->input->post('Extended');
        $MasterElevator  = $this->input->post('MasterElevator');
        
        if( empty($Name) )      $this->util->alert( $this->lang->menu->error_name_required, TRUE );

        $sth    = $this->conn->prepare("UPDATE Elevator SET Name=?,Mean=?,Lock=?,ThreatLevel=?,Floor=?,Extended=?,MasterElevator=? WHERE No=?");

        $values = array($Name,$Mean,$Lock,$ThreatLevel,$Floor,$Extended,$MasterElevator,$No);
        if( $sth->execute($values) )
        {
	        $master_reader   = $this->conn->prepare("UPDATE Reader SET Type='".$ReaderType."', CardFormatNo='".$CardFormat."' WHERE HostNo = (SELECT HostNo FROM Elevator WHERE No = '".$No."') AND Port = 1");
	        $master_reader->execute();
        
			//exec(SPIDER_COMM." send db");
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'", after_view);');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
    }

    // ----------------------------------------------------------------------------------
    
   public function to_array_floor()
    {
        $cfloor = $this->conn->prepare("SELECT * FROM Floor WHERE Site=?");
        $cfloor->execute(array($_SESSION['spider_site']));
        $cfloor = $cfloor->fetchAll(PDO::FETCH_ASSOC);

        $arr_floor  = array();
        foreach( $cfloor as $key=>$val)
        {
            $arr_floor[$val['No']]  = $val['Name'];
        }

        return $arr_floor;
    }
    
   public function to_threat_level()
    {
        $threatlist = $this->conn->prepare("SELECT * FROM ThreatLevel WHERE Site=?");
        $threatlist->execute(array($_SESSION['spider_site']));
        $threatlist = $threatlist->fetchAll(PDO::FETCH_ASSOC);
        
        $arr_threat = array();
        foreach( $threatlist as $key=>$val)
        {
            $arr_threat[$val['Level']]  = $val['ThreatName'];
        }

        return $arr_threat;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_reader()
    {
        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM Reader WHERE Site=? AND HostNo IN (SELECT HostNo FROM Elevator) AND Port = 1");
        }
        else{
            $list   = $this->conn->prepare("SELECT A.* FROM Reader AS A
                                                     JOIN Host AS B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                     WHERE A.Site=? AND A.HostNo IN (SELECT HostNo FROM Elevator) AND A.Port = 1");
        }
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr  = array();
        $arr1 = array();
        $arr2 = array();
        $arr3 = array();

        foreach( $list as $key=>$val)
        {
            $arr[$val['HostNo']]    = $val['Name'];
            $arr1[$val['HostNo']]   = $val['Type'];
            $arr2[$val['HostNo']]   = EnumTable::$attrReaderType[$val['Type']];
            $arr3[$val['HostNo']]   = $val['CardFormatNo'];
        }

        $Aarr = array("infor"=> $arr, "Type" => $arr1, "TypeStr" => $arr2, "CardFormatNo" => $arr3);

        return $Aarr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_card_format()
    {
        $list   = $this->conn->prepare("SELECT * FROM CardFormat");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_elevator_master()
    {
        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site=? AND Extended=0 AND Disable=0");
        }
        else{
            $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                       JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                       WHERE A.Site=? 
                                                       AND A.Extended=0 
                                                       AND A.Disable=0");
        }
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]    = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function get_elevator($no)
    {
        $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site=? AND No=?");
        $list->execute(array($_SESSION['spider_site'], $no));
        $row    = $list->fetch(PDO::FETCH_ASSOC);

        return $row;
    }

    // ----------------------------------------------------------------------------------

   public function get_output_count($no)
    {
        $list   = $this->conn->prepare("SELECT COUNT(*) FROM Elevator WHERE Site=? AND ((Extended=0 AND No=?) OR (Extended=1 AND MasterElevator=?))");
        $list->execute(array($_SESSION['spider_site'], $no, $no));
        $count  = $list->fetchColumn();

        return $count * 8;
    }

}

?>