<?php


class elevatoraction extends controller
{
	var $attrLockMode           = array('0'=>'Normal', '1'=>'Lock');
	    
    // ----------------------------------------------------------------------------------

   public function index()
    {
        $vars['attrElevator']   = $this->to_array_elevator();
        $vars['attrFloor']      = $this->to_array_floor();
        $vars['attrThreat']     = $this->to_threat_level();
        
        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');
        
        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();
        
        $this->util->DebugOutputLine("field : ".$field.", value : ".$word);

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay AS A, Elevator AS B WHERE A.Site = ? AND A.Disable=0 AND A.ElevatorNo = B.No");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay AS A, Elevator AS B, Host AS C 
                                                WHERE A.Site = ? AND A.Disable=0 AND A.ElevatorNo = B.No
                                                AND   A.HostNo = C.No AND (C.ByAdminId =  '".$_SESSION['spider_id']."' OR C.ByAdminId = '' OR C.ByAdminId IS null)");
            }
            
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT A.*, IFNULL(B.Name, 0) AS EName, B.Lock, B.ThreatLevel FROM ElevatorRelay AS A, Elevator AS B WHERE A.Site = ? AND A.Disable=0 AND A.ElevatorNo = B.No ORDER BY A.No DESC LIMIT ?, ?");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.*, IFNULL(B.Name, 0) AS EName, B.Lock, B.ThreatLevel 
                                                FROM ElevatorRelay AS A, Elevator AS B, Host AS C
                                                WHERE A.Site = ? AND A.Disable=0 AND A.ElevatorNo = B.No 
                                                AND   A.HostNo = C.No AND (C.ByAdminId =  '".$_SESSION['spider_id']."' OR C.ByAdminId = '' OR C.ByAdminId IS null)
                                                ORDER BY A.No DESC LIMIT ?, ?");
            }
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay WHERE Site = ? AND Disable=0 AND $field LIKE ?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay AS A 
                                                                JOIN Host AS B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                                WHERE A.Site = ? AND A.Disable=0 AND A.$field LIKE ?");
            }
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT A.*, IFNULL(B.Name, 0) AS EName, B.Lock, B.ThreatLevel FROM ElevatorRelay AS A, Elevator AS B WHERE A.Site = ? AND A.Disable=0 AND A.ElevatorNo = B.No AND A.$field LIKE ? ORDER BY A.No DESC LIMIT ?, ?");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.*, IFNULL(B.Name, 0) AS EName, B.Lock, B.ThreatLevel FROM ElevatorRelay AS A, Elevator AS B, Host AS C
                                                WHERE A.Site = ? AND A.Disable=0 AND A.ElevatorNo = B.No 
                                                AND   A.HostNo = C.No AND (C.ByAdminId =  '".$_SESSION['spider_id']."' OR C.ByAdminId = '' OR C.ByAdminId IS null)
                                                AND   A.$field LIKE ? ORDER BY A.No DESC LIMIT ?, ?");
            }
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $attrFloor      = $this->to_array_floor();
        $attrThreat     = $this->to_threat_level();

        foreach( $list as $key=>$val )
        {
        	$val['NameStr']        = $val['Name'];
        	$val['ENameStr']       = $val['EName'];
            $val['FloorStr']       = $attrFloor[$val['Floor']];
            $val['SelectTypeStr']  = EnumTable::$attrGroup[$val['SelectType']];            
            $val['UserList2']      = $this->get_element_select_val($val['ElevatorNo'], $val['No']);
            $val['UserList2Str']   = $this->get_element_select_str($val['ElevatorNo'], $val['No'], $val['SelectType']);
            $val['LockModeStr']    = $this->attrLockMode[$val['Lock']];
            $val['ThreatLevelStr'] = $attrThreat[$val['ThreatLevel']];
            $val['StateStr']       = EnumTable::$attrState[$val['State']];
            $val['ModeStr']        = EnumTable::$attrAuxOutMode[$val['Mode']];
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function select_output()
    {
        $no = $this->input->get('no');

        $elevator = $this->conn->prepare("SELECT * FROM Elevator WHERE Site=? AND No=?");
        $elevator->execute(array($_SESSION['spider_site'], $no));
        $elevator = $elevator->fetch(PDO::FETCH_ASSOC);

        $list   = $this->conn->prepare("SELECT A.*, IFNULL(B.Name, 0) AS EName, B.Lock, B.ThreatLevel FROM ElevatorRelay AS A, Elevator AS B WHERE A.Site = ? AND A.Disable = 0 AND A.ElevatorNo = B.No AND ((B.Extended=0 AND B.No=?) OR (B.Extended=1 AND B.MasterElevator=?)) ORDER BY A.No DESC");
        $list->execute(array($_SESSION['spider_site'], $no, $no));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $attrFloor      = $this->to_array_floor();
        $attrThreat     = $this->to_threat_level();

        foreach( $list as $key=>$val )
        {
        	$val['NameStr']        = $val['Name'];
            $val['EName']          = $elevator['Name'];
        	$val['ENameStr']       = $elevator['Name'];
            $val['FloorStr']       = $attrFloor[$val['Floor']];
            $val['SelectTypeStr']  = EnumTable::$attrGroup[$val['SelectType']];            
            $val['UserList2']      = $this->get_element_select_val($val['ElevatorNo'], $val['No']);
            $val['UserList2Str']   = $this->get_element_select_str($val['ElevatorNo'], $val['No'], $val['SelectType']);
            $val['LockModeStr']    = $this->attrLockMode[$val['Lock']];
            $val['ThreatLevelStr'] = $attrThreat[$val['ThreatLevel']];
            $val['StateStr']       = EnumTable::$attrState[$val['State']];
            $val['ModeStr']        = EnumTable::$attrAuxOutMode[$val['Mode']];
            $list[$key] = $val;
        }

        $result['list']  = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find2()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        
        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay WHERE Site=? AND Disable=0");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $list   = $this->conn->prepare("SELECT * FROM ElevatorRelay WHERE Site=? AND Disable=0 ORDER BY No DESC");
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM ElevatorRelay WHERE Site=? AND Disable=0 AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], "%".$word."%"));
            $count  = $count->fetchColumn();

            $list   = $this->conn->prepare("SELECT * FROM ElevatorRelay WHERE Site=? AND Disable=0 AND $field LIKE ? ORDER BY No DESC");
            $list->execute(array($_SESSION['spider_site'], "%".$word."%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
    // ----------------------------------------------------------------------------------

   public function insert()
    {
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No           = $this->input->post('No');
        $ElevatorNo   = $this->input->post('ElevatorNo');
        $SelectType   = $this->input->post('SelectType');
        $UserList2    = $this->input->post('UserList3', array());

		$Name       = strip_tags(trim($this->input->post('Name')));
        $Mean       = strip_tags($this->input->post('Mean'));
        $Floor      = $this->input->post('Floor');
        $State      = $this->input->post('State');
        $Mode       = $this->input->post('Mode');
        $OnTime     = $this->input->post('OnTime', 0);
        $OffTime    = $this->input->post('OffTime', 0);
        $Repeat     = $this->input->post('Repeat', 0);        
        
        if( empty($ElevatorNo) )      $this->util->alert( $this->lang->elevator->error_elevator_empty, TRUE );
        if( empty($Name) )	          $this->util->alert( $this->lang->menu->error_name_required, TRUE );

        $sth    = $this->conn->prepare("UPDATE ElevatorRelay SET ElevatorNo=?, SelectType=?, Name=?, Mean=?, Floor=?,State=?,Mode=?,OnTime=?,OffTime=?,Repeat=? WHERE No=? AND Site=?");

        $values = array($ElevatorNo,$SelectType,$Name,$Mean,$Floor,$State,$Mode,$OnTime,$OffTime,$Repeat,$No,$_SESSION['spider_site']);
        if( $sth->execute($values) )
        {
            $subdelete = $this->conn->prepare("DELETE FROM ElevatorUser WHERE Site=? AND ElevatorNo=? AND RelayNo=?");
            $subdelete->execute(array($_SESSION['spider_site'], $ElevatorNo, $No));

            $subinsert = $this->conn->prepare("INSERT INTO ElevatorUser (Site,ElevatorNo,RelayNo,SelectType,UserNo) VALUES (?,?,?,?,?)");
            foreach( $UserList2 as $value )
            {
                $subinsert->execute( array($_SESSION['spider_site'], $ElevatorNo, $No, $SelectType, $value) );
            }

            $elevator = $this->conn->prepare("SELECT * FROM Elevator WHERE Site=? AND No=?");
            $elevator->execute(array($_SESSION['spider_site'], $ElevatorNo));
            $elevator = $elevator->fetch(PDO::FETCH_ASSOC);

            if($elevator['Extended'] == '1') {
                $MasterElevator = $elevator['MasterElevator'];
            } else {
                $MasterElevator = $elevator['No'];
            }

			//exec(SPIDER_COMM." send db");
            $this->log->set_log_message($Name);
            $this->util->js('load_output("'.$MasterElevator.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
        $No      = $this->input->get('No');
        $RelayNo = $this->input->get('RelayNo');
        $Name    = $this->util->GetRecordName('ElevatorRelay', $No);
        
        $sth    = $this->conn->prepare("UPDATE ElevatorRelay SET ElevatorNo=0 WHERE Site=? AND No=? AND ElevatorNo=?");
        if ($sth->execute(array($_SESSION['spider_site'], $RelayNo, $No)))
        {
            $this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->delete_completed );
            //exec(SPIDER_COMM." send db");
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------
    
   public function to_array_elevator()
    {
        $elevator = $this->conn->prepare("SELECT * FROM Elevator WHERE Site=?");
        $elevator->execute(array($_SESSION['spider_site']));
        $elevator = $elevator->fetchAll(PDO::FETCH_ASSOC);

        $arr_elevator  = array();
        foreach( $elevator as $key=>$val)
        {
            $arr_elevator[$val['No']]  = $val['Name'];
        }

        return $arr_elevator;
    }
    
   public function to_array_floor()
    {
        $cfloor = $this->conn->prepare("SELECT * FROM Floor WHERE Site=?");
        $cfloor->execute(array($_SESSION['spider_site']));
        $cfloor = $cfloor->fetchAll(PDO::FETCH_ASSOC);

        $arr_floor  = array();
        foreach( $cfloor as $key=>$val)
        {
            $arr_floor[$val['No']]  = $val['Name'];
        }

        return $arr_floor;
    }
    
   public function to_threat_level()
    {
        $threatlist = $this->conn->prepare("SELECT * FROM ThreatLevel WHERE Site=?");
        $threatlist->execute(array($_SESSION['spider_site']));
        $threatlist = $threatlist->fetchAll(PDO::FETCH_ASSOC);
        
        $arr_threat = array();
        foreach( $threatlist as $key=>$val)
        {
            $arr_threat[$val['Level']]  = $val['ThreatName'];
        }

        return $arr_threat;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_reader()
    {
        $list   = $this->conn->prepare("SELECT *, Name FROM AccessLevel WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_reader_group()
    {
        $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=?");
        $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_ACCESS_LEVEL));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------
    
   public function get_element_select_val($No, $RelayNo)
    {
        $list   = $this->conn->prepare("SELECT No, Name 
                                          FROM (SELECT B.No AS No, B.Name AS Name FROM ElevatorUser AS A
		                                          JOIN AccessLevel AS B ON A.Site=B.Site AND A.UserNo = B.No
		                                         WHERE A.SelectType = 1 AND A.Site = ? AND A.ElevatorNo=? AND A.RelayNo = ?
		                                        UNION
		                                        SELECT B.No, B.Name FROM ElevatorUser AS A
		                                          JOIN GroupTable AS B ON B.Site = A.Site AND A.UserNo = B.No AND B.GroupKind=?
		                                         WHERE A.SelectType = 2 AND A.Site = ? AND A.ElevatorNo=? AND A.RelayNo = ?)");
        $list->execute(array($_SESSION['spider_site'], $No, $RelayNo, ConstTable::GROUP_ACCESS_LEVEL, $_SESSION['spider_site'], $No, $RelayNo));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        return $list;
    }

   public function get_element_select_str($No, $RelayNo, $SelectType)
    {
        $arr    = array();
        
        if ($SelectType != '2')
        {
            $list   = $this->conn->prepare("SELECT Name FROM AccessLevel WHERE Site=? AND No IN (SELECT UserNo FROM ElevatorUser WHERE Site=? AND ElevatorNo=? AND RelayNo=?)");
            $list->execute(array($_SESSION['spider_site'], $_SESSION['spider_site'], $No, $RelayNo));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT Name FROM GroupTable WHERE Site=? AND GroupKind=? AND No IN (SELECT UserNo FROM ElevatorUser WHERE Site=? AND ElevatorNo=? AND RelayNo=?)");
            $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_ACCESS_LEVEL, $_SESSION['spider_site'], $No, $RelayNo));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        $listOK = 0;
        foreach( $list as $val )
        {
            $arr[]  = $val['Name'];
            $listOK = 1;
        }
        
        if ($listOK > 0)
            return implode(',', $arr);
        else 
            return "";
    }

    // ----------------------------------------------------------------------------------

}

?>