<?php

class gemini extends controller
{
    var $arr_plug       = array('0'=>'Off', '1'=>'On');
    var $arr_plug2      = array('0'=>'Disarmed', '1'=>'Armed');

   public function index()
    {        
	    $vars = array();
        $this->display($vars);
    }

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM GEMINI");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT Enable, Key, Address, Online, ArmStat, DoorList, UserList FROM GEMINI");
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);

            foreach( $list as $key=>$val )
            {                
                $val['EnableStr']       = $this->arr_plug[$val['Enable']];
                $val['DoorListStr']     = $this->get_door_list($val['DoorList'], true);
                $val['UserListStr']     = $this->get_card_holder_list($val['UserList'], true);
                $val['DoorListNonSltd'] = $this->get_door_list_non_selected_object($val['DoorList']);
                $val['DoorList']        = $this->get_door_list($val['DoorList'], false);                
                $val['UserListNonSltd'] = $this->get_card_holder_list_non_selected_object($val['UserLis:t']);
                $val['UserList']        = $this->get_card_holder_list($val['UserList'], false);                
                $val['OnlineStr']       = $this->arr_plug[$val['Online']];
                $val['ArmstatStr']      = $this->arr_plug2[$val['ArmStat']];
                $list[$key]             = $val;
            }
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    public function update()
    {
        $Enable          = $this->input->post('Enable', 0);
        $Key             = $this->input->post('Key', '');
        $doorlist        = $this->input->post('Element5', array());
        $cardholderList  = $this->input->post('Element6', array());       
       
        $sth    = $this->conn->prepare("UPDATE GEMINI SET Enable=?, Key=?, DoorList=?, UserList=?");
        $values = array($Enable, $Key, implode(', ', $doorlist) , implode(', ', $cardholderList));
        if( $sth->executeSilent($values))
        {
            exec(SPIDER_COMM." logapi"); // process
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->js("location.href='/?c=gemini';");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }   
    }

    public function get_door_list($doorlistStr, $isstr = true)
    {   
        if (strlen($doorlistStr)) {
            $query  = "SELECT No,Name FROM Door WHERE No IN (".$doorlistStr.")";
            $list   = $this->conn->prepare($query);
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
            if ($isstr) {
                $Doorlist = '';
                foreach ($list as $key => $value) {
                    if (strlen($Doorlist) == 0) {
                        $Doorlist = $value['Name'];
                    } else {
                        $Doorlist = $Doorlist.",".$value['Name'];
                    }
                }
                return $Doorlist;
            } else {
                return $list;
            }      
        } else {
            return '';
        }
        
        // if( $this->is_SuperAdmin() == true )
        // {
        //     $list   = $this->conn->prepare("SELECT * FROM Door WHERE No IN (SELECT ElementNo FROM GroupElement WHERE Site=?)");
        // }
        // else{
        //     $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
        //                                              JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
        //                                              WHERE A.Site=? 
        //                                              AND A.No IN (SELECT ElementNo FROM GroupElement WHERE Site=?)");
        // }

        
    }

    public function get_door_list_non_selected_object($ListStr='')
    {   
        $query  = "SELECT No,Name FROM Door WHERE No NOT IN (".$ListStr.") AND Disable=0";
        $list   = $this->conn->prepare($query);
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        return $list;
    }

    public function doorsearch()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $doorselected   = $this->input->get('doorselected');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        if (strlen($doorselected)) {
            $doorselected = json_decode($doorselected);
        }        
        $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable=0 AND Name LIKE ? AND Name NOT IN (?) ORDER BY No DESC");
        $list->execute(array($_SESSION['spider_site'], "%$word%", $doorselected));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $finalResult = array();
        foreach ($list as $key => $value) {
            if (!in_array($value['Name'], $doorselected)) {
                array_push($finalResult, $value);
            }
        }

        $list = $finalResult;
        echo json_encode($list);
    }

    public function usersearch()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $userselected   = $this->input->get('userselected');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        if (strlen($userselected)) {
            $userselected = json_decode($userselected);
        }        
        
        $list   = $this->conn->prepare("SELECT *, FirstName||' '||MiddleName||' '||LastName AS Name FROM User WHERE FirstName LIKE ? OR MiddleName LIKE ? OR LastName LIKE ?");
        $list->execute(array("%$word%", "%$word%", "%$word%"));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $finalResult = array();
        foreach ($list as $key => $value) {
            if (!in_array($value['No'], $userselected)) {
                array_push($finalResult, $value);
            }
        }

        $list = $finalResult;
        echo json_encode($list);
    }

    public function get_card_holder_list($userlist, $isstr = true)
    {   

        if (strlen($userlist)) {
            $query  = "SELECT *, FirstName||' '||MiddleName||' '||LastName AS Name FROM User WHERE No IN (".$userlist.")";
            $list   = $this->conn->prepare($query);
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
            if ($isstr) {
                $UserList = '';
                foreach ($list as $key => $value) {
                    if (strlen($UserList) == 0) {
                        $UserList = $value['Name'];
                    } else {
                        $UserList = $UserList.",".$value['Name'];
                    }
                }
                return $UserList;
            } else {
                return $list;
            }      
        } else {
            return '';
        }

        // return $userlist;
        // $list   = $this->conn->prepare("SELECT *, FirstName||' '||MiddleName||' '||LastName AS Name FROM User");
        // $list->execute();
        // $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        // return $list;
    }

    public function get_card_holder_list_non_selected_object($ListStr='')
    {
        $query  = "SELECT *, FirstName||' '||MiddleName||' '||LastName AS Name FROM User WHERE No NOT IN (".$ListStr.")";
        $list   = $this->conn->prepare($query);
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        return $list;
    }

    public function get_element_select_value($No)
    {
        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
        else{
            $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                     JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                     WHERE A.Site=? 
                                                     AND A.No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
        
        $list->execute(array($_SESSION['spider_site'], $_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        return $list;
    }
    
    public function get_element_str($No)
    {
        $arr    = array();

        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
        else{
            $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                     JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                     WHERE A.Site=? 
                                                     AND A.No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
            
        $list->execute(array($_SESSION['spider_site'], $_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        
        foreach( $list as $val )
        {
            $arr[]  = $val['Name'];
        }

        return implode(', ', $arr);
    }
}