<?php

class good2go extends controller
{
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

    public function index()
    {        
        $vars = array();

        $list = $this->conn->prepare("SELECT * FROM CardFormat");
        $list->execute();
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr_card_format_default = array();
        foreach($list as $key=>$val)
        {
            $arr_card_format_default[$val['No']] = $val['Name'];
        }

        $vars['arr_card_format_default'] = $arr_card_format_default;
        
        $this->display($vars);
    }

    public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Good2Go");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT Enable, OemCode, SecuriryCode, FormatNo, TimeLimit, ResetTime FROM Good2Go");
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
            if(!empty($list)) {
                foreach( $list as $key=>$val )
                {
                    $val['EnableStr']    = $this->arr_plug[$val['Enable']];
                    $val['CardFormatNM'] = $this->get_card_format_name($val['FormatNo']);
                    $val['TimeLimitStr'] = $this->arr_plug[$val['TimeLimit']];
                    $val['ResetTimeStr'] = $val['ResetTime']." Days";
                    $list[$key] = $val;
                }
            }
            else
            {
                $list[] = [];
            }
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    public function keygen() {

        $HashKey    = $this->input->post('HashKey', '');
        $authKey = hash_hmac("sha256", time(), $HashKey);
        echo json_encode(array("datagen"=>$authKey));
    }

    public function update()
    {
        $Enable       = $this->input->post('Enable', 0);
        $OemCode      = $this->input->post('OemCode', 0);        
        $SecuriryCode = $this->input->post('SecuriryCode', 0);
        $FormatNo     = $this->input->post('FormatNo', 0);
        $TimeLimit    = $this->input->post('TimeLimit', 0);
        $ResetTime    = $this->input->post('ResetTime', 0);

        $list   = $this->conn->prepare("SELECT Enable, OemCode, SecuriryCode, FormatNo, TimeLimit, ResetTime FROM Good2Go");
        $list->execute();
        $list   = $list->fetch(PDO::FETCH_ASSOC);

        if(!empty($list)) {
            $sth = $this->conn->prepare("UPDATE Good2Go SET Enable=?, OemCode=?, SecuriryCode=?, FormatNo=?, TimeLimit=?, ResetTime=?");
            $values = array($Enable, $OemCode, $SecuriryCode, $FormatNo, $TimeLimit, $ResetTime);
        }
        else
        {
            $sth = $this->conn->prepare("INSERT INTO Good2Go (Enable, OemCode, SecuriryCode, FormatNo, TimeLimit, ResetTime) VALUES (?,?,?,?,?,?)");
            $values = array($Enable, $OemCode, $SecuriryCode, $FormatNo, $TimeLimit, $ResetTime);
        }

        // print_r($sth->executeSilent($values));exit();
        if( $sth->execute($values))
        {
            // exec(SPIDER_COMM." good2go");
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->js("location.href='/?c=good2go';");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }   
    }

    public function get_card_format_name($cardformat)
    {
        if (strlen($cardformat)) {
            $list  = $this->conn->prepare("SELECT * FROM CardFormat WHERE No = $cardformat");
            $list->execute();
            $list  = $list->fetch(PDO::FETCH_ASSOC);
            // print_r($list);exit();
            if(!empty($list))
            { return $list['Name']; }
            else { return ''; }
        } else {
            return '';
        }
    }
    
}