<?php


class groupdoor extends controller
{
    public function index()
    {
	    $vars = array();
        $this->display($vars);
    }
    
    // ----------------------------------------------------------------------------------

    public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable WHERE Site=? AND GroupKind=?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ? GROUP BY A.No");
            }
            
            $count->execute(array($_SESSION['spider_site'], ConstTable::GROUP_DOOR));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? ORDER BY No DESC LIMIT ?, ?");
            }
            else{
                $list  = $this->conn->prepare("SELECT A.* FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ? GROUP BY A.No
                                                       ORDER BY No DESC LIMIT ?, ?");
            }
            
            $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_DOOR, $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable WHERE Site=? AND GroupKind=? AND $field LIKE ?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ?  AND $field LIKE ? GROUP BY A.No");
            }
            
            $count->execute(array($_SESSION['spider_site'], ConstTable::GROUP_DOOR, $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            }
            else{
                $list  = $this->conn->prepare("SELECT A.* FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ? AND $field LIKE ? GROUP BY A.No
                                                       ORDER BY No DESC LIMIT ?, ?");
            }
            
            $list->execute(array($_SESSION['spider_site'], ConstTable::GROUP_DOOR, $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['ElementList']     = $this->get_element_select_value($val['No']);
            $val['ElementListStr']  = $this->get_element_str($val['No']);
            
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }
    
    public function elementsearch()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count   = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=? AND Disable=0");
            }
            else{
                $count   = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                           WHERE A.Site=? AND Disable=0");
            }
            
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable=0 ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? AND A.Disable=0
                                                           ORDER BY No DESC");
            }
            
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=? AND Disable=0 AND $field LIKE ?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                           WHERE A.Site=? AND Disable=0
                                                           AND $field LIKE ? "); 
            }
            
            $count->execute(array($_SESSION['spider_site'], "%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable=0 AND $field LIKE ? ORDER BY No DESC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                           WHERE A.Site=? AND Disable=0
                                                           AND $field LIKE ? 
                                                           ORDER BY No DESC");
            }
            
            $list->execute(array($_SESSION['spider_site'], "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['ElementList']     = $this->get_element_select_value($val['No']);
            $val['ElementListStr']  = $this->get_element_str($val['No']);
            
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }
    
    public function find()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable WHERE Site=? AND GroupKind=?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ? GROUP BY A.No");
            }
            
            $count->execute(array($_SESSION['spider_site'],ConstTable::GROUP_DOOR));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? ORDER BY No DESC");
            }
            else{
                $list  = $this->conn->prepare("SELECT A.* FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ? GROUP BY A.No
                                                       ORDER BY No DESC");
            }
            
            $list->execute(array($_SESSION['spider_site'],ConstTable::GROUP_DOOR));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable WHERE Site=? AND GroupKind=? AND $field LIKE ?");
            }
            else{
                $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ?  AND $field LIKE ? GROUP BY A.No");
            }
            
            $count->execute(array($_SESSION['spider_site'],ConstTable::GROUP_DOOR, "%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND $field LIKE ? ORDER BY No DESC");
            }
            else{
                $list  = $this->conn->prepare("SELECT A.* FROM GroupTable AS A 
                                                       JOIN GroupElement AS B ON A.No = B.GroupNo 
                                                       JOIN Door AS C ON B.ElementNo = C.No
                                                       JOIN Host AS H ON C.HostNo = H.No AND (H.ByAdminId =  '".$_SESSION['spider_id']."' OR H.ByAdminId = '' OR H.ByAdminId IS null)
                                                       WHERE A.Site = ? AND A.GroupKind = ? AND $field LIKE ? GROUP BY A.No
                                                       ORDER BY No DESC");
            }
            $list->execute(array($_SESSION['spider_site'],ConstTable::GROUP_DOOR, "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

    public function insert()
    {
        $No = $this->conn->prepare("SELECT MAX(No) from GroupTable WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No    = $No->fetchColumn() + 1;
        
        $Name        = strip_tags(trim($this->input->post('Name')));
        $Element2    = $this->input->post('Element3', array());


        if( empty($Name) )      $this->util->alert( $this->lang->menu->error_name_required, TRUE );


        $name_check = $this->conn->prepare("SELECT COUNT(*) from GroupTable WHERE Site=".$_SESSION['spider_site']." AND Name=?");
        $name_check->execute(array($Name));
        $name_check = $name_check->fetchColumn();

        if($name_check != '0')
        {
            Util::alert("The same name exists.");
            return;
        }

        $sth    = $this->conn->prepare("INSERT INTO GroupTable (Site,No,Name,GroupKind) VALUES (?,?,?,?)");

        $values = array($_SESSION['spider_site'],$No,$Name,ConstTable::GROUP_DOOR);
        if( $sth->execute($values) )
        {
            $EleNo = $this->conn->prepare("SELECT MAX(No) from GroupElement WHERE Site=?");
            $EleNo->execute(array($_SESSION['spider_site']));
            $EleNo = $EleNo->fetchColumn() + 1;  
            
            $sth    = $this->conn->prepare("INSERT INTO GroupElement (Site,No,GroupNo,GroupKind,ElementNo,Disable) VALUES (?,?,?,?,?,?)");
            foreach( $Element2 as $value )
            {
                $sth->execute( array($_SESSION['spider_site'],$EleNo,$No,ConstTable::GROUP_DOOR,$value,"0") );
                $EleNo = $EleNo + 1;
            }

			//exec(SPIDER_COMM." send db");
			$this->log->set_log_message($Name);
            $this->util->js('load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
    }

    // ----------------------------------------------------------------------------------

    public function update()
    {
        $No         = $this->input->post('No');
        $Name       = strip_tags(trim($this->input->post('Name')));
        $Element2   = $this->input->post('Element3', array());

        if( empty($Name) )      $this->util->alert( $this->lang->menu->error_name_required, TRUE );


        /*
        $name_check = $this->conn->prepare("SELECT COUNT(*) from GroupTable WHERE Site=".$_SESSION['spider_site']." AND Name=?");
        $name_check->execute(array($Name));
        $name_check = $name_check->fetchColumn();

        if($name_check != '0')
        {
            Util::alert("The same name exists.");
            return;
        }
        */
       
        $sth    = $this->conn->prepare("UPDATE GroupTable SET Name=? WHERE Site = ? AND No=?");

        $values = array($Name,$_SESSION['spider_site'],$No);
        if( $sth->execute($values) )
        {
            $sth    = $this->conn->prepare("DELETE FROM GroupElement WHERE Site = ? AND GroupNo=?");
            $sth->execute( array($_SESSION['spider_site'], $No) );
            
            $EleNo = $this->conn->prepare("SELECT MAX(No) from GroupElement WHERE Site=?");
            $EleNo->execute(array($_SESSION['spider_site']));
            $EleNo = $EleNo->fetchColumn() + 1;  
            
            $sth    = $this->conn->prepare("INSERT INTO GroupElement (Site,No,GroupNo,GroupKind,ElementNo,Disable) VALUES (?,?,?,?,?,?)");
            foreach( $Element2 as $value )
            {
                $sth->execute( array($_SESSION['spider_site'],$EleNo,$No,ConstTable::GROUP_DOOR,$value,"0") );
                $EleNo = $EleNo + 1;
            }
            
            //exec(SPIDER_COMM." send db");
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

    public function check_dependency()
    {
        $no     = $this->input->get('no');

        //$item   = $this->conn->prepare("SELECT A.* from AccessLevelReader AS A JOIN AccessLevel AS B ON B.No=A.AccessLevelNo AND B.Site=A.Site WHERE A.Site=? AND A.ReaderNo=?");
        //$item   = $this->conn->prepare("SELECT a.* FROM GroupTable as a join AccessLevelReader as b join AccessLevel as c where a.no=? and b.ReaderNo=?");
        $item   = $this->conn->prepare("SELECT a.* FROM GroupTable as a join AccessLevelReader as b join AccessLevel as c ON c.no=b.no where a.no=? and b.ReaderNo=? and c.selecttype=2");
        $item->execute(array($_SESSION['spider_site'], $no));
        if( $item = $item->fetchAll(PDO::FETCH_ASSOC) )
		{
			$this->util->js('confirm_dependency()', TRUE);
		}

		$this->util->js('del_data_prepass()', TRUE);
    }

    // ----------------------------------------------------------------------------------

    public function delete()
    {
        $No       = $this->input->get('no');
        $Name     = $this->util->GetRecordName('GroupTable', $No);

        $groupdel = $this->conn->prepare("DELETE FROM GroupElement WHERE Site = ? AND GroupNo=?");
        $groupdel->execute(array($_SESSION['spider_site'], $No));
        
        $groupdel = $this->conn->prepare("DELETE FROM GroupTable WHERE Site = ? AND No=?");
        if( $groupdel->execute(array($_SESSION['spider_site'], $No)) )
        {
        	//exec(SPIDER_COMM." send db");
            $this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

    public function get_element_str($No)
    {
        $arr    = array();

        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
        else{
            $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                     JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                     WHERE A.Site=? 
                                                     AND A.No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
            
        $list->execute(array($_SESSION['spider_site'], $_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        
        foreach( $list as $val )
        {
            $arr[]  = $val['Name'];
        }

        return implode(', ', $arr);
    }

    // ----------------------------------------------------------------------------------

    public function get_element_select_value($No)
    {
        if( $this->is_SuperAdmin() == true )
        {
            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
        else{
            $list   = $this->conn->prepare("SELECT A.* FROM Door AS A 
                                                     JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null) 
                                                     WHERE A.Site=? 
                                                     AND A.No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        }
        
        $list->execute(array($_SESSION['spider_site'], $_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        return $list;
    }
    // ----------------------------------------------------------------------------------
}

?>