<?php


class grouptbl extends controller
{
    public function index()
    {
	    $vars = array();
        $this->display($vars);
    }
    
    // ----------------------------------------------------------------------------------

    public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable WHERE Site=? AND GroupKind=?");
            $count->execute(array($this->login_site, ConstTable::GROUP_DOOR));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($this->login_site, ConstTable::GROUP_DOOR, $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM GroupTable WHERE Site=? AND GroupKind=? AND $field LIKE ?");
            $count->execute(array($this->login_site, ConstTable::GROUP_DOOR, $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($this->login_site, ConstTable::GROUP_DOOR, $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['ElementList']     = $this->get_element_select_value($val['No']);
            $val['ElementListStr']  = $this->get_element_str($val['No']);
            
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }
    
    public function elementsearch()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=?");
            $count->execute(array($this->login_site));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($this->login_site, $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Door WHERE Site=? AND $field LIKE ?");
            $count->execute(array($this->login_site, "%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($this->login_site, "%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['ElementList']     = $this->get_element_select_value($val['No']);
            $val['ElementListStr']  = $this->get_element_str($val['No']);
            
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

    public function insert()
    {
        $No = $this->conn->prepare("SELECT MAX(No) from GroupTable WHERE Site=?");
        $No->execute(array($this->login_site));
        $No    = $No->fetchColumn() + 1;
        
        $Name        = $this->input->post('Name');
        $Element2    = $this->input->post('Element3', array());

        if( empty($Name) )      $this->util->alert( $this->lang->alevel->error_name_required, TRUE );

        $sth    = $this->conn->prepare("INSERT INTO GroupTable (Site,No,Name,GroupKind) VALUES (?,?,?,?)");

        $values = array($this->login_site,$No,$Name,ConstTable::GROUP_DOOR);
        if( $sth->execute($values) )
        {
            $this->log->set_log();
            $EleNo = $this->conn->prepare("SELECT MAX(No) from GroupElement WHERE Site=?");
            $EleNo->execute(array($this->login_site));
            $EleNo = $EleNo->fetchColumn() + 1;  
            
            $sth    = $this->conn->prepare("INSERT INTO GroupElement (Site,No,GroupNo,GroupKind,ElementNo,Disable) VALUES (?,?,?,?,?,?)");
            foreach( $Element2 as $value )
            {
                $sth->execute( array($this->login_site,$EleNo,$No,ConstTable::GROUP_DOOR,$value,"0") );
                $EleNo = $EleNo + 1;
            }

            $this->util->js('load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
    }

    // ----------------------------------------------------------------------------------

    public function update()
    {
        $No         = $this->input->post('No');
        $Name       = $this->input->post('Name');
        $Element2   = $this->input->post('Element3', array());

        if( empty($Name) )      $this->util->alert( $this->lang->alevel->error_name_required, TRUE );

        $sth    = $this->conn->prepare("UPDATE GroupTable SET Name=? WHERE Site = ? AND No=?");

        $values = array($Name,$this->login_site,$No);
        if( $sth->execute($values) )
        {
            $sth    = $this->conn->prepare("DELETE FROM GroupElement WHERE Site = ? AND GroupNo=?");
            $sth->execute( array($this->login_site, $No) );
            
            $EleNo = $this->conn->prepare("SELECT MAX(No) from GroupElement WHERE Site=?");
            $EleNo->execute(array($this->login_site));
            $EleNo = $EleNo->fetchColumn() + 1;  
            
            $sth    = $this->conn->prepare("INSERT INTO GroupElement (Site,No,GroupNo,GroupKind,ElementNo,Disable) VALUES (?,?,?,?,?,?)");
            foreach( $Element2 as $value )
            {
                $sth->execute( array($this->login_site,$EleNo,$No,ConstTable::GROUP_DOOR,$value,"0") );
                $EleNo = $EleNo + 1;
            }
            
            $this->log->set_log();
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

    public function delete()
    {
        $No       = $this->input->get('no');
        $groupdel = $this->conn->prepare("DELETE FROM GroupElement WHERE Site = ? AND GroupNo=?");
        $groupdel->execute(array($this->login_site, $No));
        
        $groupdel = $this->conn->prepare("DELETE FROM GroupTable WHERE Site = ? AND No=?");
        if( $groupdel->execute(array($this->login_site, $No)) )
        {
            $this->log->set_log();
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------

    public function get_element_str($No)
    {
        $arr    = array();

        $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND No IN (SELECT ElementNo FROM GroupElement WHERE Site=? AND GroupNo=?)");
        $list->execute(array($this->login_site, $this->login_site, $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        
        foreach( $list as $val )
        {
            $arr[]  = $val['Name'];
        }

        return implode(',', $arr);
    }

    // ----------------------------------------------------------------------------------

    public function get_element_select_value($No)
    {
        $arr    = array();

        $list   = $this->conn->prepare("SELECT * FROM GroupElement WHERE Site= ? AND GroupNo = ?");
        $list->execute(array($this->login_site, $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        foreach( $list as $val )
        {
            $arr[]  = "'". $val['ElementNo'] ."'";
        }

        return "[". implode(',', $arr) ."]";
    }
    // ----------------------------------------------------------------------------------
}

?>