<?php
class ipset extends controller
{

    var $arr_ip_type    = array('0'=>'DHCP', '1'=>'Static');
    var $arr_d_server   = array('1'=>'dyndns.org');
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

    // ----------------------------------------------------------------------------------

   public function index()
    {
	    $vars = array();
		if( $this->input->get('wizard') == '1' )	$this->display($vars, '', 'none');
		else								$this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            //$count  = $this->conn->prepare("SELECT COUNT(*) FROM NetworkInfo");
            $count  = $this->net_work->prepare("SELECT COUNT(*) FROM Network");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            //$list   = $this->conn->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM NetworkInfo ORDER BY No DESC LIMIT ?, ?");
            $list   = $this->net_work->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM Network ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            //$count  = $this->conn->prepare("SELECT COUNT(*) FROM NetworkInfo WHERE $field LIKE ?");
            $count  = $this->net_work->prepare("SELECT COUNT(*) FROM Network WHERE $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            //$list   = $this->conn->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM NetworkInfo WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list   = $this->net_work->prepare("SELECT No, IFNULL(IPType, 0) AS IPType, IPAddress, Subnet, Gateway, DNS1, DNS2, HTTPPort, HTTPS, HTTPSPORT FROM Network WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

		$network_info	= $this->network_info();

        foreach( $list as $key=>$val )
        {
			if($val['IPType'] == '0') {
				$val['IPAddress']	= $network_info['addr'];
				$val['Subnet']	= $network_info['mask'];
				$val['Gateway']	= $network_info['bcast'];
			}

            $val['IPTypeStr']       = $this->arr_ip_type[$val['IPType']];
            $val['HTTPSStr']        = ($val['HTTPS'] == '' ? 'Off' : $this->arr_plug[$val['HTTPS']]);
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
        
    }

    public function cert_info()
    {
         exec(SPIDER_COMM." certinfo subj", $output);
         $str	= @$output[count($output)-2];
         $strTok = explode(',' , $str);
         $arr_C = explode('=' , $strTok[0]);
         $arr_O = explode('=' , $strTok[1]);
         $arr_CN = explode('=' , $strTok[2]);

         if(!strcmp($arr_O[0] , "ST="))
         {
             $vars['C'] = "US";
             $vars['O'] = "Global"; //company
             $vars['CN'] = "GlobalSystem";
         }
         else
         {
             $vars['C'] = trim($arr_C[1]);
             $vars['O'] = trim($arr_O[1]); //company
             $vars['CN'] = trim($arr_CN[1]);
         }

         exec(SPIDER_COMM." certinfo add", $output);
         $str	= @$output[count($output)-2];
         $strTok2 = explode(',' , $str);
         $strTok2[0] = trim($strTok2[0]);
         $strTok2[1] = trim($strTok2[1]);
         $strTok2[2] = trim($strTok2[2]);
         $local = explode(':' , $strTok2[0]);
         $rmc = explode(':' , $strTok2[1]);
         $public = explode(':' , $strTok2[2]); 
         
         $vars['localip'] = trim($local[1]);

         if($rmc[0] == 'DNS')
         {
             $vars['RMC'] = array('dns',trim($rmc[1]));
         }
         else
         {
            $vars['RMC'] = array('ip',trim($rmc[1]));
         }

         if($public[0] == 'DNS')
         {            
             $vars['Public'] = array('dns',trim($public[1]));
         }
         else
         {
            $vars['Public'] = array('ip',trim($public[1]));
         }
         
         echo json_encode($vars);

    }

    // ----------------------------------------------------------------------------------
   public function update1()
    {
		$confirm_pw    = $this->input->post('confirm_pw');

		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				exit;
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));

			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				exit;
			}
		}
        
        $No         = $this->input->post('No');
        $IPType     = $this->input->post('IPType', '0');
        $IPAddress  = trim($this->input->post('IPAddress'));
        $Subnet     = trim($this->input->post('Subnet'));
        $Gateway    = trim($this->input->post('Gateway'));
        $DNS1       = trim($this->input->post('DNS1'));
        $DNS2       = trim($this->input->post('DNS2'));
        $HTTPPort   = $this->input->post('HTTPPort', '80');
        $HTTPS      = $this->input->post('HTTPS');
        $HTTPSPort  = $this->input->post('HTTPSPORT', '443');

		if(empty($HTTPPort)) {
			$HTTPPort = '80';
		}

		if(empty($HTTPS)) {
			$HTTPS = '0';
		}

		if(empty($HTTPSPort)) {
			$HTTPSPort = '443';
		}

        if( $HTTPPort == '20000' || $HTTPPort == '20001' || $HTTPSPort == '20000' || $HTTPSPort == '20001' ){
            $this->util->alert( $this->lang->network->error_port_allowed, TRUE );
        }
            
        
        if( $IPType == '1' )
        {
            
            //2015.06.02 by Zeno 
            if (!filter_var($IPAddress, FILTER_VALIDATE_IP) === true) {
                $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
            }
            
            if (!filter_var($Subnet, FILTER_VALIDATE_IP) === true) {
                $this->util->alert( $this->lang->network->error_subnet_required, TRUE );
            }
            
            if( trim($Subnet) == '255.255.255.255' )
            {
				$this->util->alert( $this->lang->network->error_subnet_invalid, TRUE );
            }                       
            
            if (!filter_var($Gateway, FILTER_VALIDATE_IP) === true) {
                $this->util->alert( $this->lang->network->error_gateway_required, TRUE );
            }
            
            if(!empty($DNS1)) {
                if (!filter_var($DNS1, FILTER_VALIDATE_IP) === true) {
                    $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
                }
            }
            
            if(!empty($DNS2)) {
                if (!filter_var($DNS2, FILTER_VALIDATE_IP) === true) {
                    $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
                }
            }
            /*
			if(!$this->check_ip($IPAddress))     
				                        $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
            if( empty($Subnet) )        $this->util->alert( $this->lang->network->error_subnet_required, TRUE );
            if( trim($Subnet) == '255.255.255.255' )
										$this->util->alert( $this->lang->network->error_subnet_invalid, TRUE );
            if( empty($Gateway) )       $this->util->alert( $this->lang->network->error_gateway_required, TRUE );
            */
            
            $Country     = $this->input->post('Country');
            $Corporate   = $this->input->post('Corporate'); //o
            $IP1         = $IPAddress;
            $IP2         = $this->input->post('IP2');
            $IP3         = $this->input->post('IP3');
            $type1 = $this->input->post('Type1');
            $type2 = $this->input->post('Type2');
            
            //$info_out	= $this->network_info();
            //$IP1 = $info_out['addr']; //localip
            //$IP1 = "IP.1=".$IP1;

            if($IP1 != NULL)
            {
                $check = $this->check_ip($IP1);
                if($check != 1)
                {
                    Util::alert("Please enter your IP address correctly");
                    exit;
                }
            }
            else
            {
                Util::alert("Please enter your IP address correctly");
                exit;
            }

            $IP1 = "IP.1=".$IP1;

            if($type1 == 1){
                if(empty($IP2))
                {
                    $IP2 = "";
                }
                else
                {
                    $IP2 = "DNS.1=".$IP2;
                }
            }else{
                if(empty($IP2))
                {
                    $IP2 = "";
                }
                else
                {
                    $check = $this->check_ip($IP2);
                    if($check != 1)
                    {
                        Util::alert("Please enter your IP address correctly");
                        exit;
                    }
                    $IP2 = "IP.2=".$IP2;
                }
            }

            if($type2 == 1){
                if(empty($IP3))
                {
                    $IP3 = "";
                }
                else
                {
                    $IP3 = "DNS.2=".$IP3;
                }
            }else{
                if(empty($IP3))
                {
                    $IP3 = "";
                }
                else
                {
                    $check = $this->check_ip($IP3);
                    if($check != 1)
                    {
                        Util::alert("Please enter your IP address correctly");
                        exit;
                    }
                    $IP3 = "IP.3=".$IP3;
                }
            }

            if($Corporate == '' || $Corporate == NULL)
            {
                $this->util->alert("Please enter company item");
                exit;
            }
            
            switch($Country)
            {
                case 0: $Comm='US'; break;
                case 1: $Comm='KR'; break;
                case 2: $Comm='CN'; break;
            }

            $oem_name = $_ENV["NEPTUNE_MODE"]; // o

            if(empty($oem_name))
            {
                $oem_name = "Globle";
            }
           
            //Util::alert(SPIDER_COMM." selfcertup '".$Comm."' '".$Corporate."' '".$Corporate."' '".$IP1."' '".$IP2."' '".$IP3."'");

            exec(SPIDER_COMM." selfcertup '".$Comm."' '".$Corporate."' '".$Corporate."' '".$IP1."' '".$IP2."' '".$IP3."'");

            $sth    = $this->net_work->prepare("UPDATE Network SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=? WHERE No=?");
            $values = array($IPType,$IPAddress,$Subnet,$Gateway,$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$No);
        }
        else
        {
            $sth    = $this->net_work->prepare("UPDATE Network SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=? WHERE No=?");
            $values = array($IPType,'','','',$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$No);
        }
        
        if( $sth->execute($values) )
        {
            if( $IPType == '1' )
            {
                $sth    = $this->conn->prepare("UPDATE NetworkInfo SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=? WHERE No=?");
                $values = array($IPType,$IPAddress,$Subnet,$Gateway,$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$No);
            }
            else
            {
                $sth    = $this->conn->prepare("UPDATE NetworkInfo SET IPType=?,IPAddress=?,Subnet=?,Gateway=?,DNS1=?,DNS2=?,HTTPPort=?,HTTPS=?,HTTPSPORT=? WHERE No=?");
                $values = array($IPType,'','','',$DNS1,$DNS2,$HTTPPort,$HTTPS,$HTTPSPort,$No);
            }
            if( $sth->execute($values) )
            {
				$HTTPSStr = strtolower($HTTPS == '' ? 'off' : $this->arr_plug[$HTTPS]);
				exec(SPIDER_COMM." http {$HTTPSStr} {$HTTPPort} {$HTTPSPort}");

                $this->log->set_log(NULL, 'update');
                exec("/spider/bin/cp -a /tmp/SpiderDB/* /spider/database/.");
                exec(SPIDER_COMM." sysback");
                
                $this->util->alert($this->lang->common->reboot_system);
				flush();

                exec(SPIDER_COMM." shutdown Flags");
            }
            else
            {
                $this->util->alert($this->lang->common->error_update);
            }
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
        
    }

    // ----------------------------------------------------------------------------------

   public function save_cert()
    {
        $confirm_pw    = $this->input->post('confirm_pw');
		
		// 用户加密 20190731
        if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
                $this->util->alert($this->lang->user->error_login_pw_mismatch);
                $this->util->js('parent.hide_loading();');
				exit;
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));

			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
                $this->util->alert($this->lang->user->error_login_pw_mismatch);
                $this->util->js('parent.hide_loading();');
				exit;
			}
		}
        
        $privatekey         = $this->input->post('privatekey');
        $certificate        = $this->input->post('certificate');
        //$provide_password   = $this->input->post('provide_password');

        if( empty($privatekey) )        
        {
            $this->util->alert( $this->lang->network->error_privatekey_required);
            $this->util->js('parent.hide_loading();');
            exit;
        }
        if( empty($certificate) )       
        {
            $this->util->alert( $this->lang->network->error_certificate_required);
            $this->util->js('parent.hide_loading();');
            exit;
        }
 
        //2015.11.02 by Zeno #1973 - SSL ToolBox에서 새로운 Cert Key를 입력하고 Save하면 HTTPS 체크란에 자동으로 등록되도록
        $sth1  = $this->conn->prepare("UPDATE NetworkInfo SET HTTPS=1 WHERE No=1");
        $sth1->execute();
        $sth2  = $this->net_work->prepare("UPDATE Network SET HTTPS=1 WHERE No=1");
        $sth2->execute();
        
        //$CertInfo = $this->conn->prepare("SELECT HTTPPort, HTTPSPORT FROM NetworkInfo WHERE No=1");
        $CertInfo = $this->net_work->prepare("SELECT HTTPPort, HTTPSPORT FROM Network WHERE No=1");
        $CertInfo->execute();
        $CertInfo = $CertInfo->fetchAll(PDO::FETCH_ASSOC);
        
        $HTTPPort   = $CertInfo[0]['HTTPPort'];
        $HTTPSPort  = $CertInfo[0]['HTTPSPORT'];
      
      
        if(empty($HTTPPort)) {
			$HTTPPort = '80';
		}

		if(empty($HTTPSPort)) {
			$HTTPSPort = '443';
        }
        
        exec(SPIDER_COMM." http on {$HTTPPort} {$HTTPSPort}");
       
        //----------------------------------        
        $filename = uniqid('sicunet.') . '.crt';
        file_put_contents(ROOT_DIR."/usr/local/lighttpd/cert/{$filename}", $privatekey . "\n" . $certificate );
        
        exec(SPIDER_COMM.' cert ' . $filename);
        
        $this->util->alert($this->lang->common->save_completed_reset);
        $this->util->js('parent.hide_loading();');
        $this->util->js('self.Opener = self;');
        $this->util->js('window.close();');
    }
    
    // ----------------------------------------------------------------------------------

   public function cert()
    {
        //-----BEGIN CERTIFICATE-----
        $content = file_get_contents(ROOT_DIR.'/usr/local/lighttpd/cert/sicunet.crt');

        $pos = strpos($content, '-----BEGIN CERTIFICATE-----');

        $vars['privatekey']  = substr($content, 0, $pos);
        $vars['certificate'] = substr($content, $pos);

		$this->display($vars, 'ipset_cert', 'none');
    }
    
    // ----------------------------------------------------------------------------------
    
   public function network_info()
	{
		//exec(SPIDER_COMM.' cmd ifconfig', $lines);
		exec(SPIDER_COMM.' ifconfig', $lines);
		$output	= implode("\n", $lines);

		$match  = "/^.*addr:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})";
		$match .= ".*Bcast:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})";
		$match .= ".*Mask:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}).*$/im";
		if(!preg_match($match, $output, $matches))
			return false;

		$values = array(
			'addr'	=> $matches[1],
			//'bcast'	=> $matches[2],
			'mask'	=> $matches[3]
		);

		$lines = '';
		$output = array();
		$matches = array();

		exec(SPIDER_COMM.' getroute', $lines);
		
		foreach( $lines as $line )
		{
			$line		= strtolower(trim($line));
			$action		= explode(':', $line);
			$status		= trim(@$action[0]);

			if( strpos($status, 'result') === 0 ) {
				$values['bcast']	= trim($action[1]);
				break;
			}
		}

		return $values;
	}

    // ----------------------------------------------------------------------------------

   public function check_ip($ip) 
	{
		$values = true;
		$match = "/^(([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]).){3}([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/";
		
	    if(empty($ip)) 
		{
			$values = false;
		}
		else if(!preg_match($match, $ip))
		{
			$values = false;
		}
		
		return $values;
	}
}
?>