<?php

include APP_DIR.'/libraries/Uploader.php';

class log_viewer extends controller
{
	public $condition_fields	= array
	(
		'No'	      => 'No',
	    'LogDateTime' => 'DateTime',
	    'LogDate'     => 'Date',
		'DeviceName'  => 'Device Name',
		'UserNo'	  => 'User ID',
		'UserName'	  => 'User Name',
		'CardNo'	  => 'Card Number',
		'EventCode'	  => 'Event Code',
		'EventName'	  => 'Event Name',
		'Type'	      => 'Type',
		'Port'	      => 'Port',
		'Area' 	      => 'Area',
		'CardFacility'=> 'Card Facility',
		'Ack'	      => 'Ack',
		'Message'	  => 'Message'
	);
	
	public $item_checker = array('1'=>'0', '2'=>'0', '3'=>'0', '4'=>'0', '5'=>'0', '6'=>'0', '7'=>'0', '8'=>'0' );
	public $item_sequence = array('1'=>'0', '2'=>'0', '3'=>'0', '4'=>'0', '5'=>'0', '6'=>'0', '7'=>'0', '8'=>'0' );

    // ----------------------------------------------------------------------------------

   public function index()
    {
	    $vars = array();
        $this->display($vars);
    }

	// ----------------------------------------------------------------------------------

   public function get_info_condition()
	{
		$ReportNo	= $this->input->get('ReportNo');
		
		$list	= $this->conn->prepare("SELECT * FROM ReportCondition WHERE Site=? AND ReportNo=? ORDER BY No ASC");
		$list->execute(array($_SESSION['spider_site'], $ReportNo));
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		foreach( $list as $key=>$val )
		{
			$val['FieldTitle'] = $this->condition_fields[$val['FieldName']];
			$list[$key]	= $val;
		}

		if( !is_array($list) )	$list = array();

		echo json_encode($list);
    }

	// ----------------------------------------------------------------------------------

   public function to_aray_smartreport()
	{
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$list	= $this->conn->prepare("SELECT * FROM Report WHERE Site=? ORDER BY No ASC");
			$list->execute(array($_SESSION['spider_site']));
		}
		else
		{
			$list	= $this->conn->prepare("SELECT A.* FROM Report AS A, UserRoleReport AS B WHERE A.Site=? AND A.Site=B.Site AND A.No=B.ReportNo AND B.UserRole=? ORDER BY A.No ASC");
			$list->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole']));
		}

		$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		$arr	= array();
		foreach( $list as $row )
		{
			$arr[$row['No']] = $row['Name'];
		}

		return $arr;
    }

	// ----------------------------------------------------------------------------------

   public function condition_by_search()
	{
		$where = "WHERE (Log.Site=0 OR Log.Site=?)";
		$params = array($_SESSION['spider_site']);

		$searchbylocaltime = FALSE; // yhoh 20201124
		if( $this->input->param('searchby') == 'localtime' ) $searchbylocaltime = TRUE;

		$start_date	= $this->input->param('StartDate', FALSE);
		if( $start_date ) {
			$date_part = explode('-', $start_date);
			$start_date = mktime(0, 0, 0, $date_part[0], $date_part[1], $date_part[2]);
			if( $searchbylocaltime ) // yhoh 20201124
				$where .= " AND Log.ClientDate >= ?";
			else
				$where .= " AND Log.Date >= ?";
			$params[] = $start_date;
		}

		$end_date	= $this->input->param('EndDate', FALSE);
		if( $end_date ) {
			$date_part = explode('-', $end_date);
			$end_date = mktime(23, 59, 59, $date_part[0], $date_part[1], $date_part[2]);
			if( $searchbylocaltime ) // yhoh 20201124
				$where .= " AND Log.ClientDate <= ?";
			else
				$where .= " AND Log.Date <= ?";
			$params[] = $end_date;
		}

		$start_hh	= $this->input->param('StartTimeHH', 0);
		$start_mm	= $this->input->param('StartTimeMM', 0);
		if( $start_hh > 0 || $start_mm > 0 ) {
			$start_time = ($start_hh * 60 * 60) + ($start_mm * 60);
			if( $searchbylocaltime ) // yhoh 20201124
				$where .= " AND (Log.ClientDate % 86400) >= $start_time";
			else
				$where .= " AND (Log.Date % 86400) >= $start_time";
		}

		$end_hh	= $this->input->param('EndTimeHH', 0);
		$end_mm	= $this->input->param('EndTimeMM', 0);
		if( $end_hh > 0 || $end_mm > 0 ) {
			$end_time = ($end_hh * 60 * 60) + ($end_mm * 60);
			if( $searchbylocaltime ) // yhoh 20201124
				$where .= " AND (Log.ClientDate % 86400) <= $end_time";
			else
				$where .= " AND (Log.Date % 86400) <= $end_time";
		}

		$arr_type	= array();
		if( $this->input->param('TypeWeb', FALSE) == '1' )			$arr_type[] = '0';
		if( $this->input->param('TypeReader', FALSE) == '1' )		$arr_type[] = '1';
		if( $this->input->param('TypeContact', FALSE) == '1' )		$arr_type[] = '2';
		if( $this->input->param('TypeRex', FALSE) == '1' )			$arr_type[] = '3';
		if( $this->input->param('TypeAuxOut', FALSE) == '1' )		$arr_type[] = '4';
		if( $this->input->param('TypeAuxIn', FALSE) == '1' )		$arr_type[] = '5';
		if( $this->input->param('TypeLook', FALSE) == '1' )		$arr_type[] = '6';
		if( $this->input->param('TypeSystem', FALSE) == '1' )		$arr_type[] = '7';
		if( $this->input->param('TypeNetwork', FALSE) == '1' )		$arr_type[] = '8';
		if( $this->input->param('TypeElevator', FALSE) == '1' )	$arr_type[] = '9';
		if( $this->input->param('TypeElevatorOut', FALSE) == '1' )	$arr_type[] = '10';

		if( $this->input->param('TypeWeb', FALSE) == '1' )	{
			if( count($arr_type) > 0 ) {
				$where .= " AND ( Log.Type is null OR Log.Type IN ('". implode("','", $arr_type) ."') )";
			} 
			else 
			{
				$where .= " AND Log.Type is null";
			}			
		}
		else
		{
			if( count($arr_type) > 0 ) {
				$where .= " AND Log.Type IN ('". implode("','", $arr_type) ."')";
			}
		}

		if( $this->input->param('ConditionCheck', FALSE) ) {
			$where .= " AND Log.DeviceName LIKE ?";
			$params[] = "%".$this->input->param('ConditionText')."%";
		}
		
		if( $this->input->param('ConditionCheck_CardHolder', FALSE) ) {
			$where .= " AND Log.UserName LIKE ?";
			$params[] = $this->util->parse_search_string($this->input->param('ConditionText_CardHolder'));
		}
		
		if( $this->input->param('EventCodeCheck', FALSE) ) {
			$where .= " AND Log.EventCode = ?";
			$params[] = $this->input->param('EventCodeText');
		}
    
        if( $this->is_SuperAdmin() == false )
        {
            $where .= " AND Log.Type <> 7 AND Log.Type <> 8 AND (Log.Type <> 0 OR Log.UserName = '".$_SESSION['spider_id']."')";
        }
        
        
		return array($where, $params);
	}

	// ----------------------------------------------------------------------------------

   public function select()
	{
		list($where, $params)	= $this->condition_by_search();

		$logdb_type	= $this->input->param('logdb');
		$action	= $this->input->get('action', 'search');
        $cp	= $this->input->get('cp', 'false');

		if( $logdb_type == 'pc' ) {
			if( !file_exists(TMPDATA_URL.'/_SpiderLog.db') )	$this->util->alert( $this->lang->smartreport->error_db_required, TRUE );

			$logdb = new PDO('sqlite:'.TMPDATA_URL.'/_SpiderLog.db');
		} else if( $logdb_type == 'sd' ) {
			$sd_file	= $this->input->get('sd_file');
			if( !file_exists($sd_file) )	$this->util->alert( $this->lang->smartreport->error_db_required, TRUE );

			$logdb = new PDO('sqlite:'.$sd_file);
		} else if( $logdb_type == 'current+sd' ) {
            exec(SPIDER_COMM." backup merge");

			$sd_log_dbs = $this->_file_list(2);
			if( count($sd_log_dbs) < 1 )	$this->util->alert( $this->lang->smartreport->error_db_required, TRUE );

            $sd_file = $sd_log_dbs[0];
			if( !file_exists($sd_file) )	$this->util->alert( $this->lang->smartreport->error_db_required, TRUE );

            $logdb = new PDO('sqlite:'.$sd_file);
		} 
		else 
		{
			if ($action == 'preview' || $action == 'download' || $cp == 'true') {
				exec(SPIDER_COMM." sysback");
			}

            $logdb = $this->util->get_connect_backup_log_db();
			$spider_db_path = $this->util->get_file_backup_db();
		}

        //$spider_db_path = DATABASE_DIR.'/Spider.db';
		if(empty($spider_db_path)) $spider_db_path = DATABASE_DIR.'/Spider.db';
        $logdb->exec("ATTACH DATABASE '{$spider_db_path}' AS Spider");
        
        if( $this->is_SuperAdmin() == true )
        {
			
            $sql = " SELECT Log.*, Card.CardNo AS CardNumber, Card.CardFormatNo AS CardFormatNo , Site.Name AS SiteName, Floor.Name AS FloorName  
                        FROM Log
                        LEFT OUTER JOIN Card ON Card.Site=Log.Site AND Card.No=Log.CardNo 
                        LEFT OUTER JOIN Site ON Log.Site = Site.No
                            LEFT OUTER JOIN Door ON    (Log.Type = 1 AND (Log.Port = Door.MasterReader OR Log.Port = Door.SlaveReader)) 
                                                    OR (Log.Type = 2 AND Log.Port = Door.ContactNo )
                                                    OR (Log.Type = 3 AND Log.Port = Door.RexNo )	
                                                    OR (Log.Type = 6 AND Log.Port = Door.LockNo )
                            LEFT OUTER JOIN AuxOutput ON Log.Type = 4 AND Log.Port = AuxOutput.No
                            LEFT OUTER JOIN AuxInput ON Log.Type = 5 AND Log.Port = AuxInput.No
                            LEFT OUTER JOIN ElevatorRelay ON Log.Type = 10 AND Log.Port = ElevatorRelay.No
                            LEFT OUTER JOIN Floor ON (Door.Floor = Floor.No AND Floor.Site = Log.Site) OR AuxOutput.Floor = Floor.No  OR AuxInput.Floor = Floor.No 	OR ElevatorRelay.Floor = Floor.No ";  
			
			/*
            $sql  = " SELECT Log.No, Log.Site, Log.DeviceName, Log.Type, Log.Port, Log.Area,";
			$sql .=	" Log.EventCode, Log.UserNo, Log.UserName, Log.UserImage, Log.CardNo,";
			$sql .= " Log.CardFacility, Log.Date as Date , Log.ClientIP, Log.ClientMAC, Log.ClientDate,";
			$sql .= " Log.Ack, Log.SendToServer, Log.Res1, Log.Res2, Log.Res3, Log.Message, ";
			$sql .= " Card.CardNo AS CardNumber, Card.CardFormatNo AS CardFormatNo , ";
			$sql .= " Site.Name AS SiteName, Floor.Name AS FloorName ";
            $sql .= " FROM Log ";
            $sql .= " LEFT OUTER JOIN Card ON Card.Site=Log.Site AND Card.No=Log.CardNo ";
            $sql .= " LEFT OUTER JOIN Site ON Log.Site = Site.No ";
            $sql .= " LEFT OUTER JOIN Door ON    (Log.Type = 1 AND (Log.Port = Door.MasterReader OR Log.Port = Door.SlaveReader)) ";
            $sql .= " OR (Log.Type = 2 AND Log.Port = Door.ContactNo ) ";
            $sql .= " OR (Log.Type = 3 AND Log.Port = Door.RexNo )	";
            $sql .= " OR (Log.Type = 6 AND Log.Port = Door.LockNo ) ";
            $sql .= " LEFT OUTER JOIN AuxOutput ON Log.Type = 4 AND Log.Port = AuxOutput.No ";
            $sql .= " LEFT OUTER JOIN AuxInput ON Log.Type = 5 AND Log.Port = AuxInput.No ";
            $sql .= " LEFT OUTER JOIN ElevatorRelay ON Log.Type = 10 AND Log.Port = ElevatorRelay.No ";
            $sql .= " LEFT OUTER JOIN Floor ON Door.Floor = Floor.No OR AuxOutput.Floor = Floor.No  OR AuxInput.Floor = Floor.No 	OR ElevatorRelay.Floor = Floor.No ";  
			*/

            $sql_count = "SELECT COUNT(*) FROM Log";
        }
        else{
            $sql = " SELECT Log.*, Card.CardNo AS CardNumber, Card.CardFormatNo AS CardFormatNo  , Site.Name AS SiteName, Floor.Name AS FloorName  
                        FROM Log
                        LEFT OUTER JOIN Card ON Card.Site=Log.Site AND Card.No=Log.CardNo 
                        JOIN host ON IFNULL(Log.ClientMAC, '') = (CASE WHEN Host.No = 1 THEN '' ELSE Host.MAC END) AND (Host.ByAdminId = '".$_SESSION['spider_id']."' OR Host.ByAdminId = '' OR Host.ByAdminId IS null)
                        LEFT OUTER JOIN Site ON Log.Site = Site.No
                        LEFT OUTER JOIN Door ON    (Log.Type = 1 AND (Log.Port = Door.MasterReader OR Log.Port = Door.SlaveReader)) 
                                                OR (Log.Type = 2 AND Log.Port = Door.ContactNo )
                                                OR (Log.Type = 3 AND Log.Port = Door.RexNo )	
                                                OR (Log.Type = 6 AND Log.Port = Door.LockNo )
                        LEFT OUTER JOIN AuxOutput ON Log.Type = 4 AND Log.Port = AuxOutput.No
                        LEFT OUTER JOIN AuxInput ON Log.Type = 5 AND Log.Port = AuxInput.No
                        LEFT OUTER JOIN ElevatorRelay ON Log.Type = 10 AND Log.Port = ElevatorRelay.No
                        LEFT OUTER JOIN Floor ON (Door.Floor = Floor.No AND Floor.Site = Log.Site) OR AuxOutput.Floor = Floor.No  OR AuxInput.Floor = Floor.No 	OR ElevatorRelay.Floor = Floor.No ";  
                            

            $sql_count = "SELECT COUNT(*) FROM Log
                            JOIN host ON IFNULL(Log.ClientMAC, '') = (CASE WHEN Host.No = 1 THEN '' ELSE Host.MAC END) AND (Host.ByAdminId = '".$_SESSION['spider_id']."' OR Host.ByAdminId = '' OR Host.ByAdminId IS null)";
        }

		// yhoh 20201124
		if( $this->input->param('searchby') == 'localtime' )
			$orderby = "ORDER BY Log.ClientDate DESC";
		else
			$orderby = "ORDER BY Log.No DESC";

		if ($action == 'preview') {
			$list	= $logdb->prepare("{$sql} {$where} {$orderby}");
			$list->execute($params);

			$vars = array();
			$vars['list']	= $list;
			$vars['rownum']	= 1;
			$vars['logdb']	= $logdb;

			set_time_limit(0);
			$this->display($vars, 'log_viewer_preview', 'none');

		} else if ($action == 'download') {
			$list	= $logdb->prepare("{$sql} {$where} {$orderby}");
			$list->execute($params);

			$filename   = "log_viewer_" . date("YmdHis") .".csv";

			set_time_limit(0);
			header("Content-Description: File Transfer");
			header("Content-Type: application/octet-stream");
			header("Content-Disposition: attachment; filename=\"".$filename."\"");
			header("Content-Transfer-Encoding: Binary");
			header("Pragma: no-cache; public");
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
			header("Expires: 0");

            $items  = array();
            for( $i = 1; $i <= 17; $i++ ) {
                $items[$i] = $this->input->post("Item_{$i}", '');
            }

            $headers = array();
            
            if( $items[1] == '1' )  $headers[] = $this->lang->addmsg->item_date;
            if( $items[2] == '1' )  $headers[] = $this->lang->addmsg->item_datetime;
            if( $items[3] == '1' )  $headers[] = $this->lang->addmsg->item_time;
            if( $items[4] == '1' )  $headers[] = $this->lang->addmsg->item_event;
            if( $items[5] == '1' )  $headers[] = $this->lang->addmsg->item_user;
            if( $items[6] == '1' )  $headers[] = $this->lang->addmsg->item_user_field;
            if( $items[7] == '1' )  $headers[] = $this->lang->addmsg->item_card_no;
            if( $items[8] == '1' )  $headers[] = $this->lang->addmsg->item_message;
            if( $items[9] == '1' )  $headers[] = $this->lang->addmsg->item_devicename;
            if( $items[10] == '1' ) $headers[] = $this->lang->addmsg->item_type;
            if( $items[11] == '1' ) $headers[] = $this->lang->addmsg->item_port;
            if( $items[12] == '1' ) $headers[] = $this->lang->addmsg->item_localtime;
            if( $items[13] == '1' ) $headers[] = $this->lang->addmsg->item_ack;
            if( $items[14] == '1' ) $headers[] = $this->lang->addmsg->item_ack_message;
            if( $items[15] == '1' ) $headers[] = $this->lang->addmsg->item_reader_type;
            if( $items[16] == '1' ) $headers[] = $this->lang->addmsg->item_site_name;
            if( $items[17] == '1' ) $headers[] = $this->lang->addmsg->item_floor_name;
            
            echo implode(',', $headers) . "\n";

			while( $row = $list->fetch(PDO::FETCH_ASSOC) )
			{
                                if($row['CardNumber'] != NULL)
                                        $card_number = $row['CardNumber']."(".$this->util->GetCardFacilityCode($row['CardFormatNo']).")";
                                else if($row['EventCode'] == '100')
                                        $card_number = $row['Message']."(".$row['CardFacility'].")";
                                else
                                        $card_number = "";

				$eventcode_name = $row['EventCode'];
				$row['eventdescription']	= $this->lang->eventcode->$eventcode_name;
				$row['FDateTime']	= date('m-d-Y H:i:s', $row['Date']);
				$row['CDateTime']	= date('m-d-Y H:i:s', $row['ClientDate']);
				$row['UserDefine']	= $this->find_user_define($row['UserNo']);
				$row['LogType']		= EnumTable::$attrLogType[$row['Type']];
				$row['AckMessage']	= $this->get_ack_message($row['No'], $logdb);

                $columns = array();
                if( $items[1] == '1' )  $columns[] = date('m-d-Y', $row['Date']);
                if( $items[2] == '1' )  $columns[] = date('m-d-Y H:i:s', $row['Date']);
                if( $items[3] == '1' )  $columns[] = date('H:i:s', $row['Date']);
                if( $items[4] == '1' )  $columns[] = $this->lang->eventcode->$eventcode_name;
                if( $items[5] == '1' )  $columns[] = $row['UserName'];
                if( $items[6] == '1' )  $columns[] = $this->find_user_define($row['UserNo']);
                if( $items[7] == '1' )  $columns[] = $card_number;
                if( $items[8] == '1' )  $columns[] = $row['Message'];
                if( $items[9] == '1' )  $columns[] = $row['DeviceName'];
                if( $items[10] == '1' ) $columns[] = EnumTable::$attrLogType[$row['Type']];
                if( $items[11] == '1' ) $columns[] = $row['Port'];
                if( $items[12] == '1' ) $columns[] = date('m-d-Y H:i:s', $row['ClientDate']);
                if( $items[13] == '1' ) $columns[] = $row['Ack'];
                if( $items[14] == '1' ) $columns[] = $this->get_ack_message($row['No'], $logdb);
                if( $items[15] == '1' ) $columns[] = ($row['Type'] == 1 ? $this->get_reader_type($row['Port']) : '');
                if( $items[16] == '1' ) $columns[] = $row['SiteName'];
                if( $items[17] == '1' ) $columns[] = $row['FloorName'];

                echo '"' . implode('","', $columns) . "\"\n";
			}

		} else {
			$page	= $this->input->get('page', 1);

			$count	= $logdb->prepare("{$sql_count} {$where}");
			$count->execute($params);
			$count	= $count->fetchColumn();

			$pagination		= new Pagination();
			$page_config	= $GLOBALS['page_config'];
			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$params[]	= $pagination->offset;
			$params[]	= $pagination->row_size;

			$list	= $logdb->prepare("{$sql} {$where} {$orderby} LIMIT ?, ?");
			$list->execute($params);

			$vars = array();
			$vars['page']	= $page;
			$vars['count']	= $count;
			$vars['list']	= $list;
			$vars['pages']	= $pagination->get_pages();
			$vars['rownum']	= $pagination->offset + 1;
			$vars['logdb']	= $logdb;

			$this->display($vars, 'log_viewer_search', false);
		}
		
		exec("unmount /mnt/sd");
	}
	
	// ----------------------------------------------------------------------------------
   public function find_user_define($user_no)
	{
        $list = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND No=? LIMIT 1");
        $list->execute(array($_SESSION['spider_site'], $user_no));
        $list	= $list->fetchAll(PDO::FETCH_ASSOC);

		$user_define = array();
		if( !empty($list[0]['UserDefine1']) )	$user_define[] = $list[0]['UserDefine1'];
		if( !empty($list[0]['UserDefine2']) )	$user_define[] = $list[0]['UserDefine2'];
		if( !empty($list[0]['UserDefine3']) )	$user_define[] = $list[0]['UserDefine3'];
		if( !empty($list[0]['UserDefine4']) )	$user_define[] = $list[0]['UserDefine4'];
		if( !empty($list[0]['UserDefine5']) )	$user_define[] = $list[0]['UserDefine5'];
		if( !empty($list[0]['UserDefine6']) )	$user_define[] = $list[0]['UserDefine6'];
		if( !empty($list[0]['UserDefine7']) )	$user_define[] = $list[0]['UserDefine7'];
		if( !empty($list[0]['UserDefine8']) )	$user_define[] = $list[0]['UserDefine8'];
		if( !empty($list[0]['UserDefine9']) )	$user_define[] = $list[0]['UserDefine9'];
		if( !empty($list[0]['UserDefine10']) )	$user_define[] = $list[0]['UserDefine10'];
		if( !empty($list[0]['UserDefine11']) )	$user_define[] = $list[0]['UserDefine11'];
		if( !empty($list[0]['UserDefine12']) )	$user_define[] = $list[0]['UserDefine12'];
		if( !empty($list[0]['UserDefine13']) )	$user_define[] = $list[0]['UserDefine13'];
		if( !empty($list[0]['UserDefine14']) )	$user_define[] = $list[0]['UserDefine14'];
		if( !empty($list[0]['UserDefine15']) )	$user_define[] = $list[0]['UserDefine15'];
		if( !empty($list[0]['UserDefine16']) )	$user_define[] = $list[0]['UserDefine16'];
		if( !empty($list[0]['UserDefine17']) )	$user_define[] = $list[0]['UserDefine17'];
		if( !empty($list[0]['UserDefine18']) )	$user_define[] = $list[0]['UserDefine18'];
		if( !empty($list[0]['UserDefine19']) )	$user_define[] = $list[0]['UserDefine19'];
		if( !empty($list[0]['UserDefine20']) )	$user_define[] = $list[0]['UserDefine20'];

		return implode(',', $user_define);
	}
	
	// ----------------------------------------------------------------------------------
   public function set_item_checker()
	{
		$no    = $this->input->get('no');
		$setval   = $this->input->get('val');
		
		$item_checker[$no]  = $setval;
	}	

    // ----------------------------------------------------------------------------------

   public function to_timestamp($date="", $hour=0, $min=0, $sec=0)
    {
        if ($date != "")
        {
        	$timeval = explode('-', trim($date));
        	
        	if (count($timeval) < 3)
        	{
        		return "";
        	}
        		
            $month  = $timeval[0];
            $day    = $timeval[1];
            $year   = $timeval[2];
            return mktime($hour, $min, $sec, $month, $day, $year);
        }
        return $date;
    }

    // ----------------------------------------------------------------------------------

   public function get_ack_message($no, $logdb)
	{
        $list = $logdb->prepare("SELECT * FROM LogAck WHERE No=? LIMIT 1");
        $list->execute(array($no));
        if( $row = $list->fetch(PDO::FETCH_ASSOC) )
		{
			return $row['AckReason'];
		}
		else
		{
			return '';
		}
	}

	// ----------------------------------------------------------------------------------
   public function get_reader_type($no)
	{
        $list = $this->conn->prepare("SELECT * FROM Reader WHERE No=? LIMIT 1");
        $list->execute(array($no));
        if( $row = $list->fetch(PDO::FETCH_ASSOC) )
		{
			if( ($row['Port'] % 2) == 0 )
				return 'Out';
			else
				return 'In';
		}

		return '';
	}	

    // ----------------------------------------------------------------------------------

   public function upload_db()
    {
		unlink(TMPDATA_URL.'/'.$file);

		$file = $this->receive();
		if( $file === FALSE )
		{
			$this->util->alert($this->lang->addmsg->error_upload);
			exit;
		}

		//$this->util->alert(TMPDATA_URL.'/'.$file." : ".filesize(TMPDATA_URL.'/'.$file));
		$this->util->alert($this->lang->addmsg->success_upload);

		//unlink(TMPDATA_URL.'/'.$file);
    }

    // ----------------------------------------------------------------------------------

   public function receive()
    {
		$this->clear_receive_file();

        if( ! is_uploaded_file($_FILES['upload_file']['tmp_name']) )    return FALSE;

        $uploader                   = new Uploader();
        $uploader->upload_dir       = TMPDATA_URL;
        $uploader->allowed_types    = 'db';
		$uploader->file_name		= '_SpiderLog';

        if( $uploader->do_upload('upload_file', 40960000) )
        {
            return $uploader->save_file['basename'];
        }
        else
        {
        	$this->util->alert($this->lang->addmsg->error_backup_file);			//$this->util->alert( "Backup File Loading Error : ".$uploader->get_errors() );
            return FALSE;
        }
    }

    // ----------------------------------------------------------------------------------

   public function _file_list($type=1)
    {
		$files = array();
		$output = array();

		exec(SPIDER_COMM." sd_list {$type}", $output);

		foreach( $output as $line )
		{
			$line = trim($line);
			$name_split = explode('.', $line);

			if( $name_split[(count($name_split) - 1)] == 'db' ) {
				$files[] = $line;
			}
		}

		return $files;
    }

    // ----------------------------------------------------------------------------------

   public function file_list()
    {
		echo json_encode($this->_file_list());
    }

    // ----------------------------------------------------------------------------------

   public function sd_receive()
    {
		$this->clear_receive_file();

		$file_name = $this->input->get('file_name', '');

		if( !empty($file_name) ) {
			copy("{$file_name}", TMPDATA_URL.'/_SpiderLog.db');
			exec("unmount /mnt/sd");
		}
    }

    // ----------------------------------------------------------------------------------

   public function clear_receive_file()
    {
		@unlink(TMPDATA_URL.'/_SpiderLog.db');
    }

    // ----------------------------------------------------------------------------------

   public function get_camera_name($channelNo)
    {
		$channel	= $this->conn->prepare("SELECT No, Name, DvrNo, Type FROM DVRChannel WHERE No=?");
		$channel->execute( array($channelNo) );
		if(($channel = $channel->fetch(PDO::FETCH_ASSOC)) == false) {
			return 'unknown channel';
		}
		return "{$channel['Name']}";
    }
    
   public function get_camera_type($channelNo)
    {
		$channel	= $this->conn->prepare("SELECT No, Name, DvrNo, Type FROM DVRChannel WHERE No=?");
		$channel->execute( array($channelNo) );
		if(($channel = $channel->fetch(PDO::FETCH_ASSOC)) == false) {
			return '0';
		}
        
        return "{$channel['Type']}";
    }

    // ----------------------------------------------------------------------------------

}

?>
