<?php 
include APP_DIR.'/libraries/Uploader.php';
class logmanagement extends controller
{
	var $arr_plug       = array('0'=>'Off', '1'=>'On');
	var $arr_device     = array('0'=>'SD/USB', '1'=>'FTP'); 

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $logmanagement  = $this->conn->prepare("SELECT * FROM LogManagement WHERE Site=? AND No=1");
        $logmanagement->execute(array($_SESSION['spider_site']));
        $logmanagement  = $logmanagement->fetch(PDO::FETCH_ASSOC);
		
		if(!empty($logmanagement['Enable'])){
			$logmanagement['EnableStr'] = $this->arr_plug[$logmanagement['Enable']];
		}else{
			$logmanagement['EnableStr'] = '';
		}
		
		if($logmanagement['Device'] != ''){
			$logmanagement['DeviceStr'] = $this->arr_device[$logmanagement['Device']];
		}else{
			$logmanagement['DeviceStr'] = '';
		}

        $vars['logmanagement'] = $logmanagement;
		
        $this->display($vars);
    }

    public function confirm_pw()
	{
        $confirm_pw    = $this->input->post('confirm_pw');
	
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
			//$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
			$ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));

			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
			//$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
			$webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));

			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}

		$this->util->js("$('#form_log_restore').submit();");
	}


    // ----------------------------------------------------------------------------------
    public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM BackupSchedule WHERE No=2");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM BackupSchedule WHERE No=2 ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM BackupSchedule WHERE No=2 AND $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM BackupSchedule WHERE No=2 AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
        	$val['BackupName']    = $val['Name'];
            $val['EnableStr']     = $this->arr_plug[$val['Enable']];
            $val['DeviceStr']     = $this->arr_device[$val['Device']];            
            $val['BackupTimeStr'] = EnumTable::$attrTimeList[$val['BackupTime']];
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
   public function update()
    {        
    	$Name        = strip_tags($this->input->post('Name'));
    	$Enable      = $this->input->post('Enable', '0');
        $Device      = $this->input->post('Device', '0');
        $BackupTime  = $this->input->post('BackupTime');
        
        $sth     = $this->conn->prepare("UPDATE BackupSchedule SET Name=?,Enable=?,BackupTime=?,Device=? WHERE No=2");
        $values  = array($Name, $Enable, $BackupTime, $Device);
        
        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->redirect("/?c=logmanagement");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }
    
   public function update_msg()
    {
		if( $this->is_auth(78, 26) != TRUE) 
		{ 
	    	$this->util->alert($this->lang->user->error_not_permission, TRUE);
    	}

        $Percent    = $this->input->post('Percent', '0');
        $Message    = strip_tags($this->input->post('Message'));
        $Name	    = strip_tags($this->input->post('Name'));
        $Enable     = $this->input->post('Enable');
        $Device     = $this->input->post('Device');

        if( $Percent < 10 || $Percent > 99 )        $this->util->alert( $this->lang->aoutput->error_percent, TRUE );

        $sth    = $this->conn->prepare("UPDATE LogManagement SET Percent=?,Message=?,Name=?,Enable=?,Device=? WHERE Site=? AND No=1");

        $values = array($Percent,$Message,$Name,$Enable,$Device,$_SESSION['spider_site']);
        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->redirect("/?c=logmanagement");
            //$this->util->alert($this->lang->common->success_update);
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

   public function reset()
    {
		$confirm_pw    = $this->input->post('confirm_pw');
		
		// 用户加密 20190731
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));
			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}

		if( $this->is_auth(78, 10) != TRUE) 
		{ 
	    	$this->util->alert($this->lang->user->error_not_permission, TRUE);
    	}
    	    	
    	if ( ($_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE || 
			  $_SESSION['spider_model'] == ConstTable::MODEL_GIANT) && $_SESSION['spider_type'] != 'spider' )
    	{
			exec(SPIDER_COMM." resetlog {$_SESSION['spider_site']}");
	    }
	    else
	    {
			exec(SPIDER_COMM." resetlog 0");
	    }

		$this->log->set_log();
    }

    public function recover()
    {
		$confirm_pw    = $this->input->post('confirm_pw');
		
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));
			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}

		if( $this->is_auth(78, 10) != TRUE) 
		{ 
	    	$this->util->alert($this->lang->user->error_not_permission, TRUE);
    	}
    	
        exec(SPIDER_COMM." recoverlogdb");
		$this->log->set_log();
    }

   public function merge()
    {
		$confirm_pw    = $this->input->post('confirm_pw');
		
		// 用户加密 20190731
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));
			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));
			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch, TRUE);
			}
		}

		if( $this->is_auth(78, 10) != TRUE) 
		{ 
	    	$this->util->alert($this->lang->user->error_not_permission, TRUE);
    	}
        
        exec(SPIDER_COMM." logmerge no");

		$this->log->set_log();
    }

   public function backup()
    {
        $sel    = $this->input->post('sel');

        exec(SPIDER_COMM." sysback");
        $logdb = $this->util->get_connect_backup_log_db();

        if( $sel == 'csv' )
        {
            $list   = $logdb->prepare("SELECT * FROM Log");
            $list->execute();
            $filename   = "log_" . date("YmdHis") .".csv";

            header("Content-Description: File Transfer");
            header("Content-Type: application/octet-stream");
            header("Content-Disposition: attachment; filename=\"".$filename."\"");
            header("Content-Transfer-Encoding: Binary");
            header("Pragma: no-cache; public");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Expires: 0");

            //$list   = $list->fetchAll(PDO::FETCH_ASSOC);

            echo "Time,User Name,Device Name,Event Description\n";

            while( $row = $list->fetch(PDO::FETCH_ASSOC) )
            {
                $eventcode_name = $row['EventCode'];
                $data = date("m-d-Y H:i:s", $row['Date']) . ","
                    . $row['UserName'] . ","
                    . $row['DeviceName'] . ","
                    . "\"". $this->lang->eventcode->$eventcode_name . "\"\n";

				echo $data;
            }
        }
        else if( $sel == 'db' )
        {
            $filepath   = $this->util->get_file_backup_log_db();
            $filename   = "log_" . date("YmdHis") .".db";

            header("Content-Description: File Transfer");
            header("Content-Type: application/octet-stream");
            header("Content-Disposition: attachment; filename=\"".$filename."\"");
            header("Content-Transfer-Encoding: Binary");
            header("Pragma: no-cache; public");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Content-Length: " . filesize($filepath));
            header("Expires: 0");

            readfile($filepath);
        }

		$this->log->set_log('logmanagement', '_exec');
    }

    public function log_restore()
    {
        set_time_limit(0);
        $rt  = "0";
        $msg = $this->lang->common->success_complete_restore;
        
        $file = $this->receive();

        if( $file === FALSE )
        {
            $this->util->alert($this->lang->common->fail_complete_restore_pc_file);
            $this->util->redirect("/?c=logmanagement");
            exit;
        }
        
        $rt = exec(SPIDER_COMM." restore log '$file'");
        
        if ($rt == "-2")
        {
           //Util::alert("2");
            $msg = $this->lang->common->fail_complete_restore_pc_file;
        }
        else if ($rt != "0")
        {           
            $msg = $this->lang->common->fail_complete_restore_pc;

            $this->log->set_log('reset', 'reset');
            
            exec(SPIDER_COMM." shutdown Flags"); 
            $this->util->alert($this->lang->common->save_completed_reset);
            
            $this->util->redirect('/?c=user&m=logout');   
        }
    }

    public function receive()
    {
        
        if( ! is_uploaded_file($_FILES['upload_file']['tmp_name']) )
        {
            return FALSE;
        }

        $uploader                   = new Uploader();
        $uploader->upload_dir       = TMPDATA_URL;
        //$uploader->allowed_types    = 'tar|TAR|gz';
        $uploader->allowed_types    = 'db';
		$uploader->file_name		= 'restore';

        if( $uploader->do_upload('upload_file', 40960000) )
        //if( $uploader->do_upload('upload_file', (1000 * 1024 * 15)) )
        {
            return $uploader->save_file['basename'];
        }
        else
        {
			$this->util->alert( $uploader->get_errors() );
        	$this->util->alert($this->lang->addmsg->error_backup_file);
            return FALSE;
        }
    }

}