<?php


class lostcard extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $only_used = $this->input->get('only_used', '');
        $only_used = $only_used == 'true' ? TRUE : FALSE;

        $vars['cards'] = $this->get_onetime_card($only_used);
        $vars['only_used'] = $only_used;
    	$vars['arr_card_holder']  = array();
        
        $vars['occupancy'] = $this->get_violation_user();
        $vars['deadmantemp'] = $this->get_violation_deadman();

        $this->display($vars, '', 'lostcard');
    }
    
    public function select()
    {
	    
    }

    // ----------------------------------------------------------------------------------
    public function registration()
    {
        $CardNo = $this->input->post('CardNumber');
		$UserNo = $this->input->post('card_holder');
        
        $CardExist = $this->conn->prepare("SELECT COUNT(*) FROM Card WHERE CardNo=? AND UserNo=?");
        $CardExist->execute(array($CardNo, $UserNo));
        $CardExist = $CardExist->fetchColumn();
        
        if ($CardExist == 0)    $this->util->alert( $this->lang->license->error_card_no_not_exist, TRUE );
        if ($CardExist > 1)     $this->util->alert( $this->lang->license->error_card_no_over_1, TRUE );
        if( empty($CardNo) )    $this->util->alert( $this->lang->license->error_card_no_required, TRUE );

        $LostCardExist = $this->conn->prepare("SELECT COUNT(*) FROM Card WHERE CardNo=? AND UserNo=? AND CardStatus='1'");
        $LostCardExist->execute(array($CardNo, $UserNo));
        $LostCardExist = $LostCardExist->fetchColumn();

		if ($LostCardExist > 0)     $this->util->alert( $this->lang->license->error_exists_lostcard, TRUE );
        
        $sth    = $this->conn->prepare("UPDATE Card SET CardStatus='1' WHERE CardNo=? AND UserNo=?");
        if( $sth->execute(array($CardNo, $UserNo)))
        {
        	$query = "UPDATE Card SET CardStatus=1 WHERE CardNo='{$CardNo}', UserNo='{$UserNo}'";
            
            //exec(SPIDER_COMM." send db");
            
            $this->log->set_log(NULL, 'update');
            $this->util->alert( $this->lang->license->complete_registration);
        }
        else
        {
            $this->util->alert($this->lang->common->fail_registration);
        }
    }
    
   public function search_card_holder()
    {
    	$No    = $this->input->get('no');
    	$arr_card_holder  = $this->get_card_holder($No);

		echo json_encode($arr_card_holder);
    }
    
   public function get_card_holder($No)
    {
		$list   = $this->conn->prepare("SELECT User.No, User.FirstName, User.MiddleName, User.LastName, CardFormat.Name, CardFormat.Mean, Card.CardStatus FROM Card INNER JOIN User ON User.No=Card.UserNo LEFT OUTER JOIN CardFormat ON CardFormat.No=Card.CardFormatNo WHERE User.Site=? AND Card.CardNo=?");
        //$list   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND No=?");
        $list->execute(array($_SESSION['spider_site'], $No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        
        $arr    = array();
        foreach( $list as $key=>$val)
        {
			$row['No'] = $val['No'];
			if (empty($val['Mean']) || $val['Mean'] == '')
				$row['Name'] = $val['FirstName']." ".$val['MiddleName']." ".$val['LastName']." / ".$val['Name']." / ".EnumTable::$attrCardStatus[$val['CardStatus']];
			else
				$row['Name'] = $val['FirstName']." ".$val['MiddleName']." ".$val['LastName']." / ".$val['Mean']." / ".EnumTable::$attrCardStatus[$val['CardStatus']];
			$arr[] = $row;
        }
        return $arr;
    }

	// ----------------------------------------------------------------------------------

   public function reset_onetime_card()
    {
        $items    = $this->input->post('items', array());

        if( empty($items) ) {
            $this->util->alert( $this->lang->common->error_missing_items, TRUE );
        }

        //$cards = $this->conn->prepare("UPDATE Card Set ExpDate=0 WHERE Site=? AND No IN (". implode(',', $items) .")");
        //$cards = $this->conn->prepare("UPDATE Card Set ExpDate=0, CARDSTATUS=0 WHERE Site=? AND No IN (". implode(',', $items) .")");
        $cards = $this->conn->prepare("UPDATE Card Set CardTime=0 WHERE Site=? AND No IN (". implode(',', $items) .")");
        $cards->execute(array($_SESSION['spider_site']));

        $this->log->set_log('card', 'reset');
        $this->util->alert( $this->lang->common->save_completed );
        $this->util->js("location.href='/?c=lostcard';");
    }

   public function grace_user()
    {
        $items    = $this->input->post('Gitems', array());
        
        if( empty($items) ) {
            $this->util->alert( $this->lang->common->error_missing_items, TRUE );
        }

        
        foreach($items as $cardno) {
        	
        	$tokens			= explode('.', $cardno);
        	
            $sqln   = $this->conn->prepare("SELECT  Region.Name AS RegionName 
                                                    FROM   OccupancyViolation
                                                    LEFT   OUTER JOIN Region ON Region.No = OccupancyViolation.ToRegionNo
                                                    WHERE  OccupancyViolation.Site=? AND OccupancyViolation.CardNo = ?");
                     
            $sqln->execute( array($_SESSION['spider_site'], $tokens[0]) );
            $sqln = $sqln->fetchColumn();
            
            exec(SPIDER_COMM." graceuser $tokens[0]");
            //$this->log->set_log("lostcard", "ack", $cardno." ".$sqln);
            $this->log->set_log("lostcard", "ack", $tokens[0]." ".$tokens[1]);
        }
        
        $this->util->alert( $this->lang->common->grace_complete );
        $this->util->js("location.href='/?c=lostcard';");
    }
    
   public function grace_deadman()
    {
        $items    = $this->input->post('Gitems', array());
        
        if( empty($items) ) {
            $this->util->alert( $this->lang->common->error_missing_items, TRUE );
        }

        
        foreach($items as $cardno) {
            
            $sqln   = $this->conn->prepare("SELECT  Region.Name AS RegionName 
                                                    FROM   DeadManTemp
                                                    LEFT   OUTER JOIN Region ON Region.No = DeadManTemp.RegionNo
                                                    WHERE  DeadManTemp.Site=? AND DeadManTemp.CardNo = ? ");
                     
            $sqln->execute( array($_SESSION['spider_site'], $cardno) );
            $sqln = $sqln->fetchColumn();
            
            exec(SPIDER_COMM." gracedeadman $cardno");
            $this->log->set_log("lostcard", "off", $cardno." ".$sqln);
        }
        
        $this->util->alert( $this->lang->common->grace_complete );
        $this->util->js("location.href='/?c=lostcard';");
    }
    
	// ----------------------------------------------------------------------------------

   public function get_onetime_card($only_used)
	{
		$sql = " SELECT Card.No AS CardID, Card.CardNo AS CardNumber, Card.CardStatus, Card.CardType, Card.CardTime, Card.NeverExpire, Card.ActDate, Card.ExpDate, CardFormat.No AS CardFormatNo, CardFormat.Name AS CardFormatName, User.No, User.FirstName, User.MiddleName, User.LastName, User.Phone
                 FROM Card
                 LEFT OUTER JOIN CardFormat ON CardFormat.No=Card.CardFormatNo
                 LEFT OUTER JOIN User ON User.No=Card.UserNo AND User.Site=Card.Site
                 WHERE Card.Site=? AND Card.CardType=5 ";

		$params	= array($_SESSION['spider_site']);

        if( $only_used ) {
            $where = "AND Card.CardTime != 0";
        } else {
            $where = "";
        }

        $list	= $this->conn->prepare("{$sql} {$where} ORDER BY Card.CardNo ASC");
        $list->execute($params);

        return $list;
	}
    
   public function get_violation_user()
    {
        $sql = "SELECT OccupancyViolation.CardNo AS CardNo, 
                        User.FirstName AS FirstName, User.MiddleName AS MiddleName, User.LastName AS LastName,
                        datetime(OccupancyViolation.Date, 'unixepoch') AS DateTime,
                        Card.CardNo AS CardNumber, OccupancyViolation.CardFacility AS Facility, 
                        Region1.Name AS OccupiesRegion,  
                        Region2.Name AS CurrentRegion,
                        Region3.Name AS DestRegion, 
                        OccupancyViolation.ViolationType AS ViolationType,
                        OccupancyViolation.Date
                FROM OccupancyViolation 
                LEFT OUTER JOIN Region AS Region1 ON Region1.No = OccupancyViolation.CurrentRegion
                LEFT OUTER JOIN Region AS Region2 ON Region2.No = OccupancyViolation.FromRegion
                LEFT OUTER JOIN Region AS Region3 ON Region3.No = OccupancyViolation.ToRegionNo 
                LEFT OUTER JOIN Card ON Card.No = OccupancyViolation.CardNo
                LEFT OUTER JOIN User ON User.No = OccupancyViolation.UserNo
                WHERE NOT(OccupancyViolation.ViolationType = 1 AND Region3.EnableGrace = 0)";
        
        $occupancy	= $this->conn->prepare($sql);
        $occupancy->execute();

        return $occupancy;        
    }

   public function get_violation_deadman()
    {
        $sql = "SELECT  DeadManTemp.CardNo AS CardNo, 
                        User.FirstName AS FirstName, User.MiddleName AS MiddleName, User.LastName AS LastName,
                        Card.CardNo AS CardNumber, 
                        Region.Name AS ViolationRegion,
                        datetime(DeadManTemp.TagDate, 'unixepoch') AS tagDateTime
                        
                FROM DeadManTemp 
                LEFT OUTER JOIN Region AS Region ON Region.No = DeadManTemp.RegionNo
                LEFT OUTER JOIN Card ON Card.No = DeadManTemp.CardNo
                LEFT OUTER JOIN User ON User.No = DeadManTemp.UserNo
                WHERE DeadManTemp.Violation = 1";
        
        $deadmantemp	= $this->conn->prepare($sql);
        $deadmantemp->execute();

        return $deadmantemp;        
    }
    
    // ----------------------------------------------------------------------------------
}
?>