<?php

class mobile_credential extends controller
{    
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

   public function index()
    {
	    $vars = array();
        $this->display($vars);
    }

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM CREDENTIAL");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list = $this->conn->prepare("SELECT
                                        IFNULL(Enable,0) Enable, 
                                        IFNULL(InviteName,'') InviteName,
                                        IFNULL(DeviceNo,0) DeviceNo,
                                        IFNULL(StartTime,0) StartTime,
                                        IFNULL(CheckTime,0) CheckTime FROM CREDENTIAL");
            $list->execute();
            $list = $list->fetchAll(PDO::FETCH_ASSOC);

            foreach( $list as $key=>$val )
            {
                $val['EnabledStr']    = $this->arr_plug[$val['Enable']];
 
                if($val['StartTime'] != 0)
                {
                    $val['StartTime'] = date("Y-m-d H:i:s",$val['StartTime']);
                    if($val['CheckTime'] != 0)
                    {
                        $check = time()-$val['CheckTime'];
                        $val['Status'] = ($check < 120)?"OK":"FAIL";
                        $val['CheckTime'] = date("Y-m-d H:i:s",$val['CheckTime']);
                    }
                    else
                    {
                        $val['CheckTime'] = 'Checking...';
                        $val['Status'] = 'Checking...';
                    }                    
                }
                else
                {
                    $val['StartTime'] = '-';
                    $val['CheckTime'] = '-';
                    $val['Status'] = '-';
                }

                $list[$key] = $val;
            }
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }


   public function update()
    {
        $Enable    = $this->input->post('Enable', 0);
        $InviteName   = $this->input->post('InviteName', '');        

        $sth    = $this->conn->prepare("UPDATE Credential SET Enable=?,InviteName=?,StartTime='0',CheckTime='0'");
        $values = array($Enable,$InviteName);
        if( $sth->executeSilent($values))
        {
            exec(SPIDER_COMM." credentialkill ");
            $this->log->set_log();		 // <----- EventLog를 기록하기 위해 추가
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->js("location.href='/?c=mobile_credential';");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }   
    }
}
