<?php


class network extends controller
{

    var $arr_ip_type    = array('0'=>'DHCP', '1'=>'Static');
    var $arr_d_server   = array('1'=>'dyndns.org');
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

    // ----------------------------------------------------------------------------------

   public function index()
    {
		if( $this->input->get('wizard') == '1' )	$this->display($vars, '', 'none');
		else								$this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Network");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Network ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Network WHERE $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Network WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['ip_type_str']     = $this->arr_ip_type[$val['ip_type']];
            $val['ddns_str']        = $this->arr_plug[$val['ddns']];
            $val['d_server_str']    = $this->arr_d_server[$val['d_server']];
            $val['f_enable_str']    = $this->arr_plug[$val['f_enable']];
            $val['f_passive_str']   = $this->arr_plug[$val['f_passive']];
            $val['s_enable_str']    = $this->arr_plug[$val['s_enable']];
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function update1()
    {
        $No         = $this->input->post('No');
        $ip_type    = $this->input->post('ip_type', '0');
        $ip_add     = $this->input->post('ip_add');
        $subnet     = $this->input->post('subnet');
        $gateway    = $this->input->post('gateway');
        $dns1       = $this->input->post('dns1');
        $dns2       = $this->input->post('dns2');
        $h_port     = $this->input->post('h_port', '80');

        if( $ip_type == '1' )
        {
            if( empty($ip_add) )        $this->util->alert( $this->lang->network->error_ip_add_required, TRUE );
            if( empty($subnet) )        $this->util->alert( $this->lang->network->error_subnet_required, TRUE );
            if( empty($gateway) )       $this->util->alert( $this->lang->network->error_gateway_required, TRUE );

            $sth    = $this->conn->prepare("UPDATE Network SET ip_type=?,ip_add=?,subnet=?,gateway=?,dns1=?,dns2=?,h_port=? WHERE No=?");
            $values = array($ip_type,$ip_add,$subnet,$gateway,$dns1,$dns2,$h_port,$No);
        }
        else
        {
            $sth    = $this->conn->prepare("UPDATE Network SET ip_type=? WHERE No=?");
            $values = array($ip_type,$No);
        }

        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
        
        exec("/spider/bin/cp -a /tmp/SpiderDB/* /spider/database/.");
    }

    // ----------------------------------------------------------------------------------

   public function update2()
    {
        $No         = $this->input->post('No');
        $ddns       = $this->input->post('ddns', '0');
        $d_server   = $this->input->post('d_server', '0');
        $d_host     = $this->input->post('d_host');
        $d_id       = $this->input->post('d_id');
        $d_pass     = $this->input->post('d_pass');

        if( $ddns == '1' )
        {
            $sth    = $this->conn->prepare("UPDATE Network SET ddns=?,d_server=?,d_host=?,d_id=?,d_pass=? WHERE No=?");
            $values = array($ddns,$d_server,$d_host,$d_id,$d_pass,$No);
        }
        else
        {
            $sth    = $this->conn->prepare("UPDATE Network SET ddns=? WHERE No=?");
            $values = array($ddns,$No);
        }

        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update3()
    {
        $No         = $this->input->post('No');
        $f_enable   = $this->input->post('f_enable', '0');
        $f_add      = $this->input->post('f_add');
        $f_port     = $this->input->post('f_port', '21');
        $f_id       = $this->input->post('f_id');
        $f_pass     = $this->input->post('f_pass');
        $f_passive  = $this->input->post('f_passive', '0');
        $f_dir      = $this->input->post('f_dir');

        if( $f_enable == '1' )
        {
            $sth    = $this->conn->prepare("UPDATE Network SET f_enable=?,f_add=?,f_port=?,f_id=?,f_pass=?,f_passive=?,f_dir=? WHERE No=?");
            $values = array($f_enable,$f_add,$f_port,$f_id,$f_pass,$f_passive,$f_dir,$No);
        }
        else
        {
            $sth    = $this->conn->prepare("UPDATE Network SET f_enable=? WHERE No=?");
            $values = array($f_enable,$No);
        }

        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update4()
    {
        $No         = $this->input->post('No');
        $s_enable   = $this->input->post('s_enable', '0');
        $s_server   = $this->input->post('s_server');
        $s_id       = $this->input->post('s_id');
        $s_pass     = $this->input->post('s_pass');
        $s_send     = $this->input->post('s_send');

        if( $s_enable == '1' )
        {
            $sth    = $this->conn->prepare("UPDATE Network SET s_enable=?,s_server=?,s_id=?,s_pass=?,s_send=? WHERE No=?");
            $values = array($s_enable,$s_server,$s_id,$s_pass,$s_send,$No);
        }
        else
        {
            $sth    = $this->conn->prepare("UPDATE Network SET s_enable=? WHERE No=?");
            $values = array($s_enable,$No);
        }

        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update5()
    {
        $No         = $this->input->post('No');
        $send_to    = $this->input->post('send_to');

        $sth    = $this->conn->prepare("UPDATE Network SET send_to=? WHERE No=?");

        $values = array($send_to,$No);
        if( $sth->execute($values) )
        {
            $this->log->set_log(NULL, 'update');
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

}


?>