<?php
/***********************************************************************************
 * FILE NAME : nvr_channel.php                                   DESIGN REF : FMCM00
 * 
 * AUTHOR  : CHEOLJOO MOON
 * DATE    : 2019.06.25 (KR, UTC+9)
 * CHANGES :
 *     REF NO  VERSION     DATE        WHO        DETAIL 
 *        1    0.0.1       2019.06.25  CJMOON     Init 
 * 
 * FILE Encoding : UTF-8
 * 
 * DESCRIPTION : NVR Channel Setting Controller.
 *  
 ***********************************************************************************/
class nvr_channel extends controller
{
    /* ================================================================== */    
    /* 기본 select() 호출 */
   public function index() {
        
        $vars['DoorList'] = $this->getDoorList();
        
        $this->display($vars);
    }

    /* ================================================================== */    
    /* 기본 View */    
   public function select() {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM DVRChannel");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT a.*, b.name nvrName FROM DVRchannel a, DVR b WHERE a.DvrNo = b.no ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array( $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
	        if($field == 'channelName'){
		        
		        $field = 'Name';
		        
		        $count  = $this->conn->prepare("SELECT COUNT(*) FROM DVRChannel WHERE Name LIKE ?");
	            $count->execute(array($this->util->parse_search_string($word)));
	            $count  = $count->fetchColumn();
	
	            $page_config['current_page']    = $page;
	            $page_config['total_row']       = $count;
	            $pagination->init($page_config);
	            
	            $field = 'a.Name';
	
	            $list   = $this->conn->prepare("SELECT a.*, b.name nvrName FROM DVRchannel a, DVR b WHERE a.DvrNo = b.no and $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
	            $list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
	            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
            }else{
		        $count  = $this->conn->prepare("SELECT COUNT(*) FROM DVRChannel");
	            $count->execute();
	            $count  = $count->fetchColumn();
	
	            $page_config['current_page']    = $page;
	            $page_config['total_row']       = $count;
	            $pagination->init($page_config);
	            
	            $field = 'b.Name';
	
	            $list   = $this->conn->prepare("SELECT a.*, b.name nvrName FROM DVRchannel a, DVR b WHERE a.DvrNo = b.no and $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
	            $list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
	            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
            }
	            
        }

        $DoorList = $this->getDoorList();

        foreach( $list as $key=>$val )
        {        
            $val['EventArr'] = str_split($val['Events']);
            $val['Name2'] = $val['Name'];
            
            //if($val['Type'] == '1') $val['Mean'] = ($val['DoorNo']===null?'':$DoorList[$val['DoorNo']]);
            //else $val['Mean'] = ($val['DoorNo']===null?'':$DoorList[$val['DoorNo']]);
            if($val['DoorNo']===null || $val['DoorNo']===""){
	            $val['Mean'] = "";
            }else{
	            $val['Mean'] = $DoorList[$val['DoorNo']];
            }
	            
            $list[$key] = $val;
        }

        $result['field']    = $field;
        $result['word']     = $word;
        $result['page']     = $page;
        $result['view']     = $view;
        $result['pages']    = $pagination->get_pages();
        $result['count']    = $count;
        $result['list']     = $list;

        echo json_encode($result);
    }

    /* ================================================================== */    
    /* Data Insert */    
   public function insert() {

    }

    /* ================================================================== */    
    /* Data Update */        
   public function update() {
        $No	      = $this->input->post('No');
        $Name	  = $this->input->post('Name',"");
        $Type     = $this->input->post('Type');
		$Mean	  = strip_tags($this->input->post('Mean'));
        $Mean     = str_replace("'", "", $Mean);

        $Door     = $this->input->post('Door');
        $Events   = $this->input->post('Select_Events',array());
        $EventList = array_fill( 0, 13, "0" );
        foreach ($Events as $key => $value) {
            $EventList[$value] = '1';
        }

        $Enable   = $this->input->post('Enable');
		$Url	  = $this->input->post('Url');
		$id       = $this->input->post('ID');
		$Password = $this->input->post('Password');
        $tcpFlg	  = $this->input->post('TCP');
        $Duration = $this->input->post('Duration');
        $CameraID = $this->input->post('CameraID');

        if($Type === '1') { // Thumb Drive NVR
            $DBcontext = $this->conn->prepare("UPDATE DVRChannel Set Name=?, Events=?, Enable=?, Url=?, Id=?, Password=?, TCP=?, Duration=? WHERE No=?");
            $values = array($Name, implode('', $EventList), $Enable, $Url, $id, $Password, $tcpFlg, $Duration, $No);
        } else if($Type === '4') { // DW Spectrum
            $DBcontext = $this->conn->prepare("UPDATE DVRChannel Set Name=?, DoorNo=?, Events=?, CameraID=? WHERE No=?");
            $values = array($Name, $Door, implode('', $EventList), $CameraID, $No);
        } else {
            $DBcontext = $this->conn->prepare("UPDATE DVRChannel Set Name=?, DoorNo=?, Events=?  WHERE No=?");
            $values = array($Name, $Door, implode('', $EventList), $No);
        }

        if( $DBcontext->execute($values) ) 
        {
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'", init_view);');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }

    }

    /* ================================================================== */    
    /* Data Delete */        
   public function Delete() {
        
    }

    private function getDoorList() {
        $arr	= array();

        $DoorList   = $this->conn->prepare("SELECT No, Name FROM Door WHERE Disable='0' ");
        $DoorList->execute();

        $DoorList = $DoorList->fetchAll(PDO::FETCH_ASSOC);
        
        foreach( $DoorList as $key=>$val) {
            $arr[$val['No']] = $val['Name'];
        }

        return $arr;
    }

}

?>