<?php 
class nvr_search extends controller
{
   public function index()
	{
		$logNo		= $this->input->get('logNo');
		$channelNo	= $this->input->get('channelNo');

		$vars	= array();

//		$log	= $this->conn_log->prepare("SELECT * FROM Log WHERE No=?");
		$log	= $this->conn_log->prepare("SELECT strftime('%s',datetime(Date, 'unixepoch','localtime')) AS Date FROM Log WHERE No=?");
		$log->execute( array($logNo) );
        
		if(($log = $log->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_log );
			$this->util->js( 'top.close();' );
			exit;
		}

		$search_date = $log['Date'] - 10;

		$channel	= $this->conn->prepare("SELECT * FROM DVRChannel WHERE No=?");
		$channel->execute( array($channelNo) );
        
		if(($channel = $channel->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_channel );
			$this->util->js( 'top.close();' );
			exit;
		}

		$nvr	= $this->conn->prepare("SELECT * FROM DVR WHERE No=?");            
		$nvr->execute( array($channel['DvrNo']) );
            
		if(($nvr = $nvr->fetch(PDO::FETCH_ASSOC)) == false) {
				$this->util->alert( $this->dvr->error_unknown_nvr );
				$this->util->js( 'top.close();' );
				exit;
		}

		$vars['search_date']	= $search_date;
		$vars['log']			= $log;
		$vars['channel']		= $channel;
		$vars['nvr']			= $nvr;
		$vars['mode']           = 'PlayBack';

		/*
		if($nvr['Type'] == '2'){
			$this->display($vars, 'nvr_search_tvt', FALSE);
		}else{
			$this->display($vars, '', FALSE);
		}
		*/

		$this->display($vars, '', FALSE);

	}

   public function DoorToLiveChannel()
	{
		$doorNo	= $this->input->get('doorNo');
		
		$nvr	= $this->conn->prepare("SELECT * FROM dvr WHERE No = (SELECT dvrno FROM dvrchannel WHERE doorno=?)");
		$nvr->execute( array($doorNo) );

		if(($nvr = $nvr->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_nvr );
			$this->util->js( 'top.close();' );
			exit;
		}

		$channel	= $this->conn->prepare("SELECT * FROM DVRChannel WHERE DoorNo=? and DvrNo=?");
		$channel->execute( array($doorNo, $nvr['No']) );
        
		if(($channel = $channel->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_channel );
			$this->util->js( 'top.close();' );
			exit;
		}

		$vars['nvr']			= $nvr;
		$vars['channel']		= $channel;
		$vars['mode']           = 'Live';

		/*
		if($nvr['Type'] == '2'){
			$this->display($vars, 'nvr_search_tvt', FALSE);
		}else{
			$this->display($vars, '', FALSE);
		}
		*/

		$this->display($vars, '', FALSE);
	}

   public function ChannelToAutoPopup() {
		$channelNo	= $this->input->get('channelNo');

		$nvr	= $this->conn->prepare("SELECT * FROM dvr WHERE No = (SELECT dvrno FROM dvrchannel WHERE No=?)");
		$nvr->execute( array($channelNo) );

		if(($nvr = $nvr->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_nvr );
			$this->util->js( 'top.close();' );
			exit;
		}

		$channel	= $this->conn->prepare("SELECT * FROM DVRChannel WHERE No=?");
		$channel->execute( array($channelNo) );
        
		if(($channel = $channel->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_channel );
			$this->util->js( 'top.close();' );
			exit;
		}

		$vars['nvr']			= $nvr;
		$vars['channel']		= $channel;
		$vars['mode']           = 'Live';

		/*
		if($nvr['Type'] == '2'){
			$this->display($vars, 'nvr_search_tvt', FALSE);
		}else{
			$this->display($vars, '', FALSE);
		}
		*/

		$this->display($vars, '', FALSE);
	}

}