<?php 


class nvr_search extends controller
{
   public function index()
	{
		$logNo		= $this->input->get('logNo');
		$channelNo	= $this->input->get('channelNo');

		$vars	= array();

//		$log	= $this->conn_log->prepare("SELECT * FROM Log WHERE No=?");
		$log	= $this->conn_log->prepare("SELECT strftime('%s',datetime(Date, 'unixepoch','localtime')) AS Date FROM Log WHERE No=?");
		$log->execute( array($logNo) );
        
		if(($log = $log->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_log );
			$this->util->js( 'top.close();' );
			exit;
		}

		$search_date = $log['Date'] - 10;

		$channel	= $this->conn->prepare("SELECT * FROM DVRChannel WHERE No=?");
		$channel->execute( array($channelNo) );
        
		if(($channel = $channel->fetch(PDO::FETCH_ASSOC)) == false) {
			$this->util->alert( $this->dvr->error_unknown_channel );
			$this->util->js( 'top.close();' );
			exit;
		}

		if($channel['Type'] == '1') {            
			$dvr	= $this->conn->prepare("SELECT * FROM DVR WHERE No=?");
			$dvr->execute( array($channel['DvrNo']) );
			if(($dvr = $dvr->fetch(PDO::FETCH_ASSOC)) == false) {
				$this->util->alert( $this->dvr->error_unknown_dvr );
				$this->util->js( 'top.close();' );
				exit;
			}

			$vars['search_date']	= $search_date;
			$vars['log']			= $log;
			$vars['channel']		= $channel;
			$vars['dvr']			= $dvr;

			$this->display($vars, '', FALSE);
		} 
        else if($channel['Type'] == '2') 
        {
			$nvr	= $this->conn->prepare("SELECT * FROM DVR WHERE No=?");            
			$nvr->execute( array($channel['DvrNo']) );
            
			if(($nvr = $nvr->fetch(PDO::FETCH_ASSOC)) == false) {
				$this->util->alert( $this->dvr->error_unknown_nvr );
				$this->util->js( 'top.close();' );
				exit;
			}

			$nvr['auth']  = base64_encode($nvr['HttpID'].'&'.$nvr['HttpPassword']);

			$vars['search_date']	= $search_date;
			$vars['log']			= $log;
			$vars['channel']		= $channel;
			$vars['nvr']			= $nvr;

			$this->display($vars, '', FALSE);
		} else {
			$this->util->alert( $this->dvr->error_unknown_camera );
			$this->util->js( 'top.close();' );
		}
	}

}


