<?php
include APP_DIR.'/libraries/Reverse.php';

class nvr_setup extends controller
{    
    // ----------------------------------------------------------------------------------
   public function __construct() {
		parent::__construct();
/*
		if(!$this->is_option(ConstTable::OPTION_NVR)) {
            $this->util->alert($this->lang->menu->error_not_permission);
            $this->util->back();
            exit;
		}
*/
	}

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $vars['ClientList']    = $this->selectClientList();        
        $this->display($vars);
    }


    // ----------------------------------------------------------------------------------
   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM DVR WHERE Site=? AND ViewerType=2");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM DVR WHERE Site=? AND ViewerType=2 ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM DVR WHERE Site=? AND ViewerType=2 AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM DVR WHERE Site=? AND ViewerType=2 AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $clientList = $this->selectClientList();

        foreach( $list as $key=>$val )
        {        
            $val['TypeStr'] = EnumTable::$attrNvrType[$val['Type']];
            
            if($val['HostNo']){
	            $val['ClientStr'] = $clientList[$val['HostNo']];
            }else{
	            $val['ClientStr'] = '';
            }
            
            $val['HttpPassword']='';
            $list[$key] = $val;
        }
        
        $result['field']    = $field;
        $result['word']     = $word;
        $result['page']     = $page;
        $result['view']     = $view;
        $result['pages']    = $pagination->get_pages();
        $result['count']    = $count;
        $result['list']     = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function insert()
    {
        $No = $this->conn->prepare("SELECT ifnull(MAX(No),0) No FROM DVR WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No = $No->fetchColumn() + 1;
        
        $Name	        = strip_tags(trim($this->input->post('Name')));
        $Name           = str_replace("'", "", $Name);
		$Mean	        = strip_tags($this->input->post('Mean'));
        $Mean           = str_replace("'", "", $Mean);
        $Type           = $this->input->post('Type');
        $HostNo         = $this->input->post('HostNo');
		$IP		        = $this->input->post('IP');
		$LivePort       = $this->input->post('LivePort');
		$HttpID	        = $this->input->post('HttpID');
		$HttpPassword   = $this->input->post('HttpPassword');
		$MaxChannel	    = $this->input->post('MaxChannel');
        $DeliverRecord  = $this->input->post('DeliverRecord');

        if( empty($Name) )      		$this->util->alert( $this->lang->holiday->error_name_required, TRUE );
        if( empty($IP) )      			$this->util->alert( $this->lang->addmsg->nvr_ip_required, TRUE );
        if( empty($LivePort) )      	$this->util->alert( $this->lang->addmsg->nvr_live_port_required, TRUE );
        if( empty($HttpID) )      		$this->util->alert( $this->lang->addmsg->nvr_http_id_required, TRUE );
        if( empty($HttpPassword) )      $this->util->alert( $this->lang->addmsg->nvr_http_password_required, TRUE );

        if($Type === '1') // Thumb NVR
        {
            if( empty($HostNo) )        $this->util->alert( $this->lang->addmsg->nvr_host_no_required, TRUE );
            $MaxChannel = $this->getClientDoorPort($HostNo);
        }
        else
        {
            if( empty($MaxChannel) )    $this->util->alert( $this->lang->addmsg->nvr_max_channel_required, TRUE );
            if($MaxChannel > 32)        $this->util->alert( $this->lang->addmsg->nvr_max_channel_over, TRUE );
        }

         if($Type === '1') // Thumb NVR
        {
            if(empty($DeliverRecord)) $DeliverRecord="9001";
            $EncPass = hash('sha256', $HttpPassword, false);
        }
        else if($Type === '2' || $Type === '5') // 2:Speco NVR, 5:Transcendent NVR
        {
            exec(SPIDER_COMM." checkspeconvr ".$HttpID." ".$HttpPassword." ".$IP, $output);

            foreach( $output as $key=>$line )
            {
                $line = trim($line);
    
                if ($line == '0')
                {
                    $this->util->alert($this->lang->common->error_insert_nvr);
                    exit;
                }
                else if($line == '1')
                {
                    $EncPass = $HttpPassword;
                }
                else if($line == '2')
                {
                    $EncPass = strtoupper(md5($HttpPassword));
                }
            }
        }
        else
        {
            $EncPass = $HttpPassword;
        }

        $sth = $this->conn->prepare("INSERT INTO DVR (Site,No,Name,Mean,IP,LivePort,DeliverRecord,HttpID,HttpPassword,ViewerType,MaxChannel,Type,HostNo) VALUES (?,?,?,?,?,?,?,?,?,'2',?,?,?)");
        $values = array($_SESSION['spider_site'], $No, $Name, $Mean, $IP, $LivePort, $DeliverRecord, $HttpID, $EncPass, $MaxChannel, $Type, $HostNo);
        if( $sth->execute($values) )
        {
            $ChannelNo = $this->conn->prepare("SELECT ifnull(MAX(No),0) No FROM DVRChannel");
            $ChannelNo->execute();
            $ChannelNo = $ChannelNo->fetchColumn() + 1;
            for($Channel = 1; $Channel <= $MaxChannel; $Channel++)
            {
                $ChannelName = "Channel ".$ChannelNo;
                if($Type === '1') // Thumb NVR
                    $DoorNo = $this->getDoorNo($HostNo, $Channel);
                else
                    $DoorNo = 0;
                $sth = $this->conn->prepare("INSERT INTO DVRChannel (No, Name, DvrNo, Channel, Type, DoorNo) VALUES (?,?,?,?,?,?)");
                $sth->execute(array($ChannelNo, $ChannelName, $No, $Channel, $Type, $DoorNo)); 
                $ChannelNo++;
            }

            $this->log->set_log_message($Name);
            $this->util->js('load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No	            = $this->input->post('No');
        $Name	        = strip_tags(trim($this->input->post('Name')));
        $Name           = str_replace("'", "", $Name);
		$Mean	        = strip_tags($this->input->post('Mean'));
        $Mean           = str_replace("'", "", $Mean);
        $Type           = $this->input->post('Type');
        $HostNo         = $this->input->post('HostNo');
		$IP		        = $this->input->post('IP');
		$LivePort       = $this->input->post('LivePort');
		$HttpID	        = $this->input->post('HttpID');
		$HttpPassword   = $this->input->post('HttpPassword');
		$MaxChannel	    = $this->input->post('MaxChannel');
        $DeliverRecord  = $this->input->post('DeliverRecord');
        
        if( empty($Name) )      		$this->util->alert( $this->lang->holiday->error_name_required, TRUE );
        if( empty($IP) )      			$this->util->alert( $this->lang->addmsg->nvr_ip_required, TRUE );
        if( empty($LivePort) )      	$this->util->alert( $this->lang->addmsg->nvr_live_port_required, TRUE );
        if( empty($HttpID) )      		$this->util->alert( $this->lang->addmsg->nvr_http_id_required, TRUE );
        if( empty($HttpPassword) )      $this->util->alert( $this->lang->addmsg->nvr_http_password_required, TRUE );

        if($Type === '1') // Thumb NVR
        {
            if( empty($HostNo) )        $this->util->alert( $this->lang->addmsg->nvr_host_no_required, TRUE );
            $MaxChannel = $this->getClientDoorPort($HostNo);
        }
        else
        {
            if( empty($MaxChannel) )    $this->util->alert( $this->lang->addmsg->nvr_max_channel_required, TRUE );
            if($MaxChannel > 32)        $this->util->alert( $this->lang->addmsg->nvr_max_channel_over, TRUE );
        }

        if($Type === '1') // 1:Thumb NVR
        {
            $MaxChannel = $this->getClientDoorPort($HostNo);
            if(empty($DeliverRecord)) $DeliverRecord="9001";
            $EncPass = hash('sha256', $HttpPassword, false);
        }
        else if($Type === '2' || $Type === '5') // 2:Speco NVR, 5:Transcendent NVR
        {
            exec(SPIDER_COMM." checkspeconvr ".$HttpID." ".$HttpPassword." ".$IP, $output);

            foreach( $output as $key=>$line )
            {
                $line = trim($line);
                if ($line == '2') // new 
                {
                    $EncPass = strtoupper(md5($HttpPassword));
                }
                else
                {
                    $EncPass = $HttpPassword;
                }
            }
        }
        else
        {
            $EncPass = $HttpPassword;
        }

        $sth = $this->conn->prepare("UPDATE DVR SET Name=?, Mean=?, IP=?, LivePort=?, DeliverRecord=?, HttpID=?, HttpPassword=?, MaxChannel=?, Type=?, HostNo=? WHERE Site=? AND No=?");
        $values = array($Name, $Mean, $IP, $LivePort, $DeliverRecord, $HttpID, $EncPass, $MaxChannel, $Type, $HostNo, $_SESSION['spider_site'], $No);
	    if( $sth->execute($values) ) 
        {
            $sth = $this->conn->prepare("DELETE FROM DVRChannel WHERE DvrNo=? AND Channel>?");
            $sth->execute( array($No, $MaxChannel) );
    
            $ChannelNo = $this->conn->prepare("SELECT ifnull(MAX(No),0) No FROM DVRChannel");
            $ChannelNo->execute();
            $ChannelNo = $ChannelNo->fetchColumn() + 1;
            for($Channel = 1; $Channel <= $MaxChannel; $Channel++)
            {
                $ChannelName = "Channel ".$ChannelNo;
                if($Type === '1') // Thumb NVR
                    $DoorNo = $this->getDoorNo($HostNo, $Channel);
                else
                    $DoorNo = 0;

                $Count = $this->conn->prepare("SELECT COUNT(No) FROM DVRChannel WHERE DvrNo=? AND Channel=?");
                $Count->execute(array($No, $Channel));
                $Count = $Count->fetchColumn();
                if ($Count == 0) 
                {
                    $sth = $this->conn->prepare("INSERT INTO DVRChannel (No, Name, DvrNo, Channel, Type, DoorNo) VALUES (?,?,?,?,?,?)");
                    $sth->execute(array($ChannelNo, $ChannelName, $No, $Channel, $Type, $DoorNo)); 
                    $ChannelNo++;
                }
                else
                {
                    $sth = $this->conn->prepare("UPDATE DVRChannel SET Type=?, DoorNo=? WHERE DvrNo=? AND Channel=?");
                    $sth->execute(array($Type, $DoorNo, $No, $Channel)); 
                }
            }
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------
   public function delete()
    {
        $No        = $this->input->get('No');
        $Name      = $this->util->GetRecordName('DVR', $No);

        $sth       = $this->conn->prepare("DELETE FROM DVR WHERE Site=? AND No=?");
        if( $sth->execute(array($_SESSION['spider_site'], $No)) )
        {
			$sth       = $this->conn->prepare("DELETE FROM DVRChannel WHERE DvrNo=?");
			$sth->execute(array($No));

			$this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    /** ================================================================================
     *  All Client List 
     */
   public function selectClientList() {
        $arr	= array();

        $HostList   = $this->conn->prepare("SELECT No, Name FROM Host WHERE PortCount > 0 and Confirm = 1 ORDER BY No DESC");
        $HostList->execute();

        $HostList = $HostList->fetchAll(PDO::FETCH_ASSOC);
        
        foreach( $HostList as $key=>$val) {
            if($val['No'] === '1') $val['Name'] = "Server";
            $arr[$val['No']] = $val['Name'];
        }

        $arr['0'] = "";
        
        ksort($arr);

        return $arr;
    }

    private function getClientDoorPort($ClientNo) {
        $count  = $this->conn->prepare("SELECT PortCount FROM Host WHERE No=?");
        $count->execute(array($ClientNo));
        $count  = $count->fetchColumn();

        return $count;
    }

    private function getDoorNo($HostNo, $Port) {
        $DoorNo = $this->conn->prepare("SELECT No FROM Door WHERE HostNo=? AND Port=?");
        $DoorNo->execute(array($HostNo, $Port));
        $DoorNo = $DoorNo->fetchColumn();

        return $DoorNo;
    }
}


?>