<?php
class nvr_viewer extends controller
{
	// ----------------------------------------------------------------------------------
   public function __construct()
	{
		parent::__construct();
		
		if (!$this->is_option(ConstTable::OPTION_NVR) &&
			!$this->is_option(ConstTable::OPTION_SPECO_NVR) &&
			!$this->is_option(ConstTable::OPTION_CBC_NVR) &&
			!$this->is_option(ConstTable::OPTION_DW_SPECTRUM) &&
			!$this->is_option(ConstTable::OPTION_TRANSCENDENT_NVR)) {
            $this->util->alert($this->lang->menu->error_not_permission);
            $this->util->back();
            exit;
		}
	}

	// ----------------------------------------------------------------------------------
   public function index()
	{
        	$vars['nvrs'] = $this->to_array_nvr();
		$vars['nvrList'] = $this->to_select_nvr();

		if( $_SESSION['spider_type'] == 'spider' ) {
			$view = $this->conn->prepare("SELECT * FROM DVR WHERE Site=? AND ViewerType=2 ORDER BY No ASC");
			$view->execute(array($_SESSION['spider_site']));
		} else {
			$view = $this->conn->prepare("SELECT Dvr.* FROM Dvr JOIN UserRoleDvr ON UserRoleDvr.DvrNo=Dvr.No WHERE Dvr.Site=? AND Dvr.ViewerType=2 AND UserRoleDvr.UserRole=? ORDER BY Dvr.No DESC");
			$view->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole']));
		}

		$view	= $view->fetchAll(PDO::FETCH_ASSOC);

		if(isset($_GET['nvr'])) {
           	$viewNo = $_GET['nvr'];
       	}
       	else
       	{
           	$viewNo = $view[0]['No'];   
       	}
		// print_r($viewNo);exit;
		$channel = $this->conn->prepare("SELECT No, Name FROM DVRChannel WHERE DvrNo=?");
		$channel->execute(array($viewNo));
		$channel	= $channel->fetchAll(PDO::FETCH_ASSOC);
		// print_r($channel);exit;
		if(count($view) > 0 && count($channel) > 0)
          {
	        	$channelnos = array();
               $i = 0;
               foreach($channel as $key=>$val) {

                    $channelnos[] = array($val['Name'], $val['No']);
                    $command = "spider-command admin livestream ".$val['No']." 2";
                    // echo $command;exit();
                    exec($command, $output, $result);
                    sleep(1);
                    $i++;
               }
               // print_r($channelnos);exit();
               $str = '';
               for($j = 0; $j < (16 - count($output)); $j++) {
                    $str .= '<td><div style="padding-top: 56.25% !important;"></div></td>';
               }
       	}
       	else
       	{
           	$output     = [];
           	$channelnos = [];
           	$str = '';
           	for($j = 0; $j < (16 - 0); $j++) {
               	$str .= '<td><div style="padding-top: 56.25% !important;"></div></td>';
           	}
       	}

		$vars['channel']    = $channel;
		$vars['view']       = $view;
		$vars['output']     = $output;
		$vars['emptyVid']   = $str;
		$vars['channelnos'] = $channelnos;
		$vars['viewNo']     = $viewNo;
		$this->display($vars);
	}

   public function select() {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
		$pagination     = new Pagination();
				
		if( $_SESSION['spider_type'] == 'spider' ) {
			$list = $this->conn->prepare("SELECT * FROM DVR WHERE Site=? AND ViewerType=2 ORDER BY No ASC");
			$list->execute(array($_SESSION['spider_site']));
		} else {
			$list = $this->conn->prepare("SELECT Dvr.* FROM Dvr JOIN UserRoleDvr ON UserRoleDvr.DvrNo=Dvr.No WHERE Dvr.Site=? AND Dvr.ViewerType=2 AND UserRoleDvr.UserRole=? ORDER BY Dvr.No DESC");
			$list->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole']));
		}

		$list	= $list->fetchAll(PDO::FETCH_ASSOC);

        foreach($list as $key=>$val)
        {
			if ($val['Type'] == 4) // DW Spectrum
			{
                $val['CameraIds'] = $this->to_array_cameraid($val['No']);
                $list[$key] = $val;
			}
        }

		$result['field']    = $field;
        $result['word']     = $word;
        $result['page']     = $page;
        $result['view']     = $view;
        $result['pages']    = $pagination->get_pages();
        $result['count']    = count($list);
        $result['list']     = $list;

        echo json_encode($result);
	}

	// ----------------------------------------------------------------------------------
   public function to_array_nvr()
	{       
        if( $_SESSION['spider_type'] == 'spider' ) {
			$list = $this->conn->prepare("SELECT * FROM DVR WHERE Site=? AND ViewerType=2 ORDER BY No ASC");
			$list->execute(array($_SESSION['spider_site']));
		} else {
			$list = $this->conn->prepare("SELECT Dvr.* FROM Dvr JOIN UserRoleDvr ON UserRoleDvr.DvrNo=Dvr.No WHERE Dvr.Site=? AND Dvr.ViewerType=2 AND UserRoleDvr.UserRole=? ORDER BY Dvr.No DESC");
			$list->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole']));
		}

		$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		/*
		foreach( $list as $key=>$val )
        {
			//$list[$key]['auth']  = base64_encode($val['HttpID'].'&'.$val['HttpPassword']);
        }

		$list	= json_encode($list);
		*/
		return $list; 
	}

	// ----------------------------------------------------------------------------------
    public function to_select_nvr()
	{
		$arr	= array();
		$list = $this->conn->prepare("SELECT No, Name FROM DVR WHERE Site=? AND ViewerType=2 ORDER BY NO ASC");
		$list->execute(array($_SESSION['spider_site']));
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		foreach( $list as $key=>$val) {
            $arr[$val['No']] = $val['Name'];
        }
		return $arr;				
	}

    public function to_array_cameraid($No)
	{
		$arr	= array();
		$list = $this->conn->prepare("SELECT Channel, CameraID FROM DVRChannel WHERE DvrNo=?");
		$list->execute(array($No));
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		
		foreach( $list as $key=>$val) {
            $arr[$val['Channel']] = $val['CameraID'];
        }

		return $arr;				
	}

}