<?php

class openapi extends controller
{
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

   public function index()
    {        
	    $vars = array();
        $this->display($vars);
    }

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM OPENAPI");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);


            $list   = $this->conn->prepare("SELECT IFNULL(Port,'0') Port, IFNULL(ClientIP,'') ClientIP" .
                                           ", IFNULL(HashKey,'') HashKey" .
                                           ", IFNULL(AuthKey,'') AuthKey , IFNULL(AuthKeyUse,'') AuthKeyUse" .
                                           ", IFNULL(Enabled,0) Enabled FROM OPENAPI");
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);

            foreach( $list as $key=>$val )
            {
                $val['AuthKeyUseStr']    = EnumTable::$attrOpenAPIAuthType[$val['AuthKeyUse']];
                $val['EnabledStr']    = $this->arr_plug[$val['Enabled']];
                $list[$key] = $val;
            }
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

   public function keygen() {

        $HashKey    = $this->input->post('HashKey', '');
        $authKey = hash_hmac("sha256", time(), $HashKey);
        echo json_encode(array("datagen"=>$authKey));
   }

   public function update()
    {
        $Port       = $this->input->post('Port', 0);        
        $ClientIP   = $this->input->post('ClientIP', '');
        $HashKey    = $this->input->post('HashKey', '');        
        $CurAuthKey = $this->input->post('Authkey', '');
        $AuthKeyUse = $this->input->post('AuthKeyUse', 0);
        $Enabled    = $this->input->post('Enabled', 0);
            
        if($Enabled == 1)
        {
            if($Port==0) 
            { 
                $this->util->alert( $this->lang->common->error_Port_required );
                $this->util->js('parent.parent.hide_loading();');
                exit;                
            }

            if($AuthKeyUse==1)
            { 
                if(empty($ClientIP)) 
                { 
                    $this->util->alert( $this->lang->common->error_clientip_required );
                    $this->util->js('parent.parent.hide_loading();');
                    exit;                
                }

                if(empty($HashKey)) 
                { 
                    $this->util->alert( $this->lang->common->error_hashkey_required );
                    $this->util->js('parent.parent.hide_loading();');
                    exit;                
                }
            } 
            if($AuthKeyUse==2) 
            {
                if(empty($HashKey)) 
                { 
                    $this->util->alert( $this->lang->common->error_hashkey_required );
                    $this->util->js('parent.parent.hide_loading();');
                    exit;                
                }                
            }
        }
        
        if($Enabled == 1)
        {
            if($AuthKeyUse == 1) 
            {
                $authKey = hash_hmac("sha256", $ClientIP, $HashKey);
                $sth = $this->conn->prepare("UPDATE OPENAPI SET Enabled=?, Port=?, ClientIP=?, HashKey=?, AuthKey=?, AuthKeyUse=?");
                $values = array($Enabled,$Port,$ClientIP, $HashKey, $authKey, $AuthKeyUse);
            }
            else if($AuthKeyUse == 2) 
            {
                if(empty($CurAuthKey)) $CurAuthKey = hash_hmac("sha256", time(), $HashKey);

                $sth = $this->conn->prepare("UPDATE OPENAPI SET Enabled=?, Port=?, ClientIP='', HashKey=?, AuthKey=?, AuthKeyUse=?");
                $values = array($Enabled,$Port,$HashKey, $CurAuthKey, $AuthKeyUse);
            }            
            else 
            {                
                $sth = $this->conn->prepare("UPDATE OPENAPI SET Enabled=?, Port=?, AuthKey='', ClientIP='', HashKey='' ,AuthKeyUse=?");
                $values = array($Enabled, $Port, $AuthKeyUse);
            }
        }
        else
        {
            $sth    = $this->conn->prepare("UPDATE OPENAPI SET Enabled=?");
            $values = array($Enabled);
        }

        if( $sth->executeSilent($values))
        {
            $this->log->set_log();
            exec(SPIDER_COMM." webrestart ");
            $this->util->redirect('/?c=user&m=logout');            
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }   
    }
}