<?php

class p2p extends controller
{
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

   public function index()
    {
	    $vars = array();
        $this->display($vars);
    }

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM RMC");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list = $this->conn->prepare("SELECT
                                        IFNULL(ServerIP,'') ServerIP,
                                        IFNULL(Port,0) Port,
                                        IFNULL(DevicePort,0) DevicePort,
                                        IFNULL(DeviceID,'') DeviceID,
                                        IFNULL(Enabled,0) Enabled,
                                        IFNULL(StartTime,0) StartTime,
                                        IFNULL(CheckTime,0) CheckTime FROM CLOUD");
            $list->execute();
            $list = $list->fetchAll(PDO::FETCH_ASSOC);

            foreach( $list as $key=>$val )
            {
                if(empty($val['ServerIP']) || strlen($val['ServerIP']) == 0) 
                {
                    $val['ServerIP'] = "link.remote-manager.net";
                    $val['Port'] = "9500";
                    $val['DevicePort'] = "9000";
                }

                $val['EnabledStr']    = $this->arr_plug[$val['Enabled']];

                if($val['StartTime'] != 0)
                {
                    $val['StartTime'] = date("Y-m-d H:i:s",$val['StartTime']);
                    if($val['CheckTime'] != 0)
                    {
                        $check = time()-$val['CheckTime'];
                        $val['Status'] = ($check < 120)?"OK":"FAIL";
                        $val['CheckTime'] = date("Y-m-d H:i:s",$val['CheckTime']);
                     }
                    else
                    {
                        $val['CheckTime'] = 'Checking...';
                        $val['Status'] = 'Checking...';
                    }                    
                }
                else
                {
                    $val['StartTime'] = '-';
                    $val['CheckTime'] = '-';
                    $val['Status'] = '-';
                }

                $list[$key] = $val;
            }
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }


   public function update()
    {
        $ServerIP   = $this->input->post('ServerIP', '');
        $Port       = $this->input->post('Port', 0);
        $DevicePort = $this->input->post('DevicePort', 0);        
        $Enabled    = $this->input->post('Enabled', 0);
        
        if($Enabled == 1)
        {
            if(empty($ServerIP)) 
            { 
                $this->util->alert( $this->lang->common->error_reflectorURI_required );
                $this->util->js('parent.parent.hide_loading();');
                exit;                
            }

            if($Port==0) 
            { 
                $this->util->alert( $this->lang->common->error_Port_required );
                $this->util->js('parent.parent.hide_loading();');
                exit;                
            }

            if($DevicePort==0) 
            { 
                $this->util->alert( $this->lang->common->error_Port_required );
                $this->util->js('parent.parent.hide_loading();');
                exit;                
            }

        }
        
        if($Enabled == 1)
        {
            $sth    = $this->conn->prepare("UPDATE CLOUD SET Enabled=?,ServerIP=?,Port=?,DevicePort=?");
            $values = array($Enabled,$ServerIP,$Port,$DevicePort);
        }
        else
        {
            $sth    = $this->conn->prepare("UPDATE CLOUD SET Enabled=? ,StartTime='0',CheckTime='0'");
            $values = array($Enabled);
        }

        //if( $sth->execute($values))
        if( $sth->executeSilent($values))
        {
            exec(SPIDER_COMM." cloud ");
            $this->log->set_log();		 // <----- EventLog를 기록하기 위해 추가
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->js("location.href='/?c=p2p';");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }   
    }    

}