<?php


class region extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $vars['regions'] = $this->to_array_region();
        $vars['auxinputs'] = $this->to_array_auxinput();
        $vars['deadmanauxout'] = $this->to_array_auxoutput();
        $vars['hazmatauxout'] = $this->to_array_auxoutput();
        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Region WHERE Site=?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Region WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Region WHERE Site=? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Region WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val)
        {
	        if(!empty($val['ChildType'])){
		        $val['ChildTypeStr'] = EnumTable::$attrChildType[$val['ChildType']];
	        }else{
		        $val['ChildTypeStr'] = '';
	        }
            
            $val['DepthStr']        = 'Class '. $val['Depth'];
            $val['ParentName']      = $this->util->GetRecordName('Region', $val['ParentNo']);
            $val['OnlyMusterStr']   = EnumTable::$attrYesNo[$val['OnlyMuster']];
            $val['PassAntiStr']     = EnumTable::$attrViolationTypes[$val['PassAnti']];
            $val['PassAntiTimeStr'] = $val['PassAntiTime'] .' min';
            $val['TailAntiStr']     = EnumTable::$attrViolationTypes[$val['TailAnti']];
            $val['LimitAntiStr']    = EnumTable::$attrViolationTypes[$val['LimitAnti']];
            $val['DeadManEnableStr'] = EnumTable::$attrYesNo[$val['DeadManEnable']];
            $val['DM_AuxOutputName'] = $this->util->GetRecordName('AuxOutput', $val['DeadManAuxOutNo']);
            $val['TimeIntervalStr'] = ($val['TimeInterval'] == 0 ? 5 : $val['TimeInterval']) .' min';
            $val['HazmatEnableStr'] = EnumTable::$attrYesNo[$val['HazmatEnable']];
            $val['AuxInputName']    = $this->util->GetRecordName('AuxInput', $val['AuxInputNo']);
            $val['HM_AuxOutputName'] = $this->util->GetRecordName('AuxOutput', $val['HazmatAuxOutNo']);
            $val['EnableGraceStr']     = EnumTable::$attrYesNo[$val['EnableGrace']];
            $val['DailyResetStr']     = EnumTable::$attrYesNo[$val['DailyReset']];
            $val['TimeOfDayStr'] = EnumTable::$attrTimeList[$val['TimeOfDay']];
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function insert()
    {
        $No = $this->conn->prepare("SELECT MAX(No) FROM Region WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No = $No->fetchColumn() + 1;

        $Name           = strip_tags(trim($this->input->post('Name')));
        $Mean           = strip_tags($this->input->post('Mean'));
        $OnlyMuster     = $this->input->post('OnlyMuster', 0);
        $ParentNo       = $this->input->post('ParentNo');
        $Depth          = $this->input->post('Depth');
        $ChildType      = $this->input->post('ChildType');
        $PassAnti       = $this->input->post('PassAnti', 0);
        $PassAntiTime   = intval($this->input->post('PassAntiTime', 0));
        $TailAnti       = $this->input->post('TailAnti', 0);
        $LimitAnti      = $this->input->post('LimitAnti', 0);
        $LimitCount     = intval($this->input->post('LimitCount', 0));
        $DeadManEnable  = $this->input->post('DeadManEnable', 0);
        $DeadManAuxOutNo     = $this->input->post('DeadManAuxOutNo');
        $TimeInterval   = intval($this->input->post('TimeInterval', 5));
        $HazmatEnable   = $this->input->post('HazmatEnable', 0);
        $AuxInputNo     = $this->input->post('AuxInputNo');
        $HazmatAuxOutNo     = $this->input->post('HazmatAuxOutNo');
        $EnableGrace   = $this->input->post('EnableGrace', 0);
        $DailyReset   = $this->input->post('DailyReset', 0);
        
        if( $Depth != '1' && $ParentNo == "" )
        {
            $this->util->alert( $this->lang->region->error_parentno_invalid, TRUE );
        }
         
        if( $ParentNo != "" )
        {
            $RootParentNo = $this->conn->prepare("SELECT RootParentNo FROM Region WHERE No=?");
            $RootParentNo->execute(array($ParentNo));
            $RootParentNo = $RootParentNo->fetchColumn();
        }
        else
        {
            $RootParentNo = $No;
        }
        
        if( $DailyReset == 0 ) $TimeOfDay  = 0;
        else                   $TimeOfDay  = $this->input->post('TimeOfDay');

        
        if( empty($Name) )      $this->util->alert( $this->lang->menu->error_name_required, TRUE );
        
        if( $this->exists_name(-1) )
		{
			$this->util->alert($this->lang->addmsg->error_exist_name, TRUE);
		}
        
        //    2015.09.22 by Zeno 
        if( $DeadManEnable != 0 &&  $HazmatEnable != 0 )
        {
            if( $DeadManAuxOutNo == $HazmatAuxOutNo )
            {
                 $this->util->alert( $this->lang->region->error_cannot_be_shared, TRUE );
            }
        }
        
        
        
        if( $Depth == '1' )
        {
            $ChildType      = 0;
        }
        
        if( $ChildType == '2' )
        {
            $LimitAnti = 0;
            $LimitCount = 0;
        }
        
        if( $OnlyMuster == '1' ) {
            $PassAnti       = 0;
            $PassAntiTime   = 0;
            $TailAnti       = 0;
            $LimitAnti      = 0;
            $LimitCount     = 0;
            $DeadManEnable  = 0;
            $DeadManAuxOutNo = 0;
            $TimeInterval   = 0;
            $HazmatEnable   = 0;
            $AuxInputNo     = 0;
            $HazmatAuxOutNo = 0;
            $EnableGrace    = 0;
            $DailyReset     = 0;
            $TimeOfDay      = 0;
            $ChildType      = 0;
        } else {
            /*
            2018.11.01 : wtkim bug fix
            버그내용 : 범위 안맞음(Max값보다 작으면 무조건 true)
            수정내용 : min/max 범위 지정
            */
            if(!($PassAntiTime > 0 && $PassAntiTime <= 999 ) && ($PassAnti > 0))    $this->util->alert( $this->lang->region->error_passantitime_invalid, TRUE );
            if(!($TimeInterval >= 5 && $TimeInterval <= 999) && ($DeadManEnable > 0))   $this->util->alert( $this->lang->region->error_timeinterval_invalid, TRUE );
            if( !($LimitCount > 0 && $LimitCount <= 99999)  && ($LimitAnti > 0)) $this->util->alert( $this->lang->region->error_limitcount_invalid, TRUE );
        }

        $sth    = $this->conn->prepare("INSERT INTO Region (Site,No,Name,Mean,OnlyMuster,Depth,ParentNo,PassAnti,PassAntiTime,TailAnti,LimitAnti,LimitCount,DeadManEnable,TimeInterval,HazmatEnable,AuxInputNo,EnableGrace,DailyReset,TimeOfDay, RootParentNo, ChildType, DeadManAuxOutNo, HazmatAuxOutNo) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
        $values = array($_SESSION['spider_site'],$No,$Name,$Mean,$OnlyMuster,$Depth,$ParentNo,$PassAnti,$PassAntiTime,$TailAnti,$LimitAnti,$LimitCount,$DeadManEnable,$TimeInterval,$HazmatEnable,$AuxInputNo, $EnableGrace, $DailyReset, $TimeOfDay, $RootParentNo, $ChildType, $DeadManAuxOutNo, $HazmatAuxOutNo);
        if( $sth->execute($values) )
        {
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No             = $this->input->post('No');
        $Name           = strip_tags(trim($this->input->post('Name')));
        $Mean           = strip_tags($this->input->post('Mean'));
        $OnlyMuster     = $this->input->post('OnlyMuster', 0);
        $Depth          = $this->input->post('Depth');
        $ChildType      = $this->input->post('ChildType');
        $ParentNo       = $this->input->post('ParentNo');
        $PassAnti       = $this->input->post('PassAnti', 0);
        $PassAntiTime   = intval($this->input->post('PassAntiTime', 0));
        $TailAnti       = $this->input->post('TailAnti', 0);
        $LimitAnti      = $this->input->post('LimitAnti', 0);
        $LimitCount     = intval($this->input->post('LimitCount', 0));
        $DeadManEnable  = $this->input->post('DeadManEnable', 0);
        $DeadManAuxOutNo     = $this->input->post('DeadManAuxOutNo');
        $TimeInterval   = intval($this->input->post('TimeInterval', 5));
        $HazmatEnable   = $this->input->post('HazmatEnable', 0);
        $AuxInputNo     = $this->input->post('AuxInputNo');
        $HazmatAuxOutNo     = $this->input->post('HazmatAuxOutNo');
        $EnableGrace    = $this->input->post('EnableGrace', 0);
        $DailyReset    = $this->input->post('DailyReset', 0);
        
        if( $Depth != '1' && $ParentNo == "" )
        {
            $this->util->alert( $this->lang->region->error_parentno_invalid, TRUE );
        }
        
        if( $ParentNo != "" )
        {
            $RootParentNo = $this->conn->prepare("SELECT RootParentNo FROM Region WHERE No=?");
            $RootParentNo->execute(array($ParentNo));
            $RootParentNo = $RootParentNo->fetchColumn();
        }
        else
        {
            $RootParentNo = $No;
        }
        
        if( $DailyReset == 0 ) $TimeOfDay  = 0;
        else                   $TimeOfDay  = $this->input->post('TimeOfDay');
        
        if( $Depth == '1' )
        {
            $ChildType = 0;
        }
        
        if( $ChildType == '2' )
        {
            $LimitAnti = 0;
            $LimitCount = 0;
        }
        
        if( empty($Name) )      $this->util->alert( $this->lang->menu->error_name_required, TRUE );
        
        if( $this->exists_name($No) )
		{
			$this->util->alert($this->lang->addmsg->error_exist_name, TRUE);
		}
        
        //    2015.09.22 by Zeno
        if( $DeadManEnable != 0 &&  $HazmatEnable != 0 )
        {
            if( $DeadManAuxOutNo == $HazmatAuxOutNo )
            {
                 $this->util->alert( $this->lang->region->error_cannot_be_shared, TRUE );
            }
        }
        
        if( $OnlyMuster == '1' ) {
            $PassAnti       = 0;
            $PassAntiTime   = 0;
            $TailAnti       = 0;
            $LimitAnti      = 0;
            $LimitCount     = 0;
            $DeadManEnable  = 0;
            $TimeInterval   = 0;
            $HazmatEnable   = 0;
            $AuxInputNo     = 0;
            $EnableGrace    = 0;
            $DailyReset    = 0;
            $TimeOfDay    = 0;
        } else {
            /*
            2018.11.01 : wtkim bug fix
            버그내용 : 범위 안맞음(Max값보다 작으면 무조건 true)
            수정내용 : min/max 범위 지정
            */
            if(!($PassAntiTime > 0 && $PassAntiTime <= 999 ) && ($PassAnti > 0))    $this->util->alert( $this->lang->region->error_passantitime_invalid, TRUE );
            if(!($TimeInterval >= 5 && $TimeInterval <= 999) && ($DeadManEnable > 0))   $this->util->alert( $this->lang->region->error_timeinterval_invalid, TRUE );
            if( !($LimitCount > 0 && $LimitCount <= 2147483647)  && ($LimitAnti > 0)) $this->util->alert( $this->lang->region->error_limitcount_invalid, TRUE );
        }

        $sth    = $this->conn->prepare("UPDATE Region SET Name=?,Mean=?,OnlyMuster=?,Depth=?,ParentNo=?,PassAnti=?,PassAntiTime=?,TailAnti=?,LimitAnti=?,LimitCount=?,DeadManEnable=?,TimeInterval=?,HazmatEnable=?,AuxInputNo=?, EnableGrace=?, DailyReset=?, TimeOfDay=?, RootParentNo=?, ChildType=?, DeadManAuxOutNo = ?, HazmatAuxOutNo = ? WHERE No=?");
        $values = array($Name,$Mean,$OnlyMuster,$Depth,$ParentNo,$PassAnti,$PassAntiTime,$TailAnti,$LimitAnti,$LimitCount,$DeadManEnable,$TimeInterval,$HazmatEnable,$AuxInputNo,$EnableGrace, $DailyReset, $TimeOfDay, $RootParentNo, $ChildType, $DeadManAuxOutNo, $HazmatAuxOutNo, $No);
        if( $sth->execute($values) )
        {
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------
   public function check_dependency()
    {
        $No     = $this->input->get('no');
        $query = "select count(*) from reader where RegionNo = ? or OppRegionNo =?";  
        $stmt =  $this->conn->prepare( $query );  
        $stmt->execute(array($No,$No)); 
        $name = $stmt->fetchColumn();

        if( $name > 0 )
        {  
            $this->util->js('confirm_dependency()');
        }
        else
        {
            $this->util->js('del_data_prepass()');
        }
    }

   public function delete()
    {
        $No         = $this->input->get('no');
        $Name       = $this->util->GetRecordName('Region', $No);

        $data_del = $this->conn->prepare("DELETE FROM Region WHERE Site = ? AND No=?");
        if($data_del->execute(array($_SESSION['spider_site'], $No)) )
        {
            $this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------
   public function exists_name($No)
	{
		$Name			     = $this->input->post('Name');

		$count	= $this->conn->prepare("SELECT COUNT(*) FROM Region WHERE No != ? AND Site=? AND Name=?");
		$count->execute(array($No, $_SESSION['spider_site'], $Name));
		$count	= $count->fetchColumn();

		if( $count > 0 )	return TRUE;
		else				return FALSE;
	}
    
    // ----------------------------------------------------------------------------------

   public function to_array_region()
    {
        $list   = $this->conn->prepare("SELECT No, Name FROM Region WHERE Site=? ORDER BY Name ASC");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr = array('' => '');
        foreach( $list as $row ) {
            $arr[$row['No']] = $row['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_auxinput()
    {
        $list   = $this->conn->prepare("SELECT No, Name FROM AuxInput WHERE Site=? and Disable=0 ORDER BY Name ASC");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr = array();
        foreach( $list as $row ) {
            $arr[$row['No']] = $row['Name'];
        }

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_auxoutput()
    {
        $list   = $this->conn->prepare("SELECT No, Name FROM AuxOutput WHERE Site=? and Disable=0 ORDER BY Name ASC");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr = array();
        foreach( $list as $row ) {
            $arr[$row['No']] = $row['Name'];
        }

        return $arr;
    }
    
    // ----------------------------------------------------------------------------------

   public function find()
    {
        $no = $this->input->get('no');
        $depth = $this->input->get('depth', 0);

        if( empty($no) ) {
            $list   = $this->conn->prepare("SELECT No, Name FROM Region WHERE Site=? AND Depth < ? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site'], $depth));
        } else {
            $list   = $this->conn->prepare("SELECT No, Name FROM Region WHERE Site=? AND Depth < ? AND No != ? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site'], $depth, $no));
        }
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr = array('' => '');
        foreach( $list as $row ) {
            $arr[$row['No']] = $row['Name'];
        }

        $result = array( 'list' => $arr );

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function clear_data()
    {
        $No         = $this->input->get('No');
        $OnlyMuster = $this->input->get('OnlyMuster');
        $Name       = $this->util->GetRecordName('Region', $No);

        if( $OnlyMuster == '1' ) {
            $data_del = $this->conn->prepare("DELETE FROM Muster WHERE Site = ? AND MuRegionNo = ?");
        } else {
            $data_del = $this->conn->prepare("DELETE FROM Occupancy WHERE Site = ? AND ToRegionNo = ?");
        }

        if($data_del->execute(array($_SESSION['spider_site'], $No)) )
        {
            $this->log->set_log_message($Name);
            $this->util->alert( $this->lang->common->save_completed );
        }
    }

    // ----------------------------------------------------------------------------------

}


?>