<?php

include APP_DIR.'/libraries/EventCode.php';

class report1 extends controller
{
   public function index()
    {
        $vars['event']  = json_encode($this->to_event());
        $vars['user']       = json_encode($this->to_user());
        $vars['card']       = json_encode($this->to_card());
        $vars['door']       = json_encode($this->to_door());

        $this->display($vars);
    }

   public function select()
    {
        $field      = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM log");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM log ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM log WHERE $field LIKE ?");
            $count->execute(array("%$word%"));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM log WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array("%$word%", $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word'] = $word;
        $result['page'] = $page;
        $result['view'] = $view;
        $result['pages']    = $pagination->get_pages();
        $result['count']    = $count;
        $result['list']     = $list;

        echo json_encode($result);
    }

    
   public function search()
    {   
        $p              = $this->input->get('p');
        $st_day     = $this->input->get('st_day');
        $ed_day = $this->input->get('ed_day');
        $user       = $this->input->get('user');       
        $door       = $this->input->get('door');       
        $card_no    = $this->input->get('card_no');        
        $access     = $this->input->get('Access');
        
//      echo "aaaa";
        
        if($user != '') $var_user = " and UserNo = ".$user;
        else $var_user = "";
        
        if($door != '') $var_door = " and Port = ".$door;
        else $var_door = "";        
        
        if($card_no != '') $var_card = " and CardNo = '".$card_no."'";
        else $var_card = "";
        
        if($access == '121') $var_acc = " and EventCode ='400'";
        else if($access == '101') $var_acc = " and EventCode ='2'";
        else $var_acc = "";
        
        if( !empty($st_day) && !empty($ed_day) )
        {
//          $s_arr = explode("-", $st_day);
//          $e_arr = explode("-", $et_day);
//
//          $s_day = mktime(0,0,0,$s_arr[1], $s_arr[2], $s_arr[0]);
//          $e_day = mktime(23,59,59,$e_arr[1], $e_arr[2], $e_arr[0]);

            $var_time = " and date between strftime('%s','".$st_day."') and strftime('%s','".$ed_day."')";

            $list['time'] = $var_time;
        }
        else $var_time = "";
        
        $start_page = ($p * 20) - 20;

        $search_key = $var_user." ".$var_door." ".$var_card." ".$var_time." ".$var_acc;
        
//      echo $search_key;
        
        
        $count  = $this->conn_log->prepare("select count(*) from log where 1=1 ".$search_key);
        $count->execute();
        $list['row'] = $count->fetchColumn();
        
        $data   = $this->conn_log->prepare("select No,Type,Port,UserName,CardNo,EventCode,strftime('%Y-%m-%d %H:%M:%S',datetime(date,'unixepoch'))as dd from log where 1=1 ".$search_key." order by No asc limit ? , 20");
        $data->execute(array($start_page));
        
        
        
        $list['list']   = $data->fetchAll(PDO::FETCH_ASSOC);
        
//      print_r($list['list']);

        echo json_encode($list);
    }

   public function to_event()
    {
        $event = EventCode::$attrs;

        foreach( $event as $key=>$val)
        {
            $event[$key['No']]  = $val;     
        }   
//      print_r($event[600]);
        return $event;
    }

   public function to_user(){
        $list   = $this->conn->prepare("SELECT * FROM User WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        return $list;       
    }

   public function to_card(){
        $list   = $this->conn->prepare("SELECT * FROM Card WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        return $list;       
    }

   public function to_door(){
        $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        return $list;       
    }

   public function to_reader(){
        $list   = $this->conn->prepare("SELECT * FROM Reader WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        
        foreach( $list as $key=>$val)
        {
            $re_list[$val['No']]    = $val;
        }       
        $re_list['reader_0']    = '-';
        return $re_list;        
    }
}