<?php 
class reset extends controller
{
    var $arr_plug       = array('0'=>'Off', '1'=>'On');

   public function index()
    {
	    $vars = array();
        $this->display($vars);
    }

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM REBOOT");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT IFNULL(Enable ,0) Enable , IFNULL(Time,'0') Time FROM REBOOT");
            $list->execute();
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);

            foreach( $list as $key=>$val )
            {
                $val['EnableStr']    = $this->arr_plug[$val['Enable']];
                $val['TimeStr'] = EnumTable::$attrTimeList[$val['Time']];
                $list[$key] = $val;
            }
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['view']         = $view;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }


   public function update()
    {
        $Enable    = $this->input->post('Enable', 0);
        $Time    = $this->input->post('Time');
        
        $sth    = $this->conn->prepare("UPDATE REBOOT SET Enable=?, Time=?");
        $values = array($Enable,$Time);
        
        //if( $sth->execute($values))
        if( $sth->executeSilent($values))
        {
            //db 동기화
            exec(SPIDER_COMM." send db");
            $this->log->set_log();
            $this->util->alert( $this->lang->common->save_completed );
            $this->util->js("location.href='/?c=reset';");
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        } 
    }


	public function _save()
	{
		$confirm_pw    = $this->input->post('confirm_pw');
		//$page_type     = $this->input->post('page_type');


		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));

			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				$this->util->redirect("/?c=reset");
				exit;
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));

			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				$this->util->redirect("/?c=reset");
				exit;
			}
		}

		$save_type     = $this->input->post('save_type');
       
        // 명령어 실행 추가
        // exec("명령어");
        
        exec("/spider/bin/cp -a /tmp/SpiderDB/* /spider/database/.");
        exec(SPIDER_COMM." sysback");
        
		$rebootready = false;
		
		if( $save_type  == 'reboot' )
		{
			
			$this->log->set_log('reset', 'reset');
            
            exec(SPIDER_COMM." shutdown Flags"); 
            $this->util->alert($this->lang->common->save_completed_reset);
            
            $this->util->redirect('/?c=user&m=logout');             
            //$rebootready = true;
		}
		else
		{
            $this->log->set_log('backup', '_exec');
            $this->util->alert($this->lang->common->save_completed);
            if($page_type == 1){
				$this->util->redirect("/?c=reset&m=save");
			}else{
				$this->util->redirect("/?c=reset");
			}  
		}


	}

    public function save()
    {

	    $vars = array();
        $this->display($vars,'resetsave');
    }

   public function _exe()
    {

		
		$confirm_pw    = $this->input->post('confirm_pw');
		$page_type     = $this->input->post('page_type');


		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));

			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				$this->util->redirect("/?c=reset&m=save");
				exit;
			}
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));

			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
				$this->util->alert($this->lang->user->error_login_pw_mismatch);
				$this->util->redirect("/?c=reset&m=save");
				exit;
			}
		}
        
        $save_type     = $this->input->post('save_type');
       
        exec("/spider/bin/cp -a /tmp/SpiderDB/* /spider/database/.");
        exec(SPIDER_COMM." sysback");
        
		$rebootready = false;
		
		if( $save_type  == 'reboot' )
		{
			$this->log->set_log('reset', 'reset');
            
            exec(SPIDER_COMM." shutdown Flags"); 
            $this->util->alert($this->lang->common->save_completed_reset);
            
            $this->util->redirect('/?c=user&m=logout');             
		}
		else
		{
            $this->log->set_log('backup', '_exec');
            $this->util->alert($this->lang->common->save_completed);
            if($page_type == 1){
				$this->util->redirect("/?c=reset&m=save");
			}else{
				$this->util->redirect("/?c=reset");
			}  
		}
        
    }
}