<?php


include APP_DIR.'/libraries/CirciutType.php';


class rex extends controller
{

	// ----------------------------------------------------------------------------------

   public function index()
	{
		$this->display();
	}

	// ----------------------------------------------------------------------------------

   public function select()
	{
		$field	= $this->input->get('f');
		$word	= $this->input->get('w');
		$page	= $this->input->get('p', 1);
		$view	= $this->input->get('v');

		$page_config	= $GLOBALS['page_config'];
		$pagination		= new Pagination();

		if( empty($field) || empty($word) )
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM rex");
			$count->execute();
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM rex ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}
		else
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM rex WHERE $field LIKE ?");
			$count->execute(array($this->util->parse_search_string($word)));
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM rex WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}

		foreach( $list as $key=>$val)
		{
			$val['disable_str']	= ($val['disable'] == "1" ? 'Off' : 'On');
			$val['alram_str']	= ($val['alram'] == "1" ? 'Off' : 'On');
			$val['Type_str']	= CirciutType::$attrs[$val['Type']];
			$list[$key]	= $val;
		}

		$result['field']	= $field;
		$result['word']		= $word;
		$result['page']		= $page;
		$result['view']		= $view;
		$result['pages']	= $pagination->get_pages();
		$result['count']	= $count;
		$result['list']		= $list;

		echo json_encode($result);
	}

	// ----------------------------------------------------------------------------------

   public function update()
	{
		$No				= $this->input->post('No');
		$disable		= $this->input->post('disable', '0');
		$alram			= $this->input->post('alram', '0');
		$name			= $this->input->post('name');
		$mean			= $this->input->post('mean');
		$Type			= $this->input->post('Type');

		if($Type == '8')
		{
			$nomal_low		= $this->input->post('nomal_low');
			$nomal_high		= $this->input->post('nomal_high');
			$T_open_low		= $this->input->post('T_open_low');
			$T_open_high	= $this->input->post('T_open_high');
			$T_short_low	= $this->input->post('T_short_low');
			$T_short_high	= $this->input->post('T_short_high');
			$A_1_low		= $this->input->post('A_1_low');
			$A_1_high		= $this->input->post('A_1_high');
			$A_2_low		= $this->input->post('A_2_low');
			$A_2_high		= $this->input->post('A_2_high');
		}
		else
		{
			$nomal_low		= CirciutType::$sub_attrs[$Type]['nomal_low'];
			$nomal_high		= CirciutType::$sub_attrs[$Type]['nomal_high'];
			$T_open_low		= CirciutType::$sub_attrs[$Type]['T_open_low'];
			$T_open_high	= CirciutType::$sub_attrs[$Type]['T_open_high'];
			$T_short_low	= CirciutType::$sub_attrs[$Type]['T_short_low'];
			$T_short_high	= CirciutType::$sub_attrs[$Type]['T_short_high'];
			$A_1_low		= CirciutType::$sub_attrs[$Type]['A_1_low'];
			$A_1_high		= CirciutType::$sub_attrs[$Type]['A_1_high'];
			$A_2_low		= CirciutType::$sub_attrs[$Type]['A_2_low'];
			$A_2_high		= CirciutType::$sub_attrs[$Type]['A_2_high'];
		}

		if( empty($name) )		$this->util->alert( $this->lang->rex->error_name_required, TRUE );

		$sth	= $this->conn->prepare("UPDATE rex SET disable=?,alram=?,name=?,mean=?,Type=?,nomal_low=?,nomal_high=?,T_open_low=?,T_open_high=?,T_short_low=?,T_short_high=?,A_1_low=?,A_1_high=?,A_2_low=?,A_2_high=? WHERE No=?");

		$values	= array($disable,$alram,$name,$mean,$Type,$nomal_low,$nomal_high,$T_open_low,$T_open_high,$T_short_low,$T_short_high,$A_1_low,$A_1_high,$A_2_low,$A_2_high,$No);
		if( $sth->execute($values) )
		{
			$this->log->set_log();
			$this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
		}
		else
		{
			$this->util->alert($this->lang->common->error_update);
		}
	}

	// ----------------------------------------------------------------------------------

   public function delete()
	{
	}

	// ----------------------------------------------------------------------------------

   public function disable()
	{
		$No				= $this->input->post('No');
		$disable		= $this->input->post('disable', '0');

		$sth	= $this->conn->prepare("UPDATE rex SET disable=? WHERE No=?");

		if( $sth->execute( array($disable,$No) ) )
		{
			$this->log->set_log(NULL, 'disable');
			$this->util->alert($this->lang->common->success_update);
		}
		else
		{
			$this->util->alert($this->lang->common->error_update);
		}
	}

	// ----------------------------------------------------------------------------------

}


?>