<?php


class rgroup extends controller
{

	// ----------------------------------------------------------------------------------

   public function index()
	{
		$vars['arr_reader']		= $this->to_array_reader();
		$this->display($vars);
	}

	// ----------------------------------------------------------------------------------

   public function select()
	{
		$field	= $this->input->get('f');
		$word	= $this->input->get('w');
		$page	= $this->input->get('p', 1);
		$view	= $this->input->get('v');

		$page_config	= $GLOBALS['page_config'];
		$pagination		= new Pagination();

		if( empty($field) || empty($word) )
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM Reader_Group");
			$count->execute();
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM Reader_Group ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}
		else
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM Reader_Group WHERE $field LIKE ?");
			$count->execute(array($this->util->parse_search_string($word)));
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM Reader_Group WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}

		foreach( $list as $key=>$val )
		{
			$val['readers']			= $this->get_reader_str($val['No']);
			$val['reader_list[]']	= $this->get_reader_select_value($val['No']);
			$list[$key]	= $val;
		}

		$result['field']		= $field;
		$result['word']			= $word;
		$result['page']			= $page;
		$result['view']			= $view;
		$result['pages']		= $pagination->get_pages();
		$result['count']		= $count;
		$result['list']			= $list;

		echo json_encode($result);
	}

	// ----------------------------------------------------------------------------------

   public function insert()
	{
		$name			= $this->input->post('name');
		$mean			= $this->input->post('mean');
		$reader_list	= $this->input->post('reader_list', array());

		if( empty($name) )		$this->util->alert( $this->lang->rgroup->error_name_required, TRUE );

		$sth	= $this->conn->prepare("INSERT INTO Reader_Group (name,mean) VALUES (?,?)");

		$values	= array($name,$mean);
		if( $sth->execute($values) )
		{
			$this->log->set_log();
			
			$query = 'INSERT INTO Reader_Group (name,mean) VALUES ("'.$name.'","'.$mean.'")';

			$No	= $this->conn->lastInsertId();

			$sth	= $this->conn->prepare("INSERT INTO Reader_data (R_G_no,Reader) VALUES (?,?)");
			foreach( $reader_list as $value )
			{
				$sth->execute( array($No, $value) );
				
				$query = 'INSERT INTO Reader_data (R_G_no,Reader) VALUES ("'.$No.'","'.$value.'")';
				
			}

			$this->util->js('load_list();');
            $this->util->alert( $this->lang->common->save_completed );
		}
		else
		{
			$this->util->alert($this->lang->common->error_insert);
		}
	}

	// ----------------------------------------------------------------------------------

   public function update()
	{
		$No				= $this->input->post('No');
		$name			= $this->input->post('name');
		$mean			= $this->input->post('mean');
		$reader_list	= $this->input->post('reader_list', array());

		if( empty($name) )		$this->util->alert( $this->lang->rgroup->error_name_required, TRUE );

		$sth	= $this->conn->prepare("UPDATE Reader_Group SET name=?,mean=? WHERE No=?");

		$values	= array($name,$mean,$No);
		if( $sth->execute($values) )
		{
			$this->log->set_log();
			
			
			$query = 'UPDATE Reader_Group SET name="'.$name.'",mean="'.$mean.'" WHERE No="'.$No.'"';

			$sth	= $this->conn->prepare("DELETE FROM Reader_data WHERE R_G_no=?");
			$sth->execute( array($No) );
			
			
			$query = 'DELETE FROM Reader_data WHERE R_G_no="'.$No.'"';

			$sth	= $this->conn->prepare("INSERT INTO Reader_data (R_G_no,Reader) VALUES (?,?)");
			foreach( $reader_list as $value )
			{
				$sth->execute( array($No, $value) );
				
				$query = 'INSERT INTO Reader_data (R_G_no,Reader) VALUES ("'.$No.'","'.$value.'")';
			}

			$this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
		}
		else
		{
			$this->util->alert($this->lang->common->error_update);
		}
	}

	// ----------------------------------------------------------------------------------

   public function delete()
	{
		$no				= $this->input->get('no');
		$rgroup_del	= $this->conn->prepare("delete FROM Reader_Group WHERE No=?");
		
		$rg_del = $this->conn->prepare("delete FROM Reader_data WHERE R_G_no=?");
		$rg_del->execute(array($no));
		
		$query = 'delete FROM Reader_data WHERE R_G_no="'.$no.'"';
		
		if( $rgroup_del->execute(array($no)) )
		{
			$this->log->set_log();
            $this->util->alert( $this->lang->common->delete_completed );
			
			$query = 'delete FROM Reader_Group WHERE No="'.$no.'"';
		}
		else
		{
			$this->util->alert($this->lang->common->error_delete);
		}
	}

	// ----------------------------------------------------------------------------------

   public function to_array_reader()
	{
		$list	= $this->conn->prepare("SELECT * FROM Reader");
		$list->execute();
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);

		$arr	= array();
		foreach( $list as $key=>$val)
		{
			$arr[$val['No']]	= $val['name'];
		}

		return $arr;
	}

	// ----------------------------------------------------------------------------------

   public function get_reader_str($No)
	{
		$arr	= array();

		$list	= $this->conn->prepare("SELECT * FROM Reader_data WHERE R_G_no = ?");
		$list->execute(array($No));
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);

		foreach( $list as $val )
		{
			$arr[]	= $val['Reader'];
		}
		$arr_str	= implode(',', $arr);

		$arr	= array();
		$list	= $this->conn->prepare("SELECT * FROM Reader WHERE No IN ($arr_str)");
		$list->execute();
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);

		foreach( $list as $val )
		{
			$arr[]	= $val['name'];
		}

		return implode(',', $arr);
	}

	// ----------------------------------------------------------------------------------

   public function get_reader_select_value($No)
	{
		$arr	= array();

		$list	= $this->conn->prepare("SELECT * FROM Reader_data WHERE R_G_no = ?");
		$list->execute(array($No));
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);

		foreach( $list as $val )
		{
			$arr[]	= "'". $val['Reader'] ."'";
		}

		return "[". implode(',', $arr) ."]";
	}

	// ----------------------------------------------------------------------------------

}


?>