<?php


class server_client extends controller
{

    // ----------------------------------------------------------------------------------

    public function index()
    {
        $vars['list'] = json_encode($this->to_host());
        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------
    
    public function to_host()
    {
        $list   = $this->conn->prepare("SELECT * FROM Host WHERE No != '1' ORDER BY No DESC ");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        foreach( $list as $key=>$val )
        {
            $name   = $this->conn->prepare("SELECT Name FROM controller WHERE No = ".$list[$key]['No']);
            $name->execute();
            $name = $name->fetchColumn();
            $list[$key]['Name'] = $name;
			$list[$key]['TypeStr']     = EnumTable::$attrModelType[$val['Type']][$val['PortCount']];

            if($val['Type'] == '6' || $val['Type'] == '7') 
            {
                $elevator = $this->get_elevator_by_host($val['No']);
                if($elevator['Extended'] == '1') {
                    $list[$key]['TypeStr'] = 'EV EXT';
                }
            }
            /*wtkim 20190326 : 모델명 변경(Neptune mode*/
            // wtkim : 20190517 : neptune model 명으로 통일 됨.
            
            //if($_ENV["NEPTUNE_MODE"] == "NEPTUNE")
            //{	
                if(substr($val['Version'], 0, 1) == '5'){
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo_NT[5]; // Neptume H5 Model No
                }else if(substr($val['Version'], 0, 1) == '3'){
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo_NT[3]; // Neptume H3 Model No
                }else if(substr($val['Version'], 0, 1) == '9'){
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo_NT[9]; // Neptume Giant No
                }else if(substr($val['Version'], 0, 1) == '1'){
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo_NT[1]; // Neptume-E3
                }else{
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo_NT[0]; // E3-SPIDER
                }
                /*
            }
            else
            {
                if(substr($val['Version'], 0, 1) == '5'){
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo[5]; // Neptume H5 Model No
                }else if(substr($val['Version'], 0, 1) == '3'){
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo[3]; // Neptume H3 Model No
                }else if(substr($val['Version'], 0, 1) == '9'){
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo[9]; // Neptume Giant No
                }else{
                    $list[$key]['Modelno'] = EnumTable::$neptuneProductModelNo[0]; // E3-SPIDER
                }
            }
            */
        }
        return $list;
    }
    
    public function insert()
    {
        if ($this->valid_confirm() == false)
        {
            $this->util->alert($this->lang->user->error_login_pw_mismatch);
            exit;
        }

        $Type   = $this->input->post('Type');
        $No     = $this->input->post('No');
        
        //$ClientEnable = $this->get_client_enable($No);
        //if ($ClientEnable == 1)
        //{
	        exec(SPIDER_COMM." clntdb enable ".$No." ".$_SESSION['spider_site']." ".$_SERVER['REMOTE_ADDR']." ".$_SESSION['spider_id']);
	   // }
       // else
	   // {
	    	//alert( $this->lang->addmsg->no_connect_client );
	   // }
	    
		$this->util->js("Host = ". json_encode($this->to_host()) .";");

        //$result = json_encode($this->to_host());
        //echo $result;
    }
    
    public function client_noused()
    {
        if ($this->valid_confirm() == false)
        {
            $this->util->alert($this->lang->user->error_login_pw_mismatch);
            exit;
        }

        $Type   = $this->input->post('Type');
        $No     = $this->input->post('No');
        
        exec(SPIDER_COMM." clntdb disable ".$No." ".$_SESSION['spider_site']." ".$_SERVER['REMOTE_ADDR']." ".$_SESSION['spider_id']);

		$this->util->js("Host = ". json_encode($this->to_host()) .";");
        
        //$result = json_encode($this->to_host());
        //echo $result;
    }

    public function del_client()
    {
        if ($this->valid_confirm() == false)
        {
            $this->util->alert($this->lang->user->error_login_pw_mismatch);
            exit;
        }

        $Type   = $this->input->post('Type');
        $No     = $this->input->post('No');

        exec(SPIDER_COMM." clntdb del ".$No." ".$_SESSION['spider_site']." ".$_SERVER['REMOTE_ADDR']." ".$_SESSION['spider_id']);

		$this->util->js("Host = ". json_encode($this->to_host()) .";");
                
        //$result = json_encode($this->to_host());
        //echo $result;
    }
    
	public function update_client()
	{
		if ($this->valid_confirm() == false) {
			$this->util->alert($this->lang->user->error_login_pw_mismatch);
			exit;
		}

		$rt = exec(SPIDER_COMM." update info");
		if ($rt == '-1') {
			$this->util->alert("Fail to Connect Update Server");
			exit;
		}
		$fp = fopen(SPDIER_PACKAGE, "r");
		if ($fp == FALSE) {
			$this->util->alert("Fail to Get Update Information");
			exit;
		}
		$buffer = fread($fp, filesize(SPDIER_PACKAGE));
		fclose($fp);
		$jsonData = json_decode($buffer);
		if (json_last_error() > 0) {
			$this->util->alert("Fail to Decode Update Information");
			exit;
		}

		$No = $this->input->post('No');
		$Version = $this->conn->prepare("SELECT Version FROM Host WHERE No=?");
		$Version->execute(array($No));
		$Version = $Version->fetchColumn();

		for ($i = 0; $i < count($jsonData); $i++) {
			if (substr($jsonData[$i]->version,0,1) == substr($Version,0,1)) {
				$rt = exec(SPIDER_COMM." dnPackage ".$jsonData[$i]->model." ".$jsonData[$i]->ftp." ".$jsonData[$i]->package." ".$jsonData[$i]->storage." ".$jsonData[$i]->checksums);
				if ($rt == '-1') {
					$this->util->alert("Fail to Download Update Package");
					exit;
				}
				break;
			}
		}

		$sth = $this->conn->prepare("UPDATE Host SET Action=1 WHERE No=?");
		$sth->executeSilent(array($No));

		$this->util->alert($this->lang->common->complete_update_client);
	}

    public function update_all()
	{
		if ($this->valid_confirm() == false) {
			$this->util->alert($this->lang->user->error_login_pw_mismatch);
			exit;
		}

		$rt = exec(SPIDER_COMM." update info");
		if ($rt == '-1') {
			$this->util->alert("Fail to Connect Update Server");
			exit;
		}
		$fp = fopen(SPDIER_PACKAGE, "r");
		if ($fp == FALSE) {
			$this->util->alert("Fail to Get Update Information");
			exit;
		}
		$buffer = fread($fp, filesize(SPDIER_PACKAGE));
		fclose($fp);
		$jsonData = json_decode($buffer);
		if (json_last_error() > 0) {
			$this->util->alert("Fail to Decode Update Information");
			exit;
		}

		$list = $this->conn->prepare("SELECT SUBSTR(Version,1,1) AS Ver FROM Host WHERE Type IN (5,7) GROUP BY Ver");
		$list->execute();
		$list = $list->fetchAll(PDO::FETCH_ASSOC);

		foreach ($list as $key=>$val)
		{
			for ($i = 0; $i < count($jsonData); $i++) {
				if (substr($jsonData[$i]->version,0,1) == $val['Ver']) {
					$rt = exec(SPIDER_COMM." dnPackage ".$jsonData[$i]->model." ".$jsonData[$i]->ftp." ".$jsonData[$i]->package." ".$jsonData[$i]->storage." ".$jsonData[$i]->checksums);
					if ($rt == '-1') {
						$this->util->alert("Fail to Download Update Package");
						exit;
					}
					break;
				}
			}
		}

		$sth = $this->conn->prepare("UPDATE Host SET Action=1 WHERE Type IN (5,7)");
		$sth->executeSilent();

		$this->util->alert($this->lang->common->complete_update_client);
	}

    public function reboot_client()
    {
        if ($this->valid_confirm() == false)
        {
            $this->util->alert($this->lang->user->error_login_pw_mismatch);
            exit;
        }

        $Type   = $this->input->post('Type');
        $No     = $this->input->post('No');

        exec(SPIDER_COMM." clientreboot ".$No);
        
        $this->util->alert($this->lang->common->reboot_client);
    }
    
    public function db_sync()
    {
        if ($this->valid_confirm() == false)
        {
            $this->util->alert($this->lang->user->error_login_pw_mismatch);
            exit;
        }

        //exec(SPIDER_COMM." send db");
        exec(SPIDER_COMM." send usersync");
        
		$msg = $this->lang->common->complete_db_sync;
		$this->util->alert($msg);
    }
    
    public function get_client_enable($No)
    {
        $client_enable   = $this->conn->prepare("SELECT Alive FROM Host WHERE No=?");
        $client_enable->execute(array($No));
        $client_enable   = $client_enable->fetchColumn();

        return $client_enable;
    }

    public function valid_confirm()
    {        
		$confirm_pw    = $this->input->post('confirm_pw');		
		// 用户加密 20190731
		if( $_SESSION['spider_type'] == 'spider' )
		{
			$ctrl   = $this->conn->query("SELECT * FROM Controller WHERE ID = ? AND Password = ? AND No = 1");
            //$ctrl->execute(array($_SESSION['spider_id'], $confirm_pw));
            $ctrl->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false)));

			if( !($ctrl = $ctrl->fetch(PDO::FETCH_ASSOC)) )
			{
            	return false;
            }
		}
		else
		{
			$webuser    = $this->conn->query("SELECT * FROM WebUser WHERE ID = ? AND Password = ? AND Site = ?");
            //$webuser->execute(array($_SESSION['spider_id'], $confirm_pw, $_SESSION['spider_site']));
            $webuser->execute(array($_SESSION['spider_id'], hash('sha256', $confirm_pw, false), $_SESSION['spider_site']));

			if( !($webuser = $webuser->fetch(PDO::FETCH_ASSOC)) )
			{
            	return false;
            }
		}

        return true;
    }

    public function get_elevator_by_host($hostNo)
    {
        $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site=? AND HostNo=?");
        $list->execute(array($_SESSION['spider_site'], $hostNo));
        $row    = $list->fetch(PDO::FETCH_ASSOC);

        return $row;
    }

}