<?php


include APP_DIR.'/libraries/Uploader.php';
include APP_DIR.'/libraries/CirciutType1.php';

class server_client_ctrl extends controller
{
    // ----------------------------------------------------------------------------------

   public function index()
    {
        $HostNo             = $this->input->get('HostNo');

        $vars['arr_floor']  = $this->to_array_floor();
        $vars['tamper']     = $this->to_tamper();
        $vars['power']      = $this->to_power();
        $vars['HostNo']     = $HostNo;

        $this->display($vars, '', 'frame');
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        $CirciutType    = new CirciutType;

        $count  = $this->conn->prepare("SELECT COUNT(*) FROM Controller WHERE HostNo=?");
        $count->execute( array($word) );
        $count  = $count->fetchColumn();

        $page_config['current_page']    = $page;
        $page_config['total_row']       = $count;
        $pagination->init($page_config);

        $list   = $this->conn->prepare("SELECT * FROM Controller WHERE HostNo=? ORDER BY No DESC LIMIT ?, ?");
        $list->execute(array($word, $pagination->offset, $pagination->row_size));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr_floor  = $this->to_array_floor();
        $tamper = $this->to_tamper();
        $power      = $this->to_power();

        foreach( $list as $key=>$val )
        {
            $val['FloorStr']       = $arr_floor[$val['Floor']];
            $val['Tinput_str']  = CirciutType::$attrs[$tamper[0]['Type']];
            $val['PFinput_str'] = CirciutType::$attrs[$power[0]['Type']];
            $val['Tinput']  = $tamper[0]['Type'];
            $val['PFinput'] = $power[0]['Type'];

            $list[$key] = $val;
        }

        $result['field']            = $field;
        $result['word']     = $word;
        $result['page']     = $page;
        $result['view']     = $val['No'];
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
        $No         = $this->input->post('No');
        $Name       = $this->input->post('Name');
        $Location   = $this->input->post('Location');
        $floor      = $this->input->post('Floor');
        $Tinput     = $this->input->post('Tinput');
        $PFinput    = $this->input->post('PFinput');

        $ctrl   = $this->conn->prepare("SELECT * FROM Controller WHERE No=?");
        $ctrl->execute(array($No));
        $ctrl   = $ctrl->fetch(PDO::FETCH_ASSOC);

        if( empty($Name) )   $this->util->alert( $this->lang->menu->error_name_required, TRUE );

        $file = $this->receive();
        if( $file === FALSE )       exit;

        if( empty($file) )  $file = $ctrl['file'];

        if( !empty($ctrl['file']) && $ctrl['file'] != $file )
        {
            unlink(FLOOR_DIR.'/'.$ctrl['file']);
        }

        $sth    = $this->conn->prepare("UPDATE Controller SET Name=?,Location=?,Floor=? WHERE No=?");
        $values = array($Name,$Location,$Floor,$No);
        if( $sth->execute($values) )
        {
            $this->log->set_log();
//          $this->util->js('update_list("'.$No.'")');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }

        $sth    = $this->conn->prepare("UPDATE TamperInput SET Type=? WHERE HostNo=?");
        $values = array($Tinput, $ctrl['HostNo']);
        if( $sth->execute($values) )
        {
//          $this->util->js('update_list("'.$No.'")');
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
        
        $sth    = $this->conn->prepare("UPDATE PowerFault SET Type=? WHERE HostNo=?");
        $values = array($PFinput, $ctrl['HostNo']);
        if( $sth->execute($values) )
        {
            $this->util->js('parent.update_list("'.$No.'")');
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }

        $this->util->js('parent.location.reload();');
    }

    // ----------------------------------------------------------------------------------

   public function receive()
    {
        if( ! is_uploaded_file($_FILES['upload_file']['tmp_name']) )    return "";

        $uploader                   = new Uploader();
        $uploader->upload_dir       = FLOOR_DIR;

        if( $uploader->do_upload('upload_file') )
        {
            return $uploader->save_file['basename'];
        }
        else
        {
            $this->util->alert( $this->lang->common->error_fileuplaod );
            return FALSE;
        }
    }

    // ----------------------------------------------------------------------------------

   public function to_array_floor()
    {
        $cfloor = $this->conn->prepare("SELECT * FROM Floor WHERE Site=?");
        $cfloor->execute(array($_SESSION['spider_site']));
        $cfloor = $cfloor->fetchAll(PDO::FETCH_ASSOC);

        $arr_floor  = array();
        foreach( $cfloor as $key=>$val)
        {
            $arr_floor[$val['No']]  = $val['Name'];
        }

        return $arr_floor;
    }

   public function to_tamper()
    {
        $tamper = $this->conn->prepare("SELECT * FROM TamperInput");
        $tamper->execute();
        $tamper = $tamper->fetchAll(PDO::FETCH_ASSOC);


        return $tamper;
    }

   public function to_power()
    {
        $power = $this->conn->prepare("SELECT * FROM PowerFault");
        $power->execute();
        $power= $power->fetchAll(PDO::FETCH_ASSOC);

        return $power;
    }

    // ----------------------------------------------------------------------------------

   public function to_timestamp($date)
    {
        if ($date != "")
        {
        	$timeval = explode('-', trim($date));
        	
        	if (count($timeval) < 3)
        	{
        		return "";
        	}
        		
            $month  = $timeval[0];
            $day    = $timeval[1];
            $year   = $timeval[2];
            return mktime(0, 0, 0, $month, $day, $year);
        }
        return $date;
    }

    // ----------------------------------------------------------------------------------

}


?>