<?php

include APP_DIR.'/libraries/Uploader.php';

class site extends controller
{

    // ----------------------------------------------------------------------------------

    public function index()
    {
        $this->display();
    }

    // ----------------------------------------------------------------------------------

    public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();
        
        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Site");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Site ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Site WHERE $field LIKE ?");
            $count->execute(array($this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM Site WHERE $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        foreach( $list as $key=>$val )
        {
            $val['file']        = $val['LogoFile'];
            
            if(!empty($val['Language'])){
	            $val['LanguageStr'] = EnumTable::$attrLanguage[$val['Language']];
            }else{
	            $val['LanguageStr'] = '';
            }
            
            if(!empty($val['Country'])){
	            $val['CountryStr'] = EnumTable::$attrCountry[$val['Country']];
            }else{
	            $val['CountryStr'] = '';
            }
            
            $val['file_url'] = empty($val['LogoFile']) ? '' : FLOOR_URL.'/'.$val['file'];
            $list[$key] = $val;
        }

        $result['field']    = $field;
        $result['word']     = $word;
        $result['page']     = $page;
        $result['view']     = $view;
        $result['pages']    = $pagination->get_pages();
        $result['count']    = $count;
        $result['list']     = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

    public function insert()
    {
    	$this->max_site  = $this->util->GetLimitCount(1, 1, 5, 12 );
    	
    	if ($this->max_site <= $this->util->GetRecordCount('Site'))
    	{
    		$this->util->alert($this->lang->addmsg->error_limit_over_site);
    		$this->util->js('top.hide_loading();');
        	exit;
    	}
    	
        $No = $this->conn->prepare("SELECT MAX(No) FROM Site");
        $No->execute();
        $No = $No->fetchColumn() + 1;
        
        $Name           = strip_tags(trim($this->input->post('Name')));
        $Language       = $this->input->post('Language');
        $Country        = $this->input->post('Country');
        $ImageFile      = $this->input->post('upload_file');

        if( empty($Name) )      $this->util->alert( $this->lang->menu->error_name_required, TRUE );

        
        $cfloor = $this->conn->prepare("SELECT COUNT(*) FROM Site WHERE Name=?");
        $cfloor->execute(array($Name));
        $cfloor = $cfloor->fetchColumn();
        
        if($cfloor != "0"){
            //$this->util->alert( $this->lang->menu->error_duplicate_name, TRUE );
            Util::alert("The same name exists.");
            exit;
        }

        $ImageFileSend = $this->receive();
        if( $ImageFileSend === FALSE )      
        {
            //$this->util->alert($this->lang->common->error_insert);
            exit;
        }

        $sth    = $this->conn->prepare("INSERT INTO Site (No,Name,Language,Country,LogoFile) VALUES (?,?,?,?,?)");

        $values = array($No,$Name,$Language,$Country,$ImageFileSend);
        if( $sth->execute( $values ) )
        {
        	//exec(SPIDER_COMM." send db");
            $this->log->set_log();
            $this->util->js('parent.load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
    }

    // ----------------------------------------------------------------------------------

    public function update()
    { 
//        error_log("%s", __LINE__);
        $No             = $this->input->post('No');
        $Name           = strip_tags(trim($this->input->post('Name')));
        $Language       = $this->input->post('Language');
        $Country        = $this->input->post('Country');
        $ImageFile      = $this->input->post('upload_file');
        $noimg      = $this->input->post('noimg');

        if( empty($Name) )      $this->util->alert( $this->lang->menu->error_name_required, TRUE );
        
        /*
        $cfloor = $this->conn->prepare("SELECT COUNT(*) FROM Site WHERE Name=?");
        $cfloor->execute(array($Name));
        $cfloor = $cfloor->fetchColumn();
        
        if($cfloor != "0"){
            //$this->util->alert( $this->lang->menu->error_duplicate_name, TRUE );
            Util::alert("The same name exists.");
            exit;
        }
        */

        $ImageFileSend = $this->receive();

        if( $ImageFileSend === FALSE )      
        {
            //$this->util->alert($this->lang->common->error_insert);
            exit;
        }
        $cfloor = $this->conn->prepare("SELECT * FROM Site WHERE No=?");
        $cfloor->execute(array($No));
        $cfloor = $cfloor->fetch(PDO::FETCH_ASSOC);
        
        if( !empty($ImageFileSend) && $cfloor['LogoFile'] != $ImageFileSend ){
	        if(file_exists(FLOOR_DIR.'/'.$cfloor['LogoFile'])){
	            @unlink(FLOOR_DIR.'/'.$cfloor['LogoFile']);
            }
        }elseif( empty($ImageFileSend) && $noimg == 1 ){
	        if(file_exists(FLOOR_DIR.'/'.$cfloor['LogoFile'])){
	            @unlink(FLOOR_DIR.'/'.$cfloor['LogoFile']);
            }
	        
	        $ImageFileSend = '';
        }else{
	        $ImageFileSend = $cfloor['LogoFile'];
        }
        

        $sth    = $this->conn->prepare("UPDATE Site SET Name=?,Language=?,Country=?,LogoFile=? WHERE No=?");
	    $values = array($Name,$Language,$Country,$ImageFileSend,$No);
            
        if( $sth->execute($values) )
        {
        	//exec(SPIDER_COMM." send db");
            $this->log->set_log();
            $this->util->js('parent.update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
            //$this->util->topreload();
        }
        else
        {   
            
            $this->util->alert($this->lang->common->error_update);
        }

    }

    // ----------------------------------------------------------------------------------

    /*
    public function delete()
    {
        $No     = $this->input->get('no');
        


        if ($No == 1)
        {
        	$this->util->alert($this->lang->addmsg->cannot_delete_site_1, TRUE);
        }

        $cfloor = $this->conn->prepare("SELECT * FROM Site WHERE No=?");
        $cfloor->execute(array($No));
        $cfloor = $cfloor->fetch(PDO::FETCH_ASSOC);

        if( !empty($cfloor['LogoFile']) )
        {
            unlink(FLOOR_DIR.'/'.$cfloor['LogoFile']);
        }

        $sth    = $this->conn->prepare("DELETE FROM Site WHERE No=?");


        if( $sth->execute(array($No)) )
        {
        	//exec(SPIDER_COMM." send db");
            $this->log->set_log();
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }
*/

    public function delete()
    {        
        $No     = $this->input->get('no');
        $query = "SELECT LogoFile FROM site WHERE No=?";  
        $stmt =  $this->conn->prepare( $query );  
        $stmt->execute(array($No)); 
        $name = '/spider/web/webroot/floor_img/'.$stmt->fetchColumn();

        if ($No == 1) // default site delete 시에는 LogoFile 경로 삭제
        {   
            $sth    = $this->conn->prepare("Update site set LogoFile='' Where No=?");
        }
        else//default 아니면 레코드 삭제
        {
            $sth    = $this->conn->prepare("DELETE FROM Site WHERE No=?");
        }

        if( $sth->execute(array($No)) )
        {
            $this->log->set_log();
            $message   = $this->lang->common->delete_completed;  
            
            if(file_exists($name)){
	            @unlink($name);
            }
           
        }
        else
        {            
            $message   = $this->lang->common->error_delete;
        }
        echo json_encode($message);
    }
    // ----------------------------------------------------------------------------------
    public function receive()
    {
        if( ! is_uploaded_file($_FILES['upload_file']['tmp_name']) )    return "";

        $uploader                   = new Uploader();
        $uploader->upload_dir       = FLOOR_DIR;

        if( $uploader->do_upload('upload_file') )
        {
            return $uploader->save_file['basename'];
        }
        else
        {
            $this->util->alert($this->lang->addmsg->error_upload);			//$this->util->alert( "Image File Upload Error : ".$uploader->get_errors() );
            return FALSE;
        }
    }
    // ----------------------------------------------------------------------------------
}
?>