<?php


class sitedevice extends controller
{
    public function index()
    {
        $vars['attrSiteList'] = $this->to_site_list();
        $this->display($vars);
    }
    
    // ----------------------------------------------------------------------------------

    public function select()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');
        $page   = $this->input->get('p', 1);
        $view   = $this->input->get('v');

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Site");
            $count->execute();
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT A.No,IFNULL(A.Name, '') AS Name, 
                                                   IFNULL(B.DoorCount, 0) AS DoorCount, IFNULL(C.ElevatorCount, 0) AS ElevatorCount, 
                                                   IFNULL(D.AuxInputCount, 0)  AS AuxInputCount, IFNULL(E.AuxOutputCount, 0) AS AuxOutputCount
                                              FROM SITE AS A
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS DoorCount FROM Door WHERE Disable=0 GROUP BY Site) AS B ON B.Site = A.No
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS ElevatorCount FROM Elevator WHERE Disable=0 GROUP BY Site) AS C ON C.Site = A.No
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS AuxInputCount FROM AuxInput WHERE Disable=0 GROUP BY Site) AS D ON D.Site = A.No
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS AuxOutputCount FROM AuxOutput WHERE Disable=0 GROUP BY Site) AS E ON E.Site = A.No ORDER BY A.No DESC LIMIT ?, ?");
            $list->execute(array($pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM Site WHERE $field LIKE ?");
            $count->execute(array($this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT A.No AS No, IFNULL(A.Name, '') AS Name, 
                                                   IFNULL(B.DoorCount, 0) AS DoorCount, IFNULL(C.ElevatorCount, 0) AS ElevatorCount, 
                                                   IFNULL(D.AuxInputCount, 0)  AS AuxInputCount, IFNULL(E.AuxOutputCount, 0) AS AuxOutputCount
                                              FROM SITE AS A
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS DoorCount FROM Door GROUP BY Site) AS B ON B.Site = A.No
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS ElevatorCount FROM Elevator GROUP BY Site) AS C ON C.Site = A.No
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS AuxInputCount FROM AuxInput GROUP BY Site) AS D ON D.Site = A.No
                                              LEFT OUTER JOIN (SELECT Site, COUNT(*) AS AuxOutputCount FROM AuxOutput GROUP BY Site) AS E ON E.Site = A.No
                                             WHERE A.$field LIKE ? ORDER BY A.No DESC LIMIT ?, ?");
            $list->execute(array($this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $vars['attrSiteList'] = $this->to_site_list();

        foreach( $list as $key=>$val )
        {
        	$val['SiteName']      = $val['Name'];
            $val['DoorList']      = $this->get_door_select_value($val['No']);
            $val['ElevatorList']  = $this->get_elevator_select_value($val['No']);
            $val['AuxInputList']  = $this->get_auxinput_select_value($val['No']);
            $val['AuxOutputList'] = $this->get_auxoutput_select_value($val['No']);
            $list[$key] = $val;
        }

        $result['field'] = $field;
        $result['word']  = $word;
        $result['page']  = $page;
        $result['view']  = $view;
        $result['pages'] = $pagination->get_pages();
        $result['count'] = $count;
        $result['list']  = $list;

        echo json_encode($result);
    }
    
    public function to_site_list()
    {
        $list   = $this->conn->prepare("SELECT * FROM Site");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }
        return $arr;
    }


    // ----------------------------------------------------------------------------------

    public function insert()
    {
        
    }

    // ----------------------------------------------------------------------------------

    public function update()
    {
        $No       = $this->input->post('No');
        $DeviceKind = $this->input->post('DeviceKind');
        $Element2   = $this->input->post('Element3', array());

        if ($DeviceKind == ConstTable::DEVICE_DOOR)
        {
            $tablename = "Door";
            
            
            // Admin By Site로 인해 관계된 테이블들에서 변화된 Element들을 삭제 2015.05.19 by Zeno
            $sth    = $this->conn->prepare("DELETE FROM AccessLevelReader WHERE  Site <> ? AND (ReaderNo=(Select MasterReader FROM Door WHERE No=?)) OR (ReaderNo=(Select SlaveReader FROM Door WHERE No=?))");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value, $value) );
	        }
	        
            $sth    = $this->conn->prepare("DELETE FROM camera WHERE  Site <> ? AND DoorNo = ?");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value) );
	        }
            
            
            $sth    = $this->conn->prepare("DELETE FROM ElevatorUser WHERE  Site <> ? AND ElevatorNo = ?");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value) );
	        }
            
            $sth    = $this->conn->prepare("DELETE FROM GroupElement WHERE  Site <> ? AND GroupKind = 2 AND ElementNo = ?");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value) );
	        }
            
            $sth    = $this->conn->prepare("DELETE FROM Occupancy WHERE  Site <> ? AND DoorNo = ?");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value) );
	        }
            
            $sth    = $this->conn->prepare("DELETE FROM OneTimeUnlockSchedule WHERE  Site <> ? AND DeviceNo = ?");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value) );
	        }
            
            $sth    = $this->conn->prepare("DELETE FROM UnlockDoor WHERE  Site <> ? AND ElementNo = ? AND UnlockNo IN ( SELECT No FROM UnlockSchedule WHERE SelectType = 1 )");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value) );
	        }
            // Admin By Site로 인해 관계된 테이블들에서 변화된 Element들을 삭제 2015.05.19 by Zeno 끝
            
            $sth    = $this->conn->prepare("UPDATE Reader SET Site=1 WHERE Site=?");
	        if ($sth->execute(array($No)))
	        {   
	            $sth    = $this->conn->prepare("UPDATE Reader SET Site=?, RegionNo = 0, OppRegionNo = 0 WHERE (No=(Select MasterReader FROM Door WHERE No=?)) OR (No=(Select SlaveReader FROM Door WHERE No=?))");
	            foreach( $Element2 as $value )
	            {
	                $sth->execute( array($No, $value, $value) );
	            }
	        }
            
            $sth    = $this->conn->prepare("UPDATE DoorLock SET Site=1 WHERE Site=?");
	        if ($sth->execute(array($No)))
	        {   
	            $sth    = $this->conn->prepare("UPDATE DoorLock SET Site=? WHERE No=?");
	            foreach( $Element2 as $value )
	            {
	                $sth->execute( array($No,$value) );
	            }
	        }
	        
	        $sth    = $this->conn->prepare("UPDATE DoorRex SET Site=1 WHERE Site=?");
	        if ($sth->execute(array($No)))
	        {   
	            $sth    = $this->conn->prepare("UPDATE DoorRex SET Site=? WHERE No=?");
	            foreach( $Element2 as $value )
	            {
	                $sth->execute( array($No,$value) );
	            }
	        }

            $sth    = $this->conn->prepare("UPDATE DoorContact SET Site=1 WHERE Site=?");
	        if ($sth->execute(array($No)))
	        {   
	            $sth    = $this->conn->prepare("UPDATE DoorContact SET Site=? WHERE No=?");
	            foreach( $Element2 as $value )
	            {
	                $sth->execute( array($No,$value) );
	            }
	        }

        }
        elseif ($DeviceKind == ConstTable::DEVICE_ELEVATOR)
        {
            
            $tablename = "Elevator";
            // Elevator는 Master 단위로 이동 2015.05.19 by Zeno
            $sth    = $this->conn->prepare("UPDATE ElevatorRelay SET Site=1 WHERE Site=?");
	        if ($sth->execute(array($No)))
	        {   
	            $sth    = $this->conn->prepare("UPDATE ElevatorRelay SET Site=? WHERE ElevatorNo = ?");
	            foreach( $Element2 as $value )
	            {
	                $sth->execute( array($No, $value) );
	            }
	        }
            
        }
        elseif ($DeviceKind == ConstTable::DEVICE_AUXINPUT)
        {
            
            $tablename = "AuxInput";
        }
        elseif ($DeviceKind == ConstTable::DEVICE_AUXOUTPUT)
        {
            $tablename = "AuxOutput";
            
            $sth    = $this->conn->prepare("DELETE FROM UnlockDoor WHERE  Site <> ? AND ElementNo = ? AND UnlockNo IN ( SELECT No FROM UnlockSchedule WHERE SelectType = 4 )");
            foreach( $Element2 as $value )
	        {
	            $sth->execute( array($No, $value) );
	        }
        }
        
        
        $sth    = $this->conn->prepare("UPDATE ".$tablename." SET Site=1 WHERE Site=?");
        if ($sth->execute(array($No)))
        {   
            $sth    = $this->conn->prepare("UPDATE ".$tablename." SET Site=? WHERE No=?");
            foreach( $Element2 as $value )
            {
                $sth->execute( array($No,$value) );
            }
            
            $this->log->set_log();
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
        //exec(SPIDER_COMM." send db");    
    }

    // ----------------------------------------------------------------------------------

    public function delete()
    {

    }

    // ----------------------------------------------------------------------------------
    
    public function get_door_select_value($No)
    {
        $list   = $this->conn->prepare("Select No, Name FROM Door WHERE Site=? AND Disable=0");
        $list->execute(array($No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        return $list;
    }
    
    public function get_elevator_select_value($No)
    {
        $list   = $this->conn->prepare("Select No, Name FROM Elevator WHERE Site=? AND Disable=0");
        $list->execute(array($No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        
        return $list;
    }
    
    public function get_auxinput_select_value($No)
    {
        $list   = $this->conn->prepare("Select No, Name FROM AuxInput WHERE Site=? AND Disable=0");
        $list->execute(array($No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        return $list;
    }

    public function get_auxoutput_select_value($No)
    {
        $list   = $this->conn->prepare("Select No, Name FROM AuxOutput WHERE Site=? AND Disable=0");
        $list->execute(array($No));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        return $list;
    }

    // ----------------------------------------------------------------------------------
}

?>