<?php


class smartreport extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
		$page	= $this->input->get('page', 1);

		if( $this->is_SuperAdmin() == true ) {
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM SR_Query, SR_Main WHERE SR_Query.ReportNo=SR_Main.No");
			$count->execute(array());
			$count	= $count->fetchColumn();

			$pagination		= new Pagination();
			$page_config	= $GLOBALS['page_config'];
			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$rows	= $this->conn->prepare("SELECT SR_Main.Name AS ReportName, SR_Query.No, SR_Query.Status, SR_Query.StartTime, SR_Query.EndTime, SR_Query.DBFilename, SR_Query.SRName FROM SR_Query, SR_Main WHERE SR_Query.ReportNo=SR_Main.No ORDER BY SR_Query.No DESC LIMIT ?, ?");
			$rows->execute(array($pagination->offset, $pagination->row_size));
			$rows	= $rows->fetchAll(PDO::FETCH_ASSOC);
		} else {
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM SR_Query, SR_Main, UserRoleReport WHERE SR_Query.ReportNo=SR_Main.No AND SR_Query.ReportNo=UserRoleReport.ReportNo AND UserRoleReport.Site=? AND UserRoleReport.UserRole=?");
			$count->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole']));
			$count	= $count->fetchColumn();

			$pagination		= new Pagination();
			$page_config	= $GLOBALS['page_config'];
			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$rows	= $this->conn->prepare("SELECT SR_Main.Name AS ReportName, SR_Query.No, SR_Query.Status, SR_Query.StartTime, SR_Query.EndTime, SR_Query.DBFilename, SR_Query.SRName FROM SR_Query, SR_Main, UserRoleReport WHERE SR_Query.ReportNo=SR_Main.No AND SR_Query.ReportNo=UserRoleReport.ReportNo AND UserRoleReport.Site=? AND UserRoleReport.UserRole=? ORDER BY SR_Query.No DESC LIMIT ?, ?");
			$rows->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole'], $pagination->offset, $pagination->row_size));
			$rows	= $rows->fetchAll(PDO::FETCH_ASSOC);
		}

        $vars['page']           = $page;
		$vars['rows']			= $rows;
		$vars['report_status_items']	= $this->get_report_status_items();
		$vars['pagination']		= $pagination;
        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function get_report_status_items()
    {
		return array(
			'0'	=> $this->lang->smartreport->queued,
			'1'	=> $this->lang->smartreport->running,
			'2'	=> $this->lang->smartreport->complete,
			'3'	=> $this->lang->smartreport->error,
            '4' => $this->lang->smartreport->canceled
		);
    }

    // ----------------------------------------------------------------------------------

   public function get_query($QueryNo)
    {
		$Query   = $this->conn->prepare("SELECT * FROM SR_Query WHERE No=?");
		$Query->execute(array($QueryNo));
		$Query   = $Query->fetch(PDO::FETCH_ASSOC);

		return $Query;
    }

    // ----------------------------------------------------------------------------------

   public function cancel()
    {
		$QueryNo = $this->input->get('no');
        $Query = $this->get_query($QueryNo);
        
        if( $Query['Status'] == '2' || $Query['Status'] == '3' )
        {
            $this->util->alert($this->lang->smartreport->makecomplete);
        }
        else if ($Query['Status'] == '4')
        {
            $this->util->alert($this->lang->smartreport->continuecancel);
        }
        else
        {
            exec(SPIDER_COMM." stopreport $QueryNo");
        }
		$this->util->redirect("/?c=smartreport");
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
		$QueryNo = $this->input->get('no');
		$Query = $this->get_query($QueryNo);

        if( $Query['Status'] == '1' )
        {
            exec(SPIDER_COMM." stopreport $QueryNo");
        }
        else
        {
            @unlink($Query['SRName']);

            $delete = $this->conn->prepare("DELETE FROM SR_Query WHERE No=?");
            $delete->executeSilent(array($QueryNo));
        }
		$this->util->redirect("/?c=smartreport");
    }

    // ----------------------------------------------------------------------------------

   public function down_text()
    {
		$QueryNo = $this->input->get('no');
		$Query = $this->get_query($QueryNo);

		$filename = pathinfo($Query['SRName'], PATHINFO_FILENAME) . '.txt';

		$fp = fopen($Query['SRName'], 'r');

		header("Content-Description: File Transfer");
		header("Content-Type: application/octet-stream");
		header("Content-Length: " . filesize($Query['SRName']));
		header("Content-Disposition: attachment; filename=\"".$filename."\"");
		header("Content-Transfer-Encoding: Binary");
		header("Pragma: no-cache; public");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Expires: 0");

		fpassthru($fp);
    }

    // ----------------------------------------------------------------------------------

   public function down_csv()
    {
		$QueryNo = $this->input->get('no');
		$Query = $this->get_query($QueryNo);

		$filename = pathinfo($Query['SRName'], PATHINFO_BASENAME);

		$fp = fopen($Query['SRName'], 'r');

		header("Content-Description: File Transfer");
		header("Content-Type: application/octet-stream");
		header("Content-Length: " . filesize($Query['SRName']));
		header("Content-Disposition: attachment; filename=\"".$filename."\"");
		header("Content-Transfer-Encoding: Binary");
		header("Pragma: no-cache; public");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Expires: 0");

		fpassthru($fp);
    }

    // ----------------------------------------------------------------------------------

   public function down_html()
    {
		$QueryNo = $this->input->get('no');
		$Query = $this->get_query($QueryNo);

		$filename = pathinfo($Query['SRName'], PATHINFO_FILENAME) . '.html';

		$fp = fopen($Query['SRName'], 'r');

		header("Content-Description: File Transfer");
		header("Content-Type: application/octet-stream");
		//header("Content-Length: " . filesize($Query['SRName']));
		header("Content-Disposition: attachment; filename=\"".$filename."\"");
		header("Content-Transfer-Encoding: Binary");
		header("Pragma: no-cache; public");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Expires: 0");

		echo "<html><body><table>\n\n";
		while (($line = fgetcsv($fp)) !== false) {
			echo "<tr>";
			foreach ($line as $cell) {
				echo "<td>" . htmlspecialchars($cell) . "</td>";
			}
			echo "</tr>\n";
		}
		echo "\n</table></body></html>";

		fclose($fp);
    }

    // ----------------------------------------------------------------------------------

   public function viewer()
    {
		$page = $this->input->get('page', 1);
		$QueryNo = $this->input->get('no');
		$Query = $this->get_query($QueryNo);
		$Report = $this->get_report($Query['ReportNo']);;

		$TotalCnt = intval(exec("wc -l '{$Query['SRName']}'"));

		$pagination		= new Pagination();
		$page_config	= $GLOBALS['page_config'];
		$page_config['current_page']	= $page;
		$page_config['total_row']		= $TotalCnt;
		$page_config['row_size']		= $Report['LineCnt'];
		$pagination->init($page_config, $Report['LineCnt']);

		$fp = fopen($Query['SRName'], 'r');

		$vars['fp']			= $fp;
		$vars['no']			= $QueryNo;
		$vars['page']		= $page;
		$vars['pagination']	= $pagination;
		$vars['Report']		= $Report;
        $this->display($vars, 'smartreport_viewer', 'none');

		fclose($fp);
    }

    // ----------------------------------------------------------------------------------

   public function preview()
    {
		$QueryNo = $this->input->get('no');
		$Query = $this->get_query($QueryNo);
		$Report = $this->get_report($Query['ReportNo']);;

		$fp = fopen($Query['SRName'], 'r');

		$vars['fp']			= $fp;
		$vars['no']			= $QueryNo;
		$vars['Report']		= $Report;
        $this->display($vars, 'smartreport_preview', 'none');

		fclose($fp);
    }

    // ----------------------------------------------------------------------------------

   public function get_report($ReportNo)
    {
		$Report   = $this->conn->prepare("SELECT * FROM SR_Main WHERE Site=? AND No=?");
		$Report->execute(array($_SESSION['spider_site'], $ReportNo));
		$Report   = $Report->fetch(PDO::FETCH_ASSOC);

		$ColFormats   = $this->conn->prepare("SELECT * FROM SR_ColFormat WHERE ReportNo=?");
		$ColFormats->execute(array($ReportNo));
		$Report['ColFormats']   = $ColFormats->fetchAll(PDO::FETCH_ASSOC);

		return $Report;
    }

    // ----------------------------------------------------------------------------------

}
