<?php


class smartreport_set extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
        $this->display($vars);
    }

	// ----------------------------------------------------------------------------------

   public function get_condition_fields()
	{
		$fields = array(
			'Log.No'	      => 'No',
			'Log.LogDateTime' => 'DateTime',
			'Log.LogDate'     => 'Date',
			'Log.DeviceName'  => 'Device Name',
			'ReaderNo'		  => 'Reader',
			'DoorContactNo'	  => 'Door Contact',
			'DoorRexNo'		  => 'Rex',
			'DoorLockNo'	  => 'Door Lock',
			'AuxInputNo'	  => 'Aux Input',
			'AuxOutputNo'	  => 'Aux Output',
			'Log.UserNo'	  => 'User ID',
			'Log.UserName'	  => 'User Name',
			'Log.CardNo'	  => 'Card Number',
			'Log.EventCode'	  => 'Event Code',
			//'Log.EventName'	  => 'Event Name',
			'Log.Type'	      => 'Type',
			//'Log.Port'	      => 'Port',
			'Log.Area' 	      => 'Area',
			'Log.CardFacility'=> 'Card Facility',
			'Log.Ack'	      => 'Ack',
			'Log.Message'	  => 'Message'
		);

		$userdefined	= $this->conn->prepare("SELECT * FROM UserDefined WHERE Site=? LIMIT 1");
		$userdefined->execute(array($_SESSION['spider_site']));
		$userdefined	= $userdefined->fetch(PDO::FETCH_ASSOC);
		if( $userdefined ) {
			foreach( $userdefined as $column=>$value ) {
				if( substr($column, 0, 4) == 'User' && !empty($value) ) {
					$column = str_replace('User', 'UserDefine', $column);
					$fields["User.{$column}"] = $value;
				}
			}
		}

		return $fields;
    }

	// ----------------------------------------------------------------------------------

   public function get_report_fields()
	{
		$fields = array(
			'Log.No'	      => 'No',
			'Log.LogDateTime' => 'DateTime',
			'Log.LogDate'     => 'Date',
			'Log.LogTime'     => 'Time',
			'Log.DeviceName'  => 'Device Name',
			'Log.UserNo'	  => 'User ID',
			'Log.UserName'	  => 'User Name',
			'Log.CardNo'	  => 'Card Number',
			'Log.EventCode'	  => 'Event Code',
			'Log.EventName'	  => 'Event Name',
			'Log.Type'	      => 'Type',
			//'Log.Port'	      => 'Port',
			'Log.Area' 	      => 'Area',
			'Log.UserImage'	  => 'User Image',
			'Log.CardFacility'=> 'Card Facility',
			'Log.Ack'	      => 'Ack',
			'Log.Res1'	      => 'Res1',
			'Log.Res2'	      => 'Res2',
			'Log.Res3'	      => 'Res3',
			'Log.Message'	  => 'Message'
		);

		$userdefined	= $this->conn->prepare("SELECT * FROM UserDefined WHERE Site=? LIMIT 1");
		$userdefined->execute(array($_SESSION['spider_site']));
		$userdefined	= $userdefined->fetch(PDO::FETCH_ASSOC);
		if( $userdefined ) {
			foreach( $userdefined as $column=>$value ) {
				if( substr($column, 0, 4) == 'User' && !empty($value) ) {
					$column = str_replace('User', 'UserDefine', $column);
					$fields["User.{$column}"] = $value;
				}
			}
		}

		return $fields;
    }

	// ----------------------------------------------------------------------------------

   public function select()
	{
		$field	= $this->input->get('f');
		$word	= $this->input->get('w');
		$page	= $this->input->get('p', 1);
		$view	= $this->input->get('v');

		$page_config	= $GLOBALS['page_config'];
		$pagination		= new Pagination();

		if( empty($field) || empty($word) )
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM Report WHERE Site=?");
			$count->execute(array($_SESSION['spider_site']));
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM Report WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}
		else
		{
			$count	= $this->conn->prepare("SELECT COUNT(*) FROM Report WHERE Site=? AND $field LIKE ?");
			$count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
			$count	= $count->fetchColumn();

			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			$list	= $this->conn->prepare("SELECT * FROM Report WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
			$list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
			$list	= $list->fetchAll(PDO::FETCH_ASSOC);
		}

		$result['field']		= $field;
		$result['word']			= $word;
		$result['page']			= $page;
		$result['view']			= $view;
		$result['pages']		= $pagination->get_pages();
		$result['count']		= $count;
		$result['list']			= $list;

		echo json_encode($result);
	}

	// ----------------------------------------------------------------------------------

   public function select_condition()
	{
		$ReportNo	= $this->input->get('No');

		$list	= $this->conn->prepare("SELECT * FROM ReportCondition WHERE Site=? AND ReportNo=? ORDER BY No ASC");
		$list->execute(array($_SESSION['spider_site'], $ReportNo));
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);

		echo json_encode($list);
	}

	// ----------------------------------------------------------------------------------

   public function select_field()
	{
		$ReportNo	= $this->input->get('No');

		$list	= $this->conn->prepare("SELECT * FROM ReportField WHERE Site=? AND ReportNo=? ORDER BY No ASC");
		$list->execute(array($_SESSION['spider_site'], $ReportNo));
		$list	= $list->fetchAll(PDO::FETCH_ASSOC);

		echo json_encode($list);
	}

	// ----------------------------------------------------------------------------------

   public function newrow()
	{
		$vars['eventcodes']		= $this->to_eventcode();
		$vars['logtypes']		= $this->to_logtype();
		$vars['readers']		= $this->to_reader();
		$vars['doorcontacts']	= $this->to_doorcontact();
		$vars['doorrexs']		= $this->to_doorrex();
		$vars['doorlocks']		= $this->to_doorlock();
		$vars['auxinputs']		= $this->to_auxinput();
		$vars['auxoutputs']		= $this->to_auxoutput();

		$this->display($vars, 'smartreport_set_new', FALSE);
	}

	// ----------------------------------------------------------------------------------

   public function edit()
	{
        $No             = $this->input->get('No');

        $row = $this->conn->prepare("SELECT * FROM Report WHERE Site=? AND No=?");
        $row->execute(array($_SESSION['spider_site'], $No));
        $row = $row->fetch(PDO::FETCH_ASSOC);

		$vars['row']	= $row;

		$vars['eventcodes']		= $this->to_eventcode();
		$vars['logtypes']		= $this->to_logtype();
		$vars['readers']		= $this->to_reader();
		$vars['doorcontacts']	= $this->to_doorcontact();
		$vars['doorrexs']		= $this->to_doorrex();
		$vars['doorlocks']		= $this->to_doorlock();
		$vars['auxinputs']		= $this->to_auxinput();
		$vars['auxoutputs']		= $this->to_auxoutput();

		$this->display($vars, 'smartreport_set_edit', FALSE);
	}

	// ----------------------------------------------------------------------------------

   public function insert()
	{
		$Name	= strip_tags($this->input->post('Name'));
		$conditions_field	= $this->input->post('conditions_field', array());
		$fields_field	= $this->input->post('fields_field', array());

        if( empty($Name) )						$this->util->alert( $this->lang->menu->error_name_required, TRUE );
        if( count($conditions_field) < 1 )		$this->util->alert( $this->lang->menu->error_condition_required, TRUE );
        if( count($fields_field) < 1 )			$this->util->alert( $this->lang->menu->error_field_required, TRUE );

        $No = $this->conn->prepare("SELECT MAX(No) FROM Report");
        $No->execute();
        $No = $No->fetchColumn() + 1;

		$ConditionCount	= count($conditions_field);
		$FieldCount	= count($fields_field);

		$sth    = $this->conn->prepare("INSERT INTO Report (Site,No,Name,ConditionCount,FieldCount) VALUES (?,?,?,?,?)");
		if( !$sth->execute(array($_SESSION['spider_site'],$No,$Name,$ConditionCount,$FieldCount)) )
        {
        	$this->util->alert($this->lang->common->error_insert, TRUE);
        }

		$this->save_condition($No);
		$this->save_field($No);

        $this->log->set_log();
		$this->util->js('parent.load_list(); parent.open_edit("'.$No.'");');
        $this->util->alert( $this->lang->common->save_completed );
	}

	// ----------------------------------------------------------------------------------

   public function update()
	{
		$Name	= strip_tags($this->input->post('Name'));
		$conditions_field	= $this->input->post('conditions_field', array());
		$fields_field	= $this->input->post('fields_field', array());

        if( empty($Name) )						$this->util->alert( $this->lang->menu->error_name_required, TRUE );
        if( count($conditions_field) < 1 )		$this->util->alert( $this->lang->menu->error_condition_required, TRUE );
        if( count($fields_field) < 1 )			$this->util->alert( $this->lang->menu->error_field_required, TRUE );

        $No             = $this->input->post('No');

		$ConditionCount	= count($conditions_field);
		$FieldCount	= count($fields_field);

		$sth    = $this->conn->prepare("UPDATE Report SET Name=?,ConditionCount=?,FieldCount=? WHERE Site=? AND No=?");
		if( !$sth->execute(array($this->input->post('Name'),$ConditionCount,$FieldCount,$_SESSION['spider_site'],$No)) )
        {
            $this->util->alert($this->lang->common->error_update, TRUE);
        }

		$this->save_condition($No);
		$this->save_field($No);

        $this->log->set_log();
		$this->util->js('parent.load_list(); parent.open_edit("'.$No.'");');
        $this->util->alert( $this->lang->common->save_completed );
	}

	// ----------------------------------------------------------------------------------

   public function save_condition($ReportNo)
	{
		$sth    = $this->conn->prepare("DELETE FROM ReportCondition WHERE Site=? AND ReportNo=?");
		if( !$sth->execute(array($_SESSION['spider_site'], $ReportNo)) )
        {
            $this->util->alert($this->lang->common->error_delete, TRUE);
        }

        $InsertNo = $this->conn->prepare("SELECT MAX(No) FROM ReportCondition");
        $InsertNo->execute();
        $InsertNo = $InsertNo->fetchColumn() + 1;

		$conditions_field	= $this->input->post('conditions_field', array());
		$conditions_type	= $this->input->post('conditions_type', array());
		$conditions_value	= $this->input->post('conditions_value', array());
		$sth    = $this->conn->prepare("INSERT INTO ReportCondition (Site,No,ReportNo,FieldName,ConditionType,ConstValue) VALUES (?,?,?,?,?,?)");
		foreach( $conditions_field as $key=>$value )
		{
			$sth->execute(array(
				$_SESSION['spider_site'],
				$InsertNo,
				$ReportNo,
				$conditions_field[$key],
				$conditions_type[$key],
				$conditions_value[$key]
			));
			$InsertNo++;
		}
	}

	// ----------------------------------------------------------------------------------

   public function save_field($ReportNo)
	{
		$sth    = $this->conn->prepare("DELETE FROM ReportField WHERE Site=? AND ReportNo=?");
		if( !$sth->execute(array($_SESSION['spider_site'], $ReportNo)) )
        {
            $this->util->alert($this->lang->common->error_delete, TRUE);
        }

        $InsertNo = $this->conn->prepare("SELECT MAX(No) FROM ReportField");
        $InsertNo->execute();
        $InsertNo = $InsertNo->fetchColumn() + 1;

		$fields_field	= $this->input->post('fields_field', array());
		$fields_name	= $this->input->post('fields_name', array());
		$fields_size	= $this->input->post('fields_size', array());
		$sth    = $this->conn->prepare("INSERT INTO ReportField (Site,No,ReportNo,FieldName,OutputName,Size) VALUES (?,?,?,?,?,?)");
		foreach( $fields_field as $key=>$value )
		{
			$sth->execute(array(
				$_SESSION['spider_site'],
				$InsertNo,
				$ReportNo,
				$fields_field[$key],
				$fields_name[$key],
				$fields_size[$key]
			));
			//echo $InsertNo.'<br>';
			$InsertNo++;
		}
	}

	// ----------------------------------------------------------------------------------

   public function delete()
	{
        $No = $this->input->get('no');
    	
		$sth = $this->conn->prepare("DELETE FROM Report WHERE Site=? AND No=?");
		if( $sth->execute(array($_SESSION['spider_site'],$No)) )
        {
			$sth    = $this->conn->prepare("DELETE FROM ReportCondition WHERE Site=? AND ReportNo=?");
			$sth->execute(array($_SESSION['spider_site'], $No));

			$sth    = $this->conn->prepare("DELETE FROM ReportField WHERE Site=? AND ReportNo=?");
			$sth->execute(array($_SESSION['spider_site'], $No));
        }
	}

    // ----------------------------------------------------------------------------------

   public function to_eventcode()
    {
        $list = $this->conn->prepare("SELECT * FROM EventCode");
        $list->execute();
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['EventCode']]  = $val['Name'];
        }
        
        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_logtype()
    {
		$logtypes = array(
			'0'		=>	$this->lang->addmsg->log_web,
			'1'		=>	$this->lang->addmsg->log_readerin,
			'2'		=>	$this->lang->addmsg->log_contact,
			'3'		=>	$this->lang->addmsg->log_rex,
			'4'		=>	$this->lang->addmsg->log_auxoutput,
			'5'		=>	$this->lang->addmsg->log_auxinput,
			'6'		=>	$this->lang->addmsg->log_doorlock,
			'7'		=>	$this->lang->addmsg->log_system,
			'8'		=>	$this->lang->addmsg->log_network,
			'9'		=>	$this->lang->addmsg->log_elevator,
			'10'	=>	$this->lang->addmsg->log_elevatorout
			);

		return $logtypes;
		//return array_combine(array_values($logtypes), array_keys($logtypes));
    }

    // ----------------------------------------------------------------------------------

   public function to_reader()
    {
        $list = $this->conn->prepare("SELECT * FROM Reader WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]  = $val['Name'];
        }
        
        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_doorcontact()
    {
        $list = $this->conn->prepare("SELECT * FROM DoorContact WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]  = $val['Name'];
        }
        
        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_doorrex()
    {
        $list = $this->conn->prepare("SELECT * FROM DoorRex WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]  = $val['Name'];
        }
        
        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_doorlock()
    {
        $list = $this->conn->prepare("SELECT * FROM DoorLock WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]  = $val['Name'];
        }
        
        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_auxinput()
    {
        $list = $this->conn->prepare("SELECT * FROM AuxInput WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]  = $val['Name'];
        }
        
        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_auxoutput()
    {
        $list = $this->conn->prepare("SELECT * FROM AuxOutput WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list = $list->fetchAll(PDO::FETCH_ASSOC);

		$arr = array();
        foreach( $list as $key=>$val)
        {
            $arr[$val['No']]  = $val['Name'];
        }
        
        return $arr;
    }

    // ----------------------------------------------------------------------------------

}

?>