<?php
include APP_DIR.'/libraries/Uploader.php';

class smartreport_set extends controller
{

    // ----------------------------------------------------------------------------------

   public function index()
    {
		$page	= $this->input->get('page', 1);

		if( $this->is_SuperAdmin() == true ) 
		{
			if($_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE || 
			   $_SESSION['spider_model'] == ConstTable::MODEL_GIANT ||
				($_SESSION['spider_model'] == ConstTable::MODEL_ELITE && $this->is_option(ConstTable::OPTION_REGION))) 
				$count	= $this->conn->prepare("SELECT COUNT(*) FROM SR_Main WHERE Site=?");
			else
				$count	= $this->conn->prepare("SELECT COUNT(*) FROM SR_Main WHERE Site=? AND ReportType NOT IN (6, 7, 8)");				
				
			$count->execute(array($_SESSION['spider_site']));
			$count	= $count->fetchColumn();

			$pagination		= new Pagination();
			$page_config	= $GLOBALS['page_config'];
			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			if($_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE || 
			   $_SESSION['spider_model'] == ConstTable::MODEL_GIANT ||
				($_SESSION['spider_model'] == ConstTable::MODEL_ELITE && $this->is_option(ConstTable::OPTION_REGION))) 
				$rows	= $this->conn->prepare("SELECT * FROM SR_Main WHERE Site=? ORDER BY No ASC LIMIT ?, ?");
			else
				$rows	= $this->conn->prepare("SELECT * FROM SR_Main WHERE Site=? AND ReportType NOT IN (6, 7, 8) ORDER BY No ASC LIMIT ?, ?");
			
			$rows->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
			$rows	= $rows->fetchAll(PDO::FETCH_ASSOC);
		} 
		else 
		{
			if($_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE ||
			   $_SESSION['spider_model'] == ConstTable::MODEL_GIANT ||
				($_SESSION['spider_model'] == ConstTable::MODEL_ELITE && $this->is_option(ConstTable::OPTION_REGION))) 
				$count	= $this->conn->prepare("SELECT COUNT(*) FROM SR_Main, UserRoleReport WHERE SR_Main.Site=? AND SR_Main.Site=UserRoleReport.Site AND SR_Main.No=UserRoleReport.ReportNo AND UserRoleReport.UserRole=?");
			else
				$count	= $this->conn->prepare("SELECT COUNT(*) FROM SR_Main, UserRoleReport WHERE SR_Main.Site=? AND SR_Main.ReportType NOT IN (6, 7, 8) AND SR_Main.Site=UserRoleReport.Site AND SR_Main.No=UserRoleReport.ReportNo AND UserRoleReport.UserRole=?");
			
			$count->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole']));
			$count	= $count->fetchColumn();

			$pagination		= new Pagination();
			$page_config	= $GLOBALS['page_config'];
			$page_config['current_page']	= $page;
			$page_config['total_row']		= $count;
			$pagination->init($page_config);

			if($_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE || 
			   $_SESSION['spider_model'] == ConstTable::MODEL_GIANT ||
				($_SESSION['spider_model'] == ConstTable::MODEL_ELITE && $this->is_option(ConstTable::OPTION_REGION))) 
				$rows	= $this->conn->prepare("SELECT SR_Main.* FROM SR_Main, UserRoleReport WHERE SR_Main.Site=? AND SR_Main.Site=UserRoleReport.Site AND SR_Main.No=UserRoleReport.ReportNo AND UserRoleReport.UserRole=? ORDER BY SR_Main.No ASC LIMIT ?, ?");
			else
				$rows	= $this->conn->prepare("SELECT SR_Main.* FROM SR_Main, UserRoleReport WHERE SR_Main.Site=? AND SR_Main.ReportType NOT IN (6, 7, 8) AND SR_Main.Site=UserRoleReport.Site AND SR_Main.No=UserRoleReport.ReportNo AND UserRoleReport.UserRole=? ORDER BY SR_Main.No ASC LIMIT ?, ?");
			$rows->execute(array($_SESSION['spider_site'], $_SESSION['spider_userrole'], $pagination->offset, $pagination->row_size));
			$rows	= $rows->fetchAll(PDO::FETCH_ASSOC);
		}

        $vars['page']           = $page;
		$vars['rows']			= $rows;
		$vars['pagination']		= $pagination;
        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function newone()
    {
		$vars['datecond_type2_kind_items']	= $this->get_datecond_type2_kind_items();
		$vars['timecond_type2_kind_items']	= $this->get_timecond_type2_kind_items();
		$vars['holiday_items']	= $this->get_holiday_items();
		$vars['attr_items']	= $this->get_attr_items();
		$vars['relation_items']	= $this->get_relation_items();
		$vars['column_items']	= $this->get_column_items();
		$vars['sort_items']	= $this->get_sort_items();
        $this->display($vars, 'smartreport_set_new');
    }

    // ----------------------------------------------------------------------------------

   public function edit()
    {
		$ReportNo = $this->input->get('no');

		$vars['datecond_type2_kind_items']	= $this->get_datecond_type2_kind_items();
		$vars['timecond_type2_kind_items']	= $this->get_timecond_type2_kind_items();
		$vars['holiday_items']	= $this->get_holiday_items();
		$vars['attr_items']	= $this->get_attr_items();
		$vars['relation_items']	= $this->get_relation_items();
		$vars['column_items']	= $this->get_column_items();
		$vars['sort_items']	= $this->get_sort_items();
		$vars['Report'] = $this->get_report($ReportNo);
        $this->display($vars, 'smartreport_set_edit');
    }

    // ----------------------------------------------------------------------------------

   public function insert()
    {
        $ReportType = $this->input->post('ReportType');
        
        $ReportName = strip_tags(trim($this->input->post('ReportName')));
		$LimitCnt = $this->input->post('LimitCnt', 1000);
		$LineCnt = $this->input->post('LineCnt', 20);

        $LimitCnt = ceil($LimitCnt);
        $LineCnt = ceil($LineCnt);
        
		if( empty($ReportName) )	$this->util->alert( $this->lang->smartreport_set->error_reportname_required, TRUE );
		if( empty($LimitCnt) || $LimitCnt <= 0 )		$this->util->alert( $this->lang->smartreport_set->error_limitcnt_required, TRUE );
		if( intval($LimitCnt) > 5000 )		$this->util->alert( $this->lang->smartreport_set->error_limitcnt_too_big, TRUE );
		if( empty($LineCnt) || $LineCnt <= 0 )		$this->util->alert( $this->lang->smartreport_set->error_linecnt_required, TRUE );
        
        if( empty($ReportType) ){
            $ReportType = 0;
        }

        $Duplication = $this->conn->prepare("SELECT COUNT(No) from SR_Main WHERE Site=? AND Name=?");
        $Duplication->execute(array($_SESSION['spider_site'], $ReportName));
        $Duplication = $Duplication->fetchColumn();
		if( $Duplication > 0 )	$this->util->alert( $this->lang->smartreport_set->error_reportname_duplication, TRUE );

        $ReportNo = $this->conn->prepare("SELECT MAX(No) from SR_Main WHERE Site=?");
        $ReportNo->execute(array($_SESSION['spider_site']));
        $ReportNo = $ReportNo->fetchColumn() + 1;

		$this->conn->exec("BEGIN TRANSACTION");

        $sth    = $this->conn->prepare("INSERT INTO SR_Main (Site,No,Name,LimitCnt,LineCnt,ReportType) VALUES (?,?,?,?,?,?)");
        $values = array($_SESSION['spider_site'], $ReportNo, $ReportName, $LimitCnt, $LineCnt, $ReportType);
		if( $sth->executeSilent($values) ) {
			$this->save_datetime($ReportNo);
			$this->save_cardholder($ReportNo);
			$this->save_card($ReportNo);
			$this->save_door($ReportNo);
			$this->save_elevator($ReportNo);
			$this->save_event($ReportNo);
			$this->save_column($ReportNo);
			$this->save_userrole($ReportNo);
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}

		$this->conn->exec("COMMIT TRANSACTION");
        $this->log->set_log();
        
		$WithRun = $this->input->post('withrun');
		if( $WithRun == '1' ) {
			$this->util->redirect("/?c=smartreport_set&m=run&no={$ReportNo}");
		} else {
			$this->util->redirect("/?c=smartreport_set");
		}
    }

    // ----------------------------------------------------------------------------------

   public function update()
    {
		$ReportNo = $this->input->post('ReportNo');
		$ReportName = strip_tags(trim($this->input->post('ReportName')));
		$LimitCnt = $this->input->post('LimitCnt', 1000);
		$LineCnt = $this->input->post('LineCnt', 20);

        $LimitCnt = ceil($LimitCnt);
        $LineCnt = ceil($LineCnt);
        
		if( empty($ReportNo) )		$this->util->alert( $this->lang->smartreport_set->error_reportno_missing, TRUE );
		if( empty($ReportName) )	$this->util->alert( $this->lang->smartreport_set->error_reportname_required, TRUE );
		if( empty($LimitCnt) || $LimitCnt <= 0 )		$this->util->alert( $this->lang->smartreport_set->error_limitcnt_required, TRUE );
        if( intval($LimitCnt) > 5000 )		$this->util->alert( $this->lang->smartreport_set->error_limitcnt_too_big, TRUE );
		if( empty($LineCnt) || $LineCnt <= 0 )		$this->util->alert( $this->lang->smartreport_set->error_linecnt_required, TRUE );

        $Duplication = $this->conn->prepare("SELECT COUNT(No) from SR_Main WHERE Site=? AND Name=? AND No != ?");
        $Duplication->execute(array($_SESSION['spider_site'], $ReportName, $ReportNo));
        $Duplication = $Duplication->fetchColumn();
		if( $Duplication > 0 )	$this->util->alert( $this->lang->smartreport_set->error_reportname_duplication, TRUE );

		$this->conn->exec("BEGIN TRANSACTION");

        $sth    = $this->conn->prepare("UPDATE SR_Main SET Name=?, LimitCnt=?, LineCnt=? WHERE Site=? AND No=?");
        $values = array($ReportName, $LimitCnt, $LineCnt, $_SESSION['spider_site'], $ReportNo);
		if( $sth->executeSilent($values) ) {
			$this->save_datetime($ReportNo);
			$this->save_cardholder($ReportNo);
			$this->save_card($ReportNo);
			$this->save_door($ReportNo);
			$this->save_elevator($ReportNo);
			$this->save_event($ReportNo);
			$this->save_column($ReportNo);
			$this->save_userrole($ReportNo);
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}

		$this->conn->exec("COMMIT TRANSACTION");
        $this->log->set_log();
        
		$WithRun = $this->input->post('withrun');
		if( $WithRun == '1' ) {
			$this->util->redirect("/?c=smartreport_set&m=run&no={$ReportNo}");
		} else {
			$this->util->redirect("/?c=smartreport_set");
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_datetime($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_DateTime WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$InHoliNo = $this->input->post('InHoliNo');
		$ExHoliNo = $this->input->post('ExHoliNo');

        $DateTimeNo = $this->conn->prepare("SELECT MAX(No) from SR_DateTime");
        $DateTimeNo->execute(array());
        $DateTimeNo = $DateTimeNo->fetchColumn() + 1;

        $sth    = $this->conn->prepare("INSERT INTO SR_DateTime (No,ReportNo,InHoliNo,ExHoliNo) VALUES (?,?,?,?)");
        $values = array($DateTimeNo, $ReportNo, $InHoliNo, $ExHoliNo);
		if( $sth->executeSilent($values) ) {
			$this->save_datecond($DateTimeNo);
			$this->save_timecond($DateTimeNo);
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}
    }
	
    // ----------------------------------------------------------------------------------

   public function save_datecond($DateTimeNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_DateCond WHERE DateTimeNo=?");
		$delete->executeSilent(array($DateTimeNo));

		$ArrType = $this->input->post('DateCond_ArrType', array());
		$ArrTypeKind = $this->input->post('DateCond_ArrTypeKind', array());
		$ArrStartDate = $this->input->post('DateCond_ArrStartDate', array());
        $ArrEndDate = $this->input->post('DateCond_ArrEndDate', array());
        
		if( is_array($ArrType) ) {
			$DateCondNo = $this->conn->prepare("SELECT MAX(No) from SR_DateCond");
			$DateCondNo->execute(array());
			$DateCondNo = $DateCondNo->fetchColumn();

			foreach( $ArrType as $idx => $Type ) {
				$DateCondNo++;

				if( $Type == '2' && empty($ArrTypeKind[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_weekmonth_required, TRUE );
				}

				if( $Type == '3' && empty($ArrTypeKind[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_lastday_required, TRUE );
				}

				if( $Type == '4' && empty($ArrStartDate[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_startdate_required, TRUE );
				}

				if( $Type == '4' && empty($ArrEndDate[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_enddate_required, TRUE );
				}

				$sth    = $this->conn->prepare("INSERT INTO SR_DateCond (No,DateTimeNo,Type,TypeKind,StartDate,EndDate) VALUES (?,?,?,?,?,?)");
				$values = array($DateCondNo, $DateTimeNo, $Type, $ArrTypeKind[$idx], $ArrStartDate[$idx], $ArrEndDate[$idx]);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_timecond($DateTimeNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_TimeCond WHERE DateTimeNo=?");
		$delete->executeSilent(array($DateTimeNo));

		$ArrType = $this->input->post('TimeCond_ArrType', array());
		$ArrTypeKind = $this->input->post('TimeCond_ArrTypeKind', array());
		$ArrStartTime = $this->input->post('TimeCond_ArrStartTime', array());
		$ArrEndTime = $this->input->post('TimeCond_ArrEndTime', array());
		$ArrIsInTime = $this->input->post('TimeCond_ArrIsInTime', array());

		if( is_array($ArrType) ) {
			$TimeCondNo = $this->conn->prepare("SELECT MAX(No) from SR_TimeCond");
			$TimeCondNo->execute(array());
			$TimeCondNo = $TimeCondNo->fetchColumn();

			foreach( $ArrType as $idx => $Type ) {
				$TimeCondNo++;

				if( $Type == '3' && empty($ArrTypeKind[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_time_specification_required, TRUE );
				}

				if( $Type == '2' && empty($ArrStartTime[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_starttime_required, TRUE );
				}

				if( $Type == '2' && empty($ArrEndTime[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_endtime_required, TRUE );
				}

				$sth    = $this->conn->prepare("INSERT INTO SR_TimeCond (No,DateTimeNo,Type,StartTime,EndTime,IsInTime) VALUES (?,?,?,?,?,?)");
				$values = array($TimeCondNo, $DateTimeNo, $Type, $ArrStartTime[$idx], $ArrEndTime[$idx], $ArrIsInTime[$idx]);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_cardholder($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_Holders WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$HoldersType = $this->input->post('Holders_Type');

        $HoldersNo = $this->conn->prepare("SELECT MAX(No) from SR_Holders");
        $HoldersNo->execute(array());
        $HoldersNo = $HoldersNo->fetchColumn() + 1;

        $sth    = $this->conn->prepare("INSERT INTO SR_Holders (No,ReportNo,Type) VALUES (?,?,?)");
        $values = array($HoldersNo, $ReportNo, $HoldersType);
		if( $sth->executeSilent($values) ) {
			if( $HoldersType == '2' ) {
				$ArrElement = $this->input->post('Select_CardHolder', array());
				$this->save_elementtab(1, $HoldersNo, 0, $ArrElement);

				$ArrElement = $this->input->post('Select_CardHolderGroup', array());
				$this->save_elementtab(1, $HoldersNo, 1, $ArrElement);
			}

			$this->save_holderscond($HoldersNo);
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_holderscond($HoldersNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_HoldersCond WHERE SRHoldersNo=?");
		$delete->executeSilent(array($HoldersNo));

		$ArrAttr = $this->input->post('HoldersCond_ArrAttr', array());
		$ArrRelation = $this->input->post('HoldersCond_ArrRelation', array());
		$ArrValue = $this->input->post('HoldersCond_ArrValue', array());
		$ArrIsAsk = $this->input->post('HoldersCond_ArrIsAsk', array());

		if( is_array($ArrAttr) ) {
			$HoldersCondNo = $this->conn->prepare("SELECT MAX(No) from SR_HoldersCond");
			$HoldersCondNo->execute(array());
			$HoldersCondNo = $HoldersCondNo->fetchColumn();

			foreach( $ArrAttr as $idx => $Attr ) {
				$HoldersCondNo++;

				if( $ArrIsAsk[$idx] != '1' && empty($ArrValue[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_atttr_value_required, TRUE );
				}

				$sth    = $this->conn->prepare("INSERT INTO SR_HoldersCond (No,SRHoldersNo,Attr,Relation,IsAsk,Value) VALUES (?,?,?,?,?,?)");
				$values = array($HoldersCondNo, $HoldersNo, $ArrAttr[$idx], $ArrRelation[$idx], $ArrIsAsk[$idx], $ArrValue[$idx]);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_card($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_Cards WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$CardsType = $this->input->post('Cards_Type');

        $CardsNo = $this->conn->prepare("SELECT MAX(No) from SR_Cards");
        $CardsNo->execute(array());
        $CardsNo = $CardsNo->fetchColumn() + 1;

        $sth    = $this->conn->prepare("INSERT INTO SR_Cards (No,ReportNo,Type) VALUES (?,?,?)");
        $values = array($CardsNo, $ReportNo, $CardsType);
		if( $sth->executeSilent($values) ) {
			if( $CardsType == '2' ) {
				$ArrCard = $this->input->post('Select_Card', array());
				$this->save_elementtab(2, $CardsNo, 0, $ArrCard);

				$ArrCardType = $this->input->post('Select_CardType', array());
				$this->save_elementtab(2, $CardsNo, 1, $ArrCardType);
			}
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_door($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_Doors WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$DoorsType = $this->input->post('Doors_Type');

        $DoorsNo = $this->conn->prepare("SELECT MAX(No) from SR_Doors");
        $DoorsNo->execute(array());
        $DoorsNo = $DoorsNo->fetchColumn() + 1;

        $sth    = $this->conn->prepare("INSERT INTO SR_Doors (No,ReportNo,Type) VALUES (?,?,?)");
        $values = array($DoorsNo, $ReportNo, $DoorsType);
		if( $sth->executeSilent($values) ) {
			if( $DoorsType == '2' ) {
				$ArrDoor = $this->input->post('Select_Door', array());
				$this->save_elementtab(3, $DoorsNo, 0, $ArrDoor);

				$ArrThreatLevel = $this->input->post('Select_ThreatLevel', array());
				$this->save_elementtab(3, $DoorsNo, 1, $ArrThreatLevel);

				$ArrFloor = $this->input->post('Select_Floor', array());
				$this->save_elementtab(3, $DoorsNo, 2, $ArrFloor);
			}
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_elevator($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_Elevators WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$ElevatorsType = $this->input->post('Elevators_Type');

        $ElevatorsNo = $this->conn->prepare("SELECT MAX(No) from SR_Elevators");
        $ElevatorsNo->execute(array());
        $ElevatorsNo = $ElevatorsNo->fetchColumn() + 1;

        $sth    = $this->conn->prepare("INSERT INTO SR_Elevators (No,ReportNo,Type) VALUES (?,?,?)");
        $values = array($ElevatorsNo, $ReportNo, $ElevatorsType);
		if( $sth->executeSilent($values) ) {
			if( $ElevatorsType == '2' ) {
				$ArrElevator = $this->input->post('Select_Elevator', array());
				$this->save_elementtab(4, $ElevatorsNo, 0, $ArrElevator);

				$ArrElevatorRelay = $this->input->post('Select_Elevator_Relay', array());
				$this->save_elementtab(4, $ElevatorsNo, 1, $ArrElevatorRelay);

				$ArrElevatorFloor = $this->input->post('Select_Elevator_Floor', array());
				$this->save_elementtab(4, $ElevatorsNo, 2, $ArrElevatorFloor);
			}
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_event($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_Events WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$EventsType = $this->input->post('Events_Type');

        $EventsNo = $this->conn->prepare("SELECT MAX(No) from SR_Events");
        $EventsNo->execute(array());
        $EventsNo = $EventsNo->fetchColumn() + 1;

        $sth    = $this->conn->prepare("INSERT INTO SR_Events (No,ReportNo,Type) VALUES (?,?,?)");
        $values = array($EventsNo, $ReportNo, $EventsType);
		if( $sth->executeSilent($values) ) {
			if( $EventsType == '2' ) {
				$ArrEventGroup = $this->input->post('Select_EventGroup', array());
				$this->save_elementtab(5, $EventsNo, 0, $ArrEventGroup);

				$ArrEventCode = $this->input->post('Select_EventCode', array());
				$this->save_elementtab(5, $EventsNo, 1, $ArrEventCode);
			}
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_column($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_ColFormat WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$ArrColName = $this->input->post('ColFormat_ArrColName', array());
		$ArrTitle = $this->input->post('ColFormat_ArrTitle', array());
		$ArrWidth = $this->input->post('ColFormat_ArrWidth', array());
		$ArrSortOrder = $this->input->post('ColFormat_ArrSortOrder', array());

		if( empty($ArrColName) ) {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_column_required, TRUE );
		}

		if( is_array($ArrColName) ) {
			$ColFormatNo = $this->conn->prepare("SELECT MAX(No) from SR_ColFormat");
			$ColFormatNo->execute(array());
			$ColFormatNo = $ColFormatNo->fetchColumn();

			foreach( $ArrColName as $idx => $ColName ) {
				$ColFormatNo++;

				$sth    = $this->conn->prepare("INSERT INTO SR_ColFormat (No,ReportNo,ColName,Title,Width,SortOrder) VALUES (?,?,?,?,?,?)");
				$values = array($ColFormatNo, $ReportNo, $ArrColName[$idx], $ArrTitle[$idx], $ArrWidth[$idx], $ArrSortOrder[$idx]);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_userrole($ReportNo)
    {
		$delete = $this->conn->prepare("DELETE FROM UserRoleReport WHERE Site=? AND ReportNo=?");
		$delete->executeSilent(array($_SESSION['spider_site'], $ReportNo));

		$ArrUserRole = $this->input->post('Select_UserRole', array());

		if( is_array($ArrUserRole) ) {
			$UserRoleReportNo = $this->conn->prepare("SELECT MAX(No) from UserRoleReport");
			$UserRoleReportNo->execute(array());
			$UserRoleReportNo = $UserRoleReportNo->fetchColumn();

			foreach( $ArrUserRole as $idx => $UserRole ) {
				$UserRoleReportNo++;

				$sth    = $this->conn->prepare("INSERT INTO UserRoleReport (Site,No,UserRole,ReportNo,Disable) VALUES (?,?,?,?,?)");
				$values = array($_SESSION['spider_site'], $UserRoleReportNo, $UserRole, $ReportNo, 1);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function save_elementtab($CondKind, $CondKindNo, $ElementKind, $ArrElement)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_ElementTab WHERE CondKind=? AND CondKindNo=? AND ElementKind=?");
		$delete->executeSilent(array($CondKind, $CondKindNo, $ElementKind));

		if( is_array($ArrElement) ) {
			$ElementTabNo = $this->conn->prepare("SELECT MAX(No) from SR_ElementTab");
			$ElementTabNo->execute(array());
			$ElementTabNo = $ElementTabNo->fetchColumn();

			foreach( $ArrElement as $Element ) {
				$ElementTabNo++;

				$sth    = $this->conn->prepare("INSERT INTO SR_ElementTab (No,CondKind,CondKindNo,ElementKind,Element) VALUES (?,?,?,?,?)");
				$values = array($ElementTabNo, $CondKind, $CondKindNo, $ElementKind, $Element);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
		$ReportNo = $this->input->get('no');
		$Report = $this->get_report($ReportNo);

		$delete = $this->conn->prepare("DELETE FROM SR_Main WHERE Site=? AND No=?");
		$delete->executeSilent(array($_SESSION['spider_site'], $ReportNo));

		$delete = $this->conn->prepare("DELETE FROM UserRoleReport WHERE Site=? AND ReportNo=?");
		$delete->executeSilent(array($_SESSION['spider_site'], $ReportNo));

		$delete = $this->conn->prepare("DELETE FROM SR_ColFormat WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$delete = $this->conn->prepare("DELETE FROM SR_DateTime WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$delete = $this->conn->prepare("DELETE FROM SR_DateCond WHERE DateTimeNo=?");
		$delete->executeSilent(array($Report['DateTime']['No']));

		$delete = $this->conn->prepare("DELETE FROM SR_TimeCond WHERE DateTimeNo=?");
		$delete->executeSilent(array($Report['DateTime']['No']));

		$delete = $this->conn->prepare("DELETE FROM SR_Holders WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$delete = $this->conn->prepare("DELETE FROM SR_HoldersCond WHERE SRHoldersNo=?");
		$delete->executeSilent(array($Report['Holders']['No']));

		$delete = $this->conn->prepare("DELETE FROM SR_Cards WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$delete = $this->conn->prepare("DELETE FROM SR_Doors WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$delete = $this->conn->prepare("DELETE FROM SR_Elevators WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$delete = $this->conn->prepare("DELETE FROM SR_Events WHERE ReportNo=?");
		$delete->executeSilent(array($ReportNo));

		$this->delete_elementtab(1, $Report['Holders']['No'], 0);
		$this->delete_elementtab(1, $Report['Holders']['No'], 1);
		$this->delete_elementtab(2, $Report['Cards']['No'], 0);
		$this->delete_elementtab(2, $Report['Cards']['No'], 1);
		$this->delete_elementtab(3, $Report['Doors']['No'], 0);
		$this->delete_elementtab(3, $Report['Doors']['No'], 1);
		$this->delete_elementtab(3, $Report['Doors']['No'], 2);
		$this->delete_elementtab(4, $Report['Elevators']['No'], 0);
		$this->delete_elementtab(5, $Report['Events']['No'], 0);
		$this->delete_elementtab(5, $Report['Events']['No'], 1);

        $this->log->set_log();
		$this->util->redirect("/?c=smartreport_set");
    }

    // ----------------------------------------------------------------------------------

   public function delete_elementtab($CondKind, $CondKindNo, $ElementKind)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_ElementTab WHERE CondKind=? AND CondKindNo=? AND ElementKind=?");
		$delete->executeSilent(array($CondKind, $CondKindNo, $ElementKind));
    }

    // ----------------------------------------------------------------------------------

   public function copy()
    {
		$ReportNo = $this->input->get('no');
		$Report = $this->get_report($ReportNo);

		$vars['datecond_type2_kind_items']	= $this->get_datecond_type2_kind_items();
		$vars['timecond_type2_kind_items']	= $this->get_timecond_type2_kind_items();
		$vars['holiday_items']	= $this->get_holiday_items();
		$vars['attr_items']	= $this->get_attr_items();
		$vars['relation_items']	= $this->get_relation_items();
		$vars['column_items']	= $this->get_column_items();
		$vars['sort_items']	= $this->get_sort_items();
		$vars['Report'] = $Report;
        $this->display($vars, 'smartreport_set_copy');
    }

    // ----------------------------------------------------------------------------------

   public function run()
    {
		$ReportNo = $this->input->get('no');

		$vars['datecond_type2_kind_items']	= $this->get_datecond_type2_kind_items();
		$vars['timecond_type2_kind_items']	= $this->get_timecond_type2_kind_items();
		$vars['holiday_items']	= $this->get_holiday_items();
		$vars['attr_items']	= $this->get_attr_items();
		$vars['relation_items']	= $this->get_relation_items();
		$vars['column_items']	= $this->get_column_items();
		$vars['sort_items']	= $this->get_sort_items();
		$vars['sd_list']	= $this->get_sd();
		$vars['Report'] = $this->get_report($ReportNo);
		$vars['ask_tabs']	= $this->get_ask_tabs($vars['Report']);
        $this->display($vars, 'smartreport_set_run');
    }

    // ----------------------------------------------------------------------------------

   public function exe()
    {
		$ReportNo = $this->input->post('ReportNo');
		$DbFileKind = $this->input->post('DbFileKind', '0');

        if( $DbFileKind == '1' ) {
			$sd_file	= $this->input->post('sd_file_name');
			if( !file_exists($sd_file) )	$this->util->alert( $this->lang->smartreport->error_db_required, TRUE );

			$DbFilename = $sd_file;
            
		} else if( $DbFileKind == '2' ) {
            $file = $this->receive();
            
			if( $file == FALSE )	$this->util->alert( $this->lang->smartreport->error_db_required, TRUE );
			
            $DbFilename = "/spider/web/webroot/tmp_data/".$file;
            
		} else if( $DbFileKind == '3' ) {
            $sd_file	= $this->input->post('sd_file_name');
			if( !file_exists($sd_file) )	$this->util->alert( $this->lang->smartreport->error_db_required, TRUE );
            
            $DbFilename = $sd_file;
            
        }else{
            
			$DbFilename = DATABASE_DIR.'/SpiderLog.db';
        }

        $this->conn->exec("BEGIN TRANSACTION");
        $sth    = $this->conn->prepare("UPDATE SR_Main SET Location=?, DBFilename=? WHERE Site=? AND No=?");
        $values = array($DbFileKind, $DbFilename, $_SESSION['spider_site'], $ReportNo);
		if( $sth->executeSilent($values) ) {
			$Report = $this->get_report($ReportNo);
			$this->run_save_datetime($Report);
			$this->run_save_cardholder($Report);
			$this->run_save_card($Report);
			$this->run_save_door($Report);
			$this->run_save_elevator($Report);
			$this->run_save_event($Report);
		} else {
			$this->conn->exec("ROLLBACK TRANSACTION");
			$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
		}

		$this->conn->exec("COMMIT TRANSACTION");
        
		exec(SPIDER_COMM." runreport $ReportNo");
        
        sleep(5);
		$this->util->js("parent.location.href='/?c=smartreport';");
    }

    // ----------------------------------------------------------------------------------

   public function run_save_datetime($Report)
    {
		$this->run_save_datecond($Report['DateTime']['No']);
		$this->run_save_timecond($Report['DateTime']['No']);
    }
	
    // ----------------------------------------------------------------------------------

   public function run_save_datecond($DateTimeNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_DateCond WHERE DateTimeNo=? AND Type != '1'");
		$delete->executeSilent(array($DateTimeNo));

		$ArrType = $this->input->post('DateCond_ArrType', array());
		$ArrTypeKind = $this->input->post('DateCond_ArrTypeKind', array());
		$ArrStartDate = $this->input->post('DateCond_ArrStartDate', array());
		$ArrEndDate = $this->input->post('DateCond_ArrEndDate', array());

		if( is_array($ArrType) ) {
			$DateCondNo = $this->conn->prepare("SELECT MAX(No) from SR_DateCond");
			$DateCondNo->execute(array());
			$DateCondNo = $DateCondNo->fetchColumn();

			foreach( $ArrType as $idx => $Type ) {
				$DateCondNo++;

				$sth    = $this->conn->prepare("INSERT INTO SR_DateCond (No,DateTimeNo,Type,TypeKind,StartDate,EndDate) VALUES (?,?,?,?,?,?)");
				$values = array($DateCondNo, $DateTimeNo, $Type, $ArrTypeKind[$idx], $ArrStartDate[$idx], $ArrEndDate[$idx]);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function run_save_timecond($DateTimeNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_TimeCond WHERE DateTimeNo=? AND Type != '1'");
		$delete->executeSilent(array($DateTimeNo));

		$ArrType = $this->input->post('TimeCond_ArrType', array());
		$ArrTypeKind = $this->input->post('TimeCond_ArrTypeKind', array());
		$ArrStartTime = $this->input->post('TimeCond_ArrStartTime', array());
		$ArrEndTime = $this->input->post('TimeCond_ArrEndTime', array());
		$ArrIsInTime = $this->input->post('TimeCond_ArrIsInTime', array());

		if( is_array($ArrType) ) {
			$TimeCondNo = $this->conn->prepare("SELECT MAX(No) from SR_TimeCond");
			$TimeCondNo->execute(array());
			$TimeCondNo = $TimeCondNo->fetchColumn();

			foreach( $ArrType as $idx => $Type ) {
				$TimeCondNo++;

				$sth    = $this->conn->prepare("INSERT INTO SR_TimeCond (No,DateTimeNo,Type,StartTime,EndTime,IsInTime) VALUES (?,?,?,?,?,?)");
				$values = array($TimeCondNo, $DateTimeNo, $Type, $ArrStartTime[$idx], $ArrEndTime[$idx], $ArrIsInTime[$idx]);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function run_save_cardholder($Report)
    {
		$HoldersType = $this->input->post('Holders_Type');

		if( $HoldersType == '2' ) {
			$ArrElement = $this->input->post('Select_CardHolder', array());
			$this->save_elementtab(1, $Report['Holders']['No'], 0, $ArrElement);

			$ArrElement = $this->input->post('Select_CardHolderGroup', array());
			$this->save_elementtab(1, $Report['Holders']['No'], 1, $ArrElement);
		}

		$this->run_save_holderscond($Report['Holders']['No']);
    }

    // ----------------------------------------------------------------------------------

   public function run_save_holderscond($HoldersNo)
    {
		$delete = $this->conn->prepare("DELETE FROM SR_HoldersCond WHERE SRHoldersNo=?");
		$delete->executeSilent(array($HoldersNo));

		$ArrAttr = $this->input->post('HoldersCond_ArrAttr', array());
		$ArrRelation = $this->input->post('HoldersCond_ArrRelation', array());
		$ArrValue = $this->input->post('HoldersCond_ArrValue', array());
		$ArrIsAsk = $this->input->post('HoldersCond_ArrIsAsk', array());

		if( is_array($ArrAttr) ) {
			$HoldersCondNo = $this->conn->prepare("SELECT MAX(No) from SR_HoldersCond");
			$HoldersCondNo->execute(array());
			$HoldersCondNo = $HoldersCondNo->fetchColumn();

			foreach( $ArrAttr as $idx => $Attr ) {
				$HoldersCondNo++;

				if( empty($ArrValue[$idx]) ) {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_atttr_value_required, TRUE );
				}

				$sth    = $this->conn->prepare("INSERT INTO SR_HoldersCond (No,SRHoldersNo,Attr,Relation,IsAsk,Value) VALUES (?,?,?,?,?,?)");
				$values = array($HoldersCondNo, $HoldersNo, $ArrAttr[$idx], $ArrRelation[$idx], $ArrIsAsk[$idx], $ArrValue[$idx]);
				if( $sth->executeSilent($values) ) {
				} else {
					$this->conn->exec("ROLLBACK TRANSACTION");
					$this->util->alert( $this->lang->smartreport_set->error_save, TRUE );
				}
			}
		}
    }

    // ----------------------------------------------------------------------------------

   public function run_save_card($Report)
    {
		$CardsType = $this->input->post('Cards_Type');

		if( $CardsType == '2' ) {
			$ArrCard = $this->input->post('Select_Card', array());
			$this->save_elementtab(2, $Report['Cards']['No'], 0, $ArrCard);

			$ArrCardType = $this->input->post('Select_CardType', array());
			$this->save_elementtab(2, $Report['Cards']['No'], 1, $ArrCardType);
		}
    }

    // ----------------------------------------------------------------------------------

   public function run_save_door($Report)
    {
		$DoorsType = $this->input->post('Doors_Type');

		if( $DoorsType == '2' ) {
			$ArrDoor = $this->input->post('Select_Door', array());
			$this->save_elementtab(3, $Report['Doors']['No'], 0, $ArrDoor);

			$ArrThreatLevel = $this->input->post('Select_ThreatLevel', array());
			$this->save_elementtab(3, $Report['Doors']['No'], 1, $ArrThreatLevel);

			$ArrFloor = $this->input->post('Select_Floor', array());
			$this->save_elementtab(3, $Report['Doors']['No'], 2, $ArrFloor);
		}
    }

    // ----------------------------------------------------------------------------------

   public function run_save_elevator($Report)
    {
		$ElevatorsType = $this->input->post('Elevators_Type');

		if( $ElevatorsType == '2' ) {
			$ArrElevator = $this->input->post('Select_Elevator', array());
			$this->save_elementtab(4, $Report['Elevators']['No'], 0, $ArrElevator);

			$ArrElevatorRelay = $this->input->post('Select_Elevator_Relay', array());
			$this->save_elementtab(4, $Report['Elevators']['No'], 1, $ArrElevatorRelay);

			$ArrElevatorFloor = $this->input->post('Select_Elevator_Floor', array());
			$this->save_elementtab(4, $Report['Elevators']['No'], 2, $ArrElevatorFloor);
		}
    }

    // ----------------------------------------------------------------------------------

   public function run_save_event($Report)
    {
		$EventsType = $this->input->post('Events_Type');

		if( $EventsType == '2' ) {
			$ArrEventGroup = $this->input->post('Select_EventGroup', array());
			$this->save_elementtab(5, $Report['Events']['No'], 0, $ArrEventGroup);

			$ArrEventCode = $this->input->post('Select_EventCode', array());
			$this->save_elementtab(5, $Report['Events']['No'], 1, $ArrEventCode);
		}
    }

    // ----------------------------------------------------------------------------------

   public function get_datecond_type2_kind_items()
    {
		return array(
			//'0'	=> $this->lang->smartreport_set->pull_down_list,
			'1'	=> $this->lang->smartreport_set->this_week,
			'2'	=> $this->lang->smartreport_set->last_week,
			'3' => $this->lang->smartreport_set->this_month,
			'4'	=> $this->lang->smartreport_set->last_month
		);
    }

    // ----------------------------------------------------------------------------------

   public function get_timecond_type2_kind_items()
    {
		return array(
			//'0'	=> $this->lang->smartreport_set->pull_down_list
			'1'	=> $this->lang->smartreport_set->this_week,
			'2'	=> $this->lang->smartreport_set->last_week,
			'3' => $this->lang->smartreport_set->this_month,
			'4'	=> $this->lang->smartreport_set->last_month
		);
    }

    // ----------------------------------------------------------------------------------

   public function get_attr_items()
    {
		return array(
			'1'	=> $this->lang->smartreport_set->number_of_cardholder,
			'2'	=> $this->lang->smartreport_set->firstname_of_cardholder,
			'3'	=> $this->lang->smartreport_set->lastname_of_cardholder,
			'4'	=> $this->lang->smartreport_set->phone_number,
			'5'	=> $this->lang->smartreport_set->cell_number,
			'6'	=> $this->lang->smartreport_set->any_phone_number,
			'7'	=> $this->lang->smartreport_set->email,
			'8'	=> $this->lang->smartreport_set->use_ada,
			'9'	=> $this->lang->smartreport_set->has_web_account,
			'10'	=> $this->lang->smartreport_set->web_account_name,
			'11'	=> $this->lang->smartreport_set->threatlevel,
			'12'	=> $this->lang->smartreport_set->has_picture
		);

    }

    // ----------------------------------------------------------------------------------

   public function get_relation_items()
    {
		return array(
			'1'	=> '<',
			'2'	=> '>',
			'3'	=> '<=',
			'4'	=> '>=',
			'5'	=> '=',
			'6'	=> '!=',
			'7'	=> 'LIKE'
		);
    }

    // ----------------------------------------------------------------------------------

   public function get_column_items()
    {
		return array(
			'date'	=> $this->lang->addmsg->item_date,
			'datetime'	=> $this->lang->addmsg->item_datetime,
			'time'	=> $this->lang->addmsg->item_time,
			'localtime'	=> $this->lang->addmsg->item_localtime,
			'event'	=> $this->lang->addmsg->item_event,
			'user'	=> $this->lang->addmsg->item_user,
			'card_no'	=> $this->lang->addmsg->item_card_no,
			'message'	=> $this->lang->addmsg->item_message,
			'devicename'	=> $this->lang->addmsg->item_devicename,
			'type'	=> $this->lang->addmsg->item_type,
			'port'	=> $this->lang->addmsg->item_port,
			'ack'	=> $this->lang->addmsg->item_ack,
			'ack_message'	=> $this->lang->addmsg->item_ack_message,
			'reader_type'	=> $this->lang->addmsg->item_reader_type,
            'user_field1'	=> $this->lang->addmsg->item_user_field1,
            'user_field2'	=> $this->lang->addmsg->item_user_field2,
            'user_field3'	=> $this->lang->addmsg->item_user_field3,
            'user_field4'	=> $this->lang->addmsg->item_user_field4,
            'user_field5'	=> $this->lang->addmsg->item_user_field5,
            'user_field6'	=> $this->lang->addmsg->item_user_field6,
            'user_field7'	=> $this->lang->addmsg->item_user_field7,
            'user_field8'	=> $this->lang->addmsg->item_user_field8,
            'user_field9'	=> $this->lang->addmsg->item_user_field9,
            'user_field10'	=> $this->lang->addmsg->item_user_field10,
            'user_field11'	=> $this->lang->addmsg->item_user_field11,
            'user_field12'	=> $this->lang->addmsg->item_user_field12,
            'user_field13'	=> $this->lang->addmsg->item_user_field13,
            'user_field14'	=> $this->lang->addmsg->item_user_field14,
            'user_field15'	=> $this->lang->addmsg->item_user_field15,
            'user_field16'	=> $this->lang->addmsg->item_user_field16,
            'user_field17'	=> $this->lang->addmsg->item_user_field17,
            'user_field18'	=> $this->lang->addmsg->item_user_field18,
            'user_field19'	=> $this->lang->addmsg->item_user_field19,
            'user_field20'	=> $this->lang->addmsg->item_user_field20,
            'first_time_in' => $this->lang->addmsg->item_first_timein,
            'last_time_out' => $this->lang->addmsg->item_last_timeout,
            'time_inside'   => $this->lang->addmsg->item_time_inside,
            'threatlevel'   => $this->lang->addmsg->item_threatlevel,
            'region'        => $this->lang->addmsg->item_region
		);
    }

    // ----------------------------------------------------------------------------------

   public function get_sort_items()
    {
		return array(
			'0'	=> 'none',
			'1'	=> '1',
			'2'	=> '2',
			'3'	=> '3',
			'4'	=> '4',
			'5'	=> '5'
		);
    }

    // ----------------------------------------------------------------------------------

   public function get_holiday_items()
    {
		$year   = date('Y');

		$search_year_start = $this->to_timestamp("01/01/{$year}", 0, 0, 0);
		$search_year_end = $this->to_timestamp("12/31/{$year}", 23, 59, 59);

		$list   = $this->conn->prepare("SELECT * FROM Holiday WHERE Site=? AND StartTime BETWEEN ? AND ? ORDER BY No ASC");
		$list->execute(array($_SESSION['spider_site'], $search_year_start, $search_year_end));
		$list   = $list->fetchAll(PDO::FETCH_ASSOC);

		$holidays = array('' => 'none');
		foreach( $list as $row ) {
			$holidays[$row['No']] = $row['Name'];
		}

		return $holidays;
    }

    // ----------------------------------------------------------------------------------

   public function get_report($ReportNo)
    {
		$Report   = $this->conn->prepare("SELECT * FROM SR_Main WHERE Site=? AND No=?");
		$Report->execute(array($_SESSION['spider_site'], $ReportNo));
		$Report   = $Report->fetch(PDO::FETCH_ASSOC);

		$DateTime   = $this->conn->prepare("SELECT * FROM SR_DateTime WHERE ReportNo=?");
		$DateTime->execute(array($ReportNo));
		$Report['DateTime']   = $DateTime->fetch(PDO::FETCH_ASSOC);

		$DateConds   = $this->conn->prepare("SELECT * FROM SR_DateCond WHERE DateTimeNo=?");
		$DateConds->execute(array($Report['DateTime']['No']));
		$Report['DateTime']['DateConds']   = $DateConds->fetchAll(PDO::FETCH_ASSOC);
		foreach( $Report['DateTime']['DateConds'] as $DateCond ) {
			if( $DateCond['Type'] == '1' ) {
				$Report['DateTime']['DateConds'] = array($DateCond);
				break;
			}
		}

		$TimeConds   = $this->conn->prepare("SELECT * FROM SR_TimeCond WHERE DateTimeNo=?");
		$TimeConds->execute(array($Report['DateTime']['No']));
		$Report['DateTime']['TimeConds']   = $TimeConds->fetchAll(PDO::FETCH_ASSOC);
		foreach( $Report['DateTime']['TimeConds'] as $TimeCond ) {
			if( $TimeCond['Type'] == '1' ) {
				$Report['DateTime']['TimeConds'] = array($TimeCond);
				break;
			}
		}

		$Holders   = $this->conn->prepare("SELECT * FROM SR_Holders WHERE ReportNo=?");
		$Holders->execute(array($ReportNo));
		$Report['Holders']   = $Holders->fetch(PDO::FETCH_ASSOC);

		if( $Report['Holders']['Type'] == '2' ) {
			$Report['Holders']['CardHolders'] = $this->get_cardholders($Report['Holders']['No']);
			$Report['Holders']['CardHolderGroups'] = $this->get_cardholdergroups($Report['Holders']['No']);
		} else {
			$Report['Holders']['CardHolders'] = array();
			$Report['Holders']['CardHolderGroups'] = array();
		}

		$HoldersConds   = $this->conn->prepare("SELECT * FROM SR_HoldersCond WHERE SRHoldersNo=?");
		$HoldersConds->execute(array($Report['Holders']['No']));
		$Report['Holders']['HoldersConds']   = $HoldersConds->fetchAll(PDO::FETCH_ASSOC);

		$Cards   = $this->conn->prepare("SELECT * FROM SR_Cards WHERE ReportNo=?");
		$Cards->execute(array($ReportNo));
		$Report['Cards']   = $Cards->fetch(PDO::FETCH_ASSOC);

		if( $Report['Cards']['Type'] == '2' ) {
			$Report['Cards']['Cards'] = $this->get_cards($Report['Cards']['No']);
			$Report['Cards']['CardTypes'] = $this->get_cardTypes($Report['Cards']['No']);
		} else {
			$Report['Cards']['Cards'] = array();
			$Report['Cards']['CardTypes'] = array();
		}

		$Doors   = $this->conn->prepare("SELECT * FROM SR_Doors WHERE ReportNo=?");
		$Doors->execute(array($ReportNo));
		$Report['Doors']   = $Doors->fetch(PDO::FETCH_ASSOC);

		if( $Report['Doors']['Type'] == '2' ) {
			$Report['Doors']['Doors'] = $this->get_doors($Report['Doors']['No']);
			$Report['Doors']['ThreatLevels'] = $this->get_threatlevels($Report['Doors']['No']);
			$Report['Doors']['Floors'] = $this->get_floors($Report['Doors']['No']);
		} else {
			$Report['Doors']['Doors'] = array();
			$Report['Doors']['ThreatLevels'] = array();
			$Report['Doors']['Floors'] = array();
		}

		$Elevators   = $this->conn->prepare("SELECT * FROM SR_Elevators WHERE ReportNo=?");
		$Elevators->execute(array($ReportNo));
		$Report['Elevators']   = $Elevators->fetch(PDO::FETCH_ASSOC);

		if( $Report['Elevators']['Type'] == '2' ) {
			$Report['Elevators']['Elevators'] = $this->get_elevators($Report['Elevators']['No']);
			$Report['Elevators']['ElevatorRelays'] = $this->get_elevator_relays($Report['Elevators']['No']);
			$Report['Elevators']['ElevatorFloors'] = $this->get_elevator_floors($Report['Elevators']['No']);
		} else {
			$Report['Elevators']['Elevators'] = array();
			$Report['Elevators']['ElevatorRelays'] = array();
			$Report['Elevators']['ElevatorFloors'] = array();
		}

		$Events   = $this->conn->prepare("SELECT * FROM SR_Events WHERE ReportNo=?");
		$Events->execute(array($ReportNo));
		$Report['Events']   = $Events->fetch(PDO::FETCH_ASSOC);

		if( $Report['Events']['Type'] == '2' ) {
			$Report['Events']['EventGroups'] = $this->get_eventgroups($Report['Events']['No']);
			$Report['Events']['EventCodes'] = $this->get_eventcodes($Report['Events']['No']);
		} else {
			$Report['Events']['EventGroups'] = array();
			$Report['Events']['EventCodes'] = array();
		}

		$ColFormats   = $this->conn->prepare("SELECT * FROM SR_ColFormat WHERE ReportNo=?");
		$ColFormats->execute(array($ReportNo));
		$Report['ColFormats']   = $ColFormats->fetchAll(PDO::FETCH_ASSOC);

		$Report['UserRoles'] = $this->get_userrole($Report['No']);

		return $Report;
    }

    // ----------------------------------------------------------------------------------

   public function get_cardholders($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT User.No, User.FirstName, User.MiddleName, User.LastName FROM SR_ElementTab, User WHERE SR_ElementTab.Element=User.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(1, $CondKindNo, 0));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$CardHolders = array();
		foreach( $Elements as $Element ) {
			$CardHolders[$Element['No']] = $Element['FirstName'] .' '. $Element['MiddleName'] .' '. $Element['LastName'];
		}

		return $CardHolders;

    }

    // ----------------------------------------------------------------------------------

   public function get_cardholdergroups($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT GroupTable.No, GroupTable.Name FROM SR_ElementTab, GroupTable WHERE SR_ElementTab.Element=GroupTable.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=? AND GroupTable.GroupKind=?");
		$Elements->execute(array(1, $CondKindNo, 1, ConstTable::GROUP_USER));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$CardHolderGroups = array();
		foreach( $Elements as $Element ) {
			$CardHolderGroups[$Element['No']] = $Element['Name'];
		}

		return $CardHolderGroups;

    }

    // ----------------------------------------------------------------------------------

   public function get_cards($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT Card.No, Card.CardNo FROM SR_ElementTab, Card WHERE SR_ElementTab.Element=Card.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(2, $CondKindNo, 0));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$Cards = array();
		foreach( $Elements as $Element ) {
			$Cards[$Element['No']] = $Element['CardNo'];
		}

		return $Cards;

    }

    // ----------------------------------------------------------------------------------

   public function get_cardtypes($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT CardFormat.No, CardFormat.Name FROM SR_ElementTab, CardFormat WHERE SR_ElementTab.Element=CardFormat.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(2, $CondKindNo, 1));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$CardTypes = array();
		foreach( $Elements as $Element ) {
			$CardTypes[$Element['No']] = $Element['Name'];
		}

		return $CardTypes;

    }

    // ----------------------------------------------------------------------------------

   public function get_doors($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT Door.No, Door.Name FROM SR_ElementTab, Door WHERE SR_ElementTab.Element=Door.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(3, $CondKindNo, 0));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$Doors = array();
		foreach( $Elements as $Element ) {
			$Doors[$Element['No']] = $Element['Name'];
		}

		return $Doors;

    }

    // ----------------------------------------------------------------------------------

   public function get_threatlevels($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT ThreatLevel.No, ThreatLevel.ThreatName FROM SR_ElementTab, ThreatLevel WHERE SR_ElementTab.Element=ThreatLevel.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(3, $CondKindNo, 1));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$ThreatLevels = array();
		foreach( $Elements as $Element ) {
			$ThreatLevels[$Element['No']] = $Element['ThreatName'];
		}

		return $ThreatLevels;

    }

    // ----------------------------------------------------------------------------------

   public function get_floors($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT Floor.No, Floor.Name FROM SR_ElementTab, Floor WHERE SR_ElementTab.Element=Floor.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(3, $CondKindNo, 2));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$Floors = array();
		foreach( $Elements as $Element ) {
			$Floors[$Element['No']] = $Element['Name'];
		}

		return $Floors;

    }

    // ----------------------------------------------------------------------------------

   public function get_elevators($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT Elevator.No, Elevator.Name FROM SR_ElementTab, Elevator WHERE SR_ElementTab.Element=Elevator.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(4, $CondKindNo, 0));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$Elevators = array();
		foreach( $Elements as $Element ) {
			$Elevators[$Element['No']] = $Element['Name'];
		}

		return $Elevators;

    }

    // ----------------------------------------------------------------------------------

   public function get_elevator_relays($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT ElevatorRelay.No, ElevatorRelay.Name FROM SR_ElementTab, ElevatorRelay WHERE SR_ElementTab.Element=ElevatorRelay.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(4, $CondKindNo, 1));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$ElevatorRelays = array();
		foreach( $Elements as $Element ) {
			$ElevatorRelays[$Element['No']] = $Element['Name'];
		}

		return $ElevatorRelays;

    }

    // ----------------------------------------------------------------------------------

   public function get_elevator_floors($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT Floor.No, Floor.Name FROM SR_ElementTab, Floor WHERE SR_ElementTab.Element=Floor.No AND SR_ElementTab.CondKind=? AND SR_ElementTab.CondKindNo=? AND SR_ElementTab.ElementKind=?");
		$Elements->execute(array(4, $CondKindNo, 2));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$Floors = array();
		foreach( $Elements as $Element ) {
			$Floors[$Element['No']] = $Element['Name'];
		}

		return $Floors;

    }

    // ----------------------------------------------------------------------------------

   public function get_eventgroups($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT * FROM SR_ElementTab WHERE CondKind=? AND CondKindNo=? AND ElementKind=?");
		$Elements->execute(array(5, $CondKindNo, 0));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$EventGroups = array();
		foreach( $Elements as $Element ) {
			$EventGroups[] = $Element['Element'];
		}

		return $EventGroups;

    }

    // ----------------------------------------------------------------------------------

   public function get_eventcodes($CondKindNo)
    {
		$Elements   = $this->conn->prepare("SELECT * FROM SR_ElementTab WHERE CondKind=? AND CondKindNo=? AND ElementKind=?");
		$Elements->execute(array(5, $CondKindNo, 1));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$EventCodes = array();
		foreach( $Elements as $Element ) {
			$EventCodes[] = $Element['Element'];
		}

		return $EventCodes;

    }

    // ----------------------------------------------------------------------------------

   public function get_userrole($ReportNo)
    {
		$Elements   = $this->conn->prepare("SELECT UserRole.No, UserRole.Name FROM UserRole, UserRoleReport WHERE UserRole.No=UserRoleReport.UserRole AND UserRoleReport.ReportNo=?");
		$Elements->execute(array($ReportNo));
		$Elements   = $Elements->fetchAll(PDO::FETCH_ASSOC);

		$UserRoles = array();
		foreach( $Elements as $Element ) {
			$UserRoles[$Element['No']] = $Element['Name'];
		}

		return $UserRoles;

    }

    // ----------------------------------------------------------------------------------

   public function get_sd($type=1)
    {
		$files = array();
		$output = array();

		exec(SPIDER_COMM." sd_list {$type}", $output);

		foreach( $output as $line )
		{
			$line = trim($line);
			$name_split = explode('.', $line);

			if( $name_split[(count($name_split) - 1)] == 'db' ) {
				$files[] = $line;
			}
		}

		return $files;
    }

    // ----------------------------------------------------------------------------------

   public function get_ask_tabs($Report)
    {
		$ask_tabs = array('run_report');

		foreach( $Report['DateTime']['DateConds'] as $DateCond ) {
			if( $DateCond['Type'] == 1 ) {
				$ask_tabs[] = 'datetime';
				break;
			}
		}

		if( !in_array('datetime', $ask_tabs) ) {
			foreach( $Report['DateTime']['TimeConds'] as $TimeCond ) {
				if( $TimeCond['Type'] == 1 ) {
					$ask_tabs[] = 'datetime';
					break;
				}
			}
		}

		if( $Report['Holders']['Type'] == 1 ) {
			$ask_tabs[] = 'cardholders';
		}

        if( !in_array('cardholders', $ask_tabs) ) {
			foreach( $Report['Holders']['HoldersConds'] as $HoldersCond ) {
				if( $HoldersCond['IsAsk'] == 1 ) {
					$ask_tabs[] = 'cardholders';
					break;
				}
			}
		}
        
		if( $Report['Cards']['Type'] == 1 ) {
			$ask_tabs[] = 'cards';
		}

		if( $Report['Doors']['Type'] == 1 ) {
			$ask_tabs[] = 'doors';
		}

		if( $_SESSION['spider_model'] == ConstTable::MODEL_ELITE || 
			$_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE ||
			$_SESSION['spider_model'] == ConstTable::MODEL_GIANT) {
			if( $Report['Elevators']['Type'] == 1 ) {
				$ask_tabs[] = 'elevators';
			}
		}

		if( $Report['Events']['Type'] == 1 ) {
			$ask_tabs[] = 'events';
		}

		return $ask_tabs;
    }

    // ----------------------------------------------------------------------------------

   public function to_timestamp($date="", $hour=0, $min=0, $sec=0)
    {
        if ($date != "")
        {
        	$timeval = explode('/', trim($date));

        	if (count($timeval) < 3)
        	{
        		return "";
        	}

            $month  = $timeval[0];
            $day    = $timeval[1];
            $year   = $timeval[2];
            return mktime($hour, $min, $sec, $month, $day, $year);
        }
        return $date;
    }

       // ----------------------------------------------------------------------------------

   public function datetime_to_timestamp($date)
    {
        if ($date != "")
        {
        	$arg=explode(' ',$date); // 날짜 와 시간을 분리
            $ymd=explode('-',$arg[0]); // 날짜 부분
            $hms=explode(':',$arg[1]); // 시간 부분
            $time=mktime($hms[0],$hms[1],$hms[2],$ymd[1],$ymd[2],$ymd[0]);
            return $time;
        }
        return $date;
    }
    
   public function timestamp_to_datetime($time) {
        $date=date("Y-m-d H:i:s", $time);
        return $date;
    } 
    // ----------------------------------------------------------------------------------

   public function find_cardholder()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM User WHERE Site=?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();

            $list   = $this->conn->prepare("SELECT No, FirstName, MiddleName, LastName FROM User WHERE Site=? ORDER BY No ASC");
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM User WHERE Site=? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], "%".$word."%"));
            $count  = $count->fetchColumn();

            $list   = $this->conn->prepare("SELECT No, FirstName, MiddleName, LastName FROM User WHERE Site=? AND $field LIKE ? ORDER BY No ASC");
            $list->execute(array($_SESSION['spider_site'], "%".$word."%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_cardholder_group()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site'],ConstTable::GROUP_USER));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT * FROM GroupTable WHERE Site=? AND GroupKind=? AND $field LIKE ? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site'],ConstTable::GROUP_USER, "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_card()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $list   = $this->conn->prepare("SELECT * FROM Card WHERE Site=? ORDER BY CardNo ASC");
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT * FROM Card WHERE Site=? AND $field LIKE ? ORDER BY CardNo ASC");
            $list->execute(array($_SESSION['spider_site'], "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_cardformat()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $list   = $this->conn->prepare("SELECT * FROM CardFormat ORDER BY Name ASC");
            $list->execute(array());
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT * FROM CardFormat WHERE $field LIKE ? ORDER BY Name ASC");
            $list->execute(array("%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_door()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Disable=0 AND Site=? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT * FROM Door WHERE Site=? AND Disable=0 AND $field LIKE ? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site'], "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_threatlevel()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $list   = $this->conn->prepare("SELECT * FROM ThreatLevel WHERE Site=? ORDER BY Level ASC");
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT * FROM ThreatLevel WHERE Site=? AND $field LIKE ? ORDER BY Level ASC");
            $list->execute(array($_SESSION['spider_site'], "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_floor()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $list   = $this->conn->prepare("SELECT * FROM Floor WHERE Site=? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT * FROM Floor WHERE Site=? AND $field LIKE ? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site'], "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_elevator()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 AND Extended=0 ORDER BY No ASC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND   A.Extended=0 
                                                           ORDER BY A.No ASC");
            }
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 AND Extended=0 AND $field LIKE ? ORDER BY No ASC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND   A.Extended=0 
                                                           AND   A.$field LIKE ? 
                                                           ORDER BY A.No ASC");
            }
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

		foreach( $list as $idx => $row ) {
			$slaves   = $this->conn->prepare("SELECT A.*, IFNULL(B.Name, 0) AS EName FROM ElevatorRelay AS A, Elevator AS B WHERE A.Site = ? AND A.Disable = 0 AND A.ElevatorNo = B.No AND ((B.Extended=0 AND B.No=?) OR (B.Extended=1 AND B.MasterElevator=?)) ORDER BY A.No ASC");
			$slaves->execute(array($_SESSION['spider_site'], $row['No'], $row['No']));
			$list[$idx]['Slaves']   = $slaves->fetchAll(PDO::FETCH_ASSOC);
		}

        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_elevator_master()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 AND Extended=0 ORDER BY No ASC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND   A.Extended=0 
                                                           ORDER BY A.No ASC");
            }
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            if( $this->is_SuperAdmin() == true )
            {
                $list   = $this->conn->prepare("SELECT * FROM Elevator WHERE Site = ? AND Disable=0 AND Extended=0 AND $field LIKE ? ORDER BY No ASC");
            }
            else{
                $list   = $this->conn->prepare("SELECT A.* FROM Elevator AS A 
                                                           JOIN Host B ON A.HostNo = B.No AND (B.ByAdminId =  '".$_SESSION['spider_id']."' OR B.ByAdminId = '' OR B.ByAdminId IS null)
                                                           WHERE A.Site=? 
                                                           AND   A.Disable=0 
                                                           AND   A.Extended=0 
                                                           AND   A.$field LIKE ? 
                                                           ORDER BY A.No ASC");
            }
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_elevator_relay()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

		$slaves   = $this->conn->prepare("SELECT A.*, IFNULL(B.Name, 0) AS EName FROM ElevatorRelay AS A, Elevator AS B WHERE A.Site = ? AND A.Disable = 0 AND A.ElevatorNo = B.No ORDER BY A.No ASC");
		$slaves->execute(array($_SESSION['spider_site']));
		$list   = $slaves->fetchAll(PDO::FETCH_ASSOC);

        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function find_userrole()
    {
        $field  = $this->input->get('f');
        $word   = $this->input->get('w');

        if( empty($field) || empty($word) )
        {
            $list   = $this->conn->prepare("SELECT * FROM UserRole WHERE Site=? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site']));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $list   = $this->conn->prepare("SELECT * FROM UserRole WHERE Site=? AND $field LIKE ? ORDER BY Name ASC");
            $list->execute(array($_SESSION['spider_site'], "%$word%"));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        
        $result['field']        = $field;
        $result['word']         = $word;
        $result['list']         = $list;

        echo json_encode($result);
    }

    // ----------------------------------------------------------------------------------

   public function receive()
    {
        $this->clear_receive_file();
        
        if( ! is_uploaded_file($_FILES['upload_file']['tmp_name']) )    return FALSE;

        $uploader                   = new Uploader();
        $uploader->upload_dir       = TMPDATA_URL;
        $uploader->allowed_types    = 'db';
		$uploader->file_name		= '_SpiderLog';

        if( $uploader->do_upload('upload_file', 1000 * 1024 * 100) )
        {
            return $uploader->save_file['basename'];
        }
        else
        {
            $this->util->alert($this->lang->addmsg->error_backup_file);			//$this->util->alert( "Backup File Loading Error : ".$uploader->get_errors() );
            return FALSE;
        }
    }

    // ----------------------------------------------------------------------------------

   public function clear_receive_file()
    {
		@unlink(TMPDATA_URL.'/_SpiderLog.db');
    }

    // ----------------------------------------------------------------------------------

   public function report()
    {
		$rows	= $this->conn->prepare("SELECT SR_Main.Name AS ReportName, SR_Query.Status, SR_Query.StartTime, SR_Query.EndTime, SR_Query.DBFilename, SR_Query.SRName FROM SR_Query, SR_Main WHERE SR_Query.ReportNo=SR_Main.No ORDER BY SR_Query.No DESC");
		$rows->execute(array());
		$rows	= $rows->fetchAll(PDO::FETCH_ASSOC);

		$vars['rows']			= $rows;
		$vars['report_status_items']	= $this->get_report_status_items();
        $this->display($vars, 'smartreport_set_report');
    }

    // ----------------------------------------------------------------------------------

   public function get_report_status_items()
    {
		return array(
			'0'	=> $this->lang->smartreport->queued,
			'1'	=> $this->lang->smartreport->running,
			'2'	=> $this->lang->smartreport->complete,
			'3'	=> $this->lang->smartreport->error,
            '4' => $this->lang->smartreport->canceled
		);
    }

    // ----------------------------------------------------------------------------------

}
