<?php

class systemreport extends controller
{
	var $arr_plug       = array('0'=>'Off', '1'=>'On');

	// ----------------------------------------------------------------------------------

   public function index()
	{
		$rows = array();
		$fields = array($_SESSION['spider_site']);

		// user
		$use = 0;
		$use = $this->util->GetRecordCount("User");
		$rows[] = array(
			'name' => 'user',
			'total' => EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][2],
			'use' => $use
		);

		// card
		$use = 0;
		$use = $this->util->GetRecordCount("Card");
		$rows[] = array(
			'name' => 'card',
			'total' => EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][4],
			'use' => $use
		);

		// cardformat
		$use = 0;
		$use = $this->util->GetRecordCount("CardFormat");
		$rows[] = array(
			'name' => 'card_format',
			'total' => EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][6],
			'use' => $use
		);

		// access leve
		$use = 0;
		$use = $this->util->GetRecordCount("AccessLevel");
		$rows[] = array(
			'name' => 'alevel',
			'total' => EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][11],
			'use' => $use
		);

		// schedule
		$use = 0;
		$use = $this->util->GetRecordCount("Schedule");
		$rows[] = array(
			'name' => 'schedule',
			'total' => EnumTable::$attrModelSpec[$_SESSION['spider_model']][$_SESSION['spider_kind']][12],
			'use' => $use
		);

		// holiday
		$year = date('Y');
		$search_year_start = $this->to_timestamp("01-01-{$year}", 0, 0, 0);
		$search_year_end = $this->to_timestamp("12-31-{$year}", 23, 59, 59);
		$holiday_fields = array($search_year_start, $search_year_end);

		$use = 0;
		$use = $this->util->GetRecordCountSet("Holiday", "WHERE StartTime BETWEEN ? AND ?", $holiday_fields);
		$rows[] = array(
			'name' => 'holiday',
			'total' => $this->util->GetLimitCount( ConstTable::MAX_HOLIDAY_1, ConstTable::MAX_HOLIDAY_2, ConstTable::MAX_HOLIDAY_3,ConstTable::MAX_HOLIDAY_4 ),
			'use' => $use
		);

		// user defined
		$use = 0;
		$user_def	= $this->conn->prepare("SELECT * FROM UserDefined WHERE Site=?");
		$user_def->execute($fields);
		if( $user_def = $user_def->fetch(PDO::FETCH_ASSOC) ) {
			foreach( $user_def as $name=>$val ) {
				if( substr($name, 0, 4) == 'User' && !empty($val) ) {
					$use++;
				}
			}
		}
		$rows[] = array(
			'name' => 'userdefinefield',
			'total' => $this->util->GetLimitCount( ConstTable::MAX_USERDEFINE_1, ConstTable::MAX_USERDEFINE_2, ConstTable::MAX_USERDEFINE_3,ConstTable::MAX_USERDEFINE_4 ),
			'use' => $use
		);

		$vars = array(
			'rows' => $rows,
			'logstatus'	=> $this->util->get_logstatus(),
			'diskspace'	=> $this->util->get_diskspace(),
			'userspace'	=> $this->util->get_userspace(),
			'sdspace'	=> $this->util->get_sdspace(),
			'usbspace'	=> $this->util->get_usbspace()
		);

		$this->display($vars, 'system_report');
    }

    // ----------------------------------------------------------------------------------

   public function to_timestamp($date="", $hour=0, $min=0, $sec=0)
    {
        if ($date != "")
        {
        	$timeval = explode('-', trim($date));
        	
        	if (count($timeval) < 3)
        	{
        		return "";
        	}
        		
            $month  = $timeval[0];
            $day    = $timeval[1];
            $year   = $timeval[2];
            return mktime($hour, $min, $sec, $month, $day, $year);
        }
        return $date;
    }

	// ----------------------------------------------------------------------------------

}

?>