<?php


class webuser extends controller
{
    // ----------------------------------------------------------------------------------
    public $attrUserRole;
    
   public function index()
    {
	    $vars = array();
        $this->attrUserRole = $this->to_array_userrole();
        $this->display($vars);
    }

    // ----------------------------------------------------------------------------------

   public function select()
    {
        $field      = $this->input->get('f');
        $word       = $this->input->get('w');
        $page       = $this->input->get('p', 1);

        $page_config    = $GLOBALS['page_config'];
        $pagination     = new Pagination();
        if( empty($field) || empty($word) )
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM WebUser WHERE Site=?");
            $count->execute(array($_SESSION['spider_site']));
            $count  = $count->fetchColumn();
            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM WebUser WHERE Site=? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }
        else
        {
            $count  = $this->conn->prepare("SELECT COUNT(*) FROM WebUser WHERE Site=? AND $field LIKE ?");
            $count->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word)));
            $count  = $count->fetchColumn();

            $page_config['current_page']    = $page;
            $page_config['total_row']       = $count;
            $pagination->init($page_config);

            $list   = $this->conn->prepare("SELECT * FROM WebUser WHERE Site=? AND $field LIKE ? ORDER BY No DESC LIMIT ?, ?");
            $list->execute(array($_SESSION['spider_site'], $this->util->parse_search_string($word), $pagination->offset, $pagination->row_size));
            $list   = $list->fetchAll(PDO::FETCH_ASSOC);
        }

        $attrUserRole   = $this->to_array_userrole();
        $attrFloor      = $this->to_array_floor();
        
        foreach( $list as $key=>$val )
        {
        	$val['ID2']         = $val['ID'];
        	
        	if($val['Type']){
	        	$val['TypeStr'] = EnumTable::$attrUserType[$val['Type']];
        	}else{
	        	$val['TypeStr'] = '';
        	}
        	
        	if($val['UserRole']){
	        	$val['UserRoleStr'] = $attrUserRole[$val['UserRole']];
        	}else{
	        	$val['UserRoleStr'] = '';
        	}
        	
        	if($val['Language']){
	        	$val['LanguageStr'] = EnumTable::$attrLanguage[$val['Language']];
        	}else{
	        	$val['LanguageStr'] = '';
        	}
        	
        	$_attrDefaultPage = EnumTable::$attrDefaultPage;
        	
        	if(isset($_attrDefaultPage[$val['DefaultPage']])){
	        	$val['DefaultPageStr'] = $_attrDefaultPage[$val['DefaultPage']];
        	}else{
	        	$val['DefaultPageStr'] = '';
        	}
        	
        	if($val['DefaultFloorNo']){
	        	$val['DefaultFloorStr'] = $attrFloor[$val['DefaultFloorNo']];
        	}else{
	        	$val['DefaultFloorStr'] = '';
        	}
        	
        	if($val['DefaultFloorState']){
	        	$val['DefaultFloorSateStr'] = EnumTable::$attrYesNo[$val['DefaultFloorState']];
        	}else{
	        	$val['DefaultFloorSateStr'] = '';
        	}
        	
        	if($val['AutoDisconnectTime']){
	        	$val['AutoDisconnectTimeStr'] = EnumTable::$attrAutoDisconnectTime[$val['AutoDisconnectTime']];
        	}else{
	        	$val['AutoDisconnectTimeStr'] = '';
        	}
			
            $val['Password'] = '';
            
            $list[$key] = $val;
        }

        $result['field']        = $field;
        $result['word']         = $word;
        $result['page']         = $page;
        $result['pages']        = $pagination->get_pages();
        $result['count']        = $count;
        $result['list']         = $list;

        echo json_encode($result);
    }
    
    // ----------------------------------------------------------------------------------
    
   public function insert()
    {
    	$max_user  = $this->util->GetLimitCount(ConstTable::MAX_CONNECT_1, 
		                                 ConstTable::MAX_CONNECT_2, 
                                         ConstTable::MAX_CONNECT_3,
                                         ConstTable::MAX_CONNECT_4);
		if ($max_user <= $this->util->GetRecordCount('WebUser'))
    	{
    		$this->util->alert($this->lang->addmsg->error_limit_connect, TRUE);
    	}
    	
        $No = $this->conn->prepare("SELECT MAX(No) from WebUser WHERE Site=?");
        $No->execute(array($_SESSION['spider_site']));
        $No    = $No->fetchColumn() + 1;
            
        $Name     = strip_tags(trim($this->input->post('Name')));
        $Type     = $this->input->post('Type');
        $ID       = strip_tags($this->input->post('ID'));
        $Password = $this->input->post('Password');
        $UserRole = $this->input->post('UserRole');
        $Language = $this->input->post('Language');
        $DefaultPage = $this->input->post('DefaultPage');
        $DefaultFloorNo = $this->input->post('DefaultFloorNo');
        $DefaultFloorState = $this->input->post('DefaultFloorState');
        $AutoDisconnectTime = $this->input->post('AutoDisconnectTime');
        
        if( empty($ID) )   			$this->util->alert( $this->lang->menu->error_id_required, TRUE );
        if( empty($Password) )   	$this->util->alert( $this->lang->menu->error_password_required, TRUE );
        
        $idcount  = $this->util->GetRecordCount("WebUser", " WHERE Site='".$_SESSION['spider_site']."' AND ID='".$ID."'");
        if( $idcount > 0)			$this->util->alert( $this->lang->addmsg->already_id_exist, TRUE );
        
        if( empty($Name) )          $this->util->alert( $this->lang->menu->error_name_required, TRUE );

        $sth = $this->conn->prepare("INSERT INTO WebUser (Site,No,Name,Type,ID,Password,UserRole,Language,DefaultPage,DefaultFloorNo,DefaultFloorState,AutoDisconnectTime) VALUES (?,?,?,?,?,?,?,?,?,?,?,?)");

		//$values = array($_SESSION['spider_site'],$No,$Name,$Type,$ID,$Password,$UserRole,$Language,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,$AutoDisconnectTime);
          $values = array($_SESSION['spider_site'],$No,$Name,$Type,$ID,hash('sha256', $Password, false),$UserRole,$Language,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,$AutoDisconnectTime);
        if( $sth->execute($values) )
        {
            $this->log->set_log_message($Name);
            $this->util->js('load_list();');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_insert);
        }
    }

   public function update()
    {
        $No       = $this->input->post('No');
        $ID       = strip_tags($this->input->post('ID'));
        $Password = $this->input->post('Password');
        $NewPassword = $this->input->post('NewPassword');
        $Name     = strip_tags(trim($this->input->post('Name')));
        $Type     = $this->input->post('Type');
        $UserRole = $this->input->post('UserRole');
        $Language = $this->input->post('Language');
        $DefaultPage = $this->input->post('DefaultPage');
        $DefaultFloorNo = $this->input->post('DefaultFloorNo');
        $DefaultFloorState = $this->input->post('DefaultFloorState');
        $AutoDisconnectTime = $this->input->post('AutoDisconnectTime');

        if( empty($ID) )   			$this->util->alert( $this->lang->menu->error_id_required, TRUE );        
        if( empty($Password) )   	$this->util->alert( $this->lang->menu->error_password_required, TRUE );
        if( empty($Name) )          $this->util->alert( $this->lang->menu->error_name_required, TRUE );
        
        if(!empty($NewPassword)) {			
            $sth    = $this->conn->prepare("UPDATE WebUser SET Name=?,Type=?,ID=?,Password=?,UserRole=?,Language=?,DefaultPage=?,DefaultFloorNo=?,DefaultFloorState=?,AutoDisconnectTime=? WHERE Site=? AND No=?");
			//$values = array($Name,$Type,$ID,$NewPassword,$UserRole,$Language,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,$AutoDisconnectTime,$_SESSION['spider_site'],$No);            
              $values = array($Name,$Type,$ID,hash('sha256', $NewPassword, false),$UserRole,$Language,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,$AutoDisconnectTime,$_SESSION['spider_site'],$No);            
        } 
        else {
            $sth    = $this->conn->prepare("UPDATE WebUser SET Name=?,Type=?,ID=?,UserRole=?,Language=?,DefaultPage=?,DefaultFloorNo=?,DefaultFloorState=?,AutoDisconnectTime=? WHERE Site=? AND No=?");            
            $values = array($Name,$Type,$ID,$UserRole,$Language,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,$AutoDisconnectTime,$_SESSION['spider_site'],$No);
        }


        if( $sth->execute($values) )
        {
            $this->log->set_log_message($Name);
            $this->util->js('update_list("'.$No.'");');
            $this->util->alert( $this->lang->common->save_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_update);
        }
    }

    // ----------------------------------------------------------------------------------

   public function check_dependency()
    {
        $no     = $this->input->get('no');

        $userrole   = $this->conn->prepare("SELECT * FROM User WHERE Site=? AND WEBLevel=?");
        $userrole->execute(array($_SESSION['spider_site'], $no));
        if( $userrole = $userrole->fetchAll(PDO::FETCH_ASSOC) )
		{
			$this->util->js('confirm_dependency()', TRUE);
		}

		$this->util->js('del_data_prepass()', TRUE);
    }

    // ----------------------------------------------------------------------------------

   public function delete()
    {
        $no     = $this->input->get('no');
        $Name   = $this->util->GetRecordName('WebUser', $no);

        $User   = $this->conn->query("DELETE FROM WebUser WHERE Site=? AND No=?");
        if( $User->execute(array($_SESSION['spider_site'], $no)) )
        {
            $this->log->set_log_message($Name);
            $this->util->js('update_list();');
            $this->util->alert( $this->lang->common->delete_completed );
        }
        else
        {
            $this->util->alert($this->lang->common->error_delete);
        }
    }

    // ----------------------------------------------------------------------------------
   public function to_array_userrole()
    {
        $list   = $this->conn->prepare("SELECT * FROM UserRole WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach ($list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }        

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function to_array_floor()
    {
        $list   = $this->conn->prepare("SELECT * FROM Floor WHERE Site=?");
        $list->execute(array($_SESSION['spider_site']));
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach ($list as $key=>$val)
        {
            $arr[$val['No']] = $val['Name'];
        }        

        return $arr;
    }

    // ----------------------------------------------------------------------------------

   public function floor_show()
    {
		if( $_SESSION['spider_type'] == 'spider' ) {
			$sth    = $this->conn->prepare("UPDATE Controller SET DefaultFloorState=? WHERE No=?");
			$values = array('1','1');
			$sth->execute($values);
		} else {
	        $sth    = $this->conn->prepare("UPDATE WebUser SET DefaultFloorState=? WHERE Site=? AND No=?");
			$values = array('1',$_SESSION['spider_site'],$_SESSION['spider_userno']);
			$sth->execute($values);
		}

		$_SESSION['spider_floorstate'] = '1';
		session_write_close();
    }

    // ----------------------------------------------------------------------------------

   public function floor_hide()
    {
		if( $_SESSION['spider_type'] == 'spider' ) {
	        $sth    = $this->conn->prepare("UPDATE Controller SET DefaultFloorState=? WHERE No=?");
			$values = array('0','1');
			$sth->execute($values);
		} else {
	        $sth    = $this->conn->prepare("UPDATE WebUser SET DefaultFloorState=? WHERE Site=? AND No=?");
			$values = array('0',$_SESSION['spider_site'],$_SESSION['spider_userno']);
			$sth->execute($values);
		}

		$_SESSION['spider_floorstate'] = '0';
		session_write_close();
    }

    // ----------------------------------------------------------------------------------

   public function check_max_count()
	{
    	$max_user  = $this->util->GetLimitCount(ConstTable::MAX_CONNECT_1, 
		                                 ConstTable::MAX_CONNECT_2, 
                                         ConstTable::MAX_CONNECT_3,
                                         ConstTable::MAX_CONNECT_4);
		if ($max_user <= $this->util->GetRecordCount('WebUser'))
    	{
			$this->util->js('close_new();');
    		$this->util->alert($this->lang->addmsg->error_limit_connect);
    	} else {
			$this->util->js('open_new();');
			$this->util->js("init_form_data('new');");
		}
	}

    // ----------------------------------------------------------------------------------
}


?>