<?php
/***********************************************************************************
 * FILE NAME : IntercomImpl.php                                  DESIGN REF : FMCM00
 * 
 * AUTHOR  : CHEOLJOO MOON
 * DATE    : 2019.03.08 (KR, UTC+9)
 * CHANGES :
 *     REF NO  VERSION     DATE        WHO        DETAIL 
 *        1    0.0.1       2019.03.08  CJMOON     Init 
 * 
 * FILE Encoding : UTF-8
 * 
 * DESCRIPTION : Intercom abstract
 *  
 ***********************************************************************************/
include_once "./common/IntercomBaseImpl.php";

class beward extends IntercomBaseImpl
{   
		
    /* ================================================================== */    
    /* Intercom의 호출 시 */        
    public function call()
    {
        $doorNo = $this->input->get('door');
        
        if(empty($doorNo))
        {
            header("HTTP/1.0 404 Not Found");
            exit;            
        }

        //check SQL Injection Attack
        if(parent::IS_SQLInjection($doorNo))
        {
            header("HTTP/1.0 404 Not Found");
            exit;
        }        
        
        /* SPIDER-NVR Recoding Start */
        $Channel = $this->NVR_record($doorNo);

        $door = $this->conn->prepare("SELECT Site, Name, Port FROM Door WHERE No = ?");
        $door->execute( array($doorNo) );
        $door = $door->fetch(PDO::FETCH_ASSOC);

        /* log '0' 'Intercom' '0' '99999' '' '0' 'VISIT' '0' '0' '' */        
        $Site = $door['Site'];
        $DeviceName = $door['Name'];
        $Port = $door['Port'];
        $EventCode = "16705";       //TODO
        $CardNo = "";
        $UserNo = 0;
        $UserName = "VISIT";
        $Ack        = '0';
        $Type		= '0';   
        $Message = '';
        
        // example) ./spider-cgi intercom 1 client1 1 16705 '' '' 'VISIT' 0 0 '' 77
        if($Channel > 0)
            exec(SPIDER_COMM." intercom '{$Site}' '{$DeviceName}' '{$Port}' '{$EventCode}' '{$CardNo}' '{$UserNo}' '{$UserName}' '{$Ack}' '{$Type}' '{$Message}' '{$Channel}' ");
        else 
            exec(SPIDER_COMM." log '{$Site}' '{$DeviceName}' '{$Port}' '{$EventCode}' '{$CardNo}' '{$UserNo}' '{$UserName}' '{$Ack}' '{$Type}' '{$Message}' ");
    }

    /* ================================================================== */    
    /* Intercom의 Camera에서 Motion Detect Event 발생 시 */
    public function motion()
    {
        $doorNo     = $this->input->get('door');
        
        if(empty($doorNo))
        {
            header("HTTP/1.0 404 Not Found");
            exit;            
        }

        //check SQL Injection Attack
        if(parent::IS_SQLInjection($doorNo))
        {
            header("HTTP/1.0 404 Not Found");
            exit;
        }        
        
        $door = $this->conn->prepare("SELECT Site, Name, Port FROM Door WHERE No = ?");
        $door->execute( array($doorNo) );
        $door = $door->fetch(PDO::FETCH_ASSOC);

        /* log '0' 'Intercom' '0' '99999' '' '0' 'VISIT' '0' '0' '' */        
        $Site = $door['Site'];
        $DeviceName = $door['Name'];
        $Port = $door['Port'];
        $EventCode = "16705";       //TODO
        $CardNo = "";
        $UserNo = 0;
        $UserName = "Motion Detect";
        $Ack        = '0';
        $Type		= '0';
        $Message = '';
             
        exec(SPIDER_COMM." log '{$Site}' '{$DeviceName}' '{$Port}' '{$EventCode}' '{$CardNo}' '{$UserNo}' '{$UserName}' '{$Ack}' '{$Type}' '{$Message}'");
    }

    /* ================================================================== */    
    /* Intercom 동작시 SPIDER-NVR에 Record 동작 명령 */
    private function NVR_record($doorNo)
    {
        $nvr = $this->conn->prepare("SELECT a.ip ip, ifnull(a.DeliverRecord, 9001) port, b.Channel channel, b.Events Events" .
                                    " FROM DVR a, ( SELECT Channel, dvrno ,Events FROM dvrchannel WHERE Enable=1 and doorno=? ) b " .
                                    " WHERE a.no = b.dvrno and a.Type=1 ");
        $nvr->execute( array($doorNo) );
        $nvr = $nvr->fetch(PDO::FETCH_ASSOC);

        if(!empty($nvr)) {   
            $ip      = $nvr['ip'];
            $port    = $nvr['port'];
            $channel = $nvr['channel'];
            $videoTag = substr($nvr['Events'], 12, 1);
            if($videoTag === '1') {
                exec(SPIDER_COMM." recording '{$ip}' '{$port}' '{$channel}' ");
                return $channel;
            }            
        }

        return 0;
    }
}