<?php

class EventCode
{
	static $attrs	= array(
		"0" => "Event None",
		"2" => "Denied",
		"100" => "Access Denied",
		"101" => "Denied Invalid Wiegand Format",
		"102" => "Access Denied-Key Number",
		"201" => "Card Format Not Defined",
		"300" => "Denied Lost Card",
		"301" => "Denied Stolen Card",
		"302" => "Denied Expired Card",
		"303" => "Denied Inactive Card",
		"305" => "Denied by Schedule",
		"307" => "Denied Timed Anti Passback Violation",
		"308" => "Denied Room Anti Passback Violation",
		"311" => "Denied Threat Level Violation",
		"313" => "Access Denied By Hazmat Lockdown",
		"315" => "Access Denied Invalid card type",
		"317" => "Access Denied without Deadman zone Check Card",
		"320" => "Access Denied by Occupancy",
		"400" => "Granted",
		"401" => "Door Forced Open",
		"402" => "Door Held Open",
		"404" => "Door Contact Trouble",
		"405" => "Door Open",
		"406" => "Door Closed",
		"407" => "REX Trouble",
		"408" => "REX In",
		"409" => "REX Ignored",
		"410" => "Access complete",
		"411" => "Access not complete",
		"420" => "Access Granted Muster Region",
		"430" => "Access Granted Manager Read In",
		"431" => "Access Granted Manager Read Out",
		"440" => "Access Granted One Time User",
		"450" => "Guard Tour checked",
		"452" => "DeadMan Region Checked",
		"453" => "DeadMan Region Timed Out",
		"460" => "Arming Burglar Alarm",
		"461" => "Disarming Burglar Alarm",
		"462" => "Check Zone Status",
		"470" => "Extended Unlock Time",
		"480" => "Arming by Burglar Card",
		"481" => "Disarming by Burglar Card",
		"500" => "Aux Input Trouble",
		"501" => "Aux Input",
		"502" => "Aux Input Normal",
		"600" => "Door Locked",
		"601" => "Door Unlocked",
		"603" => "Door relock by toggle",
		"604" => "Door unlock by toggle",
		"605" => "Door relock by relock user",
		"607" => "Door lock by hazmat",
		"608" => "Door relock by passage",
		"609" => "Door unlock by passage",
		"610" => "Door relock by Latch",
		"611" => "Door unlock by Latch",
		"650" => "Granted Elevator",
		"651" => "Unregistered Card",
		"700" => "Tamper OK",
		"701" => "Power OK",
		"702" => "Check the IF Board",
		"730" => "Record Video",
		"770" => "System Startup",
		"800" => "DB Sync Start",
		"801" => "DB Sync Complete",
		"802" => "DB Sync Error",
		"900" => "Client Connected",
		"901" => "Client Disconnected",
		"903" => "Starting the Client Update",
		"904" => "Starting the Software Update",
		"907" => "License Changed",
		"909" => "Certificate Changed",
		"10103" => "Floor Map Setting Change",
		"10201" => "Camera Data Added",
		"10202" => "Camera Data Delete",
		"10203" => "Camera Data Update",
		"10301" => "Card Holder Data Added",
		"10302" => "Card Holder Data Delete",
		"10303" => "Card Holder Data Update",
		"10316" => "Card Holder Data Delete All",
		"10401" => "Card Data Added",
		"10402" => "Card Data Delete",
		"10403" => "Card Data Update",
		"10409" => "One Time Card Reset",
		"10501" => "Card Format Data Added",
		"10502" => "Card Format Data Delete",
		"10503" => "Card Format Data Update",
		"10601" => "Access Level Data Added",
		"10602" => "Access Level Data Delete",
		"10603" => "Access Level Data Update",
		"10701" => "Event Action Data Added",
		"10702" => "Event Action Data Delete",
		"10703" => "Event Action Data Update",
		"10803" => "Threat Level Update",
		"11001" => "Schedule Data Added",
		"11002" => "Schedule Data Delete",
		"11003" => "Schedule Data Update",
		"11101" => "Holiday Data Added",
		"11102" => "Holiday Data Delete",
		"11103" => "Holiday Data Update",
		"11203" => "Door Data Update",
		"11211" => "Dashboard M-Unlock",
		"11212" => "Dashboard E-Unlock",
		"11213" => "Dashboard Lock",
		"11303" => "Aux Input Data Update",
		"11403" => "Aux Output Data Update",
		"11414" => "Dashboard Aux Trigger",
		"11415" => "Dashboard Aux Stop",
		"11501" => "Floor Data Added",
		"11502" => "Floor Data Delete",
		"11503" => "Floor Data Update",
		"11603" => "Controller Data Update",
		"11705" => "Software Update Successful",
		"11710" => "Software Update Failed",
		"11803" => "Backup Scheduled Updated",
		"11805" => "Data Backup Successful",
		"11810" => "Data Backup Failed",
		"11905" => "Restored from backup",
		"11910" => "Data Restore Failed",
		"12009" => "System Reboot",
		"12205" => "Data Export Complete",
		"12305" => "Data Import Complete",
		"12401" => "Web User Account Data Added",
		"12402" => "Web User Account Data Delete",
		"12403" => "Web User Account Data Update",
		"12503" => "Log Management Data Update",
		"12505" => "Log Data Backup Successful",
		"12509" => "Log Data Reset",
		"12510" => "Log Data Backup Failed",
		"12518" => "Log Data Merge",
		"12603" => "Threat Level Setting Data Update",
		"12703" => "IP Address Configuration Updated",
		"12903" => "FTP Configuration Updated",
		"13003" => "Update Server Configuration Updated",
		"13203" => "SMTP Configuration Updated",
		"13606" => "ACK message",
		"13705" => "Skin Change",
		"13801" => "Unlock Schedule Data Added",
		"13802" => "Unlock Schedule Data Delete",
		"13803" => "Unlock Schedule Data Update",
		"13903" => "Elevator Data Update",
		"13914" => "Dashboard Elevator Trigger",
		"13915" => "Dashboard Elevator Stop",
		"14003" => "User Define Field Data Update",
		"14101" => "User Role Data Added",
		"14102" => "User Role Data Delete",
		"14103" => "User Role Data Update",
		"14301" => "User Group Data Added",
		"14302" => "User Group Data Delete",
		"14303" => "User Group Data Update",
		"14401" => "Door Group Data Added",
		"14402" => "Door Group Data Delete",
		"14403" => "Door Group Data Update",
		"14701" => "Access Group Data Added",
		"14702" => "Access Group Data Delete",
		"14703" => "Access Group Data Update",
		"14903" => "Site Data Update",
		"15003" => "Site Device Data Update",
		"15101" => "Web User Added",
		"15102" => "Web User Delete",
		"15103" => "Web User Update",
		"15107" => "Web User Login",
		"15108" => "Web User Logout",
		"15110" => "Invalid Login Attempt",
		"15201" => "DVR Data Added",
		"15202" => "DVR Data Delete",
		"15203" => "DVR Configuration Update",
		"15303" => "License Key Updated",
		"15401" => "Smart Report Set Data Added",
		"15402" => "Smart Report Set Data Delete",
		"15403" => "Smart Report Set Data Update",
		"15404" => "Smart Report Run Added",
		"15405" => "Smart Report Run Start",
		"15406" => "Smart Report Run Complete",
		"15407" => "Smart Report Run Failed",
		"15408" => "Smart Report Run Canceled",
		"15503" => "Time Settings Change",
		"15603" => "Lost Card Registration",
		"15606" => "Grace Complete",
		"15615" => "DeadMan Grace Complete",
		"15703" => "Client Data Update",
		"15709" => "Client Reboot",
		"15717" => "Client Replace",
		"15803" => "Event Code Data Update",
		"15902" => "Elevator Action Data Delete",
		"15903" => "Elevator Action Data Update",
		"16003" => "RMC Update",
		"16101" => "Camera Group Data Added",
		"16102" => "Camera Group Data Delete",
		"16103" => "Camera Group Data Update",
		"16201" => "One Time Unlock Schedule Data Added",
		"16202" => "One Time Unlock Schedule Data Delete",
		"16203" => "One Time Unlock Schedule Data Update",
		"16301" => "Region Data Added",
		"16302" => "Region Data Delete",
		"16303" => "Region Data Update",
		"16319" => "Occupancy Data Clear",
		"16403" => "RMC Setting Change",
		"16503" => "CLOUD Setting Change",
		"16603" => "OpenAPI Setting Change",
		"16705" => "Intercom Calling",
		"16801" => "NVR Data Added",
		"16802" => "NVR Data Delete",
		"16803" => "NVR Data Update",
		"16901" => "NVR Channel Added",
		"16902" => "NVR Channel Delete",
		"16903" => "NVR Channel Update",
		"17001" => "Video Tag Added",
		"17002" => "Video Tag Delete",
		"17003" => "Video Tag Update",
		"110313" => "Aux Output Follow AuxIn",
		"110314" => "Aux Output E-On",
		"110315" => "Aux Output Repeat",
		"110316" => "Aux Output Single",
		"110317" => "Aux Output Trouble",
		"110318" => "Send Email",
		"110320" => "Tamper Fault",
		"110321" => "Power Fault",
		"110328" => "Aux Output Off",
		"110331" => "Aux Output Repeat by Elevator",
		"110332" => "Aux Output Single by Elevator",
		"110333" => "Aux Output Off by Elevator",
		"1010206" => "Denied By Lock mode is not normal",
		"1010207" => "Denied Invalid Access Level",
		"1020201" => "Access Denied By Elevator Information not found",
		"1020202" => "Access Denied By Elevator Lock",
		"1104301" => "Log Database Warning Message",
		"1104302" => "Popup System Message",
		"1104303" => "System Log is Full",
		"1105020" => "First Person Out",
		"1105021" => "Access Violation Two Person Rule",
		"1105022" => "Access Granted First Person In",
		"1105023" => "Access Denied",
		"1105025" => "Access Violation First Person In",
		"1105026" => "Access Violation Key Number Check",
		"1105027" => "Access Pending Two Person Rule",
		"1105028" => "Access Granted Grace Period First Person In",
		"1105030" => "Denied Region Occupancy Limit Violation",
		"1105031" => "Denied Region Anti Passback Violation",
		"1105032" => "Denied Region Tailgating Violation",
		"1105033" => "Access Denied",
		"1170101" => "Scheduled Backup to SD/USB was Successful",
		"1170102" => "Scheduled Backup to SD/USB Failed",
		"1170103" => "Backup to SD/USB was Successful",
		"1170104" => "Backup to SD/USB Failed",
		"1170201" => "Scheduled Backup to FTP was Successful",
		"1170202" => "Scheduled Backup to FTP Failed",
		"1170203" => "Backup to FTP was Successful",
		"1170204" => "Backup to FTP Failed",
		"1170301" => "Scheduled Log Backup to SD/USB was Successful",
		"1170302" => "Scheduled Log Backup to SD/USB Failed",
		"1170303" => "Log Backup to SD/USB was Successful",
		"1170304" => "Log Backup to SD/USB Failed",
		"1170401" => "Scheduled Log Backup to FTP was Successful",
		"1170402" => "Scheduled Log Backup to FTP Failed",
		"1170403" => "Log Backup to FTP was Successful",
		"1170404" => "Log Backup to FTP Failed"
	);
}
	
?>