<?php
/* PHP Error Page 출력 여부 - 개발 시에는 On, Release 시에는 Off 해야 한다. */
ini_set('display_errors', 'off');

//define('ROOT_DIR',  '/Users/lxd/private/工具/系统/sicunet/Neptune-php7');
define('ROOT_DIR',  '');
define('BASE_DIR',  ROOT_DIR.'/spider/web');
define('APP_DIR',   BASE_DIR.'/app');
define('WEBROOT', BASE_DIR.'/webroot');

require_once APP_DIR.'/common/config.php';
//require_once APP_DIR.'/libraries/DBSession.php';

/* ================================================================== */
/* 기존 System은 SITE개념이 존재 하나, OpenAPI에서는 SITE개념이 존재 하지 않는다. */
define('OPENAPI_ID',    "OpenAPI");
define('OPENAPI_SITE',  "1");

/* ================================================================== */
/* Log and Report 조회 시, 검색 시작일자와 종료일자의 차이를 최대 7일 (1주일)로 제한한다. 
   검색 대상 Record가 128M를 초과하면 PHP Error 발생 함. 

   PHP.INI의 Default Max Memory Size가 128M로 설정되어 있음 */
define('MAX_SEARCH_DAY',  "7");
define('MAX_LIST_ROW', 20);

/* Image File Path */
define('API_USER_IMG', WEBROOT.'/user_img');
/* Max Image File Size */
define('MAX_IMAGE_SIZE', 1024000);
/* ================================================================== */
header("Pragma: no-cache");
header("Cache-Control: no-cache,must-revalidate,no-store"); 
header('Content-Type:application/json; charset=utf-8');

/* ================================================================== */
/* URL Parser                                                         */
$urlPath = explode('/', parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH));
$apiName = $urlPath[1];
$method  = @$urlPath[2];

if(strtolower($apiName) == "log"){
	$apiName = "SysLog";
}

/* ================================================================== */
/* DEBUG LINE */
//print_r(var_dump($_FILES));
//error_log('contents:'.$_SERVER["CONTENT_TYPE"]);
//error_log('contents:'.$_SERVER["CONTENT_DISPOSITION"]);
//print_r(var_dump($_REQUEST));
//exit;

/* ================================================================== */
/* 하위 Method가 없다면 HTTP METHOD에 따른 CRUD로 처리                  */
if(empty($method)) {
    if($_SERVER['REQUEST_METHOD'] === "GET") $method = "clist";
    else if($_SERVER['REQUEST_METHOD'] === "POST") $method = "insert";
    else if($_SERVER['REQUEST_METHOD'] === "PUT") $method = "update";
    else if($_SERVER['REQUEST_METHOD'] === "DELETE") $method = "delete";
}

/* ================================================================== */
/* Version Check                                                     */
$server_header = getallheaders();

/*
$server_header['Api-Ver'] = "1.0";
$server_header['Auth-Key'] = "5f54a4e67fcf599a7b8d5fa83609e928880cc1d83216359afbc21793f9853833";
$_ENV["OPENAPI_DATA"] = "::1:5f54a4e67fcf599a7b8d5fa83609e928880cc1d83216359afbc21793f9853833:123123:1:3:360";
*/
$apiVer = $server_header['Api-Ver'];
if(empty($apiVer)) {    
    header("HTTP/1.0 404 Not Found");
    exit;    
}

/* ================================================================== */
/* Class File Check (경로 규칙은 호출시 1.0 => /v1.0 )                 */
if(!is_file("./v".$apiVer."/".$apiName.EXT)) {
    header("HTTP/1.0 404 Not Found");
    exit;
}



require_once "./v"."$apiVer/".$apiName.EXT;
$controller = new $apiName();

/* ================================================================== */
/* Method Check                                                       */                             
if(!method_exists($controller, $method)) {    
    header("HTTP/1.0 404 Not Found");
    exit;
}

call_user_func_array(array(&$controller, $method), array());
?>
