<?php
/***********************************************************************************
 * FILE NAME : Card.php                                          DESIGN REF : FMCM00
 * 
 * AUTHOR  : CHEOLJOO MOON
 * DATE    : 2019.01.03 (KR, UTC+9)
 * CHANGES :
 *     REF NO  VERSION     DATE        WHO        DETAIL 
 *        1    0.0.1       2018.12.26  CJMOON     Init 
 * 
 * FILE Encoding : UTF-8
 * 
 * DESCRIPTION : Client API
 *  
 ***********************************************************************************/
require_once "./common/OpenApiBaseImpl.php";
require_once "./common/ConstOpenapiErrorCode.php";
require_once APP_DIR.'/libraries/EnumTable.php';

class Account extends OpenApiBaseImpl
{ 
    /* ================================================================== */    
    /* Account List */
    public function clist() 
    {
        $attrUserRole   = $this->to_array_userrole();
        $attrFloor      = $this->to_array_floor();

        try {	        
            
            $No = $this->conn->prepare("SELECT COUNT(*) from WebUser WHERE Site=?");
            $No->execute(array(parent::getAccountSite()));
            $No    = $No->fetchColumn();
            $list['total'] = $No;

            $dbContext = $this->conn->prepare("SELECT No, Name, Type, Id,UserRole, Language, DefaultPage," .
                                              " DefaultFloorNo, DefaultFloorState, AutoDisconnectTime FROM WebUser ORDER BY No DESC");
            if(is_bool($dbContext)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }

            $dbContext->execute();
            $dbContext = $dbContext->fetchAll(PDO::FETCH_ASSOC);
            
            
            
            if(count($dbContext) > 0) {
                foreach( $dbContext as $key=>$val ) {
                    $dbContext[$key]['AutoDisconnectTimeStr'] = EnumTable::$attrAutoDisconnectTime[$val['AutoDisconnectTime']];
                    $dbContext[$key]['DefaultFloorStateStr'] = EnumTable::$attrYesNo[$val['DefaultFloorState']];
                    $dbContext[$key]['DefaultPageStr'] = EnumTable::$attrDefaultPage[$val['DefaultPage']];
                    $dbContext[$key]['UserRoleStr'] = $attrUserRole[$val['UserRole']];
                    $dbContext[$key]['DefaultFloorStr'] = $attrFloor[$val['DefaultFloorNo']];
                    $dbContext[$key]['LanguageStr'] = EnumTable::$attrLanguage[$val['Language']];
                    $list['row'] = $dbContext;
                }

                parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS, array($list));       
            } 
            else {
                parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS);
            }  
        } // try
        catch (PDOException $e) {
            parent::toError(ConstOpenapiErrorCode::ERR_ETC, $e->getMessage());
            exit;
        } // catch
        catch(Exception $e) {
            parent::toError(ConstOpenapiErrorCode::ERR_ETC, $e->getMessage());
            exit;
        } // catch           
    }    

    /* ================================================================== */    
    /* Account Insert */
    public function insert()
    {


        


      $Name = $this->input->post('Name');
      $Id   = $this->input->post('Id');
      $Password = $this->input->post('Password');
      $UserRole = $this->input->post('UserRole');
      $DefaultPage = $this->input->post('DefaultPage','alarm_map');
      $Lang = $this->input->post('Language','en');
      $DefaultFloorNo = $this->input->post('DefaultFloorNo','1');
      $DefaultFloorState = $this->input->post('DefaultFloorState','1');

      $AutoDisconnectTime = $this->input->post('AutoDisconnectTime','01:00');

      /* 필수 입력정보 체크 */
      /*
      if(empty($Name)     || 
         empty($Id)       || 
         empty($Password) || 
         empty($UserRole)) {
        parent::toError(ConstOpenapiErrorCode::ERR_INPUT_VALUE);
        exit;
      }
      */

      if(empty($Name)) 
      {
        parent::toError(ConstOpenapiErrorCode::ERR_INPUT_VALUE);
        exit;
      }

      if(empty($Id)) 
      {
        parent::toError(ConstOpenapiErrorCode::ERR_INPUT_VALUE);
        exit;
      }

      if(empty($Password)) 
      {
        parent::toError(ConstOpenapiErrorCode::ERR_INPUT_VALUE);
        exit;
      }

      if(empty($UserRole)) 
      {
        parent::toError(ConstOpenapiErrorCode::ERR_INPUT_VALUE);
        exit;
      }


      try 
      {   
            $No = $this->conn->prepare("SELECT MAX(No) from WebUser WHERE Site=?");
            $No->execute(array(parent::getAccountSite()));
            $No    = $No->fetchColumn() + 1;

            $dbContext = $this->conn->prepare("SELECT count(id) FROM WebUser where id='?'");
            if(is_bool($dbContext)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }

            ///parent::toError("ddddddd");
            //exit;

            //$dbContext->execute(array($Id));
            //$dbContext = $dbContext->fetchAll();
            //if( $dbContext > 0 ) {
             //   parent::toError(ConstOpenapiErrorCode::ERR_ACCOUNT_ID_DUPLICATION);
              //  exit;
            //}
            
            $valueArr =    array(parent::getAccountSite(), $No,$Name," ",$Id,$Password,
                           $UserRole,$Lang,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,
                           $AutoDisconnectTime);
            
            $Type= ' ';
            $valueArr =    array(1, $No,$Name,$Type,$Id,$Password,$UserRole,$Lang,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,$AutoDisconnectTime);

            //$dbContext2 = $this->conn->prepare("INSERT INTO WebUser (Site, No, Name, Type, ID, Password, UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) VALUES(1,7,'test6',' ','test4','1234',1,'en','alarm_map',1,1,1)");
            //$dbContext2 = $this->conn->prepare("INSERT INTO WebUser (Site, No, Name, Type, ID, Password, UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) VALUES('1','11','12345','1234','1234','1','en','alarm_map','1','1','1')");
            $dbContext2 = $this->conn->prepare("insert into WebUser values ('1','11','test11',' ','test11','1234','1','en','alarm_map','1','1','1')");

            //$dbContext2 = $this->conn->prepare("INSERT INTO WebUser (Site, No, Name, ID, Password, UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) VALUES(?','?','?','?','?','?','?','?','?','?','?')");
            //$dbContext2 = $this->conn->prepare("INSERT INTO WebUser (Site, No, Name, Type, ID, Password, UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) VALUES('".parent::getAccountSite()."','".$No."','".$Name."','".$Type."','".$Id."','".$Password."','".$UserRole."','".$Lang."','".$DefaultPage."','".$DefaultFloorNo."','".$DefaultFloorState."','".$AutoDisconnectTime."'");

            if(is_bool($dbContext2)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }
            
            //parent::toError($valueArr);    
            //exit;

            //$dbContext2->execute(array( '1','7','12345',' ','1234','1234','1','en','alarm_map','1','1','1'));
            $dbContext2->execute();
            //$dbContext2    = $dbContext2->fetchColumn() + 1;

            /*
            if(!$dbContext2->execute(array($valueArr))) {
                throw new Exception($this->conn->errorInfo()[2]);
            }
            */

            parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS);
            
/*            
            $dbContext = $this->conn->prepare("INSERT INTO WebUser (Site, No, Name, Type, ID, Password, UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) VALUES(?,?,'?'," ",'?','?',1,'?','?',?,?,?)");

            if(is_bool($dbContext)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }

            if(!$dbContext->execute($valueArr)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }



            parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS);
*/

            




        /*
            //$No = $this->conn->prepare("SELECT MAX(No) from WebUser WHERE Site=?");
            //$No->execute(array(parent::getAccountSite()));
            //$No    = $No->fetchColumn() + 1;

            // User ID 중복 체크
            $dbContext = $this->conn->prepare("SELECT count(id) " .
                                              " FROM WebUser id=?");


            if(is_bool($dbContext)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }

            $dbContext->execute(array($Id));
            $dbContext = $dbContext->fetchAll();
            if( $dbContext > 0 ) {
                parent::toError(ConstOpenapiErrorCode::ERR_ACCOUNT_ID_DUPLICATION);
                exit;
            }

            parent::toError("ddddddd");
            exit;
            INSERT INTO WebUser (Site, No, Name, Type, ID, Password, UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) VALUES(1,,"test4"," ","test4","1234",1,"en","alarm_map",1,1,1)
            //INSERT INTO WebUser (Site, No, Name, Type, ID, Password, UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) VALUES(1,4,"test4"," ","test4","1234",1,"en","alarm_map",1,1,1)
            $temp=" ";
            $valueArr = array(parent::getAccountSite(), $No,$Name,$temp,$Id,$Password,$UserRole,$Lang,$DefaultPage,$DefaultFloorNo,$DefaultFloorState,$AutoDisconnectTime);

            //Account Insert
            $dbContext = $this->conn->prepare("INSERT INTO WebUser (Site, No, Name, Type, ID, Password, ".
                                              " UserRole, Language, DefaultPage, DefaultFloorNo, DefaultFloorState, AutoDisconnectTime) ".
                                              " VALUES(?,?,'?'," ",'?','?',1,'?','?',?,?,?)");

            
            

            if(is_bool($dbContext)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }

            if(!$dbContext->execute($valueArr)) {
                throw new Exception($this->conn->errorInfo()[2]);
            }



            parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS);

            //parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS, array("No"=>$No));

            //parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS, array("No"=>$No));  
            */   
        }
        catch (PDOException $e) {
            
            //parent::toError(ConstOpenapiErrorCode::ERR_ETC, $e->getMessage());
            exit;
        } // catch
        catch(Exception $e) {
            parent::toError("vv");
            //parent::toError(ConstOpenapiErrorCode::ERR_ETC, $e->getMessage());
            exit;
        } // catch 

    }

    /* ================================================================== */    
    /* User Role List */
    private function to_array_userrole()
    {
        $list   = $this->conn->prepare("SELECT * FROM UserRole");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach ($list as $key=>$val) {
            $arr[$val['No']] = $val['Name'];
        }        

        return $arr;
    }

    /* ================================================================== */    
    /* floor List */
    private function to_array_floor()
    {
        $list   = $this->conn->prepare("SELECT * FROM Floor");
        $list->execute();
        $list   = $list->fetchAll(PDO::FETCH_ASSOC);

        $arr    = array();
        foreach ($list as $key=>$val) {
            $arr[$val['No']] = $val['Name'];
        }        

        return $arr;
    }
}
?>