<?php
/***********************************************************************************
 * FILE NAME : CodeValue.php                                          DESIGN REF : FMCM00
 * 
 * AUTHOR  : CHEOLJOO MOON
 * DATE    : 2019.01.03 (KR, UTC+9)
 * CHANGES :
 *     REF NO  VERSION     DATE        WHO        DETAIL 
 *        1    0.0.1       2018.12.26  CJMOON     Init 
 * 
 * FILE Encoding : UTF-8
 * 
 * DESCRIPTION : Code성 Value들만을 위한 모음
 *  
 ***********************************************************************************/
include_once "./common/OpenApiBaseImpl.php";
include_once "./common/ConstOpenapiErrorCode.php";
include_once APP_DIR.'/libraries/EnumTable.php';

class CodeValue extends OpenApiBaseImpl
{  
    /* ================================================================== */    
    /* Event Code LIst */
    public function eventcode()
    {
        /* 국가별 언어에 따른 Log Message 처리 */
        if(empty($this->request_header['Lang']) || $this->request_header['Lang'] === 'en') {            
            $str = file_get_contents(APP_DIR.'language/en/eventcode.json');
        } 
        else if($this->request_header['Lang'] === 'cn') {
            $str = file_get_contents(APP_DIR.'language/cn/eventcode.json');
        }               
        else if($this->request_header['Lang'] === 'kr') {
            $str = file_get_contents(APP_DIR.'language/kr/eventcode.json');
        }            
        else if($this->request_header['Lang'] === 'fr') {
            $str = file_get_contents(APP_DIR.'language/fr/eventcode.json');
        }            
        else if($this->request_header['Lang'] === 'pt') {
            $str = file_get_contents(APP_DIR.'language/pt/eventcode.json');
        }            
        else if($this->request_header['Lang'] === 'sp') {
            $str = file_get_contents(APP_DIR.'language/sp/eventcode.json');
        }            

        $json = json_decode($str, true);
        parent::toJson(ConstOpenapiErrorCode::ERR_SUCCESS, array($json));
    }
}
?>