<?php 

global $log;

$log_img    = $this->conn->prepare("SELECT LogoFile FROM Site WHERE No=?");
$log_img->execute(array($_SESSION['spider_site']));
$log_img    = $log_img->fetchColumn();
if (empty($log_img) || $log_img == "")
	$log_img = "/img/default_logo.png";
else
	$log_img = "./floor_img/".$log_img;
	
$threat  = $this->conn->prepare("SELECT B.ThreatName FROM Threat AS A JOIN ThreatLevel AS B ON A.ThreatStatus = B.Level AND A.Site = B.Site WHERE A.Site=?");
$threat->execute(array($_SESSION['spider_site']));
$threat  = $threat->fetchColumn();
if($threat == FALSE) {
	$threat = $lang->tlevel->NotSet;
}

$camera  = $this->conn->prepare("SELECT COUNT(*) FROM Camera WHERE Site=? AND DoorNo != 0");
$camera->execute(array($_SESSION['spider_site']));
$camera  = $camera->fetchColumn();

$doors    = $this->conn->prepare("SELECT No,Name FROM Door WHERE Site=? AND Disable=0");
$doors->execute(array($_SESSION['spider_site']));
$arr_door = array();
while( $door = $doors->fetch(PDO::FETCH_ASSOC) )
{
	$arr_door[$door['No']] = $door['Name'];
}

$door_list = $this->conn->prepare("SELECT No,Name FROM Door WHERE Site=? AND Disable=0");
$door_list->execute(array($_SESSION['spider_site']));
$door_list = $door_list->fetchAll(PDO::FETCH_ASSOC);
$door_list = json_encode($door_list);

$reader_list = $this->conn->prepare("SELECT DISTINCT ReaderNo, No FROM (SELECT MasterReader AS ReaderNo, No FROM Door WHERE Site=? UNION SELECT SlaveReader  AS ReaderNo, No FROM Door WHERE Site=?)");
$reader_list->execute(array($_SESSION['spider_site'], $_SESSION['spider_site']));
$reader_list = $reader_list->fetchAll(PDO::FETCH_ASSOC);
$reader_list = json_encode($reader_list);

$channel_list = $this->conn->prepare("SELECT DISTINCT No, Channel, DvrNo FROM DVRChannel");
$channel_list->execute();
$channel_list = $channel_list->fetchAll(PDO::FETCH_ASSOC);
$channel_list = json_encode($channel_list);

$log_display_list = array();
$ack_list = array();
$eventcodes = $this->conn->query("SELECT * FROM EventCode");
$eventcodes = $eventcodes->fetchAll(PDO::FETCH_ASSOC);
foreach( $eventcodes as $eventcode )
{
	if( $eventcode['LogDisplay'] == '1' )
	{
		$log_display_list[] = $eventcode['EventCode'];
	}
	if( $eventcode['Ack'] == '1' )
	{
		$ack_list[] = $eventcode['EventCode'];
	}
}
?>

<script>

var DoorFilter = false;
var log_display_list = <?=json_encode($log_display_list);?>;
var ack_list = <?=json_encode($ack_list);?>;


jQuery("*").ready(function()
{
    //|| $this->class == 'log_report'
    <? if( $this->class == 'alarm_map' || $this->class == 'timesvr' || $this->class == 'nvr_viewer') { ?>
    setTimeout("log_top('<?=$log[0]['No'] ?>')",600);
    <? } ?>
    thl();
});

function thl()
{
    $.getJSON('./threat_status.php','',function(data)
    {
		if( $.isArray(data) )
		{
			if(data[0]['ThreatName'] != "")
			{
				$("#threat").html(data[0]['ThreatName']);
			}
		}
    });
}

function reader(no,ea)
{
    if(ea < 14)
    {
        if(ea % 2)
        {
            $("#R_"+no).css("background","yellow") 
        }
        else
        {
            $("#R_"+no).css("background","#000000") 
        }
        ea = ea + 1;
        setTimeout('reader('+no+','+ea+')',300);
    }
}

function Ack(no,ea,list)
{
    if(ea < 20)
    {
        if(ea % 2)
        {
            $("#DC_"+no).css("background-position","0px 0px") 
        }
        else
        {
            $("#DC_"+no).css("background-position","0px -74px") 
        }
        ea = ea + 1;
        setTimeout('Ack('+no+','+ea+')',300);
    }
    else
    {
        $("#ack_"+list).css("background","#ffffff");
    }
}

function Rex(no,ea)
{
    if(ea < 14)
    {
        if(ea % 2)
        {
            $("#Rex_"+no).css("background","blue") 
        }
        else
        {
            $("#Rex_"+no).css("background","#ffffff") 
        }
        ea = ea + 1;
        setTimeout('Rex('+no+','+ea+')',300);
    }
}

function DC(no,key)
{
    if(key=='405')
    {
        $("#DC_"+no).css("background-position","0px -37px") 
    }
    else if(key == '406')
    {
        $("#DC_"+no).css("background-position","0px 0px") 
    }
}

function DL(no,key)
{
    if(key=='601')
    {
        $("#DL_"+no).css("background","#fff") 
    }
    else if(key == '600')
    {
        $("#DL_"+no).css("background","red") 
    }
}

function Ack_btn(no)
{
    $.post('./ack_log.php',{no:no},function()
    {
        $("#ack_"+no).remove();
    });
}

function user_reset()
{
    $("#user_img").html("<img src='./img/user.png' style='width:110px;height:130px' />");
    $("#user_name").html("");
    $("#user_card").html("");
    $("#user_date").html("");
}

function pic_reset(port)
{
    //$("#pic_"+data[i]['Port']).html("<img src='' style='width:0px;height:0px' />");
    $("#pic_"+port).html("<img src='' style='width:0px;height:0px' />");
}

function change_state_door(target, bgimage)
{
    var t = $("#" + target);
    t.css("backgroundImage", "url("+bgimage+")");
}

function change_state_aux(target, bgimage)
{
    var t = $("#" + target + " > div");
    t.css("backgroundImage", "url("+bgimage+")");
}

function find_door(No)
{
    var door_list = <?=$door_list?>;
    
    for(var i in door_list)
    {
        if( i == 'indexOf') continue;

        if(door_list[i]['No'] == No)
        {
            return door_list[i]['Name'];
            break;
        }
    }
    return '';
}

function find_door_by_reader(ReaderNo)
{
    var reader_list = <?=$reader_list?>;
    
    for(var i in reader_list)
    {
        if( i == 'indexOf') continue;

        if(reader_list[i]['ReaderNo'] == ReaderNo)
        {
            return reader_list[i]['No'];
            break;
        }
    }
    return '';
}

function find_nvr_by_channel(ChannelNo)
{
    var channel_list = <?=$channel_list?>;
    
    for(var i in channel_list)
    {
        if( i == 'indexOf') continue;

        if(channel_list[i]['No'] == ChannelNo)
        {
            return channel_list[i]['DvrNo'];
            break;
        }
    }
    return '';
}

function find_channel_by_no(ChannelNo)
{
    var channel_list = <?=$channel_list?>;
    
    for(var i in channel_list)
    {
        if( i == 'indexOf') continue;

        if(channel_list[i]['No'] == ChannelNo)
        {
            return channel_list[i]['Channel'];
            break;
        }
    }
    return '';
}

function log_top(no)
{
   	var log_no = '';
    $.getJSON('log.php',{top:25},function(response)
    {
		var data = response.logs;

		$('#e3_time').text(response.time);

		if( typeof write_log_list != "undefined" ) write_log_list(response, true, true);
		if( $.isArray(data) )
		{
            for(i=0;i<data.length;i++)
            {
            	log_no = data[i]['No'];
			}
		}
	    if(!log_no)
	    {
	        log_no = no;
	    }
	    setTimeout("log("+log_no+")",1000);
	});
}

function log(no)
{
   	var log_no = '';
    $.getJSON('log.php',{no:no},function(response)
    {
		var data = response.logs;

		$('#e3_time').text(response.time);

		if( typeof write_log_list != "undefined" ) write_log_list(response);

		if( $.isArray(data) )
		{
            for(i=0;i<data.length;i++)
            {
				<? if($this->is_option(ConstTable::OPTION_VIDEOTAG)) { ?>
				if(typeof data[i]['VideoTag'] != 'undefined' ) {
					if($("input[name='VideoAutoPopup']").is(":checked")) openNVRAutoPopup(data[i]['VideoTag']);
				}
				<? } ?>
				
            	log_no = data[i]['No'];
            	
				if (data[i]['Site'] != 0 && data[i]['Site'] != <?=$_SESSION['spider_site']?>) 
					continue;

				if(data[i]['EventCode'] == "1104303") {
					$("#alert_log_full").show();
				}
					
                <?
                if($this->input->get('c') == 'log_report')
                {
                ?>
                    if (!data[i]['UserName'])
                    {
                        usr_name = '';
                    }
                    else
                    {
                        usr_name = data[i]['UserName'];
                    }
                
                    if(data[i]['No'] % 2)
                    {
                        dom = "<tr id='log_"+data[i]['No']+"' style='background:#ffffff'>";
                    }
                    else
                    {
                        dom = "<tr id='log_"+data[i]['No']+"' style='background:#f4f4f4'>";
                    }
            
                    if(data[i].DeviceName == 'WEB')
                    {
                        //event_mean = data[i].EventCode;
						event_mean = data[i].EventDescription;
                    }
                    else
                    {
                        //event_mean = Event[data[i].EventCode];
						event_mean = data[i].EventDescription;
                    }
        
                    dom = dom + "<td align='center'>"+nullToBlank(data[i]['dd'])+"</td>" +
		                        "<td class=\"<?=($is_localtime_display ? '' : 'hide')?>\">"+nullToBlank(data[i]['LocalTime'])+"</td>" +
		                        "<td style='padding-left:5px;'>"+nullToBlank(data[i]['DeviceName'])+"</td>" +
		                        "<td>"+nullToBlank(usr_name)+"</td>" +
								"<td>"+nullToBlank(data[i]['EventCode'])+"</td>" +
		                        "<td>"+nullToBlank(event_mean)+"</td></tr>";
            
                    $("#log").prepend(dom);
                    $("#log_"+(data[i]['No']-50)).remove();
                <?      
                }
                ?>
                
                <?
                if($this->input->get('c') == 'nvr_viewer')
                {
                ?>
                    if(data[i]['EventCode']=='730')
                    {
	                    var nvr_key = find_nvr_by_channel(data[i]['Res1']);
	                    
                    	var $nvrno = $('select[name="nvr_list"]');
                    	
						if ($nvrno.val() == nvr_key)
						{
							var channel = find_channel_by_no(data[i]['Res1']);
							
							onEventDoorEvent(channel);
						}
                    }
                <?      
                }
                ?>

				if( typeof write_log_list != "undefined" )
				{
	            //<?php 
	            //if($this->input->get('c') == 'alarm_map')
	            //{
	            //?>
	                if(data[i]['Ack'] == '1')
	                {
	                    $("#Ack").prepend("<tr id='ack_"+data[i]['No']+"'   style='background:#ffc7c7'><td>"+nullToBlank(data[i]['UserName'])+"</td><td>"+nullToBlank(data[i]['dd'])+"</td><td><button onclick='Ack_btn("+data[i]['No']+")'> //Ack </button></td></tr>");
	                    //Ack(data[i]['Port'],0,data[i]['No']);
	                }
	                
	                if(data[i]['EventCode']=='400' || data[i]['EventCode']=='1105022') 	// granted
	                {
	                	var key = {};
						key['no'] = data[i]['UserNo'];
						key['site'] = data[i]['Site']; 
						key['doorno'] = find_door_by_reader(data[i]['Port']);
	                	$.getJSON('./user_search.php',key,function(dd)
                        {
							if( $.isArray(dd) && dd.length > 0 && dd[0]['ImageFile'] != "")
							{
								$("#pic_"+dd[0]['doorno']).html("<img src='./user_img/"+dd[0]['ImageFile']+"' style='width:34px;height:42px;' />");
								setTimeout(function() { pic_reset(dd[0]['doorno']); }, 3000);
							}
                        });
	                }
	    	        else if(data[i]['EventCode']=='401')        // ����������(Contact)
	                {
						$("#DC_"+data[i]['Port']).addClass("door-forced_open");
	                	//change_state_door("DC_"+data[i]['Port'], "/img/icon/door_open_blink.gif");
	                    //Ack(data[i]['Port'],0,data[i]['No']);
						change_camera_for_sidebar(data[i]['DoorNo']);
	                } 
	                else if(data[i]['EventCode']=='406')        // ������(Contact)
	                {
						$("#DC_"+data[i]['Port']).removeClass("door-open door-forced_open");
	                    //change_state_door("DC_"+data[i]['Port'], "/img/icon/door_close.png");
	                    $("#pic_"+data[i]['Port']).html("<img src='' style='width:0px;height:0px' />");
	                }
	                else if(data[i]['EventCode']=='405')        // ������(Contact)
	                {
						$("#DC_"+data[i]['Port']).addClass("door-open");
	                    //change_state_door("DC_"+data[i]['Port'], "/img/icon/door_open.png");
	                } 
	                else if(data[i]['EventCode']=='600' || data[i]['EventCode']=='603' || data[i]['EventCode']=='605' || data[i]['EventCode']=='607' || data[i]['EventCode']=='608' || data[i]['EventCode']=='610')        // �����(Door Lock)
	                {
						$("#DC_"+data[i]['Port']).addClass("door-lock");
	                	//change_state_door("DC_"+data[i]['Port'], "/img/icon/door_lock.png");
	                	$("#pic_"+data[i]['Port']).html("<img src='' style='width:0px;height:0px' />");
	                } 
	                else if(data[i]['EventCode']=='601' || data[i]['EventCode']=='604'  || data[i]['EventCode']=='609' || data[i]['EventCode']=='611')        // ���������(Door Lock)
	                {
						$("#DC_"+data[i]['Port']).removeClass("door-lock");
						//console.log(data[i]);
	                	//change_state_door("DC_"+data[i]['Port'], "/img/icon/door_close.png");
	                } 
	                else if(data[i]['EventCode']=='408')        // Rex �Է�
	                {
	                }
	                else if(data[i]['EventCode']=='900')        // Client Connect
	                {
						$.getJSON('/?c=door&m=select&f=hostno&w=' + data[i]['Port'], function(dd) {
							var items = dd['list'];
							if( $.isArray(items) ) {
								$.each(items, function() {
									$("#DC_"+this['No']).removeClass("door-disconnect");
								});
							}
						});
						$.getJSON('/?c=ainput&m=select&f=hostno&w=' + data[i]['Port'], function(dd) {
							var items = dd['list'];
							if( $.isArray(items) ) {
								$.each(items, function() {
									change_state_aux("aux_input_"+this['No'], "/img/icon/auxin_n.png");
								});
							}
						});
						$.getJSON('/?c=aoutput&m=select&f=hostno&w=' + data[i]['Port'], function(dd) {
							var items = dd['list'];
							if( $.isArray(items) ) {
								$.each(items, function() {
									change_state_aux("aux_output_"+this['No'], "/img/icon/auxout_n.png");
								});
							}
						});
	                }
	                else if(data[i]['EventCode']=='901')        // Client Disconnect
	                {
						$.getJSON('/?c=alarm_map&m=to_disconnect_door&hostno=' + data[i]['Port'], function(dd) {
							var items = dd['list'];
							if( $.isArray(items) ) {
								$.each(items, function() {
									$("#DC_"+this['No']).addClass("door-disconnect");
								});
							}
						});
						$.getJSON('/?c=alarm_map&m=to_disconnect_input&hostno=' + data[i]['Port'], function(dd) {
							var items = dd['list'];
							if( $.isArray(items) ) {
								$.each(items, function() {
									change_state_aux("aux_input_"+this['No'], "/img/icon/auxin_disconnect.png");
								});
							}
						});
						$.getJSON('/?c=alarm_map&m=to_disconnect_output&hostno=' + data[i]['Port'], function(dd) {
							var items = dd['list'];
							if( $.isArray(items) ) {
								$.each(items, function() {
									change_state_aux("aux_output_"+this['No'], "/img/icon/auxout_disconnect.png");
								});
							}
						});
	                } 
	                else if(data[i]['EventCode']=='501')        // Aux Input alarm
	                {
						//change_state_aux("aux_input_"+data[i]['Port'], "/img/icon/auxin_blink.gif");
						
						<? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>
							change_state_aux("aux_input_"+data[i]['Port'], "/img/icon/auxin_blink.gif");
						<? } ?>

	                    var normal_cmd = "change_state_aux(\"aux_input_"+data[i]['Port']+"\", \"/img/icon/auxin_n.png\")";
	                    setTimeout(normal_cmd, 15000);
	                } 
	                else if(data[i]['EventCode']=='500')        // Aux Input trouble
	                {
						//change_state_aux("aux_input_"+data[i]['Port'], "/img/icon/auxin_blink.gif");
						<? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>
							change_state_aux("aux_input_"+data[i]['Port'], "/img/icon/auxin_blink.gif");
						<? } ?>
	                    var normal_cmd = "change_state_aux(\"aux_input_"+data[i]['Port']+"\", \"/img/icon/auxin_n.png\")";
	                    setTimeout(normal_cmd, 15000);
	                } 
	                else if(data[i]['EventCode']=='13606')      // Aux Input normal
	                {
	                    change_state_aux("aux_input_"+data[i]['Port'], "/img/icon/auxin_n.png");
	                } 
	                else if(data[i]['EventCode']=='110316')     // Aux Output alarm
	                { 

						<? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>
							change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
						<? } ?>	                    
	                    //var normal_cmd = "change_state_aux(\"aux_output_"+data[i]['Port']+"\", \"/img/icon/auxout_n.png\")";
	                    //setTimeout(normal_cmd, 30000);
	                } 
	                else if(data[i]['EventCode']=='110315')     // Aux Output alarm
	                {
						//change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
						
						<? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>
							change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
						<? } ?>

	                    //var normal_cmd = "change_state_aux(\"aux_output_"+data[i]['Port']+"\", \"/img/icon/auxout_n.png\")";
	                    //setTimeout(normal_cmd, 30000);
	                }
	                else if(data[i]['EventCode']=='110314')     // Aux Output E-On
	                {
						//change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
						<? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>
							change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
						<? } ?>
					}
					else if(data[i]['EventCode']=='110313')     // Aux Output Follow AuxIn
	                {
						//change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
						<? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>
							change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
						<? } ?>
	                }
					else if(data[i]['EventCode']=='110328')		// Aux Output alarm off
					{
						change_state_aux("aux_output_"+data[i]['Port'], "/img/icon/auxout_n.png");
					}
	                else if(data[i]['EventCode']=='110331' || data[i]['EventCode']=='110332')     // Elevator alarm
	                {
						//change_state_aux("elevator_"+data[i]['Port'], "/img/icon/elevator_blink.gif");
						
						<? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>
							change_state_aux("elevator_"+data[i]['Port'], "/img/icon/elevator_blink.gif");
						<? } ?>

	                }
					else if(data[i]['EventCode']=='110333')		// Elevator alarm off
					{
						change_state_aux("elevator_"+data[i]['Port'], "/img/icon/elevator.png");
					}
	                else if(data[i]['EventCode']=='650')        // Elevator Granted
	                {
	                } 
	                else if(data[i]['EventCode']=='110331')     // Auxoutput Repeat by Elevator 
	                {
	                	//change_state_aux("elevator_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
	                    //var normal_cmd = "change_state_aux(\"aux_output_"+data[i]['Port']+"\", \"/img/icon/auxout_n.png\")";
	                    //setTimeout(normal_cmd, 30000);
	                } 
	                else if(data[i]['EventCode']=='110332')     // Auxoutput Single by Elevator 
	                {
	                	//change_state_aux("elevator_"+data[i]['Port'], "/img/icon/auxout_blink.gif");
	                    //var normal_cmd = "change_state_aux(\"aux_output_"+data[i]['Port']+"\", \"/img/icon/auxout_n.png\")";
	                    //setTimeout(normal_cmd, 30000);
	                } 
	                else if(data[i]['EventCode']=='700')        // Tamper Input
	                {    
	                } 
	                else if(data[i]['EventCode']=='701')        // Power Fault
	                {    
	                } 
	                else if(data[i]['EventCode']=='1104301')    // Popup
	                {    
	                    alert(data[i]['Message']);
	                } 
	                else if(data[i]['EventCode']=='1104302')    // Popup
	                {    
	                    alert(data[i]['Message']);
	                }
	                else if(data[i]['EventCode']=='1104303')    // Popup
	                {    
	                    alert(data[i]['EventDescription']);
                    } else if(data[i]['EventCode']=='10803') {    // Threat Level changed
                        $.getJSON('/threat_status.php', function(response) {
                            console.log(response);
                            $('#threat_level_status').text(response['ThreatName']);
                        });
	                }
	                	                
	                if(data[i]['UserNo'] && data[i]['DeviceName'] !== 'WEB')
	                {
	                    var doorno = $("#form_side select[name='door']").val();
	                    var doorname = find_door(doorno);
	                    
	                    if (data[i]['Type'] == '1' && (doorname === data[i]['DeviceName'] || DoorFilter == false))
	                    {
	                    	var key = {};
							key['no'] = data[i]['UserNo'];
							key['site'] = data[i]['Site']; 
							
							if(data[i]['EventCode']=='400' || data[i]['EventCode']=='1105022') { 	// granted
								key['doorno'] = find_door_by_reader(data[i]['Port']);
								$("#form_side select[name='door']").val(key['doorno']);
								$("#user_card").html(data[i]['CardNo']);
								$("#user_date").html(data[i]['dd']);
								change_camera_for_sidebar(data[i]['DoorNo']);
							} else {
								key['doorno'] = data[i]['Port'];
							}
							
							var opentime = data[i]['dd'];
							 
	                        $.getJSON('./user_search.php',key,function(dd)
	                        {
								if( $.isArray(dd) && dd.length > 0 ) 
								{
									if (dd[0]['ImageFile'] != "" )
									{
										$("#user_img").html("<img src='./user_img/"+dd[0]['ImageFile']+"' style='width:110px;height:130px' />");
									}
									else
									{
										$("#user_img").html("<img src='./img/user.png' style='width:110px;height:130px' />");
									}
									$("#user_name").html(dd[0]['FirstName']+" "+dd[0]['MiddleName']+" "+dd[0]['LastName']);
									$("#user_date").html(opentime);
								}
	                        });
	                        //setTimeout('user_reset()',3000);
	                        	                        
	                    }
	                }
	            }
	            else
	            {
	    	        if(data[i]['EventCode']=='401')        // ����������(Contact)
	                {
						change_camera_for_sidebar(data[i]['DoorNo']);
                    } else if(data[i]['EventCode']=='10803') {    // Threat Level changed
                        $.getJSON('/threat_status.php', function(response) {
                            console.log(response);
                            $('#threat_level_status').text(response['ThreatName']);
                        });
	                }

	                if(data[i]['UserNo'] && data[i]['DeviceName'] !== 'WEB')
	                {
	                    var doorno = $("#form_side select[name='door']").val();
	                    var doorname = find_door(doorno);
	                    if (data[i]['Type'] == '1' && (doorname === data[i]['DeviceName'] || DoorFilter == false))
	                    {
	                    	var key = {};

							key['no'] = data[i]['UserNo'];
							key['site'] = data[i]['Site']; 
							key['doorno'] = data[i]['Port'];
							
							if(data[i]['EventCode']=='400' || data[i]['EventCode']=='1105022') { 	// granted
								key['doorno'] = find_door_by_reader(data[i]['Port']);
								$("#form_side select[name='door']").val(key['doorno']);
								$("#user_card").html(data[i]['CardNo']);
								$("#user_date").html(data[i]['dd']);
								change_camera_for_sidebar(data[i]['DoorNo']);
							} else {
								key['doorno'] = data[i]['Port'];
							}
	                    	
	                    	var opentime = data[i]['dd'];
	                    	
	                        $.getJSON('./user_search.php',key,function(dd)
	                        {
								if( $.isArray(dd) && dd.length > 0 )
								{
									if (dd[0]['ImageFile'] != "") 
									{
			                            $("#user_img").html("<img src='./user_img/"+dd[0]['ImageFile']+"' style='width:110px;height:130px' />");
			                        }
									else
									{
										$("#user_img").html("<img src='./img/user.png' style='width:110px;height:130px' />");
									}
			                        
									$("#user_name").html(dd[0]['FirstName']+" "+dd[0]['MiddleName']+" "+dd[0]['LastName']);
									$("#user_date").html(opentime);
								}
	                        });
	                    }
	                }
	            }

				//if(data[i]["Type"] == "1") {
				//	change_camera_for_sidebar(data[i]['DoorNo']);
				//}
	        }
		}
	    if(!log_no)
	    {
	        log_no = no;
	    }
	    setTimeout("log("+log_no+")",1000);
	});
}

function DoorFilterCheck()
{
	/*
	    if( $("#form_side input[name='FilterDoor']").attr("checked") )   
	            DoorFilter = true;
	    else    DoorFilter = false;
	*/
	DoorFilter = ifIsChecked($("#form_side input[name='FilterDoor']"));
}

function change_camera_for_sidebar(doorNo)
{
	$("#sidebar_camera").hide();

	$.getJSON("/?c=cam_view&m=camera_info_for_door&door_no="+ doorNo, function(camera) {
		if( camera.exists == true ) {
			$("#sidebar_camera").attr("src", camera["src"]).show();
		}
	});
}
</script>

<style>

#lnb td { vertical-align:middle;}
#lnb td #user_img {text-align:center; }

.sidebar_title {
	color:#f2b632;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}
.sidebar_subtitle {
	font-weight: bold;
	font-size: 12px;
	font-family: Arial, Helvetica, sans-serif;
	color:#181b2a; 
	text-align: left;
	
	padding-left: 5px;
}
.sidebar_default {
	color:#181b2a;
	font-size: 12px;
	text-align: left;
	
	font-weight: bold;
	
}
.threatlevel {
	font-weight: bold;
	text-align: left;
	/*font-size: 18px;*/
	color: #181b2a;
}

</style>
<form id="form_side">
<table width="147" border="0" cellspacing="0" cellpadding="0">
  <tr>
	  <td  height="35" align="center"></td>
  </tr>
  <? if( $this->class == 'alarm_map' ) { ?>
  <? if( $_SESSION['spider_model'] != ConstTable::MODEL_ESSENTIAL) { ?>   
   <tr>
    <td background="/img/menu/sidebar_window_card.jpg"><table width="147px" height="147px">
      <tr>	       		
		<td width="110" align="center" class="sidebar_title <? echo SPIDER_COLOR_COLOR1;?>" style="height:35px;"><?=$lang->menu->automonitor?></td>
	  </tr>	  
	  <tr>
        <td width="110" id="user_img" style="vertical-align:middle;"></td>
      </tr>
    </table></td>
  </tr>
  
  <td height="2"></td>
  <tr>
    <td><table border="0" cellspacing="0" cellpadding="0">       
   <tr>   
      <td class="sidebar_subtitle" style="height:35px;"><?=$lang->menu->name?></td>   
   	<tr>   
      <td><div id="user_name" class="sidebar_default truncate" style="width:142px;height:35px;background:#8f979a; padding-left:5px;" >User</div></td>
      </tr>	 	  	  
	  
	  <tr>
        <td height="35px"><span class="sidebar_subtitle" style="font-size:12px; color:#181b2a; padding-left:5px; text-align:left;"><?=$lang->menu->date?></span></td>
      </tr>
	  
	  <tr>
        <td height="35px" id="user_date" class="sidebar_default"  align="center" style="background:#8f979a;padding-left:5px;"></td>
      </tr>	  
	</table></td>
	      
  <tr>
    <td><table>     		
      <tr>		
        <td width="147px" height="35px" id="user_door" class="sidebar_default"><span class="sidebar_subtitle" ><?=$lang->menu->door?></span>		
		<?=$this->from->checkbox('FilterDoor', '', FALSE, '1', array('onclick'=>'DoorFilterCheck()'))?></td> 		  
	  </tr>
		
      <tr>		  
        <td><?=$this->from->select('door', '', $arr_door, array('style'=>'background:#bdc2c5; width:147px; height:35px'))?></td>		  
      </tr>		
      </table>	  
	</td>				
  </tr>

  </tr>
  <? } ?>
  <? if( $_SESSION['spider_model'] == ConstTable::MODEL_ELITE || 
         $_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE ||
	     $_SESSION['spider_model'] == ConstTable::MODEL_GIANT) { ?>
  <tr>
      <td><table border="0" cellspacing="0" cellpadding="0">	  
	  <tr>	  
	    <td width="147" height="35"></td>		
	  </tr>
	  
	  <tr>	  
	    <td width="147" height="35" align="left"><span class="sidebar_title <? echo SPIDER_COLOR_COLOR1;?>" style="padding-left:5px; color:#f2b632"><?=$lang->menu->threatlevelstatus?></span> </td>		
	  </tr>
      <tr>	  
	    <td width="147px" height="35" id="threat_level_status" class="threatlevel" style="background:#8e9699; font-size:12px; color:#181b2a; padding-left:5px; text-align:left;"><?=$threat?></td>	  
	  </tr>
    </table></td>
  </tr>
  <? } ?>
  
  <tr> 
    <td ><table border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td width="147px" height="35px"><span class="sidebar_title <? echo SPIDER_COLOR_COLOR1;?>" style="padding-left:5px; color:#f2b632" ><?=$lang->menu->e3_time?></span></td>
      </tr>
      <tr>
        <td width="147px" height="35px" align="left" id="e3_time" class="threatlevel" style="background:#8e9699;padding-left:5px;"></td>
      </tr>
    </table></td>
  </tr>
  <? if( $camera > 0 && ($_SESSION['spider_model'] == ConstTable::MODEL_ELITE || 
         $_SESSION['spider_model'] == ConstTable::MODEL_ENTERPRISE ||
	     $_SESSION['spider_model'] == ConstTable::MODEL_GIANT) ) { ?>
  <? //if (false && $camera > 0) { ?>
	  <tr>
	    <td height="250"> </td>
	    <td background="/img/menu/sidebar_window_camera.jpg"><table border="0" cellspacing="0" cellpadding="0">
	      <tr>
	        <td width="10" height="30">&nbsp;</td>
	        <td width="147" align="left"><span class="sidebar_title <? echo SPIDER_COLOR_COLOR1;?>"><?=$lang->menu->cameraview?></span></td>
	      </tr>
		  <tr height="8"></tr>
	      <tr>
	        <td height="212">&nbsp;</td>
	        <td height="212" style="vertical-align:top;">
				<table border="0" cellspacing="0" cellpadding="0" style="width:147px;">
				<tr>
					<img id="sidebar_camera" src="about:blank" width="250" height="204" class="hide">
					<!-- <iframe id="frame_camera" src="about:blank" width="250" height="204" marginwidth="0" marginheight="0" frameborder="0" scrolling="no"></iframe> -->
				</tr>
				</table>
			</td>
	      </tr>
	    </table></td>
	    
	  </tr>
  <? } ?>  	 

  <? if($this->is_option(ConstTable::OPTION_RMR)) { ?>
	<? if($this->rmr['Disable'] == '1') { ?>
	  <!-- <tr>
	    <td height="100"></td>
	    <td><iframe src="https://<?=$this->rmr['ServerIP']?>/home/banner" width="270" height="100" frameborder="0" scrolling="no"></iframe></td>
	    <td></td>
	  </tr>  -->
	  <? } ?>
  <? } ?>
  <? } else if( $this->class == 'timesvr' ) { ?>
  <tr>

  
    <td>
			<table border="0" cellspacing="0" cellpadding="0">
  

        
			<tr>
  

          <td width="147" height="35" align="center">
              <span class="sidebar_title <? echo SPIDER_COLOR_COLOR1;?>"><?=$lang->menu->e3_time?></span>
			  </td>
			</tr>
			
			<tr height="35" style="background:#8f979a;">
			  <td id="e3_time" class="threatlevel" style='text-align: center;'></td>
  

        </tr>

 
            </table>
	  </td>
  </tr>
  <? } ?>
</table>
</form>